(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define('leancloud-realtime', ['exports'], factory) :
  (global = global || self, factory(global.AV = global.AV || {}));
}(this, (function (exports) { 'use strict';

  var define = undefined;
  var require = require || function(id) {throw new Error('Unexpected required ' + id)};



  var process = (typeof window !== 'undefined' && window.process) || {};
  process.env = process.env || {};

  var XMLHttpRequest;function Function(){return function(){}};

  function _typeof(obj) {
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function (obj) {
        return typeof obj;
      };
    } else {
      _typeof = function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    subClass.__proto__ = superClass;
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _toArray(arr) {
    return _arrayWithHoles(arr) || _iterableToArray(arr) || _nonIterableRest();
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

      return arr2;
    }
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
  }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object.keys(descriptor).forEach(function (key) {
      desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
      desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
      return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
      desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
      desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
      Object.defineProperty(target, property, desc);
      desc = null;
    }

    return desc;
  }

  var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

  function commonjsRequire () {
  	throw new Error('Dynamic requires are not currently supported by rollup-plugin-commonjs');
  }

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  var Storage =
  /*#__PURE__*/
  function () {
    function Storage() {}

    var _proto = Storage.prototype;

    _proto.getItem = function getItem(key) {
      return wx.getStorageSync(key);
    };

    _proto.setItem = function setItem(key, value) {
      return wx.setStorageSync(key, value);
    };

    _proto.removeItem = function removeItem(key) {
      return this.setItem(key, '');
    };

    _proto.clear = function clear() {
      return wx.clearStorageSync();
    };

    return Storage;
  }();

  var localstorage = new Storage();

  /*
  object-assign
  (c) Sindre Sorhus
  @license MIT
  */
  /* eslint-disable no-unused-vars */
  var getOwnPropertySymbols = Object.getOwnPropertySymbols;
  var hasOwnProperty = Object.prototype.hasOwnProperty;
  var propIsEnumerable = Object.prototype.propertyIsEnumerable;

  function toObject(val) {
  	if (val === null || val === undefined) {
  		throw new TypeError('Object.assign cannot be called with null or undefined');
  	}

  	return Object(val);
  }

  function shouldUseNative() {
  	try {
  		if (!Object.assign) {
  			return false;
  		}

  		// Detect buggy property enumeration order in older V8 versions.

  		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
  		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
  		test1[5] = 'de';
  		if (Object.getOwnPropertyNames(test1)[0] === '5') {
  			return false;
  		}

  		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
  		var test2 = {};
  		for (var i = 0; i < 10; i++) {
  			test2['_' + String.fromCharCode(i)] = i;
  		}
  		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
  			return test2[n];
  		});
  		if (order2.join('') !== '0123456789') {
  			return false;
  		}

  		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
  		var test3 = {};
  		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
  			test3[letter] = letter;
  		});
  		if (Object.keys(Object.assign({}, test3)).join('') !==
  				'abcdefghijklmnopqrst') {
  			return false;
  		}

  		return true;
  	} catch (err) {
  		// We don't expect any of the above to throw, but better to be safe.
  		return false;
  	}
  }

  var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
  	var from;
  	var to = toObject(target);
  	var symbols;

  	for (var s = 1; s < arguments.length; s++) {
  		from = Object(arguments[s]);

  		for (var key in from) {
  			if (hasOwnProperty.call(from, key)) {
  				to[key] = from[key];
  			}
  		}

  		if (getOwnPropertySymbols) {
  			symbols = getOwnPropertySymbols(from);
  			for (var i = 0; i < symbols.length; i++) {
  				if (propIsEnumerable.call(from, symbols[i])) {
  					to[symbols[i]] = from[symbols[i]];
  				}
  			}
  		}
  	}

  	return to;
  };

  var commons = createCommonjsModule(function (module, exports) {

  /**
   * Creates a unique key.
   *
   * @param {string} name - A name to create.
   * @returns {symbol|string}
   * @private
   */
  var createUniqueKey = exports.createUniqueKey = (typeof Symbol !== "undefined" ?
      Symbol :
      function createUniqueKey(name) {
          return "[[" + name + "_" + Math.random().toFixed(8).slice(2) + "]]";
      });

  /**
   * The key of listeners.
   *
   * @type {symbol|string}
   * @private
   */
  exports.LISTENERS = createUniqueKey("listeners");

  /**
   * A value of kind for listeners which are registered in the capturing phase.
   *
   * @type {number}
   * @private
   */
  exports.CAPTURE = 1;

  /**
   * A value of kind for listeners which are registered in the bubbling phase.
   *
   * @type {number}
   * @private
   */
  exports.BUBBLE = 2;

  /**
   * A value of kind for listeners which are registered as an attribute.
   *
   * @type {number}
   * @private
   */
  exports.ATTRIBUTE = 3;

  /**
   * @typedef object ListenerNode
   * @property {function} listener - A listener function.
   * @property {number} kind - The kind of the listener.
   * @property {ListenerNode|null} next - The next node.
   *      If this node is the last, this is `null`.
   */

  /**
   * Creates a node of singly linked list for a list of listeners.
   *
   * @param {function} listener - A listener function.
   * @param {number} kind - The kind of the listener.
   * @returns {ListenerNode} The created listener node.
   */
  exports.newNode = function newNode(listener, kind) {
      return {listener: listener, kind: kind, next: null};
  };
  });
  var commons_1 = commons.createUniqueKey;
  var commons_2 = commons.LISTENERS;
  var commons_3 = commons.CAPTURE;
  var commons_4 = commons.BUBBLE;
  var commons_5 = commons.ATTRIBUTE;
  var commons_6 = commons.newNode;

  //-----------------------------------------------------------------------------
  // Requirements
  //-----------------------------------------------------------------------------


  var LISTENERS = commons.LISTENERS;
  var ATTRIBUTE = commons.ATTRIBUTE;
  var newNode = commons.newNode;

  //-----------------------------------------------------------------------------
  // Helpers
  //-----------------------------------------------------------------------------

  /**
   * Gets a specified attribute listener from a given EventTarget object.
   *
   * @param {EventTarget} eventTarget - An EventTarget object to get.
   * @param {string} type - An event type to get.
   * @returns {function|null} The found attribute listener.
   */
  function getAttributeListener(eventTarget, type) {
      var node = eventTarget[LISTENERS][type];
      while (node != null) {
          if (node.kind === ATTRIBUTE) {
              return node.listener;
          }
          node = node.next;
      }
      return null;
  }

  /**
   * Sets a specified attribute listener to a given EventTarget object.
   *
   * @param {EventTarget} eventTarget - An EventTarget object to set.
   * @param {string} type - An event type to set.
   * @param {function|null} listener - A listener to be set.
   * @returns {void}
   */
  function setAttributeListener(eventTarget, type, listener) {
      if (typeof listener !== "function" && typeof listener !== "object") {
          listener = null; // eslint-disable-line no-param-reassign
      }

      var prev = null;
      var node = eventTarget[LISTENERS][type];
      while (node != null) {
          if (node.kind === ATTRIBUTE) {
              // Remove old value.
              if (prev == null) {
                  eventTarget[LISTENERS][type] = node.next;
              }
              else {
                  prev.next = node.next;
              }
          }
          else {
              prev = node;
          }

          node = node.next;
      }

      // Add new value.
      if (listener != null) {
          if (prev == null) {
              eventTarget[LISTENERS][type] = newNode(listener, ATTRIBUTE);
          }
          else {
              prev.next = newNode(listener, ATTRIBUTE);
          }
      }
  }

  //-----------------------------------------------------------------------------
  // Public Interface
  //-----------------------------------------------------------------------------

  /**
   * Defines an `EventTarget` implementation which has `onfoobar` attributes.
   *
   * @param {EventTarget} EventTargetBase - A base implementation of EventTarget.
   * @param {string[]} types - A list of event types which are defined as attribute listeners.
   * @returns {EventTarget} The defined `EventTarget` implementation which has attribute listeners.
   */
  var defineCustomEventTarget = function(EventTargetBase, types) {
      function EventTarget() {
          EventTargetBase.call(this);
      }

      var descripter = {
          constructor: {
              value: EventTarget,
              configurable: true,
              writable: true
          }
      };

      types.forEach(function(type) {
          descripter["on" + type] = {
              get: function() { return getAttributeListener(this, type); },
              set: function(listener) { setAttributeListener(this, type, listener); },
              configurable: true,
              enumerable: true
          };
      });

      EventTarget.prototype = Object.create(EventTargetBase.prototype, descripter);

      return EventTarget;
  };

  var customEventTarget = {
  	defineCustomEventTarget: defineCustomEventTarget
  };

  //-----------------------------------------------------------------------------
  // Requirements
  //-----------------------------------------------------------------------------

  var createUniqueKey = commons.createUniqueKey;

  //-----------------------------------------------------------------------------
  // Constsnts
  //-----------------------------------------------------------------------------

  /**
   * The key of the flag which is turned on by `stopImmediatePropagation` method.
   *
   * @type {symbol|string}
   * @private
   */
  var STOP_IMMEDIATE_PROPAGATION_FLAG =
      createUniqueKey("stop_immediate_propagation_flag");

  /**
   * The key of the flag which is turned on by `preventDefault` method.
   *
   * @type {symbol|string}
   * @private
   */
  var CANCELED_FLAG = createUniqueKey("canceled_flag");

  /**
   * The key of the original event object.
   *
   * @type {symbol|string}
   * @private
   */
  var ORIGINAL_EVENT = createUniqueKey("original_event");

  /**
   * Method definitions for the event wrapper.
   *
   * @type {object}
   * @private
   */
  var wrapperPrototypeDefinition = Object.freeze({
      stopPropagation: Object.freeze({
          value: function stopPropagation() {
              var e = this[ORIGINAL_EVENT];
              if (typeof e.stopPropagation === "function") {
                  e.stopPropagation();
              }
          },
          writable: true,
          configurable: true
      }),

      stopImmediatePropagation: Object.freeze({
          value: function stopImmediatePropagation() {
              this[STOP_IMMEDIATE_PROPAGATION_FLAG] = true;

              var e = this[ORIGINAL_EVENT];
              if (typeof e.stopImmediatePropagation === "function") {
                  e.stopImmediatePropagation();
              }
          },
          writable: true,
          configurable: true
      }),

      preventDefault: Object.freeze({
          value: function preventDefault() {
              if (this.cancelable === true) {
                  this[CANCELED_FLAG] = true;
              }

              var e = this[ORIGINAL_EVENT];
              if (typeof e.preventDefault === "function") {
                  e.preventDefault();
              }
          },
          writable: true,
          configurable: true
      }),

      defaultPrevented: Object.freeze({
          get: function defaultPrevented() { return this[CANCELED_FLAG]; },
          enumerable: true,
          configurable: true
      })
  });

  //-----------------------------------------------------------------------------
  // Public Interface
  //-----------------------------------------------------------------------------

  var STOP_IMMEDIATE_PROPAGATION_FLAG_1 = STOP_IMMEDIATE_PROPAGATION_FLAG;

  /**
   * Creates an event wrapper.
   *
   * We cannot modify several properties of `Event` object, so we need to create the wrapper.
   * Plus, this wrapper supports non `Event` objects.
   *
   * @param {Event|{type: string}} event - An original event to create the wrapper.
   * @param {EventTarget} eventTarget - The event target of the event.
   * @returns {Event} The created wrapper. This object is implemented `Event` interface.
   * @private
   */
  var createEventWrapper = function createEventWrapper(event, eventTarget) {
      var timeStamp = (
          typeof event.timeStamp === "number" ? event.timeStamp : Date.now()
      );
      var propertyDefinition = {
          type: {value: event.type, enumerable: true},
          target: {value: eventTarget, enumerable: true},
          currentTarget: {value: eventTarget, enumerable: true},
          eventPhase: {value: 2, enumerable: true},
          bubbles: {value: Boolean(event.bubbles), enumerable: true},
          cancelable: {value: Boolean(event.cancelable), enumerable: true},
          timeStamp: {value: timeStamp, enumerable: true},
          isTrusted: {value: false, enumerable: true}
      };
      propertyDefinition[STOP_IMMEDIATE_PROPAGATION_FLAG] = {value: false, writable: true};
      propertyDefinition[CANCELED_FLAG] = {value: false, writable: true};
      propertyDefinition[ORIGINAL_EVENT] = {value: event};

      // For CustomEvent.
      if (typeof event.detail !== "undefined") {
          propertyDefinition.detail = {value: event.detail, enumerable: true};
      }

      return Object.create(
          Object.create(event, wrapperPrototypeDefinition),
          propertyDefinition
      );
  };

  var eventWrapper = {
  	STOP_IMMEDIATE_PROPAGATION_FLAG: STOP_IMMEDIATE_PROPAGATION_FLAG_1,
  	createEventWrapper: createEventWrapper
  };

  var eventTarget = createCommonjsModule(function (module) {

  //-----------------------------------------------------------------------------
  // Requirements
  //-----------------------------------------------------------------------------




  var LISTENERS = commons.LISTENERS;
  var CAPTURE = commons.CAPTURE;
  var BUBBLE = commons.BUBBLE;
  var ATTRIBUTE = commons.ATTRIBUTE;
  var newNode = commons.newNode;
  var defineCustomEventTarget = customEventTarget.defineCustomEventTarget;
  var createEventWrapper = eventWrapper.createEventWrapper;
  var STOP_IMMEDIATE_PROPAGATION_FLAG =
      eventWrapper.STOP_IMMEDIATE_PROPAGATION_FLAG;

  //-----------------------------------------------------------------------------
  // Constants
  //-----------------------------------------------------------------------------

  /**
   * A flag which shows there is the native `EventTarget` interface object.
   *
   * @type {boolean}
   * @private
   */
  var HAS_EVENTTARGET_INTERFACE = (
      typeof window !== "undefined" &&
      typeof window.EventTarget !== "undefined"
  );

  //-----------------------------------------------------------------------------
  // Public Interface
  //-----------------------------------------------------------------------------

  /**
   * An implementation for `EventTarget` interface.
   *
   * @constructor
   * @public
   */
  var EventTarget = module.exports = function EventTarget() {
      if (this instanceof EventTarget) {
          // this[LISTENERS] is a Map.
          // Its key is event type.
          // Its value is ListenerNode object or null.
          //
          // interface ListenerNode {
          //     var listener: Function
          //     var kind: CAPTURE|BUBBLE|ATTRIBUTE
          //     var next: ListenerNode|null
          // }
          Object.defineProperty(this, LISTENERS, {value: Object.create(null)});
      }
      else if (arguments.length === 1 && Array.isArray(arguments[0])) {
          return defineCustomEventTarget(EventTarget, arguments[0]);
      }
      else if (arguments.length > 0) {
          var types = Array(arguments.length);
          for (var i = 0; i < arguments.length; ++i) {
              types[i] = arguments[i];
          }

          // To use to extend with attribute listener properties.
          // e.g.
          //     class MyCustomObject extends EventTarget("message", "error") {
          //         //...
          //     }
          return defineCustomEventTarget(EventTarget, types);
      }
      else {
          throw new TypeError("Cannot call a class as a function");
      }
  };

  EventTarget.prototype = Object.create(
      (HAS_EVENTTARGET_INTERFACE ? window.EventTarget : Object).prototype,
      {
          constructor: {
              value: EventTarget,
              writable: true,
              configurable: true
          },

          addEventListener: {
              value: function addEventListener(type, listener, capture) {
                  if (listener == null) {
                      return false;
                  }
                  if (typeof listener !== "function" && typeof listener !== "object") {
                      throw new TypeError("\"listener\" is not an object.");
                  }

                  var kind = (capture ? CAPTURE : BUBBLE);
                  var node = this[LISTENERS][type];
                  if (node == null) {
                      this[LISTENERS][type] = newNode(listener, kind);
                      return true;
                  }

                  var prev = null;
                  while (node != null) {
                      if (node.listener === listener && node.kind === kind) {
                          // Should ignore a duplicated listener.
                          return false;
                      }
                      prev = node;
                      node = node.next;
                  }

                  prev.next = newNode(listener, kind);
                  return true;
              },
              configurable: true,
              writable: true
          },

          removeEventListener: {
              value: function removeEventListener(type, listener, capture) {
                  if (listener == null) {
                      return false;
                  }

                  var kind = (capture ? CAPTURE : BUBBLE);
                  var prev = null;
                  var node = this[LISTENERS][type];
                  while (node != null) {
                      if (node.listener === listener && node.kind === kind) {
                          if (prev == null) {
                              this[LISTENERS][type] = node.next;
                          }
                          else {
                              prev.next = node.next;
                          }
                          return true;
                      }

                      prev = node;
                      node = node.next;
                  }

                  return false;
              },
              configurable: true,
              writable: true
          },

          dispatchEvent: {
              value: function dispatchEvent(event) {
                  // If listeners aren't registered, terminate.
                  var node = this[LISTENERS][event.type];
                  if (node == null) {
                      return true;
                  }

                  // Since we cannot rewrite several properties, so wrap object.
                  var wrapped = createEventWrapper(event, this);

                  // This doesn't process capturing phase and bubbling phase.
                  // This isn't participating in a tree.
                  while (node != null) {
                      if (typeof node.listener === "function") {
                          node.listener.call(this, wrapped);
                      }
                      else if (node.kind !== ATTRIBUTE && typeof node.listener.handleEvent === "function") {
                          node.listener.handleEvent(wrapped);
                      }

                      if (wrapped[STOP_IMMEDIATE_PROPAGATION_FLAG]) {
                          break;
                      }
                      node = node.next;
                  }

                  return !wrapped.defaultPrevented;
              },
              configurable: true,
              writable: true
          }
      }
  );
  });

  var FormData$1 =
  /*#__PURE__*/
  function () {
    function FormData() {
      this._entries = [];
    }

    var _proto = FormData.prototype;

    _proto.append = function append(name, value) {
      if (typeof name !== 'string') {
        throw new TypeError('FormData name must be a string');
      }

      if (typeof value !== 'string') {
        if (_typeof(value) !== 'object' || typeof value.uri !== 'string') {
          throw new TypeError('FormData value must be a string or { uri: tempFilePath }');
        }
      }

      this._entries.push([name, value]);
    };

    _proto.set = function set(name, value) {
      var entry = this.get(name);

      if (entry) {
        entry[1] = value;
      } else {
        this.append(name, value);
      }
    };

    _proto["delete"] = function _delete(name) {
      this._entries = this._entries.filter(function (entry) {
        return entry[0] !== name;
      });
    };

    _proto.entries = function entries() {
      return this._entries;
    };

    _proto.get = function get(name) {
      return this._entries.find(function (entry) {
        return entry[0] === name;
      });
    };

    _proto.getAll = function getAll(name) {
      return this._entries.filter(function (entry) {
        return entry[0] === name;
      });
    };

    _proto.has = function has(name) {
      return this._entries.some(function (entry) {
        return entry[0] === name;
      });
    };

    _proto.keys = function keys() {
      return this._entries.map(function (entry) {
        return entry[0];
      });
    };

    _proto.values = function values() {
      return this._entries.map(function (entry) {
        return entry[1];
      });
    };

    return FormData;
  }();

  var formdata = FormData$1;

  var UNSENT = 0;
  var OPENED = 1;
  var HEADERS_RECEIVED = 2;
  var LOADING = 3;
  var DONE = 4;
  var REQUEST_EVENTS = ['abort', 'error', 'load', 'loadstart', 'progress', 'timeout', 'loadend', 'readystatechange'];
  var REQUEST_UPLOAD_EVENTS = ['abort', 'error', 'load', 'loadstart', 'progress', 'timeout', 'loadend'];

  function successCallback(response) {
    this.status = response.statusCode;
    this.statusText = response.statusCode; // 基础库 1.2.0 开始支持

    if (response.header) {
      this._responseHeaders = Object.keys(response.header).reduce(function (headers, key) {
        headers[key.toLowerCase()] = response.header[key];
        return headers;
      }, {});
    }

    var text = response.data;

    if (typeof text !== 'string') {
      text = JSON.stringify(text);
    }

    this.responseText = this.response = text;
    this.readyState = DONE;
    this.dispatchEvent({
      type: 'readystatechange'
    });
  }

  var XMLHttpRequestUpload =
  /*#__PURE__*/
  function (_EventTarget) {
    _inheritsLoose(XMLHttpRequestUpload, _EventTarget);

    function XMLHttpRequestUpload() {
      return _EventTarget.apply(this, arguments) || this;
    }

    return XMLHttpRequestUpload;
  }(eventTarget(REQUEST_UPLOAD_EVENTS));

  var XMLHttpRequest$1 =
  /*#__PURE__*/
  function (_EventTarget2) {
    _inheritsLoose(XMLHttpRequest, _EventTarget2);

    function XMLHttpRequest() {
      var _this;

      _this = _EventTarget2.call(this) || this;
      _this.readyState = UNSENT;
      _this._headers = {};
      _this.upload = new XMLHttpRequestUpload();
      return _this;
    }

    var _proto = XMLHttpRequest.prototype;

    _proto.abort = function abort() {
      // 基础库 1.4.0 开始支持
      if (!this._request || this._request.abort) {
        this.status = 0;
        this.readyState = DONE;
        return this._request.abort();
      }

      throw new Error('该版本基础库不支持 abort request');
    };

    _proto.getAllResponseHeaders = function getAllResponseHeaders() {
      var _this2 = this;

      return this._responseHeaders ? Object.keys(this._responseHeaders).map(function (key) {
        return "".concat(key, ": ").concat(_this2._responseHeaders[key]);
      }).join('\r\n') : '';
    };

    _proto.getResponseHeader = function getResponseHeader(key) {
      var lowserCasedKey = key.toLowerCase();

      if (this._responseHeaders && this._responseHeaders[lowserCasedKey]) {
        return this._responseHeaders[lowserCasedKey];
      }

      return null;
    };

    _proto.overrideMimeType = function overrideMimeType() {
      throw new Error('not supported in weapp');
    };

    _proto.open = function open(method, url) {
      var async = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      if (this.readyState !== UNSENT) {
        throw new Error('request is already opened');
      }

      if (!async) {
        throw new Error('sync request is not supported');
      }

      this._method = method;
      this._url = url;
      this.readyState = OPENED;
      this.dispatchEvent({
        type: 'readystatechange'
      });
    };

    _proto.setRequestHeader = function setRequestHeader(header, value) {
      if (this.readyState !== OPENED) {
        throw new Error('request is not opened');
      }

      this._headers[header.toLowerCase()] = value;
    };

    _proto.send = function send(data) {
      var _this3 = this;

      if (this.readyState !== OPENED) {
        throw new Error('request is not opened');
      }

      if (data instanceof formdata) {
        var entries = data.entries();
        var blobs = entries.filter(function (entry) {
          return typeof entry[1] !== 'string';
        });

        if (blobs.length === 0) {
          throw new Error('Must specify a Blob field in FormData');
        }

        if (blobs.length > 1) {
          console.warn('Only the first Blob will be send in Weapp');
        }

        var restData = entries.filter(function (entry) {
          return typeof entry[1] === 'string';
        }).reduce(function (result, entry) {
          return objectAssign(result, _defineProperty({}, entry[0], entry[1]));
        }, {});
        this._request = wx.uploadFile({
          url: this._url,
          name: blobs[0][0],
          filePath: blobs[0][1].uri,
          formData: restData,
          header: this._headers,
          success: successCallback.bind(this),
          fail: function fail(error) {
            _this3.status = 0;
            _this3.readyState = DONE;

            _this3.dispatchEvent({
              type: 'readystatechange'
            });

            _this3.dispatchEvent({
              type: 'error'
            });
          }
        }); // 基础库 1.4.0 开始支持

        if (this._request && this._request.onProgressUpdate) {
          this._request.onProgressUpdate(function (_ref) {
            var totalBytesSent = _ref.totalBytesSent,
                totalBytesExpectedToSend = _ref.totalBytesExpectedToSend;

            _this3.upload.dispatchEvent({
              type: 'progress',
              loaded: totalBytesSent,
              total: totalBytesExpectedToSend
            });
          });
        }
      } else {
        this._request = wx.request({
          url: this._url,
          data: data || '',
          // method 的 value 居然必须为大写
          method: this._method.toUpperCase(),
          header: this._headers,
          success: successCallback.bind(this),
          fail: function fail(error) {
            _this3.status = 0;
            _this3.readyState = DONE;

            _this3.dispatchEvent({
              type: 'readystatechange'
            });

            _this3.dispatchEvent({
              type: 'error'
            });
          }
        });
      }
    };

    return XMLHttpRequest;
  }(eventTarget(REQUEST_EVENTS));

  objectAssign(XMLHttpRequest$1, {
    UNSENT: UNSENT,
    OPENED: OPENED,
    HEADERS_RECEIVED: HEADERS_RECEIVED,
    LOADING: LOADING,
    DONE: DONE
  });
  var xmlhttprequest = XMLHttpRequest$1;

  var CONNECTING = 0;
  var OPEN = 1;
  var CLOSING = 2;
  var CLOSED = 3;
  var EVENTS = ['open', 'error', 'message', 'close'];

  var WebSocket$1 =
  /*#__PURE__*/
  function (_EventTarget) {
    _inheritsLoose(WebSocket, _EventTarget);

    function WebSocket(url, protocal) {
      var _this;

      if (!url) {
        throw new TypeError('Failed to construct \'WebSocket\': url required');
      }

      if (protocal && !(wx.canIUse && wx.canIUse('connectSocket.object.protocols'))) {
        throw new Error('subprotocal not supported in weapp');
      }

      _this = _EventTarget.call(this) || this;
      _this._url = url;
      _this._protocal = protocal || ''; // default value according to specs

      _this._readyState = CONNECTING;

      var errorHandler = function errorHandler(event) {
        _this._readyState = CLOSED;

        _this.dispatchEvent({
          type: 'error',
          message: event.errMsg
        });
      };

      var socketTask = wx.connectSocket({
        url: url,
        protocals: _this._protocal,
        fail: function fail(error) {
          return setTimeout(function () {
            return errorHandler(error);
          }, 0);
        }
      });
      _this._socketTask = socketTask;
      socketTask.onOpen(function (event) {
        _this._readyState = OPEN;

        _this.dispatchEvent({
          type: 'open'
        });
      });
      socketTask.onError(errorHandler);
      socketTask.onMessage(function (event) {
        var data = event.data,
            origin = event.origin,
            ports = event.ports,
            source = event.source;

        _this.dispatchEvent({
          data: data,
          origin: origin,
          ports: ports,
          source: source,
          type: 'message'
        });
      });
      socketTask.onClose(function (event) {
        _this._readyState = CLOSED;
        var code = event.code,
            reason = event.reason,
            wasClean = event.wasClean;

        _this.dispatchEvent({
          code: code,
          reason: reason,
          wasClean: wasClean,
          type: 'close'
        });
      });
      return _this;
    }

    var _proto = WebSocket.prototype;

    _proto.close = function close() {
      if (this.readyState === CLOSED) return;

      if (this.readyState === CONNECTING) {
        console.warn('close WebSocket which is connecting might not work');
      }

      this._socketTask.close();
    };

    _proto.send = function send(data) {
      if (this.readyState !== OPEN) {
        throw new Error('INVALID_STATE_ERR');
      }

      if (!(typeof data === 'string' || data instanceof ArrayBuffer)) {
        throw new TypeError('only String/ArrayBuffer supported');
      }

      this._socketTask.send({
        data: data
      });
    };

    _createClass(WebSocket, [{
      key: "url",
      get: function get() {
        return this._url;
      }
    }, {
      key: "protocal",
      get: function get() {
        return this._protocal;
      }
    }, {
      key: "readyState",
      get: function get() {
        return this._readyState;
      }
    }]);

    return WebSocket;
  }(eventTarget(EVENTS));

  objectAssign(WebSocket$1, {
    CONNECTING: CONNECTING,
    OPEN: OPEN,
    CLOSING: CLOSING,
    CLOSED: CLOSED
  });
  var websocket = WebSocket$1;

  var polyfill = function polyfill(target) {
    if (!wx.onNetworkStatusChange) return;
    if (target.__onlineOfflinePolyfilled) return;
    target.__onlineOfflinePolyfilled = true;
    var internalEventTarget = new eventTarget();

    if (!target.dispatchEvent) {
      target.addEventListener = internalEventTarget.addEventListener.bind(internalEventTarget);
      target.removeEventListener = internalEventTarget.removeEventListener.bind(internalEventTarget);
      target.dispatchEvent = internalEventTarget.dispatchEvent.bind(internalEventTarget); // avoid this condition to be true:
      // https://github.com/zloirock/core-js/blob/9f051803760c02b306aae2595621bb7ef698fc29/library/modules/_task.js#L61

      if (typeof postMessage == 'function' && !target.importScripts) {
        target.importScripts = function () {
          throw new Error('mocked');
        };
      }
    }

    wx.getNetworkType({
      success: function success(_ref) {
        var networkType = _ref.networkType;
        target.onLine = networkType !== 'none';
        wx.onNetworkStatusChange(function (_ref2) {
          var isConnected = _ref2.isConnected;
          if (target.onLine === isConnected) return;
          target.onLine = isConnected;
          target.dispatchEvent({
            type: isConnected ? 'online' : 'offline'
          });
        });
      }
    });
  };

  var onlineOfflineEvents = {
    polyfill: polyfill
  };

  var navigator$1 = {};

  var weappPolyfill = {
    polyfill: function polyfill() {
      var target = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : commonjsGlobal || window;

      if (_typeof(target) !== 'object') {
        throw new Error('polyfill target is not an Object');
      }

      var polyfills = {
        localStorage: localstorage,
        XMLHttpRequest: xmlhttprequest,
        FormData: formdata,
        WebSocket: websocket,
        Object: Object,
        navigator: navigator$1
      };

      for (var k in polyfills) {
        if (!target[k]) target[k] = polyfills[k];
      }

      onlineOfflineEvents.polyfill(target); //  假扮为 React Native，让 axios 认为这是一个 nonStandardBrowserEnv

      target.navigator.product = 'ReactNative';
    },
    localStorage: localstorage,
    XMLHttpRequest: xmlhttprequest,
    FormData: formdata,
    WebSocket: websocket
  };

  var polyfill$1 = weappPolyfill.polyfill;

  try {
    polyfill$1();
  } catch (e) {}

  try {
    polyfill$1(GameGlobal);
  } catch (e) {}

  try {
    window = window || {};
    polyfill$1(window);
  } catch (e) {}

  try {
    localStorage = localStorage || localstorage;
  } catch (e) {}

  try {
    XMLHttpRequest = XMLHttpRequest || xmlhttprequest;
  } catch (e) {}

  try {
    FormData = FormData || formdata;
  } catch (e) {}

  try {
    WebSocket = WebSocket || websocket;
  } catch (e) {}

  try {
    navigator = navigator || navigator$1;
  } catch (e) {}

  var long_1 = createCommonjsModule(function (module) {
  /*
   Copyright 2013 Daniel Wirtz <dcode@dcode.io>
   Copyright 2009 The Closure Library Authors. All Rights Reserved.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS-IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
   */

  /**
   * @license long.js (c) 2013 Daniel Wirtz <dcode@dcode.io>
   * Released under the Apache License, Version 2.0
   * see: https://github.com/dcodeIO/long.js for details
   */
  (function(global, factory) {

      /* AMD */ if (typeof commonjsRequire === 'function' && 'object' === "object" && module && module["exports"])
          module["exports"] = factory();
      /* Global */ else
          (global["dcodeIO"] = global["dcodeIO"] || {})["Long"] = factory();

  })(commonjsGlobal, function() {

      /**
       * Constructs a 64 bit two's-complement integer, given its low and high 32 bit values as *signed* integers.
       *  See the from* functions below for more convenient ways of constructing Longs.
       * @exports Long
       * @class A Long class for representing a 64 bit two's-complement integer value.
       * @param {number} low The low (signed) 32 bits of the long
       * @param {number} high The high (signed) 32 bits of the long
       * @param {boolean=} unsigned Whether unsigned or not, defaults to `false` for signed
       * @constructor
       */
      function Long(low, high, unsigned) {

          /**
           * The low 32 bits as a signed value.
           * @type {number}
           */
          this.low = low | 0;

          /**
           * The high 32 bits as a signed value.
           * @type {number}
           */
          this.high = high | 0;

          /**
           * Whether unsigned or not.
           * @type {boolean}
           */
          this.unsigned = !!unsigned;
      }

      // The internal representation of a long is the two given signed, 32-bit values.
      // We use 32-bit pieces because these are the size of integers on which
      // Javascript performs bit-operations.  For operations like addition and
      // multiplication, we split each number into 16 bit pieces, which can easily be
      // multiplied within Javascript's floating-point representation without overflow
      // or change in sign.
      //
      // In the algorithms below, we frequently reduce the negative case to the
      // positive case by negating the input(s) and then post-processing the result.
      // Note that we must ALWAYS check specially whether those values are MIN_VALUE
      // (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
      // a positive number, it overflows back into a negative).  Not handling this
      // case would often result in infinite recursion.
      //
      // Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the from*
      // methods on which they depend.

      /**
       * An indicator used to reliably determine if an object is a Long or not.
       * @type {boolean}
       * @const
       * @private
       */
      Long.prototype.__isLong__;

      Object.defineProperty(Long.prototype, "__isLong__", {
          value: true,
          enumerable: false,
          configurable: false
      });

      /**
       * @function
       * @param {*} obj Object
       * @returns {boolean}
       * @inner
       */
      function isLong(obj) {
          return (obj && obj["__isLong__"]) === true;
      }

      /**
       * Tests if the specified object is a Long.
       * @function
       * @param {*} obj Object
       * @returns {boolean}
       */
      Long.isLong = isLong;

      /**
       * A cache of the Long representations of small integer values.
       * @type {!Object}
       * @inner
       */
      var INT_CACHE = {};

      /**
       * A cache of the Long representations of small unsigned integer values.
       * @type {!Object}
       * @inner
       */
      var UINT_CACHE = {};

      /**
       * @param {number} value
       * @param {boolean=} unsigned
       * @returns {!Long}
       * @inner
       */
      function fromInt(value, unsigned) {
          var obj, cachedObj, cache;
          if (unsigned) {
              value >>>= 0;
              if (cache = (0 <= value && value < 256)) {
                  cachedObj = UINT_CACHE[value];
                  if (cachedObj)
                      return cachedObj;
              }
              obj = fromBits(value, (value | 0) < 0 ? -1 : 0, true);
              if (cache)
                  UINT_CACHE[value] = obj;
              return obj;
          } else {
              value |= 0;
              if (cache = (-128 <= value && value < 128)) {
                  cachedObj = INT_CACHE[value];
                  if (cachedObj)
                      return cachedObj;
              }
              obj = fromBits(value, value < 0 ? -1 : 0, false);
              if (cache)
                  INT_CACHE[value] = obj;
              return obj;
          }
      }

      /**
       * Returns a Long representing the given 32 bit integer value.
       * @function
       * @param {number} value The 32 bit integer in question
       * @param {boolean=} unsigned Whether unsigned or not, defaults to `false` for signed
       * @returns {!Long} The corresponding Long value
       */
      Long.fromInt = fromInt;

      /**
       * @param {number} value
       * @param {boolean=} unsigned
       * @returns {!Long}
       * @inner
       */
      function fromNumber(value, unsigned) {
          if (isNaN(value) || !isFinite(value))
              return unsigned ? UZERO : ZERO;
          if (unsigned) {
              if (value < 0)
                  return UZERO;
              if (value >= TWO_PWR_64_DBL)
                  return MAX_UNSIGNED_VALUE;
          } else {
              if (value <= -TWO_PWR_63_DBL)
                  return MIN_VALUE;
              if (value + 1 >= TWO_PWR_63_DBL)
                  return MAX_VALUE;
          }
          if (value < 0)
              return fromNumber(-value, unsigned).neg();
          return fromBits((value % TWO_PWR_32_DBL) | 0, (value / TWO_PWR_32_DBL) | 0, unsigned);
      }

      /**
       * Returns a Long representing the given value, provided that it is a finite number. Otherwise, zero is returned.
       * @function
       * @param {number} value The number in question
       * @param {boolean=} unsigned Whether unsigned or not, defaults to `false` for signed
       * @returns {!Long} The corresponding Long value
       */
      Long.fromNumber = fromNumber;

      /**
       * @param {number} lowBits
       * @param {number} highBits
       * @param {boolean=} unsigned
       * @returns {!Long}
       * @inner
       */
      function fromBits(lowBits, highBits, unsigned) {
          return new Long(lowBits, highBits, unsigned);
      }

      /**
       * Returns a Long representing the 64 bit integer that comes by concatenating the given low and high bits. Each is
       *  assumed to use 32 bits.
       * @function
       * @param {number} lowBits The low 32 bits
       * @param {number} highBits The high 32 bits
       * @param {boolean=} unsigned Whether unsigned or not, defaults to `false` for signed
       * @returns {!Long} The corresponding Long value
       */
      Long.fromBits = fromBits;

      /**
       * @function
       * @param {number} base
       * @param {number} exponent
       * @returns {number}
       * @inner
       */
      var pow_dbl = Math.pow; // Used 4 times (4*8 to 15+4)

      /**
       * @param {string} str
       * @param {(boolean|number)=} unsigned
       * @param {number=} radix
       * @returns {!Long}
       * @inner
       */
      function fromString(str, unsigned, radix) {
          if (str.length === 0)
              throw Error('empty string');
          if (str === "NaN" || str === "Infinity" || str === "+Infinity" || str === "-Infinity")
              return ZERO;
          if (typeof unsigned === 'number') {
              // For goog.math.long compatibility
              radix = unsigned,
              unsigned = false;
          } else {
              unsigned = !! unsigned;
          }
          radix = radix || 10;
          if (radix < 2 || 36 < radix)
              throw RangeError('radix');

          var p;
          if ((p = str.indexOf('-')) > 0)
              throw Error('interior hyphen');
          else if (p === 0) {
              return fromString(str.substring(1), unsigned, radix).neg();
          }

          // Do several (8) digits each time through the loop, so as to
          // minimize the calls to the very expensive emulated div.
          var radixToPower = fromNumber(pow_dbl(radix, 8));

          var result = ZERO;
          for (var i = 0; i < str.length; i += 8) {
              var size = Math.min(8, str.length - i),
                  value = parseInt(str.substring(i, i + size), radix);
              if (size < 8) {
                  var power = fromNumber(pow_dbl(radix, size));
                  result = result.mul(power).add(fromNumber(value));
              } else {
                  result = result.mul(radixToPower);
                  result = result.add(fromNumber(value));
              }
          }
          result.unsigned = unsigned;
          return result;
      }

      /**
       * Returns a Long representation of the given string, written using the specified radix.
       * @function
       * @param {string} str The textual representation of the Long
       * @param {(boolean|number)=} unsigned Whether unsigned or not, defaults to `false` for signed
       * @param {number=} radix The radix in which the text is written (2-36), defaults to 10
       * @returns {!Long} The corresponding Long value
       */
      Long.fromString = fromString;

      /**
       * @function
       * @param {!Long|number|string|!{low: number, high: number, unsigned: boolean}} val
       * @returns {!Long}
       * @inner
       */
      function fromValue(val) {
          if (val /* is compatible */ instanceof Long)
              return val;
          if (typeof val === 'number')
              return fromNumber(val);
          if (typeof val === 'string')
              return fromString(val);
          // Throws for non-objects, converts non-instanceof Long:
          return fromBits(val.low, val.high, val.unsigned);
      }

      /**
       * Converts the specified value to a Long.
       * @function
       * @param {!Long|number|string|!{low: number, high: number, unsigned: boolean}} val Value
       * @returns {!Long}
       */
      Long.fromValue = fromValue;

      // NOTE: the compiler should inline these constant values below and then remove these variables, so there should be
      // no runtime penalty for these.

      /**
       * @type {number}
       * @const
       * @inner
       */
      var TWO_PWR_16_DBL = 1 << 16;

      /**
       * @type {number}
       * @const
       * @inner
       */
      var TWO_PWR_24_DBL = 1 << 24;

      /**
       * @type {number}
       * @const
       * @inner
       */
      var TWO_PWR_32_DBL = TWO_PWR_16_DBL * TWO_PWR_16_DBL;

      /**
       * @type {number}
       * @const
       * @inner
       */
      var TWO_PWR_64_DBL = TWO_PWR_32_DBL * TWO_PWR_32_DBL;

      /**
       * @type {number}
       * @const
       * @inner
       */
      var TWO_PWR_63_DBL = TWO_PWR_64_DBL / 2;

      /**
       * @type {!Long}
       * @const
       * @inner
       */
      var TWO_PWR_24 = fromInt(TWO_PWR_24_DBL);

      /**
       * @type {!Long}
       * @inner
       */
      var ZERO = fromInt(0);

      /**
       * Signed zero.
       * @type {!Long}
       */
      Long.ZERO = ZERO;

      /**
       * @type {!Long}
       * @inner
       */
      var UZERO = fromInt(0, true);

      /**
       * Unsigned zero.
       * @type {!Long}
       */
      Long.UZERO = UZERO;

      /**
       * @type {!Long}
       * @inner
       */
      var ONE = fromInt(1);

      /**
       * Signed one.
       * @type {!Long}
       */
      Long.ONE = ONE;

      /**
       * @type {!Long}
       * @inner
       */
      var UONE = fromInt(1, true);

      /**
       * Unsigned one.
       * @type {!Long}
       */
      Long.UONE = UONE;

      /**
       * @type {!Long}
       * @inner
       */
      var NEG_ONE = fromInt(-1);

      /**
       * Signed negative one.
       * @type {!Long}
       */
      Long.NEG_ONE = NEG_ONE;

      /**
       * @type {!Long}
       * @inner
       */
      var MAX_VALUE = fromBits(0xFFFFFFFF|0, 0x7FFFFFFF|0, false);

      /**
       * Maximum signed value.
       * @type {!Long}
       */
      Long.MAX_VALUE = MAX_VALUE;

      /**
       * @type {!Long}
       * @inner
       */
      var MAX_UNSIGNED_VALUE = fromBits(0xFFFFFFFF|0, 0xFFFFFFFF|0, true);

      /**
       * Maximum unsigned value.
       * @type {!Long}
       */
      Long.MAX_UNSIGNED_VALUE = MAX_UNSIGNED_VALUE;

      /**
       * @type {!Long}
       * @inner
       */
      var MIN_VALUE = fromBits(0, 0x80000000|0, false);

      /**
       * Minimum signed value.
       * @type {!Long}
       */
      Long.MIN_VALUE = MIN_VALUE;

      /**
       * @alias Long.prototype
       * @inner
       */
      var LongPrototype = Long.prototype;

      /**
       * Converts the Long to a 32 bit integer, assuming it is a 32 bit integer.
       * @returns {number}
       */
      LongPrototype.toInt = function toInt() {
          return this.unsigned ? this.low >>> 0 : this.low;
      };

      /**
       * Converts the Long to a the nearest floating-point representation of this value (double, 53 bit mantissa).
       * @returns {number}
       */
      LongPrototype.toNumber = function toNumber() {
          if (this.unsigned)
              return ((this.high >>> 0) * TWO_PWR_32_DBL) + (this.low >>> 0);
          return this.high * TWO_PWR_32_DBL + (this.low >>> 0);
      };

      /**
       * Converts the Long to a string written in the specified radix.
       * @param {number=} radix Radix (2-36), defaults to 10
       * @returns {string}
       * @override
       * @throws {RangeError} If `radix` is out of range
       */
      LongPrototype.toString = function toString(radix) {
          radix = radix || 10;
          if (radix < 2 || 36 < radix)
              throw RangeError('radix');
          if (this.isZero())
              return '0';
          if (this.isNegative()) { // Unsigned Longs are never negative
              if (this.eq(MIN_VALUE)) {
                  // We need to change the Long value before it can be negated, so we remove
                  // the bottom-most digit in this base and then recurse to do the rest.
                  var radixLong = fromNumber(radix),
                      div = this.div(radixLong),
                      rem1 = div.mul(radixLong).sub(this);
                  return div.toString(radix) + rem1.toInt().toString(radix);
              } else
                  return '-' + this.neg().toString(radix);
          }

          // Do several (6) digits each time through the loop, so as to
          // minimize the calls to the very expensive emulated div.
          var radixToPower = fromNumber(pow_dbl(radix, 6), this.unsigned),
              rem = this;
          var result = '';
          while (true) {
              var remDiv = rem.div(radixToPower),
                  intval = rem.sub(remDiv.mul(radixToPower)).toInt() >>> 0,
                  digits = intval.toString(radix);
              rem = remDiv;
              if (rem.isZero())
                  return digits + result;
              else {
                  while (digits.length < 6)
                      digits = '0' + digits;
                  result = '' + digits + result;
              }
          }
      };

      /**
       * Gets the high 32 bits as a signed integer.
       * @returns {number} Signed high bits
       */
      LongPrototype.getHighBits = function getHighBits() {
          return this.high;
      };

      /**
       * Gets the high 32 bits as an unsigned integer.
       * @returns {number} Unsigned high bits
       */
      LongPrototype.getHighBitsUnsigned = function getHighBitsUnsigned() {
          return this.high >>> 0;
      };

      /**
       * Gets the low 32 bits as a signed integer.
       * @returns {number} Signed low bits
       */
      LongPrototype.getLowBits = function getLowBits() {
          return this.low;
      };

      /**
       * Gets the low 32 bits as an unsigned integer.
       * @returns {number} Unsigned low bits
       */
      LongPrototype.getLowBitsUnsigned = function getLowBitsUnsigned() {
          return this.low >>> 0;
      };

      /**
       * Gets the number of bits needed to represent the absolute value of this Long.
       * @returns {number}
       */
      LongPrototype.getNumBitsAbs = function getNumBitsAbs() {
          if (this.isNegative()) // Unsigned Longs are never negative
              return this.eq(MIN_VALUE) ? 64 : this.neg().getNumBitsAbs();
          var val = this.high != 0 ? this.high : this.low;
          for (var bit = 31; bit > 0; bit--)
              if ((val & (1 << bit)) != 0)
                  break;
          return this.high != 0 ? bit + 33 : bit + 1;
      };

      /**
       * Tests if this Long's value equals zero.
       * @returns {boolean}
       */
      LongPrototype.isZero = function isZero() {
          return this.high === 0 && this.low === 0;
      };

      /**
       * Tests if this Long's value is negative.
       * @returns {boolean}
       */
      LongPrototype.isNegative = function isNegative() {
          return !this.unsigned && this.high < 0;
      };

      /**
       * Tests if this Long's value is positive.
       * @returns {boolean}
       */
      LongPrototype.isPositive = function isPositive() {
          return this.unsigned || this.high >= 0;
      };

      /**
       * Tests if this Long's value is odd.
       * @returns {boolean}
       */
      LongPrototype.isOdd = function isOdd() {
          return (this.low & 1) === 1;
      };

      /**
       * Tests if this Long's value is even.
       * @returns {boolean}
       */
      LongPrototype.isEven = function isEven() {
          return (this.low & 1) === 0;
      };

      /**
       * Tests if this Long's value equals the specified's.
       * @param {!Long|number|string} other Other value
       * @returns {boolean}
       */
      LongPrototype.equals = function equals(other) {
          if (!isLong(other))
              other = fromValue(other);
          if (this.unsigned !== other.unsigned && (this.high >>> 31) === 1 && (other.high >>> 31) === 1)
              return false;
          return this.high === other.high && this.low === other.low;
      };

      /**
       * Tests if this Long's value equals the specified's. This is an alias of {@link Long#equals}.
       * @function
       * @param {!Long|number|string} other Other value
       * @returns {boolean}
       */
      LongPrototype.eq = LongPrototype.equals;

      /**
       * Tests if this Long's value differs from the specified's.
       * @param {!Long|number|string} other Other value
       * @returns {boolean}
       */
      LongPrototype.notEquals = function notEquals(other) {
          return !this.eq(/* validates */ other);
      };

      /**
       * Tests if this Long's value differs from the specified's. This is an alias of {@link Long#notEquals}.
       * @function
       * @param {!Long|number|string} other Other value
       * @returns {boolean}
       */
      LongPrototype.neq = LongPrototype.notEquals;

      /**
       * Tests if this Long's value is less than the specified's.
       * @param {!Long|number|string} other Other value
       * @returns {boolean}
       */
      LongPrototype.lessThan = function lessThan(other) {
          return this.comp(/* validates */ other) < 0;
      };

      /**
       * Tests if this Long's value is less than the specified's. This is an alias of {@link Long#lessThan}.
       * @function
       * @param {!Long|number|string} other Other value
       * @returns {boolean}
       */
      LongPrototype.lt = LongPrototype.lessThan;

      /**
       * Tests if this Long's value is less than or equal the specified's.
       * @param {!Long|number|string} other Other value
       * @returns {boolean}
       */
      LongPrototype.lessThanOrEqual = function lessThanOrEqual(other) {
          return this.comp(/* validates */ other) <= 0;
      };

      /**
       * Tests if this Long's value is less than or equal the specified's. This is an alias of {@link Long#lessThanOrEqual}.
       * @function
       * @param {!Long|number|string} other Other value
       * @returns {boolean}
       */
      LongPrototype.lte = LongPrototype.lessThanOrEqual;

      /**
       * Tests if this Long's value is greater than the specified's.
       * @param {!Long|number|string} other Other value
       * @returns {boolean}
       */
      LongPrototype.greaterThan = function greaterThan(other) {
          return this.comp(/* validates */ other) > 0;
      };

      /**
       * Tests if this Long's value is greater than the specified's. This is an alias of {@link Long#greaterThan}.
       * @function
       * @param {!Long|number|string} other Other value
       * @returns {boolean}
       */
      LongPrototype.gt = LongPrototype.greaterThan;

      /**
       * Tests if this Long's value is greater than or equal the specified's.
       * @param {!Long|number|string} other Other value
       * @returns {boolean}
       */
      LongPrototype.greaterThanOrEqual = function greaterThanOrEqual(other) {
          return this.comp(/* validates */ other) >= 0;
      };

      /**
       * Tests if this Long's value is greater than or equal the specified's. This is an alias of {@link Long#greaterThanOrEqual}.
       * @function
       * @param {!Long|number|string} other Other value
       * @returns {boolean}
       */
      LongPrototype.gte = LongPrototype.greaterThanOrEqual;

      /**
       * Compares this Long's value with the specified's.
       * @param {!Long|number|string} other Other value
       * @returns {number} 0 if they are the same, 1 if the this is greater and -1
       *  if the given one is greater
       */
      LongPrototype.compare = function compare(other) {
          if (!isLong(other))
              other = fromValue(other);
          if (this.eq(other))
              return 0;
          var thisNeg = this.isNegative(),
              otherNeg = other.isNegative();
          if (thisNeg && !otherNeg)
              return -1;
          if (!thisNeg && otherNeg)
              return 1;
          // At this point the sign bits are the same
          if (!this.unsigned)
              return this.sub(other).isNegative() ? -1 : 1;
          // Both are positive if at least one is unsigned
          return (other.high >>> 0) > (this.high >>> 0) || (other.high === this.high && (other.low >>> 0) > (this.low >>> 0)) ? -1 : 1;
      };

      /**
       * Compares this Long's value with the specified's. This is an alias of {@link Long#compare}.
       * @function
       * @param {!Long|number|string} other Other value
       * @returns {number} 0 if they are the same, 1 if the this is greater and -1
       *  if the given one is greater
       */
      LongPrototype.comp = LongPrototype.compare;

      /**
       * Negates this Long's value.
       * @returns {!Long} Negated Long
       */
      LongPrototype.negate = function negate() {
          if (!this.unsigned && this.eq(MIN_VALUE))
              return MIN_VALUE;
          return this.not().add(ONE);
      };

      /**
       * Negates this Long's value. This is an alias of {@link Long#negate}.
       * @function
       * @returns {!Long} Negated Long
       */
      LongPrototype.neg = LongPrototype.negate;

      /**
       * Returns the sum of this and the specified Long.
       * @param {!Long|number|string} addend Addend
       * @returns {!Long} Sum
       */
      LongPrototype.add = function add(addend) {
          if (!isLong(addend))
              addend = fromValue(addend);

          // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

          var a48 = this.high >>> 16;
          var a32 = this.high & 0xFFFF;
          var a16 = this.low >>> 16;
          var a00 = this.low & 0xFFFF;

          var b48 = addend.high >>> 16;
          var b32 = addend.high & 0xFFFF;
          var b16 = addend.low >>> 16;
          var b00 = addend.low & 0xFFFF;

          var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
          c00 += a00 + b00;
          c16 += c00 >>> 16;
          c00 &= 0xFFFF;
          c16 += a16 + b16;
          c32 += c16 >>> 16;
          c16 &= 0xFFFF;
          c32 += a32 + b32;
          c48 += c32 >>> 16;
          c32 &= 0xFFFF;
          c48 += a48 + b48;
          c48 &= 0xFFFF;
          return fromBits((c16 << 16) | c00, (c48 << 16) | c32, this.unsigned);
      };

      /**
       * Returns the difference of this and the specified Long.
       * @param {!Long|number|string} subtrahend Subtrahend
       * @returns {!Long} Difference
       */
      LongPrototype.subtract = function subtract(subtrahend) {
          if (!isLong(subtrahend))
              subtrahend = fromValue(subtrahend);
          return this.add(subtrahend.neg());
      };

      /**
       * Returns the difference of this and the specified Long. This is an alias of {@link Long#subtract}.
       * @function
       * @param {!Long|number|string} subtrahend Subtrahend
       * @returns {!Long} Difference
       */
      LongPrototype.sub = LongPrototype.subtract;

      /**
       * Returns the product of this and the specified Long.
       * @param {!Long|number|string} multiplier Multiplier
       * @returns {!Long} Product
       */
      LongPrototype.multiply = function multiply(multiplier) {
          if (this.isZero())
              return ZERO;
          if (!isLong(multiplier))
              multiplier = fromValue(multiplier);
          if (multiplier.isZero())
              return ZERO;
          if (this.eq(MIN_VALUE))
              return multiplier.isOdd() ? MIN_VALUE : ZERO;
          if (multiplier.eq(MIN_VALUE))
              return this.isOdd() ? MIN_VALUE : ZERO;

          if (this.isNegative()) {
              if (multiplier.isNegative())
                  return this.neg().mul(multiplier.neg());
              else
                  return this.neg().mul(multiplier).neg();
          } else if (multiplier.isNegative())
              return this.mul(multiplier.neg()).neg();

          // If both longs are small, use float multiplication
          if (this.lt(TWO_PWR_24) && multiplier.lt(TWO_PWR_24))
              return fromNumber(this.toNumber() * multiplier.toNumber(), this.unsigned);

          // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
          // We can skip products that would overflow.

          var a48 = this.high >>> 16;
          var a32 = this.high & 0xFFFF;
          var a16 = this.low >>> 16;
          var a00 = this.low & 0xFFFF;

          var b48 = multiplier.high >>> 16;
          var b32 = multiplier.high & 0xFFFF;
          var b16 = multiplier.low >>> 16;
          var b00 = multiplier.low & 0xFFFF;

          var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
          c00 += a00 * b00;
          c16 += c00 >>> 16;
          c00 &= 0xFFFF;
          c16 += a16 * b00;
          c32 += c16 >>> 16;
          c16 &= 0xFFFF;
          c16 += a00 * b16;
          c32 += c16 >>> 16;
          c16 &= 0xFFFF;
          c32 += a32 * b00;
          c48 += c32 >>> 16;
          c32 &= 0xFFFF;
          c32 += a16 * b16;
          c48 += c32 >>> 16;
          c32 &= 0xFFFF;
          c32 += a00 * b32;
          c48 += c32 >>> 16;
          c32 &= 0xFFFF;
          c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
          c48 &= 0xFFFF;
          return fromBits((c16 << 16) | c00, (c48 << 16) | c32, this.unsigned);
      };

      /**
       * Returns the product of this and the specified Long. This is an alias of {@link Long#multiply}.
       * @function
       * @param {!Long|number|string} multiplier Multiplier
       * @returns {!Long} Product
       */
      LongPrototype.mul = LongPrototype.multiply;

      /**
       * Returns this Long divided by the specified. The result is signed if this Long is signed or
       *  unsigned if this Long is unsigned.
       * @param {!Long|number|string} divisor Divisor
       * @returns {!Long} Quotient
       */
      LongPrototype.divide = function divide(divisor) {
          if (!isLong(divisor))
              divisor = fromValue(divisor);
          if (divisor.isZero())
              throw Error('division by zero');
          if (this.isZero())
              return this.unsigned ? UZERO : ZERO;
          var approx, rem, res;
          if (!this.unsigned) {
              // This section is only relevant for signed longs and is derived from the
              // closure library as a whole.
              if (this.eq(MIN_VALUE)) {
                  if (divisor.eq(ONE) || divisor.eq(NEG_ONE))
                      return MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
                  else if (divisor.eq(MIN_VALUE))
                      return ONE;
                  else {
                      // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
                      var halfThis = this.shr(1);
                      approx = halfThis.div(divisor).shl(1);
                      if (approx.eq(ZERO)) {
                          return divisor.isNegative() ? ONE : NEG_ONE;
                      } else {
                          rem = this.sub(divisor.mul(approx));
                          res = approx.add(rem.div(divisor));
                          return res;
                      }
                  }
              } else if (divisor.eq(MIN_VALUE))
                  return this.unsigned ? UZERO : ZERO;
              if (this.isNegative()) {
                  if (divisor.isNegative())
                      return this.neg().div(divisor.neg());
                  return this.neg().div(divisor).neg();
              } else if (divisor.isNegative())
                  return this.div(divisor.neg()).neg();
              res = ZERO;
          } else {
              // The algorithm below has not been made for unsigned longs. It's therefore
              // required to take special care of the MSB prior to running it.
              if (!divisor.unsigned)
                  divisor = divisor.toUnsigned();
              if (divisor.gt(this))
                  return UZERO;
              if (divisor.gt(this.shru(1))) // 15 >>> 1 = 7 ; with divisor = 8 ; true
                  return UONE;
              res = UZERO;
          }

          // Repeat the following until the remainder is less than other:  find a
          // floating-point that approximates remainder / other *from below*, add this
          // into the result, and subtract it from the remainder.  It is critical that
          // the approximate value is less than or equal to the real value so that the
          // remainder never becomes negative.
          rem = this;
          while (rem.gte(divisor)) {
              // Approximate the result of division. This may be a little greater or
              // smaller than the actual value.
              approx = Math.max(1, Math.floor(rem.toNumber() / divisor.toNumber()));

              // We will tweak the approximate result by changing it in the 48-th digit or
              // the smallest non-fractional digit, whichever is larger.
              var log2 = Math.ceil(Math.log(approx) / Math.LN2),
                  delta = (log2 <= 48) ? 1 : pow_dbl(2, log2 - 48),

              // Decrease the approximation until it is smaller than the remainder.  Note
              // that if it is too large, the product overflows and is negative.
                  approxRes = fromNumber(approx),
                  approxRem = approxRes.mul(divisor);
              while (approxRem.isNegative() || approxRem.gt(rem)) {
                  approx -= delta;
                  approxRes = fromNumber(approx, this.unsigned);
                  approxRem = approxRes.mul(divisor);
              }

              // We know the answer can't be zero... and actually, zero would cause
              // infinite recursion since we would make no progress.
              if (approxRes.isZero())
                  approxRes = ONE;

              res = res.add(approxRes);
              rem = rem.sub(approxRem);
          }
          return res;
      };

      /**
       * Returns this Long divided by the specified. This is an alias of {@link Long#divide}.
       * @function
       * @param {!Long|number|string} divisor Divisor
       * @returns {!Long} Quotient
       */
      LongPrototype.div = LongPrototype.divide;

      /**
       * Returns this Long modulo the specified.
       * @param {!Long|number|string} divisor Divisor
       * @returns {!Long} Remainder
       */
      LongPrototype.modulo = function modulo(divisor) {
          if (!isLong(divisor))
              divisor = fromValue(divisor);
          return this.sub(this.div(divisor).mul(divisor));
      };

      /**
       * Returns this Long modulo the specified. This is an alias of {@link Long#modulo}.
       * @function
       * @param {!Long|number|string} divisor Divisor
       * @returns {!Long} Remainder
       */
      LongPrototype.mod = LongPrototype.modulo;

      /**
       * Returns the bitwise NOT of this Long.
       * @returns {!Long}
       */
      LongPrototype.not = function not() {
          return fromBits(~this.low, ~this.high, this.unsigned);
      };

      /**
       * Returns the bitwise AND of this Long and the specified.
       * @param {!Long|number|string} other Other Long
       * @returns {!Long}
       */
      LongPrototype.and = function and(other) {
          if (!isLong(other))
              other = fromValue(other);
          return fromBits(this.low & other.low, this.high & other.high, this.unsigned);
      };

      /**
       * Returns the bitwise OR of this Long and the specified.
       * @param {!Long|number|string} other Other Long
       * @returns {!Long}
       */
      LongPrototype.or = function or(other) {
          if (!isLong(other))
              other = fromValue(other);
          return fromBits(this.low | other.low, this.high | other.high, this.unsigned);
      };

      /**
       * Returns the bitwise XOR of this Long and the given one.
       * @param {!Long|number|string} other Other Long
       * @returns {!Long}
       */
      LongPrototype.xor = function xor(other) {
          if (!isLong(other))
              other = fromValue(other);
          return fromBits(this.low ^ other.low, this.high ^ other.high, this.unsigned);
      };

      /**
       * Returns this Long with bits shifted to the left by the given amount.
       * @param {number|!Long} numBits Number of bits
       * @returns {!Long} Shifted Long
       */
      LongPrototype.shiftLeft = function shiftLeft(numBits) {
          if (isLong(numBits))
              numBits = numBits.toInt();
          if ((numBits &= 63) === 0)
              return this;
          else if (numBits < 32)
              return fromBits(this.low << numBits, (this.high << numBits) | (this.low >>> (32 - numBits)), this.unsigned);
          else
              return fromBits(0, this.low << (numBits - 32), this.unsigned);
      };

      /**
       * Returns this Long with bits shifted to the left by the given amount. This is an alias of {@link Long#shiftLeft}.
       * @function
       * @param {number|!Long} numBits Number of bits
       * @returns {!Long} Shifted Long
       */
      LongPrototype.shl = LongPrototype.shiftLeft;

      /**
       * Returns this Long with bits arithmetically shifted to the right by the given amount.
       * @param {number|!Long} numBits Number of bits
       * @returns {!Long} Shifted Long
       */
      LongPrototype.shiftRight = function shiftRight(numBits) {
          if (isLong(numBits))
              numBits = numBits.toInt();
          if ((numBits &= 63) === 0)
              return this;
          else if (numBits < 32)
              return fromBits((this.low >>> numBits) | (this.high << (32 - numBits)), this.high >> numBits, this.unsigned);
          else
              return fromBits(this.high >> (numBits - 32), this.high >= 0 ? 0 : -1, this.unsigned);
      };

      /**
       * Returns this Long with bits arithmetically shifted to the right by the given amount. This is an alias of {@link Long#shiftRight}.
       * @function
       * @param {number|!Long} numBits Number of bits
       * @returns {!Long} Shifted Long
       */
      LongPrototype.shr = LongPrototype.shiftRight;

      /**
       * Returns this Long with bits logically shifted to the right by the given amount.
       * @param {number|!Long} numBits Number of bits
       * @returns {!Long} Shifted Long
       */
      LongPrototype.shiftRightUnsigned = function shiftRightUnsigned(numBits) {
          if (isLong(numBits))
              numBits = numBits.toInt();
          numBits &= 63;
          if (numBits === 0)
              return this;
          else {
              var high = this.high;
              if (numBits < 32) {
                  var low = this.low;
                  return fromBits((low >>> numBits) | (high << (32 - numBits)), high >>> numBits, this.unsigned);
              } else if (numBits === 32)
                  return fromBits(high, 0, this.unsigned);
              else
                  return fromBits(high >>> (numBits - 32), 0, this.unsigned);
          }
      };

      /**
       * Returns this Long with bits logically shifted to the right by the given amount. This is an alias of {@link Long#shiftRightUnsigned}.
       * @function
       * @param {number|!Long} numBits Number of bits
       * @returns {!Long} Shifted Long
       */
      LongPrototype.shru = LongPrototype.shiftRightUnsigned;

      /**
       * Converts this Long to signed.
       * @returns {!Long} Signed long
       */
      LongPrototype.toSigned = function toSigned() {
          if (!this.unsigned)
              return this;
          return fromBits(this.low, this.high, false);
      };

      /**
       * Converts this Long to unsigned.
       * @returns {!Long} Unsigned long
       */
      LongPrototype.toUnsigned = function toUnsigned() {
          if (this.unsigned)
              return this;
          return fromBits(this.low, this.high, true);
      };

      /**
       * Converts this Long to its byte representation.
       * @param {boolean=} le Whether little or big endian, defaults to big endian
       * @returns {!Array.<number>} Byte representation
       */
      LongPrototype.toBytes = function(le) {
          return le ? this.toBytesLE() : this.toBytesBE();
      };

      /**
       * Converts this Long to its little endian byte representation.
       * @returns {!Array.<number>} Little endian byte representation
       */
      LongPrototype.toBytesLE = function() {
          var hi = this.high,
              lo = this.low;
          return [
               lo         & 0xff,
              (lo >>>  8) & 0xff,
              (lo >>> 16) & 0xff,
              (lo >>> 24) & 0xff,
               hi         & 0xff,
              (hi >>>  8) & 0xff,
              (hi >>> 16) & 0xff,
              (hi >>> 24) & 0xff
          ];
      };

      /**
       * Converts this Long to its big endian byte representation.
       * @returns {!Array.<number>} Big endian byte representation
       */
      LongPrototype.toBytesBE = function() {
          var hi = this.high,
              lo = this.low;
          return [
              (hi >>> 24) & 0xff,
              (hi >>> 16) & 0xff,
              (hi >>>  8) & 0xff,
               hi         & 0xff,
              (lo >>> 24) & 0xff,
              (lo >>> 16) & 0xff,
              (lo >>>  8) & 0xff,
               lo         & 0xff
          ];
      };

      return Long;
  });
  });

  var bytebuffer = createCommonjsModule(function (module) {
  /*
   Copyright 2013-2014 Daniel Wirtz <dcode@dcode.io>

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
   */

  /**
   * @license bytebuffer.js (c) 2015 Daniel Wirtz <dcode@dcode.io>
   * Backing buffer: ArrayBuffer, Accessor: Uint8Array
   * Released under the Apache License, Version 2.0
   * see: https://github.com/dcodeIO/bytebuffer.js for details
   */
  (function(global, factory) {

      /* AMD */ if (typeof commonjsRequire === 'function' && 'object' === "object" && module && module["exports"])
          module['exports'] = (function() {
              var Long; try { Long = long_1; } catch (e) {}
              return factory(Long);
          })();
      /* Global */ else
          (global["dcodeIO"] = global["dcodeIO"] || {})["ByteBuffer"] = factory(global["dcodeIO"]["Long"]);

  })(commonjsGlobal, function(Long) {

      /**
       * Constructs a new ByteBuffer.
       * @class The swiss army knife for binary data in JavaScript.
       * @exports ByteBuffer
       * @constructor
       * @param {number=} capacity Initial capacity. Defaults to {@link ByteBuffer.DEFAULT_CAPACITY}.
       * @param {boolean=} littleEndian Whether to use little or big endian byte order. Defaults to
       *  {@link ByteBuffer.DEFAULT_ENDIAN}.
       * @param {boolean=} noAssert Whether to skip assertions of offsets and values. Defaults to
       *  {@link ByteBuffer.DEFAULT_NOASSERT}.
       * @expose
       */
      var ByteBuffer = function(capacity, littleEndian, noAssert) {
          if (typeof capacity === 'undefined')
              capacity = ByteBuffer.DEFAULT_CAPACITY;
          if (typeof littleEndian === 'undefined')
              littleEndian = ByteBuffer.DEFAULT_ENDIAN;
          if (typeof noAssert === 'undefined')
              noAssert = ByteBuffer.DEFAULT_NOASSERT;
          if (!noAssert) {
              capacity = capacity | 0;
              if (capacity < 0)
                  throw RangeError("Illegal capacity");
              littleEndian = !!littleEndian;
              noAssert = !!noAssert;
          }

          /**
           * Backing ArrayBuffer.
           * @type {!ArrayBuffer}
           * @expose
           */
          this.buffer = capacity === 0 ? EMPTY_BUFFER : new ArrayBuffer(capacity);

          /**
           * Uint8Array utilized to manipulate the backing buffer. Becomes `null` if the backing buffer has a capacity of `0`.
           * @type {?Uint8Array}
           * @expose
           */
          this.view = capacity === 0 ? null : new Uint8Array(this.buffer);

          /**
           * Absolute read/write offset.
           * @type {number}
           * @expose
           * @see ByteBuffer#flip
           * @see ByteBuffer#clear
           */
          this.offset = 0;

          /**
           * Marked offset.
           * @type {number}
           * @expose
           * @see ByteBuffer#mark
           * @see ByteBuffer#reset
           */
          this.markedOffset = -1;

          /**
           * Absolute limit of the contained data. Set to the backing buffer's capacity upon allocation.
           * @type {number}
           * @expose
           * @see ByteBuffer#flip
           * @see ByteBuffer#clear
           */
          this.limit = capacity;

          /**
           * Whether to use little endian byte order, defaults to `false` for big endian.
           * @type {boolean}
           * @expose
           */
          this.littleEndian = littleEndian;

          /**
           * Whether to skip assertions of offsets and values, defaults to `false`.
           * @type {boolean}
           * @expose
           */
          this.noAssert = noAssert;
      };

      /**
       * ByteBuffer version.
       * @type {string}
       * @const
       * @expose
       */
      ByteBuffer.VERSION = "5.0.1";

      /**
       * Little endian constant that can be used instead of its boolean value. Evaluates to `true`.
       * @type {boolean}
       * @const
       * @expose
       */
      ByteBuffer.LITTLE_ENDIAN = true;

      /**
       * Big endian constant that can be used instead of its boolean value. Evaluates to `false`.
       * @type {boolean}
       * @const
       * @expose
       */
      ByteBuffer.BIG_ENDIAN = false;

      /**
       * Default initial capacity of `16`.
       * @type {number}
       * @expose
       */
      ByteBuffer.DEFAULT_CAPACITY = 16;

      /**
       * Default endianess of `false` for big endian.
       * @type {boolean}
       * @expose
       */
      ByteBuffer.DEFAULT_ENDIAN = ByteBuffer.BIG_ENDIAN;

      /**
       * Default no assertions flag of `false`.
       * @type {boolean}
       * @expose
       */
      ByteBuffer.DEFAULT_NOASSERT = false;

      /**
       * A `Long` class for representing a 64-bit two's-complement integer value. May be `null` if Long.js has not been loaded
       *  and int64 support is not available.
       * @type {?Long}
       * @const
       * @see https://github.com/dcodeIO/long.js
       * @expose
       */
      ByteBuffer.Long = Long || null;

      /**
       * @alias ByteBuffer.prototype
       * @inner
       */
      var ByteBufferPrototype = ByteBuffer.prototype;

      /**
       * An indicator used to reliably determine if an object is a ByteBuffer or not.
       * @type {boolean}
       * @const
       * @expose
       * @private
       */
      ByteBufferPrototype.__isByteBuffer__;

      Object.defineProperty(ByteBufferPrototype, "__isByteBuffer__", {
          value: true,
          enumerable: false,
          configurable: false
      });

      // helpers

      /**
       * @type {!ArrayBuffer}
       * @inner
       */
      var EMPTY_BUFFER = new ArrayBuffer(0);

      /**
       * String.fromCharCode reference for compile-time renaming.
       * @type {function(...number):string}
       * @inner
       */
      var stringFromCharCode = String.fromCharCode;

      /**
       * Creates a source function for a string.
       * @param {string} s String to read from
       * @returns {function():number|null} Source function returning the next char code respectively `null` if there are
       *  no more characters left.
       * @throws {TypeError} If the argument is invalid
       * @inner
       */
      function stringSource(s) {
          var i=0; return function() {
              return i < s.length ? s.charCodeAt(i++) : null;
          };
      }

      /**
       * Creates a destination function for a string.
       * @returns {function(number=):undefined|string} Destination function successively called with the next char code.
       *  Returns the final string when called without arguments.
       * @inner
       */
      function stringDestination() {
          var cs = [], ps = []; return function() {
              if (arguments.length === 0)
                  return ps.join('')+stringFromCharCode.apply(String, cs);
              if (cs.length + arguments.length > 1024)
                  ps.push(stringFromCharCode.apply(String, cs)),
                      cs.length = 0;
              Array.prototype.push.apply(cs, arguments);
          };
      }

      /**
       * Gets the accessor type.
       * @returns {Function} `Buffer` under node.js, `Uint8Array` respectively `DataView` in the browser (classes)
       * @expose
       */
      ByteBuffer.accessor = function() {
          return Uint8Array;
      };
      /**
       * Allocates a new ByteBuffer backed by a buffer of the specified capacity.
       * @param {number=} capacity Initial capacity. Defaults to {@link ByteBuffer.DEFAULT_CAPACITY}.
       * @param {boolean=} littleEndian Whether to use little or big endian byte order. Defaults to
       *  {@link ByteBuffer.DEFAULT_ENDIAN}.
       * @param {boolean=} noAssert Whether to skip assertions of offsets and values. Defaults to
       *  {@link ByteBuffer.DEFAULT_NOASSERT}.
       * @returns {!ByteBuffer}
       * @expose
       */
      ByteBuffer.allocate = function(capacity, littleEndian, noAssert) {
          return new ByteBuffer(capacity, littleEndian, noAssert);
      };

      /**
       * Concatenates multiple ByteBuffers into one.
       * @param {!Array.<!ByteBuffer|!ArrayBuffer|!Uint8Array|string>} buffers Buffers to concatenate
       * @param {(string|boolean)=} encoding String encoding if `buffers` contains a string ("base64", "hex", "binary",
       *  defaults to "utf8")
       * @param {boolean=} littleEndian Whether to use little or big endian byte order for the resulting ByteBuffer. Defaults
       *  to {@link ByteBuffer.DEFAULT_ENDIAN}.
       * @param {boolean=} noAssert Whether to skip assertions of offsets and values for the resulting ByteBuffer. Defaults to
       *  {@link ByteBuffer.DEFAULT_NOASSERT}.
       * @returns {!ByteBuffer} Concatenated ByteBuffer
       * @expose
       */
      ByteBuffer.concat = function(buffers, encoding, littleEndian, noAssert) {
          if (typeof encoding === 'boolean' || typeof encoding !== 'string') {
              noAssert = littleEndian;
              littleEndian = encoding;
              encoding = undefined;
          }
          var capacity = 0;
          for (var i=0, k=buffers.length, length; i<k; ++i) {
              if (!ByteBuffer.isByteBuffer(buffers[i]))
                  buffers[i] = ByteBuffer.wrap(buffers[i], encoding);
              length = buffers[i].limit - buffers[i].offset;
              if (length > 0) capacity += length;
          }
          if (capacity === 0)
              return new ByteBuffer(0, littleEndian, noAssert);
          var bb = new ByteBuffer(capacity, littleEndian, noAssert),
              bi;
          i=0; while (i<k) {
              bi = buffers[i++];
              length = bi.limit - bi.offset;
              if (length <= 0) continue;
              bb.view.set(bi.view.subarray(bi.offset, bi.limit), bb.offset);
              bb.offset += length;
          }
          bb.limit = bb.offset;
          bb.offset = 0;
          return bb;
      };

      /**
       * Tests if the specified type is a ByteBuffer.
       * @param {*} bb ByteBuffer to test
       * @returns {boolean} `true` if it is a ByteBuffer, otherwise `false`
       * @expose
       */
      ByteBuffer.isByteBuffer = function(bb) {
          return (bb && bb["__isByteBuffer__"]) === true;
      };
      /**
       * Gets the backing buffer type.
       * @returns {Function} `Buffer` under node.js, `ArrayBuffer` in the browser (classes)
       * @expose
       */
      ByteBuffer.type = function() {
          return ArrayBuffer;
      };
      /**
       * Wraps a buffer or a string. Sets the allocated ByteBuffer's {@link ByteBuffer#offset} to `0` and its
       *  {@link ByteBuffer#limit} to the length of the wrapped data.
       * @param {!ByteBuffer|!ArrayBuffer|!Uint8Array|string|!Array.<number>} buffer Anything that can be wrapped
       * @param {(string|boolean)=} encoding String encoding if `buffer` is a string ("base64", "hex", "binary", defaults to
       *  "utf8")
       * @param {boolean=} littleEndian Whether to use little or big endian byte order. Defaults to
       *  {@link ByteBuffer.DEFAULT_ENDIAN}.
       * @param {boolean=} noAssert Whether to skip assertions of offsets and values. Defaults to
       *  {@link ByteBuffer.DEFAULT_NOASSERT}.
       * @returns {!ByteBuffer} A ByteBuffer wrapping `buffer`
       * @expose
       */
      ByteBuffer.wrap = function(buffer, encoding, littleEndian, noAssert) {
          if (typeof encoding !== 'string') {
              noAssert = littleEndian;
              littleEndian = encoding;
              encoding = undefined;
          }
          if (typeof buffer === 'string') {
              if (typeof encoding === 'undefined')
                  encoding = "utf8";
              switch (encoding) {
                  case "base64":
                      return ByteBuffer.fromBase64(buffer, littleEndian);
                  case "hex":
                      return ByteBuffer.fromHex(buffer, littleEndian);
                  case "binary":
                      return ByteBuffer.fromBinary(buffer, littleEndian);
                  case "utf8":
                      return ByteBuffer.fromUTF8(buffer, littleEndian);
                  case "debug":
                      return ByteBuffer.fromDebug(buffer, littleEndian);
                  default:
                      throw Error("Unsupported encoding: "+encoding);
              }
          }
          if (buffer === null || typeof buffer !== 'object')
              throw TypeError("Illegal buffer");
          var bb;
          if (ByteBuffer.isByteBuffer(buffer)) {
              bb = ByteBufferPrototype.clone.call(buffer);
              bb.markedOffset = -1;
              return bb;
          }
          if (buffer instanceof Uint8Array) { // Extract ArrayBuffer from Uint8Array
              bb = new ByteBuffer(0, littleEndian, noAssert);
              if (buffer.length > 0) { // Avoid references to more than one EMPTY_BUFFER
                  bb.buffer = buffer.buffer;
                  bb.offset = buffer.byteOffset;
                  bb.limit = buffer.byteOffset + buffer.byteLength;
                  bb.view = new Uint8Array(buffer.buffer);
              }
          } else if (buffer instanceof ArrayBuffer) { // Reuse ArrayBuffer
              bb = new ByteBuffer(0, littleEndian, noAssert);
              if (buffer.byteLength > 0) {
                  bb.buffer = buffer;
                  bb.offset = 0;
                  bb.limit = buffer.byteLength;
                  bb.view = buffer.byteLength > 0 ? new Uint8Array(buffer) : null;
              }
          } else if (Object.prototype.toString.call(buffer) === "[object Array]") { // Create from octets
              bb = new ByteBuffer(buffer.length, littleEndian, noAssert);
              bb.limit = buffer.length;
              for (var i=0; i<buffer.length; ++i)
                  bb.view[i] = buffer[i];
          } else
              throw TypeError("Illegal buffer"); // Otherwise fail
          return bb;
      };

      /**
       * Writes the array as a bitset.
       * @param {Array<boolean>} value Array of booleans to write
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by `length` if omitted.
       * @returns {!ByteBuffer}
       * @expose
       */
      ByteBufferPrototype.writeBitSet = function(value, offset) {
        var relative = typeof offset === 'undefined';
        if (relative) offset = this.offset;
        if (!this.noAssert) {
          if (!(value instanceof Array))
            throw TypeError("Illegal BitSet: Not an array");
          if (typeof offset !== 'number' || offset % 1 !== 0)
              throw TypeError("Illegal offset: "+offset+" (not an integer)");
          offset >>>= 0;
          if (offset < 0 || offset + 0 > this.buffer.byteLength)
              throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
        }

        var start = offset,
            bits = value.length,
            bytes = (bits >> 3),
            bit = 0,
            k;

        offset += this.writeVarint32(bits,offset);

        while(bytes--) {
          k = (!!value[bit++] & 1) |
              ((!!value[bit++] & 1) << 1) |
              ((!!value[bit++] & 1) << 2) |
              ((!!value[bit++] & 1) << 3) |
              ((!!value[bit++] & 1) << 4) |
              ((!!value[bit++] & 1) << 5) |
              ((!!value[bit++] & 1) << 6) |
              ((!!value[bit++] & 1) << 7);
          this.writeByte(k,offset++);
        }

        if(bit < bits) {
          var m = 0; k = 0;
          while(bit < bits) k = k | ((!!value[bit++] & 1) << (m++));
          this.writeByte(k,offset++);
        }

        if (relative) {
          this.offset = offset;
          return this;
        }
        return offset - start;
      };

      /**
       * Reads a BitSet as an array of booleans.
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by `length` if omitted.
       * @returns {Array<boolean>
       * @expose
       */
      ByteBufferPrototype.readBitSet = function(offset) {
        var relative = typeof offset === 'undefined';
        if (relative) offset = this.offset;

        var ret = this.readVarint32(offset),
            bits = ret.value,
            bytes = (bits >> 3),
            bit = 0,
            value = [],
            k;

        offset += ret.length;

        while(bytes--) {
          k = this.readByte(offset++);
          value[bit++] = !!(k & 0x01);
          value[bit++] = !!(k & 0x02);
          value[bit++] = !!(k & 0x04);
          value[bit++] = !!(k & 0x08);
          value[bit++] = !!(k & 0x10);
          value[bit++] = !!(k & 0x20);
          value[bit++] = !!(k & 0x40);
          value[bit++] = !!(k & 0x80);
        }

        if(bit < bits) {
          var m = 0;
          k = this.readByte(offset++);
          while(bit < bits) value[bit++] = !!((k >> (m++)) & 1);
        }

        if (relative) {
          this.offset = offset;
        }
        return value;
      };
      /**
       * Reads the specified number of bytes.
       * @param {number} length Number of bytes to read
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by `length` if omitted.
       * @returns {!ByteBuffer}
       * @expose
       */
      ByteBufferPrototype.readBytes = function(length, offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + length > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+length+") <= "+this.buffer.byteLength);
          }
          var slice = this.slice(offset, offset + length);
          if (relative) this.offset += length;
          return slice;
      };

      /**
       * Writes a payload of bytes. This is an alias of {@link ByteBuffer#append}.
       * @function
       * @param {!ByteBuffer|!ArrayBuffer|!Uint8Array|string} source Data to write. If `source` is a ByteBuffer, its offsets
       *  will be modified according to the performed read operation.
       * @param {(string|number)=} encoding Encoding if `data` is a string ("base64", "hex", "binary", defaults to "utf8")
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  written if omitted.
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.writeBytes = ByteBufferPrototype.append;

      // types/ints/int8

      /**
       * Writes an 8bit signed integer.
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and advance {@link ByteBuffer#offset} by `1` if omitted.
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.writeInt8 = function(value, offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof value !== 'number' || value % 1 !== 0)
                  throw TypeError("Illegal value: "+value+" (not an integer)");
              value |= 0;
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          offset += 1;
          var capacity0 = this.buffer.byteLength;
          if (offset > capacity0)
              this.resize((capacity0 *= 2) > offset ? capacity0 : offset);
          offset -= 1;
          this.view[offset] = value;
          if (relative) this.offset += 1;
          return this;
      };

      /**
       * Writes an 8bit signed integer. This is an alias of {@link ByteBuffer#writeInt8}.
       * @function
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and advance {@link ByteBuffer#offset} by `1` if omitted.
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.writeByte = ByteBufferPrototype.writeInt8;

      /**
       * Reads an 8bit signed integer.
       * @param {number=} offset Offset to read from. Will use and advance {@link ByteBuffer#offset} by `1` if omitted.
       * @returns {number} Value read
       * @expose
       */
      ByteBufferPrototype.readInt8 = function(offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 1 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+1+") <= "+this.buffer.byteLength);
          }
          var value = this.view[offset];
          if ((value & 0x80) === 0x80) value = -(0xFF - value + 1); // Cast to signed
          if (relative) this.offset += 1;
          return value;
      };

      /**
       * Reads an 8bit signed integer. This is an alias of {@link ByteBuffer#readInt8}.
       * @function
       * @param {number=} offset Offset to read from. Will use and advance {@link ByteBuffer#offset} by `1` if omitted.
       * @returns {number} Value read
       * @expose
       */
      ByteBufferPrototype.readByte = ByteBufferPrototype.readInt8;

      /**
       * Writes an 8bit unsigned integer.
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and advance {@link ByteBuffer#offset} by `1` if omitted.
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.writeUint8 = function(value, offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof value !== 'number' || value % 1 !== 0)
                  throw TypeError("Illegal value: "+value+" (not an integer)");
              value >>>= 0;
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          offset += 1;
          var capacity1 = this.buffer.byteLength;
          if (offset > capacity1)
              this.resize((capacity1 *= 2) > offset ? capacity1 : offset);
          offset -= 1;
          this.view[offset] = value;
          if (relative) this.offset += 1;
          return this;
      };

      /**
       * Writes an 8bit unsigned integer. This is an alias of {@link ByteBuffer#writeUint8}.
       * @function
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and advance {@link ByteBuffer#offset} by `1` if omitted.
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.writeUInt8 = ByteBufferPrototype.writeUint8;

      /**
       * Reads an 8bit unsigned integer.
       * @param {number=} offset Offset to read from. Will use and advance {@link ByteBuffer#offset} by `1` if omitted.
       * @returns {number} Value read
       * @expose
       */
      ByteBufferPrototype.readUint8 = function(offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 1 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+1+") <= "+this.buffer.byteLength);
          }
          var value = this.view[offset];
          if (relative) this.offset += 1;
          return value;
      };

      /**
       * Reads an 8bit unsigned integer. This is an alias of {@link ByteBuffer#readUint8}.
       * @function
       * @param {number=} offset Offset to read from. Will use and advance {@link ByteBuffer#offset} by `1` if omitted.
       * @returns {number} Value read
       * @expose
       */
      ByteBufferPrototype.readUInt8 = ByteBufferPrototype.readUint8;

      // types/ints/int16

      /**
       * Writes a 16bit signed integer.
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and advance {@link ByteBuffer#offset} by `2` if omitted.
       * @throws {TypeError} If `offset` or `value` is not a valid number
       * @throws {RangeError} If `offset` is out of bounds
       * @expose
       */
      ByteBufferPrototype.writeInt16 = function(value, offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof value !== 'number' || value % 1 !== 0)
                  throw TypeError("Illegal value: "+value+" (not an integer)");
              value |= 0;
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          offset += 2;
          var capacity2 = this.buffer.byteLength;
          if (offset > capacity2)
              this.resize((capacity2 *= 2) > offset ? capacity2 : offset);
          offset -= 2;
          if (this.littleEndian) {
              this.view[offset+1] = (value & 0xFF00) >>> 8;
              this.view[offset  ] =  value & 0x00FF;
          } else {
              this.view[offset]   = (value & 0xFF00) >>> 8;
              this.view[offset+1] =  value & 0x00FF;
          }
          if (relative) this.offset += 2;
          return this;
      };

      /**
       * Writes a 16bit signed integer. This is an alias of {@link ByteBuffer#writeInt16}.
       * @function
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and advance {@link ByteBuffer#offset} by `2` if omitted.
       * @throws {TypeError} If `offset` or `value` is not a valid number
       * @throws {RangeError} If `offset` is out of bounds
       * @expose
       */
      ByteBufferPrototype.writeShort = ByteBufferPrototype.writeInt16;

      /**
       * Reads a 16bit signed integer.
       * @param {number=} offset Offset to read from. Will use and advance {@link ByteBuffer#offset} by `2` if omitted.
       * @returns {number} Value read
       * @throws {TypeError} If `offset` is not a valid number
       * @throws {RangeError} If `offset` is out of bounds
       * @expose
       */
      ByteBufferPrototype.readInt16 = function(offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 2 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+2+") <= "+this.buffer.byteLength);
          }
          var value = 0;
          if (this.littleEndian) {
              value  = this.view[offset  ];
              value |= this.view[offset+1] << 8;
          } else {
              value  = this.view[offset  ] << 8;
              value |= this.view[offset+1];
          }
          if ((value & 0x8000) === 0x8000) value = -(0xFFFF - value + 1); // Cast to signed
          if (relative) this.offset += 2;
          return value;
      };

      /**
       * Reads a 16bit signed integer. This is an alias of {@link ByteBuffer#readInt16}.
       * @function
       * @param {number=} offset Offset to read from. Will use and advance {@link ByteBuffer#offset} by `2` if omitted.
       * @returns {number} Value read
       * @throws {TypeError} If `offset` is not a valid number
       * @throws {RangeError} If `offset` is out of bounds
       * @expose
       */
      ByteBufferPrototype.readShort = ByteBufferPrototype.readInt16;

      /**
       * Writes a 16bit unsigned integer.
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and advance {@link ByteBuffer#offset} by `2` if omitted.
       * @throws {TypeError} If `offset` or `value` is not a valid number
       * @throws {RangeError} If `offset` is out of bounds
       * @expose
       */
      ByteBufferPrototype.writeUint16 = function(value, offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof value !== 'number' || value % 1 !== 0)
                  throw TypeError("Illegal value: "+value+" (not an integer)");
              value >>>= 0;
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          offset += 2;
          var capacity3 = this.buffer.byteLength;
          if (offset > capacity3)
              this.resize((capacity3 *= 2) > offset ? capacity3 : offset);
          offset -= 2;
          if (this.littleEndian) {
              this.view[offset+1] = (value & 0xFF00) >>> 8;
              this.view[offset  ] =  value & 0x00FF;
          } else {
              this.view[offset]   = (value & 0xFF00) >>> 8;
              this.view[offset+1] =  value & 0x00FF;
          }
          if (relative) this.offset += 2;
          return this;
      };

      /**
       * Writes a 16bit unsigned integer. This is an alias of {@link ByteBuffer#writeUint16}.
       * @function
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and advance {@link ByteBuffer#offset} by `2` if omitted.
       * @throws {TypeError} If `offset` or `value` is not a valid number
       * @throws {RangeError} If `offset` is out of bounds
       * @expose
       */
      ByteBufferPrototype.writeUInt16 = ByteBufferPrototype.writeUint16;

      /**
       * Reads a 16bit unsigned integer.
       * @param {number=} offset Offset to read from. Will use and advance {@link ByteBuffer#offset} by `2` if omitted.
       * @returns {number} Value read
       * @throws {TypeError} If `offset` is not a valid number
       * @throws {RangeError} If `offset` is out of bounds
       * @expose
       */
      ByteBufferPrototype.readUint16 = function(offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 2 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+2+") <= "+this.buffer.byteLength);
          }
          var value = 0;
          if (this.littleEndian) {
              value  = this.view[offset  ];
              value |= this.view[offset+1] << 8;
          } else {
              value  = this.view[offset  ] << 8;
              value |= this.view[offset+1];
          }
          if (relative) this.offset += 2;
          return value;
      };

      /**
       * Reads a 16bit unsigned integer. This is an alias of {@link ByteBuffer#readUint16}.
       * @function
       * @param {number=} offset Offset to read from. Will use and advance {@link ByteBuffer#offset} by `2` if omitted.
       * @returns {number} Value read
       * @throws {TypeError} If `offset` is not a valid number
       * @throws {RangeError} If `offset` is out of bounds
       * @expose
       */
      ByteBufferPrototype.readUInt16 = ByteBufferPrototype.readUint16;

      // types/ints/int32

      /**
       * Writes a 32bit signed integer.
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by `4` if omitted.
       * @expose
       */
      ByteBufferPrototype.writeInt32 = function(value, offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof value !== 'number' || value % 1 !== 0)
                  throw TypeError("Illegal value: "+value+" (not an integer)");
              value |= 0;
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          offset += 4;
          var capacity4 = this.buffer.byteLength;
          if (offset > capacity4)
              this.resize((capacity4 *= 2) > offset ? capacity4 : offset);
          offset -= 4;
          if (this.littleEndian) {
              this.view[offset+3] = (value >>> 24) & 0xFF;
              this.view[offset+2] = (value >>> 16) & 0xFF;
              this.view[offset+1] = (value >>>  8) & 0xFF;
              this.view[offset  ] =  value         & 0xFF;
          } else {
              this.view[offset  ] = (value >>> 24) & 0xFF;
              this.view[offset+1] = (value >>> 16) & 0xFF;
              this.view[offset+2] = (value >>>  8) & 0xFF;
              this.view[offset+3] =  value         & 0xFF;
          }
          if (relative) this.offset += 4;
          return this;
      };

      /**
       * Writes a 32bit signed integer. This is an alias of {@link ByteBuffer#writeInt32}.
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by `4` if omitted.
       * @expose
       */
      ByteBufferPrototype.writeInt = ByteBufferPrototype.writeInt32;

      /**
       * Reads a 32bit signed integer.
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by `4` if omitted.
       * @returns {number} Value read
       * @expose
       */
      ByteBufferPrototype.readInt32 = function(offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 4 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+4+") <= "+this.buffer.byteLength);
          }
          var value = 0;
          if (this.littleEndian) {
              value  = this.view[offset+2] << 16;
              value |= this.view[offset+1] <<  8;
              value |= this.view[offset  ];
              value += this.view[offset+3] << 24 >>> 0;
          } else {
              value  = this.view[offset+1] << 16;
              value |= this.view[offset+2] <<  8;
              value |= this.view[offset+3];
              value += this.view[offset  ] << 24 >>> 0;
          }
          value |= 0; // Cast to signed
          if (relative) this.offset += 4;
          return value;
      };

      /**
       * Reads a 32bit signed integer. This is an alias of {@link ByteBuffer#readInt32}.
       * @param {number=} offset Offset to read from. Will use and advance {@link ByteBuffer#offset} by `4` if omitted.
       * @returns {number} Value read
       * @expose
       */
      ByteBufferPrototype.readInt = ByteBufferPrototype.readInt32;

      /**
       * Writes a 32bit unsigned integer.
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by `4` if omitted.
       * @expose
       */
      ByteBufferPrototype.writeUint32 = function(value, offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof value !== 'number' || value % 1 !== 0)
                  throw TypeError("Illegal value: "+value+" (not an integer)");
              value >>>= 0;
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          offset += 4;
          var capacity5 = this.buffer.byteLength;
          if (offset > capacity5)
              this.resize((capacity5 *= 2) > offset ? capacity5 : offset);
          offset -= 4;
          if (this.littleEndian) {
              this.view[offset+3] = (value >>> 24) & 0xFF;
              this.view[offset+2] = (value >>> 16) & 0xFF;
              this.view[offset+1] = (value >>>  8) & 0xFF;
              this.view[offset  ] =  value         & 0xFF;
          } else {
              this.view[offset  ] = (value >>> 24) & 0xFF;
              this.view[offset+1] = (value >>> 16) & 0xFF;
              this.view[offset+2] = (value >>>  8) & 0xFF;
              this.view[offset+3] =  value         & 0xFF;
          }
          if (relative) this.offset += 4;
          return this;
      };

      /**
       * Writes a 32bit unsigned integer. This is an alias of {@link ByteBuffer#writeUint32}.
       * @function
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by `4` if omitted.
       * @expose
       */
      ByteBufferPrototype.writeUInt32 = ByteBufferPrototype.writeUint32;

      /**
       * Reads a 32bit unsigned integer.
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by `4` if omitted.
       * @returns {number} Value read
       * @expose
       */
      ByteBufferPrototype.readUint32 = function(offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 4 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+4+") <= "+this.buffer.byteLength);
          }
          var value = 0;
          if (this.littleEndian) {
              value  = this.view[offset+2] << 16;
              value |= this.view[offset+1] <<  8;
              value |= this.view[offset  ];
              value += this.view[offset+3] << 24 >>> 0;
          } else {
              value  = this.view[offset+1] << 16;
              value |= this.view[offset+2] <<  8;
              value |= this.view[offset+3];
              value += this.view[offset  ] << 24 >>> 0;
          }
          if (relative) this.offset += 4;
          return value;
      };

      /**
       * Reads a 32bit unsigned integer. This is an alias of {@link ByteBuffer#readUint32}.
       * @function
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by `4` if omitted.
       * @returns {number} Value read
       * @expose
       */
      ByteBufferPrototype.readUInt32 = ByteBufferPrototype.readUint32;

      // types/ints/int64

      if (Long) {

          /**
           * Writes a 64bit signed integer.
           * @param {number|!Long} value Value to write
           * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by `8` if omitted.
           * @returns {!ByteBuffer} this
           * @expose
           */
          ByteBufferPrototype.writeInt64 = function(value, offset) {
              var relative = typeof offset === 'undefined';
              if (relative) offset = this.offset;
              if (!this.noAssert) {
                  if (typeof value === 'number')
                      value = Long.fromNumber(value);
                  else if (typeof value === 'string')
                      value = Long.fromString(value);
                  else if (!(value && value instanceof Long))
                      throw TypeError("Illegal value: "+value+" (not an integer or Long)");
                  if (typeof offset !== 'number' || offset % 1 !== 0)
                      throw TypeError("Illegal offset: "+offset+" (not an integer)");
                  offset >>>= 0;
                  if (offset < 0 || offset + 0 > this.buffer.byteLength)
                      throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
              }
              if (typeof value === 'number')
                  value = Long.fromNumber(value);
              else if (typeof value === 'string')
                  value = Long.fromString(value);
              offset += 8;
              var capacity6 = this.buffer.byteLength;
              if (offset > capacity6)
                  this.resize((capacity6 *= 2) > offset ? capacity6 : offset);
              offset -= 8;
              var lo = value.low,
                  hi = value.high;
              if (this.littleEndian) {
                  this.view[offset+3] = (lo >>> 24) & 0xFF;
                  this.view[offset+2] = (lo >>> 16) & 0xFF;
                  this.view[offset+1] = (lo >>>  8) & 0xFF;
                  this.view[offset  ] =  lo         & 0xFF;
                  offset += 4;
                  this.view[offset+3] = (hi >>> 24) & 0xFF;
                  this.view[offset+2] = (hi >>> 16) & 0xFF;
                  this.view[offset+1] = (hi >>>  8) & 0xFF;
                  this.view[offset  ] =  hi         & 0xFF;
              } else {
                  this.view[offset  ] = (hi >>> 24) & 0xFF;
                  this.view[offset+1] = (hi >>> 16) & 0xFF;
                  this.view[offset+2] = (hi >>>  8) & 0xFF;
                  this.view[offset+3] =  hi         & 0xFF;
                  offset += 4;
                  this.view[offset  ] = (lo >>> 24) & 0xFF;
                  this.view[offset+1] = (lo >>> 16) & 0xFF;
                  this.view[offset+2] = (lo >>>  8) & 0xFF;
                  this.view[offset+3] =  lo         & 0xFF;
              }
              if (relative) this.offset += 8;
              return this;
          };

          /**
           * Writes a 64bit signed integer. This is an alias of {@link ByteBuffer#writeInt64}.
           * @param {number|!Long} value Value to write
           * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by `8` if omitted.
           * @returns {!ByteBuffer} this
           * @expose
           */
          ByteBufferPrototype.writeLong = ByteBufferPrototype.writeInt64;

          /**
           * Reads a 64bit signed integer.
           * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by `8` if omitted.
           * @returns {!Long}
           * @expose
           */
          ByteBufferPrototype.readInt64 = function(offset) {
              var relative = typeof offset === 'undefined';
              if (relative) offset = this.offset;
              if (!this.noAssert) {
                  if (typeof offset !== 'number' || offset % 1 !== 0)
                      throw TypeError("Illegal offset: "+offset+" (not an integer)");
                  offset >>>= 0;
                  if (offset < 0 || offset + 8 > this.buffer.byteLength)
                      throw RangeError("Illegal offset: 0 <= "+offset+" (+"+8+") <= "+this.buffer.byteLength);
              }
              var lo = 0,
                  hi = 0;
              if (this.littleEndian) {
                  lo  = this.view[offset+2] << 16;
                  lo |= this.view[offset+1] <<  8;
                  lo |= this.view[offset  ];
                  lo += this.view[offset+3] << 24 >>> 0;
                  offset += 4;
                  hi  = this.view[offset+2] << 16;
                  hi |= this.view[offset+1] <<  8;
                  hi |= this.view[offset  ];
                  hi += this.view[offset+3] << 24 >>> 0;
              } else {
                  hi  = this.view[offset+1] << 16;
                  hi |= this.view[offset+2] <<  8;
                  hi |= this.view[offset+3];
                  hi += this.view[offset  ] << 24 >>> 0;
                  offset += 4;
                  lo  = this.view[offset+1] << 16;
                  lo |= this.view[offset+2] <<  8;
                  lo |= this.view[offset+3];
                  lo += this.view[offset  ] << 24 >>> 0;
              }
              var value = new Long(lo, hi, false);
              if (relative) this.offset += 8;
              return value;
          };

          /**
           * Reads a 64bit signed integer. This is an alias of {@link ByteBuffer#readInt64}.
           * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by `8` if omitted.
           * @returns {!Long}
           * @expose
           */
          ByteBufferPrototype.readLong = ByteBufferPrototype.readInt64;

          /**
           * Writes a 64bit unsigned integer.
           * @param {number|!Long} value Value to write
           * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by `8` if omitted.
           * @returns {!ByteBuffer} this
           * @expose
           */
          ByteBufferPrototype.writeUint64 = function(value, offset) {
              var relative = typeof offset === 'undefined';
              if (relative) offset = this.offset;
              if (!this.noAssert) {
                  if (typeof value === 'number')
                      value = Long.fromNumber(value);
                  else if (typeof value === 'string')
                      value = Long.fromString(value);
                  else if (!(value && value instanceof Long))
                      throw TypeError("Illegal value: "+value+" (not an integer or Long)");
                  if (typeof offset !== 'number' || offset % 1 !== 0)
                      throw TypeError("Illegal offset: "+offset+" (not an integer)");
                  offset >>>= 0;
                  if (offset < 0 || offset + 0 > this.buffer.byteLength)
                      throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
              }
              if (typeof value === 'number')
                  value = Long.fromNumber(value);
              else if (typeof value === 'string')
                  value = Long.fromString(value);
              offset += 8;
              var capacity7 = this.buffer.byteLength;
              if (offset > capacity7)
                  this.resize((capacity7 *= 2) > offset ? capacity7 : offset);
              offset -= 8;
              var lo = value.low,
                  hi = value.high;
              if (this.littleEndian) {
                  this.view[offset+3] = (lo >>> 24) & 0xFF;
                  this.view[offset+2] = (lo >>> 16) & 0xFF;
                  this.view[offset+1] = (lo >>>  8) & 0xFF;
                  this.view[offset  ] =  lo         & 0xFF;
                  offset += 4;
                  this.view[offset+3] = (hi >>> 24) & 0xFF;
                  this.view[offset+2] = (hi >>> 16) & 0xFF;
                  this.view[offset+1] = (hi >>>  8) & 0xFF;
                  this.view[offset  ] =  hi         & 0xFF;
              } else {
                  this.view[offset  ] = (hi >>> 24) & 0xFF;
                  this.view[offset+1] = (hi >>> 16) & 0xFF;
                  this.view[offset+2] = (hi >>>  8) & 0xFF;
                  this.view[offset+3] =  hi         & 0xFF;
                  offset += 4;
                  this.view[offset  ] = (lo >>> 24) & 0xFF;
                  this.view[offset+1] = (lo >>> 16) & 0xFF;
                  this.view[offset+2] = (lo >>>  8) & 0xFF;
                  this.view[offset+3] =  lo         & 0xFF;
              }
              if (relative) this.offset += 8;
              return this;
          };

          /**
           * Writes a 64bit unsigned integer. This is an alias of {@link ByteBuffer#writeUint64}.
           * @function
           * @param {number|!Long} value Value to write
           * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by `8` if omitted.
           * @returns {!ByteBuffer} this
           * @expose
           */
          ByteBufferPrototype.writeUInt64 = ByteBufferPrototype.writeUint64;

          /**
           * Reads a 64bit unsigned integer.
           * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by `8` if omitted.
           * @returns {!Long}
           * @expose
           */
          ByteBufferPrototype.readUint64 = function(offset) {
              var relative = typeof offset === 'undefined';
              if (relative) offset = this.offset;
              if (!this.noAssert) {
                  if (typeof offset !== 'number' || offset % 1 !== 0)
                      throw TypeError("Illegal offset: "+offset+" (not an integer)");
                  offset >>>= 0;
                  if (offset < 0 || offset + 8 > this.buffer.byteLength)
                      throw RangeError("Illegal offset: 0 <= "+offset+" (+"+8+") <= "+this.buffer.byteLength);
              }
              var lo = 0,
                  hi = 0;
              if (this.littleEndian) {
                  lo  = this.view[offset+2] << 16;
                  lo |= this.view[offset+1] <<  8;
                  lo |= this.view[offset  ];
                  lo += this.view[offset+3] << 24 >>> 0;
                  offset += 4;
                  hi  = this.view[offset+2] << 16;
                  hi |= this.view[offset+1] <<  8;
                  hi |= this.view[offset  ];
                  hi += this.view[offset+3] << 24 >>> 0;
              } else {
                  hi  = this.view[offset+1] << 16;
                  hi |= this.view[offset+2] <<  8;
                  hi |= this.view[offset+3];
                  hi += this.view[offset  ] << 24 >>> 0;
                  offset += 4;
                  lo  = this.view[offset+1] << 16;
                  lo |= this.view[offset+2] <<  8;
                  lo |= this.view[offset+3];
                  lo += this.view[offset  ] << 24 >>> 0;
              }
              var value = new Long(lo, hi, true);
              if (relative) this.offset += 8;
              return value;
          };

          /**
           * Reads a 64bit unsigned integer. This is an alias of {@link ByteBuffer#readUint64}.
           * @function
           * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by `8` if omitted.
           * @returns {!Long}
           * @expose
           */
          ByteBufferPrototype.readUInt64 = ByteBufferPrototype.readUint64;

      } // Long


      // types/floats/float32

      /*
       ieee754 - https://github.com/feross/ieee754

       The MIT License (MIT)

       Copyright (c) Feross Aboukhadijeh

       Permission is hereby granted, free of charge, to any person obtaining a copy
       of this software and associated documentation files (the "Software"), to deal
       in the Software without restriction, including without limitation the rights
       to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
       copies of the Software, and to permit persons to whom the Software is
       furnished to do so, subject to the following conditions:

       The above copyright notice and this permission notice shall be included in
       all copies or substantial portions of the Software.

       THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
       IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
       FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
       AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
       LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
       OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
       THE SOFTWARE.
      */

      /**
       * Reads an IEEE754 float from a byte array.
       * @param {!Array} buffer
       * @param {number} offset
       * @param {boolean} isLE
       * @param {number} mLen
       * @param {number} nBytes
       * @returns {number}
       * @inner
       */
      function ieee754_read(buffer, offset, isLE, mLen, nBytes) {
          var e, m,
              eLen = nBytes * 8 - mLen - 1,
              eMax = (1 << eLen) - 1,
              eBias = eMax >> 1,
              nBits = -7,
              i = isLE ? (nBytes - 1) : 0,
              d = isLE ? -1 : 1,
              s = buffer[offset + i];

          i += d;

          e = s & ((1 << (-nBits)) - 1);
          s >>= (-nBits);
          nBits += eLen;
          for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

          m = e & ((1 << (-nBits)) - 1);
          e >>= (-nBits);
          nBits += mLen;
          for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

          if (e === 0) {
              e = 1 - eBias;
          } else if (e === eMax) {
              return m ? NaN : ((s ? -1 : 1) * Infinity);
          } else {
              m = m + Math.pow(2, mLen);
              e = e - eBias;
          }
          return (s ? -1 : 1) * m * Math.pow(2, e - mLen);
      }

      /**
       * Writes an IEEE754 float to a byte array.
       * @param {!Array} buffer
       * @param {number} value
       * @param {number} offset
       * @param {boolean} isLE
       * @param {number} mLen
       * @param {number} nBytes
       * @inner
       */
      function ieee754_write(buffer, value, offset, isLE, mLen, nBytes) {
          var e, m, c,
              eLen = nBytes * 8 - mLen - 1,
              eMax = (1 << eLen) - 1,
              eBias = eMax >> 1,
              rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0),
              i = isLE ? 0 : (nBytes - 1),
              d = isLE ? 1 : -1,
              s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0;

          value = Math.abs(value);

          if (isNaN(value) || value === Infinity) {
              m = isNaN(value) ? 1 : 0;
              e = eMax;
          } else {
              e = Math.floor(Math.log(value) / Math.LN2);
              if (value * (c = Math.pow(2, -e)) < 1) {
                  e--;
                  c *= 2;
              }
              if (e + eBias >= 1) {
                  value += rt / c;
              } else {
                  value += rt * Math.pow(2, 1 - eBias);
              }
              if (value * c >= 2) {
                  e++;
                  c /= 2;
              }

              if (e + eBias >= eMax) {
                  m = 0;
                  e = eMax;
              } else if (e + eBias >= 1) {
                  m = (value * c - 1) * Math.pow(2, mLen);
                  e = e + eBias;
              } else {
                  m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
                  e = 0;
              }
          }

          for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

          e = (e << mLen) | m;
          eLen += mLen;
          for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

          buffer[offset + i - d] |= s * 128;
      }

      /**
       * Writes a 32bit float.
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by `4` if omitted.
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.writeFloat32 = function(value, offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof value !== 'number')
                  throw TypeError("Illegal value: "+value+" (not a number)");
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          offset += 4;
          var capacity8 = this.buffer.byteLength;
          if (offset > capacity8)
              this.resize((capacity8 *= 2) > offset ? capacity8 : offset);
          offset -= 4;
          ieee754_write(this.view, value, offset, this.littleEndian, 23, 4);
          if (relative) this.offset += 4;
          return this;
      };

      /**
       * Writes a 32bit float. This is an alias of {@link ByteBuffer#writeFloat32}.
       * @function
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by `4` if omitted.
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.writeFloat = ByteBufferPrototype.writeFloat32;

      /**
       * Reads a 32bit float.
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by `4` if omitted.
       * @returns {number}
       * @expose
       */
      ByteBufferPrototype.readFloat32 = function(offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 4 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+4+") <= "+this.buffer.byteLength);
          }
          var value = ieee754_read(this.view, offset, this.littleEndian, 23, 4);
          if (relative) this.offset += 4;
          return value;
      };

      /**
       * Reads a 32bit float. This is an alias of {@link ByteBuffer#readFloat32}.
       * @function
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by `4` if omitted.
       * @returns {number}
       * @expose
       */
      ByteBufferPrototype.readFloat = ByteBufferPrototype.readFloat32;

      // types/floats/float64

      /**
       * Writes a 64bit float.
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by `8` if omitted.
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.writeFloat64 = function(value, offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof value !== 'number')
                  throw TypeError("Illegal value: "+value+" (not a number)");
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          offset += 8;
          var capacity9 = this.buffer.byteLength;
          if (offset > capacity9)
              this.resize((capacity9 *= 2) > offset ? capacity9 : offset);
          offset -= 8;
          ieee754_write(this.view, value, offset, this.littleEndian, 52, 8);
          if (relative) this.offset += 8;
          return this;
      };

      /**
       * Writes a 64bit float. This is an alias of {@link ByteBuffer#writeFloat64}.
       * @function
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by `8` if omitted.
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.writeDouble = ByteBufferPrototype.writeFloat64;

      /**
       * Reads a 64bit float.
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by `8` if omitted.
       * @returns {number}
       * @expose
       */
      ByteBufferPrototype.readFloat64 = function(offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 8 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+8+") <= "+this.buffer.byteLength);
          }
          var value = ieee754_read(this.view, offset, this.littleEndian, 52, 8);
          if (relative) this.offset += 8;
          return value;
      };

      /**
       * Reads a 64bit float. This is an alias of {@link ByteBuffer#readFloat64}.
       * @function
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by `8` if omitted.
       * @returns {number}
       * @expose
       */
      ByteBufferPrototype.readDouble = ByteBufferPrototype.readFloat64;


      // types/varints/varint32

      /**
       * Maximum number of bytes required to store a 32bit base 128 variable-length integer.
       * @type {number}
       * @const
       * @expose
       */
      ByteBuffer.MAX_VARINT32_BYTES = 5;

      /**
       * Calculates the actual number of bytes required to store a 32bit base 128 variable-length integer.
       * @param {number} value Value to encode
       * @returns {number} Number of bytes required. Capped to {@link ByteBuffer.MAX_VARINT32_BYTES}
       * @expose
       */
      ByteBuffer.calculateVarint32 = function(value) {
          // ref: src/google/protobuf/io/coded_stream.cc
          value = value >>> 0;
               if (value < 1 << 7 ) return 1;
          else if (value < 1 << 14) return 2;
          else if (value < 1 << 21) return 3;
          else if (value < 1 << 28) return 4;
          else                      return 5;
      };

      /**
       * Zigzag encodes a signed 32bit integer so that it can be effectively used with varint encoding.
       * @param {number} n Signed 32bit integer
       * @returns {number} Unsigned zigzag encoded 32bit integer
       * @expose
       */
      ByteBuffer.zigZagEncode32 = function(n) {
          return (((n |= 0) << 1) ^ (n >> 31)) >>> 0; // ref: src/google/protobuf/wire_format_lite.h
      };

      /**
       * Decodes a zigzag encoded signed 32bit integer.
       * @param {number} n Unsigned zigzag encoded 32bit integer
       * @returns {number} Signed 32bit integer
       * @expose
       */
      ByteBuffer.zigZagDecode32 = function(n) {
          return ((n >>> 1) ^ -(n & 1)) | 0; // // ref: src/google/protobuf/wire_format_lite.h
      };

      /**
       * Writes a 32bit base 128 variable-length integer.
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  written if omitted.
       * @returns {!ByteBuffer|number} this if `offset` is omitted, else the actual number of bytes written
       * @expose
       */
      ByteBufferPrototype.writeVarint32 = function(value, offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof value !== 'number' || value % 1 !== 0)
                  throw TypeError("Illegal value: "+value+" (not an integer)");
              value |= 0;
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          var size = ByteBuffer.calculateVarint32(value),
              b;
          offset += size;
          var capacity10 = this.buffer.byteLength;
          if (offset > capacity10)
              this.resize((capacity10 *= 2) > offset ? capacity10 : offset);
          offset -= size;
          value >>>= 0;
          while (value >= 0x80) {
              b = (value & 0x7f) | 0x80;
              this.view[offset++] = b;
              value >>>= 7;
          }
          this.view[offset++] = value;
          if (relative) {
              this.offset = offset;
              return this;
          }
          return size;
      };

      /**
       * Writes a zig-zag encoded (signed) 32bit base 128 variable-length integer.
       * @param {number} value Value to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  written if omitted.
       * @returns {!ByteBuffer|number} this if `offset` is omitted, else the actual number of bytes written
       * @expose
       */
      ByteBufferPrototype.writeVarint32ZigZag = function(value, offset) {
          return this.writeVarint32(ByteBuffer.zigZagEncode32(value), offset);
      };

      /**
       * Reads a 32bit base 128 variable-length integer.
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  written if omitted.
       * @returns {number|!{value: number, length: number}} The value read if offset is omitted, else the value read
       *  and the actual number of bytes read.
       * @throws {Error} If it's not a valid varint. Has a property `truncated = true` if there is not enough data available
       *  to fully decode the varint.
       * @expose
       */
      ByteBufferPrototype.readVarint32 = function(offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 1 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+1+") <= "+this.buffer.byteLength);
          }
          var c = 0,
              value = 0 >>> 0,
              b;
          do {
              if (!this.noAssert && offset > this.limit) {
                  var err = Error("Truncated");
                  err['truncated'] = true;
                  throw err;
              }
              b = this.view[offset++];
              if (c < 5)
                  value |= (b & 0x7f) << (7*c);
              ++c;
          } while ((b & 0x80) !== 0);
          value |= 0;
          if (relative) {
              this.offset = offset;
              return value;
          }
          return {
              "value": value,
              "length": c
          };
      };

      /**
       * Reads a zig-zag encoded (signed) 32bit base 128 variable-length integer.
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  written if omitted.
       * @returns {number|!{value: number, length: number}} The value read if offset is omitted, else the value read
       *  and the actual number of bytes read.
       * @throws {Error} If it's not a valid varint
       * @expose
       */
      ByteBufferPrototype.readVarint32ZigZag = function(offset) {
          var val = this.readVarint32(offset);
          if (typeof val === 'object')
              val["value"] = ByteBuffer.zigZagDecode32(val["value"]);
          else
              val = ByteBuffer.zigZagDecode32(val);
          return val;
      };

      // types/varints/varint64

      if (Long) {

          /**
           * Maximum number of bytes required to store a 64bit base 128 variable-length integer.
           * @type {number}
           * @const
           * @expose
           */
          ByteBuffer.MAX_VARINT64_BYTES = 10;

          /**
           * Calculates the actual number of bytes required to store a 64bit base 128 variable-length integer.
           * @param {number|!Long} value Value to encode
           * @returns {number} Number of bytes required. Capped to {@link ByteBuffer.MAX_VARINT64_BYTES}
           * @expose
           */
          ByteBuffer.calculateVarint64 = function(value) {
              if (typeof value === 'number')
                  value = Long.fromNumber(value);
              else if (typeof value === 'string')
                  value = Long.fromString(value);
              // ref: src/google/protobuf/io/coded_stream.cc
              var part0 = value.toInt() >>> 0,
                  part1 = value.shiftRightUnsigned(28).toInt() >>> 0,
                  part2 = value.shiftRightUnsigned(56).toInt() >>> 0;
              if (part2 == 0) {
                  if (part1 == 0) {
                      if (part0 < 1 << 14)
                          return part0 < 1 << 7 ? 1 : 2;
                      else
                          return part0 < 1 << 21 ? 3 : 4;
                  } else {
                      if (part1 < 1 << 14)
                          return part1 < 1 << 7 ? 5 : 6;
                      else
                          return part1 < 1 << 21 ? 7 : 8;
                  }
              } else
                  return part2 < 1 << 7 ? 9 : 10;
          };

          /**
           * Zigzag encodes a signed 64bit integer so that it can be effectively used with varint encoding.
           * @param {number|!Long} value Signed long
           * @returns {!Long} Unsigned zigzag encoded long
           * @expose
           */
          ByteBuffer.zigZagEncode64 = function(value) {
              if (typeof value === 'number')
                  value = Long.fromNumber(value, false);
              else if (typeof value === 'string')
                  value = Long.fromString(value, false);
              else if (value.unsigned !== false) value = value.toSigned();
              // ref: src/google/protobuf/wire_format_lite.h
              return value.shiftLeft(1).xor(value.shiftRight(63)).toUnsigned();
          };

          /**
           * Decodes a zigzag encoded signed 64bit integer.
           * @param {!Long|number} value Unsigned zigzag encoded long or JavaScript number
           * @returns {!Long} Signed long
           * @expose
           */
          ByteBuffer.zigZagDecode64 = function(value) {
              if (typeof value === 'number')
                  value = Long.fromNumber(value, false);
              else if (typeof value === 'string')
                  value = Long.fromString(value, false);
              else if (value.unsigned !== false) value = value.toSigned();
              // ref: src/google/protobuf/wire_format_lite.h
              return value.shiftRightUnsigned(1).xor(value.and(Long.ONE).toSigned().negate()).toSigned();
          };

          /**
           * Writes a 64bit base 128 variable-length integer.
           * @param {number|Long} value Value to write
           * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by the number of bytes
           *  written if omitted.
           * @returns {!ByteBuffer|number} `this` if offset is omitted, else the actual number of bytes written.
           * @expose
           */
          ByteBufferPrototype.writeVarint64 = function(value, offset) {
              var relative = typeof offset === 'undefined';
              if (relative) offset = this.offset;
              if (!this.noAssert) {
                  if (typeof value === 'number')
                      value = Long.fromNumber(value);
                  else if (typeof value === 'string')
                      value = Long.fromString(value);
                  else if (!(value && value instanceof Long))
                      throw TypeError("Illegal value: "+value+" (not an integer or Long)");
                  if (typeof offset !== 'number' || offset % 1 !== 0)
                      throw TypeError("Illegal offset: "+offset+" (not an integer)");
                  offset >>>= 0;
                  if (offset < 0 || offset + 0 > this.buffer.byteLength)
                      throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
              }
              if (typeof value === 'number')
                  value = Long.fromNumber(value, false);
              else if (typeof value === 'string')
                  value = Long.fromString(value, false);
              else if (value.unsigned !== false) value = value.toSigned();
              var size = ByteBuffer.calculateVarint64(value),
                  part0 = value.toInt() >>> 0,
                  part1 = value.shiftRightUnsigned(28).toInt() >>> 0,
                  part2 = value.shiftRightUnsigned(56).toInt() >>> 0;
              offset += size;
              var capacity11 = this.buffer.byteLength;
              if (offset > capacity11)
                  this.resize((capacity11 *= 2) > offset ? capacity11 : offset);
              offset -= size;
              switch (size) {
                  case 10: this.view[offset+9] = (part2 >>>  7) & 0x01;
                  case 9 : this.view[offset+8] = size !== 9 ? (part2       ) | 0x80 : (part2       ) & 0x7F;
                  case 8 : this.view[offset+7] = size !== 8 ? (part1 >>> 21) | 0x80 : (part1 >>> 21) & 0x7F;
                  case 7 : this.view[offset+6] = size !== 7 ? (part1 >>> 14) | 0x80 : (part1 >>> 14) & 0x7F;
                  case 6 : this.view[offset+5] = size !== 6 ? (part1 >>>  7) | 0x80 : (part1 >>>  7) & 0x7F;
                  case 5 : this.view[offset+4] = size !== 5 ? (part1       ) | 0x80 : (part1       ) & 0x7F;
                  case 4 : this.view[offset+3] = size !== 4 ? (part0 >>> 21) | 0x80 : (part0 >>> 21) & 0x7F;
                  case 3 : this.view[offset+2] = size !== 3 ? (part0 >>> 14) | 0x80 : (part0 >>> 14) & 0x7F;
                  case 2 : this.view[offset+1] = size !== 2 ? (part0 >>>  7) | 0x80 : (part0 >>>  7) & 0x7F;
                  case 1 : this.view[offset  ] = size !== 1 ? (part0       ) | 0x80 : (part0       ) & 0x7F;
              }
              if (relative) {
                  this.offset += size;
                  return this;
              } else {
                  return size;
              }
          };

          /**
           * Writes a zig-zag encoded 64bit base 128 variable-length integer.
           * @param {number|Long} value Value to write
           * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by the number of bytes
           *  written if omitted.
           * @returns {!ByteBuffer|number} `this` if offset is omitted, else the actual number of bytes written.
           * @expose
           */
          ByteBufferPrototype.writeVarint64ZigZag = function(value, offset) {
              return this.writeVarint64(ByteBuffer.zigZagEncode64(value), offset);
          };

          /**
           * Reads a 64bit base 128 variable-length integer. Requires Long.js.
           * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by the number of bytes
           *  read if omitted.
           * @returns {!Long|!{value: Long, length: number}} The value read if offset is omitted, else the value read and
           *  the actual number of bytes read.
           * @throws {Error} If it's not a valid varint
           * @expose
           */
          ByteBufferPrototype.readVarint64 = function(offset) {
              var relative = typeof offset === 'undefined';
              if (relative) offset = this.offset;
              if (!this.noAssert) {
                  if (typeof offset !== 'number' || offset % 1 !== 0)
                      throw TypeError("Illegal offset: "+offset+" (not an integer)");
                  offset >>>= 0;
                  if (offset < 0 || offset + 1 > this.buffer.byteLength)
                      throw RangeError("Illegal offset: 0 <= "+offset+" (+"+1+") <= "+this.buffer.byteLength);
              }
              // ref: src/google/protobuf/io/coded_stream.cc
              var start = offset,
                  part0 = 0,
                  part1 = 0,
                  part2 = 0,
                  b  = 0;
              b = this.view[offset++]; part0  = (b & 0x7F)      ; if ( b & 0x80                                                   ) {
              b = this.view[offset++]; part0 |= (b & 0x7F) <<  7; if ((b & 0x80) || (this.noAssert && typeof b === 'undefined')) {
              b = this.view[offset++]; part0 |= (b & 0x7F) << 14; if ((b & 0x80) || (this.noAssert && typeof b === 'undefined')) {
              b = this.view[offset++]; part0 |= (b & 0x7F) << 21; if ((b & 0x80) || (this.noAssert && typeof b === 'undefined')) {
              b = this.view[offset++]; part1  = (b & 0x7F)      ; if ((b & 0x80) || (this.noAssert && typeof b === 'undefined')) {
              b = this.view[offset++]; part1 |= (b & 0x7F) <<  7; if ((b & 0x80) || (this.noAssert && typeof b === 'undefined')) {
              b = this.view[offset++]; part1 |= (b & 0x7F) << 14; if ((b & 0x80) || (this.noAssert && typeof b === 'undefined')) {
              b = this.view[offset++]; part1 |= (b & 0x7F) << 21; if ((b & 0x80) || (this.noAssert && typeof b === 'undefined')) {
              b = this.view[offset++]; part2  = (b & 0x7F)      ; if ((b & 0x80) || (this.noAssert && typeof b === 'undefined')) {
              b = this.view[offset++]; part2 |= (b & 0x7F) <<  7; if ((b & 0x80) || (this.noAssert && typeof b === 'undefined')) {
              throw Error("Buffer overrun"); }}}}}}}}}}
              var value = Long.fromBits(part0 | (part1 << 28), (part1 >>> 4) | (part2) << 24, false);
              if (relative) {
                  this.offset = offset;
                  return value;
              } else {
                  return {
                      'value': value,
                      'length': offset-start
                  };
              }
          };

          /**
           * Reads a zig-zag encoded 64bit base 128 variable-length integer. Requires Long.js.
           * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by the number of bytes
           *  read if omitted.
           * @returns {!Long|!{value: Long, length: number}} The value read if offset is omitted, else the value read and
           *  the actual number of bytes read.
           * @throws {Error} If it's not a valid varint
           * @expose
           */
          ByteBufferPrototype.readVarint64ZigZag = function(offset) {
              var val = this.readVarint64(offset);
              if (val && val['value'] instanceof Long)
                  val["value"] = ByteBuffer.zigZagDecode64(val["value"]);
              else
                  val = ByteBuffer.zigZagDecode64(val);
              return val;
          };

      } // Long


      // types/strings/cstring

      /**
       * Writes a NULL-terminated UTF8 encoded string. For this to work the specified string must not contain any NULL
       *  characters itself.
       * @param {string} str String to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  contained in `str` + 1 if omitted.
       * @returns {!ByteBuffer|number} this if offset is omitted, else the actual number of bytes written
       * @expose
       */
      ByteBufferPrototype.writeCString = function(str, offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          var i,
              k = str.length;
          if (!this.noAssert) {
              if (typeof str !== 'string')
                  throw TypeError("Illegal str: Not a string");
              for (i=0; i<k; ++i) {
                  if (str.charCodeAt(i) === 0)
                      throw RangeError("Illegal str: Contains NULL-characters");
              }
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          // UTF8 strings do not contain zero bytes in between except for the zero character, so:
          k = utfx.calculateUTF16asUTF8(stringSource(str))[1];
          offset += k+1;
          var capacity12 = this.buffer.byteLength;
          if (offset > capacity12)
              this.resize((capacity12 *= 2) > offset ? capacity12 : offset);
          offset -= k+1;
          utfx.encodeUTF16toUTF8(stringSource(str), function(b) {
              this.view[offset++] = b;
          }.bind(this));
          this.view[offset++] = 0;
          if (relative) {
              this.offset = offset;
              return this;
          }
          return k;
      };

      /**
       * Reads a NULL-terminated UTF8 encoded string. For this to work the string read must not contain any NULL characters
       *  itself.
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  read if omitted.
       * @returns {string|!{string: string, length: number}} The string read if offset is omitted, else the string
       *  read and the actual number of bytes read.
       * @expose
       */
      ByteBufferPrototype.readCString = function(offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 1 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+1+") <= "+this.buffer.byteLength);
          }
          var start = offset;

          // UTF8 strings do not contain zero bytes in between except for the zero character itself, so:
          var sd, b = -1;
          utfx.decodeUTF8toUTF16(function() {
              if (b === 0) return null;
              if (offset >= this.limit)
                  throw RangeError("Illegal range: Truncated data, "+offset+" < "+this.limit);
              b = this.view[offset++];
              return b === 0 ? null : b;
          }.bind(this), sd = stringDestination(), true);
          if (relative) {
              this.offset = offset;
              return sd();
          } else {
              return {
                  "string": sd(),
                  "length": offset - start
              };
          }
      };

      // types/strings/istring

      /**
       * Writes a length as uint32 prefixed UTF8 encoded string.
       * @param {string} str String to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  written if omitted.
       * @returns {!ByteBuffer|number} `this` if `offset` is omitted, else the actual number of bytes written
       * @expose
       * @see ByteBuffer#writeVarint32
       */
      ByteBufferPrototype.writeIString = function(str, offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof str !== 'string')
                  throw TypeError("Illegal str: Not a string");
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          var start = offset,
              k;
          k = utfx.calculateUTF16asUTF8(stringSource(str), this.noAssert)[1];
          offset += 4+k;
          var capacity13 = this.buffer.byteLength;
          if (offset > capacity13)
              this.resize((capacity13 *= 2) > offset ? capacity13 : offset);
          offset -= 4+k;
          if (this.littleEndian) {
              this.view[offset+3] = (k >>> 24) & 0xFF;
              this.view[offset+2] = (k >>> 16) & 0xFF;
              this.view[offset+1] = (k >>>  8) & 0xFF;
              this.view[offset  ] =  k         & 0xFF;
          } else {
              this.view[offset  ] = (k >>> 24) & 0xFF;
              this.view[offset+1] = (k >>> 16) & 0xFF;
              this.view[offset+2] = (k >>>  8) & 0xFF;
              this.view[offset+3] =  k         & 0xFF;
          }
          offset += 4;
          utfx.encodeUTF16toUTF8(stringSource(str), function(b) {
              this.view[offset++] = b;
          }.bind(this));
          if (offset !== start + 4 + k)
              throw RangeError("Illegal range: Truncated data, "+offset+" == "+(offset+4+k));
          if (relative) {
              this.offset = offset;
              return this;
          }
          return offset - start;
      };

      /**
       * Reads a length as uint32 prefixed UTF8 encoded string.
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  read if omitted.
       * @returns {string|!{string: string, length: number}} The string read if offset is omitted, else the string
       *  read and the actual number of bytes read.
       * @expose
       * @see ByteBuffer#readVarint32
       */
      ByteBufferPrototype.readIString = function(offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 4 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+4+") <= "+this.buffer.byteLength);
          }
          var start = offset;
          var len = this.readUint32(offset);
          var str = this.readUTF8String(len, ByteBuffer.METRICS_BYTES, offset += 4);
          offset += str['length'];
          if (relative) {
              this.offset = offset;
              return str['string'];
          } else {
              return {
                  'string': str['string'],
                  'length': offset - start
              };
          }
      };

      // types/strings/utf8string

      /**
       * Metrics representing number of UTF8 characters. Evaluates to `c`.
       * @type {string}
       * @const
       * @expose
       */
      ByteBuffer.METRICS_CHARS = 'c';

      /**
       * Metrics representing number of bytes. Evaluates to `b`.
       * @type {string}
       * @const
       * @expose
       */
      ByteBuffer.METRICS_BYTES = 'b';

      /**
       * Writes an UTF8 encoded string.
       * @param {string} str String to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} if omitted.
       * @returns {!ByteBuffer|number} this if offset is omitted, else the actual number of bytes written.
       * @expose
       */
      ByteBufferPrototype.writeUTF8String = function(str, offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          var k;
          var start = offset;
          k = utfx.calculateUTF16asUTF8(stringSource(str))[1];
          offset += k;
          var capacity14 = this.buffer.byteLength;
          if (offset > capacity14)
              this.resize((capacity14 *= 2) > offset ? capacity14 : offset);
          offset -= k;
          utfx.encodeUTF16toUTF8(stringSource(str), function(b) {
              this.view[offset++] = b;
          }.bind(this));
          if (relative) {
              this.offset = offset;
              return this;
          }
          return offset - start;
      };

      /**
       * Writes an UTF8 encoded string. This is an alias of {@link ByteBuffer#writeUTF8String}.
       * @function
       * @param {string} str String to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} if omitted.
       * @returns {!ByteBuffer|number} this if offset is omitted, else the actual number of bytes written.
       * @expose
       */
      ByteBufferPrototype.writeString = ByteBufferPrototype.writeUTF8String;

      /**
       * Calculates the number of UTF8 characters of a string. JavaScript itself uses UTF-16, so that a string's
       *  `length` property does not reflect its actual UTF8 size if it contains code points larger than 0xFFFF.
       * @param {string} str String to calculate
       * @returns {number} Number of UTF8 characters
       * @expose
       */
      ByteBuffer.calculateUTF8Chars = function(str) {
          return utfx.calculateUTF16asUTF8(stringSource(str))[0];
      };

      /**
       * Calculates the number of UTF8 bytes of a string.
       * @param {string} str String to calculate
       * @returns {number} Number of UTF8 bytes
       * @expose
       */
      ByteBuffer.calculateUTF8Bytes = function(str) {
          return utfx.calculateUTF16asUTF8(stringSource(str))[1];
      };

      /**
       * Calculates the number of UTF8 bytes of a string. This is an alias of {@link ByteBuffer.calculateUTF8Bytes}.
       * @function
       * @param {string} str String to calculate
       * @returns {number} Number of UTF8 bytes
       * @expose
       */
      ByteBuffer.calculateString = ByteBuffer.calculateUTF8Bytes;

      /**
       * Reads an UTF8 encoded string.
       * @param {number} length Number of characters or bytes to read.
       * @param {string=} metrics Metrics specifying what `length` is meant to count. Defaults to
       *  {@link ByteBuffer.METRICS_CHARS}.
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  read if omitted.
       * @returns {string|!{string: string, length: number}} The string read if offset is omitted, else the string
       *  read and the actual number of bytes read.
       * @expose
       */
      ByteBufferPrototype.readUTF8String = function(length, metrics, offset) {
          if (typeof metrics === 'number') {
              offset = metrics;
              metrics = undefined;
          }
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (typeof metrics === 'undefined') metrics = ByteBuffer.METRICS_CHARS;
          if (!this.noAssert) {
              if (typeof length !== 'number' || length % 1 !== 0)
                  throw TypeError("Illegal length: "+length+" (not an integer)");
              length |= 0;
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          var i = 0,
              start = offset,
              sd;
          if (metrics === ByteBuffer.METRICS_CHARS) { // The same for node and the browser
              sd = stringDestination();
              utfx.decodeUTF8(function() {
                  return i < length && offset < this.limit ? this.view[offset++] : null;
              }.bind(this), function(cp) {
                  ++i; utfx.UTF8toUTF16(cp, sd);
              });
              if (i !== length)
                  throw RangeError("Illegal range: Truncated data, "+i+" == "+length);
              if (relative) {
                  this.offset = offset;
                  return sd();
              } else {
                  return {
                      "string": sd(),
                      "length": offset - start
                  };
              }
          } else if (metrics === ByteBuffer.METRICS_BYTES) {
              if (!this.noAssert) {
                  if (typeof offset !== 'number' || offset % 1 !== 0)
                      throw TypeError("Illegal offset: "+offset+" (not an integer)");
                  offset >>>= 0;
                  if (offset < 0 || offset + length > this.buffer.byteLength)
                      throw RangeError("Illegal offset: 0 <= "+offset+" (+"+length+") <= "+this.buffer.byteLength);
              }
              var k = offset + length;
              utfx.decodeUTF8toUTF16(function() {
                  return offset < k ? this.view[offset++] : null;
              }.bind(this), sd = stringDestination(), this.noAssert);
              if (offset !== k)
                  throw RangeError("Illegal range: Truncated data, "+offset+" == "+k);
              if (relative) {
                  this.offset = offset;
                  return sd();
              } else {
                  return {
                      'string': sd(),
                      'length': offset - start
                  };
              }
          } else
              throw TypeError("Unsupported metrics: "+metrics);
      };

      /**
       * Reads an UTF8 encoded string. This is an alias of {@link ByteBuffer#readUTF8String}.
       * @function
       * @param {number} length Number of characters or bytes to read
       * @param {number=} metrics Metrics specifying what `n` is meant to count. Defaults to
       *  {@link ByteBuffer.METRICS_CHARS}.
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  read if omitted.
       * @returns {string|!{string: string, length: number}} The string read if offset is omitted, else the string
       *  read and the actual number of bytes read.
       * @expose
       */
      ByteBufferPrototype.readString = ByteBufferPrototype.readUTF8String;

      // types/strings/vstring

      /**
       * Writes a length as varint32 prefixed UTF8 encoded string.
       * @param {string} str String to write
       * @param {number=} offset Offset to write to. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  written if omitted.
       * @returns {!ByteBuffer|number} `this` if `offset` is omitted, else the actual number of bytes written
       * @expose
       * @see ByteBuffer#writeVarint32
       */
      ByteBufferPrototype.writeVString = function(str, offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof str !== 'string')
                  throw TypeError("Illegal str: Not a string");
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          var start = offset,
              k, l;
          k = utfx.calculateUTF16asUTF8(stringSource(str), this.noAssert)[1];
          l = ByteBuffer.calculateVarint32(k);
          offset += l+k;
          var capacity15 = this.buffer.byteLength;
          if (offset > capacity15)
              this.resize((capacity15 *= 2) > offset ? capacity15 : offset);
          offset -= l+k;
          offset += this.writeVarint32(k, offset);
          utfx.encodeUTF16toUTF8(stringSource(str), function(b) {
              this.view[offset++] = b;
          }.bind(this));
          if (offset !== start+k+l)
              throw RangeError("Illegal range: Truncated data, "+offset+" == "+(offset+k+l));
          if (relative) {
              this.offset = offset;
              return this;
          }
          return offset - start;
      };

      /**
       * Reads a length as varint32 prefixed UTF8 encoded string.
       * @param {number=} offset Offset to read from. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  read if omitted.
       * @returns {string|!{string: string, length: number}} The string read if offset is omitted, else the string
       *  read and the actual number of bytes read.
       * @expose
       * @see ByteBuffer#readVarint32
       */
      ByteBufferPrototype.readVString = function(offset) {
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 1 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+1+") <= "+this.buffer.byteLength);
          }
          var start = offset;
          var len = this.readVarint32(offset);
          var str = this.readUTF8String(len['value'], ByteBuffer.METRICS_BYTES, offset += len['length']);
          offset += str['length'];
          if (relative) {
              this.offset = offset;
              return str['string'];
          } else {
              return {
                  'string': str['string'],
                  'length': offset - start
              };
          }
      };


      /**
       * Appends some data to this ByteBuffer. This will overwrite any contents behind the specified offset up to the appended
       *  data's length.
       * @param {!ByteBuffer|!ArrayBuffer|!Uint8Array|string} source Data to append. If `source` is a ByteBuffer, its offsets
       *  will be modified according to the performed read operation.
       * @param {(string|number)=} encoding Encoding if `data` is a string ("base64", "hex", "binary", defaults to "utf8")
       * @param {number=} offset Offset to append at. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  written if omitted.
       * @returns {!ByteBuffer} this
       * @expose
       * @example A relative `<01 02>03.append(<04 05>)` will result in `<01 02 04 05>, 04 05|`
       * @example An absolute `<01 02>03.append(04 05>, 1)` will result in `<01 04>05, 04 05|`
       */
      ByteBufferPrototype.append = function(source, encoding, offset) {
          if (typeof encoding === 'number' || typeof encoding !== 'string') {
              offset = encoding;
              encoding = undefined;
          }
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          if (!(source instanceof ByteBuffer))
              source = ByteBuffer.wrap(source, encoding);
          var length = source.limit - source.offset;
          if (length <= 0) return this; // Nothing to append
          offset += length;
          var capacity16 = this.buffer.byteLength;
          if (offset > capacity16)
              this.resize((capacity16 *= 2) > offset ? capacity16 : offset);
          offset -= length;
          this.view.set(source.view.subarray(source.offset, source.limit), offset);
          source.offset += length;
          if (relative) this.offset += length;
          return this;
      };

      /**
       * Appends this ByteBuffer's contents to another ByteBuffer. This will overwrite any contents at and after the
          specified offset up to the length of this ByteBuffer's data.
       * @param {!ByteBuffer} target Target ByteBuffer
       * @param {number=} offset Offset to append to. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  read if omitted.
       * @returns {!ByteBuffer} this
       * @expose
       * @see ByteBuffer#append
       */
      ByteBufferPrototype.appendTo = function(target, offset) {
          target.append(this, offset);
          return this;
      };

      /**
       * Enables or disables assertions of argument types and offsets. Assertions are enabled by default but you can opt to
       *  disable them if your code already makes sure that everything is valid.
       * @param {boolean} assert `true` to enable assertions, otherwise `false`
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.assert = function(assert) {
          this.noAssert = !assert;
          return this;
      };

      /**
       * Gets the capacity of this ByteBuffer's backing buffer.
       * @returns {number} Capacity of the backing buffer
       * @expose
       */
      ByteBufferPrototype.capacity = function() {
          return this.buffer.byteLength;
      };
      /**
       * Clears this ByteBuffer's offsets by setting {@link ByteBuffer#offset} to `0` and {@link ByteBuffer#limit} to the
       *  backing buffer's capacity. Discards {@link ByteBuffer#markedOffset}.
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.clear = function() {
          this.offset = 0;
          this.limit = this.buffer.byteLength;
          this.markedOffset = -1;
          return this;
      };

      /**
       * Creates a cloned instance of this ByteBuffer, preset with this ByteBuffer's values for {@link ByteBuffer#offset},
       *  {@link ByteBuffer#markedOffset} and {@link ByteBuffer#limit}.
       * @param {boolean=} copy Whether to copy the backing buffer or to return another view on the same, defaults to `false`
       * @returns {!ByteBuffer} Cloned instance
       * @expose
       */
      ByteBufferPrototype.clone = function(copy) {
          var bb = new ByteBuffer(0, this.littleEndian, this.noAssert);
          if (copy) {
              bb.buffer = new ArrayBuffer(this.buffer.byteLength);
              bb.view = new Uint8Array(bb.buffer);
          } else {
              bb.buffer = this.buffer;
              bb.view = this.view;
          }
          bb.offset = this.offset;
          bb.markedOffset = this.markedOffset;
          bb.limit = this.limit;
          return bb;
      };

      /**
       * Compacts this ByteBuffer to be backed by a {@link ByteBuffer#buffer} of its contents' length. Contents are the bytes
       *  between {@link ByteBuffer#offset} and {@link ByteBuffer#limit}. Will set `offset = 0` and `limit = capacity` and
       *  adapt {@link ByteBuffer#markedOffset} to the same relative position if set.
       * @param {number=} begin Offset to start at, defaults to {@link ByteBuffer#offset}
       * @param {number=} end Offset to end at, defaults to {@link ByteBuffer#limit}
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.compact = function(begin, end) {
          if (typeof begin === 'undefined') begin = this.offset;
          if (typeof end === 'undefined') end = this.limit;
          if (!this.noAssert) {
              if (typeof begin !== 'number' || begin % 1 !== 0)
                  throw TypeError("Illegal begin: Not an integer");
              begin >>>= 0;
              if (typeof end !== 'number' || end % 1 !== 0)
                  throw TypeError("Illegal end: Not an integer");
              end >>>= 0;
              if (begin < 0 || begin > end || end > this.buffer.byteLength)
                  throw RangeError("Illegal range: 0 <= "+begin+" <= "+end+" <= "+this.buffer.byteLength);
          }
          if (begin === 0 && end === this.buffer.byteLength)
              return this; // Already compacted
          var len = end - begin;
          if (len === 0) {
              this.buffer = EMPTY_BUFFER;
              this.view = null;
              if (this.markedOffset >= 0) this.markedOffset -= begin;
              this.offset = 0;
              this.limit = 0;
              return this;
          }
          var buffer = new ArrayBuffer(len);
          var view = new Uint8Array(buffer);
          view.set(this.view.subarray(begin, end));
          this.buffer = buffer;
          this.view = view;
          if (this.markedOffset >= 0) this.markedOffset -= begin;
          this.offset = 0;
          this.limit = len;
          return this;
      };

      /**
       * Creates a copy of this ByteBuffer's contents. Contents are the bytes between {@link ByteBuffer#offset} and
       *  {@link ByteBuffer#limit}.
       * @param {number=} begin Begin offset, defaults to {@link ByteBuffer#offset}.
       * @param {number=} end End offset, defaults to {@link ByteBuffer#limit}.
       * @returns {!ByteBuffer} Copy
       * @expose
       */
      ByteBufferPrototype.copy = function(begin, end) {
          if (typeof begin === 'undefined') begin = this.offset;
          if (typeof end === 'undefined') end = this.limit;
          if (!this.noAssert) {
              if (typeof begin !== 'number' || begin % 1 !== 0)
                  throw TypeError("Illegal begin: Not an integer");
              begin >>>= 0;
              if (typeof end !== 'number' || end % 1 !== 0)
                  throw TypeError("Illegal end: Not an integer");
              end >>>= 0;
              if (begin < 0 || begin > end || end > this.buffer.byteLength)
                  throw RangeError("Illegal range: 0 <= "+begin+" <= "+end+" <= "+this.buffer.byteLength);
          }
          if (begin === end)
              return new ByteBuffer(0, this.littleEndian, this.noAssert);
          var capacity = end - begin,
              bb = new ByteBuffer(capacity, this.littleEndian, this.noAssert);
          bb.offset = 0;
          bb.limit = capacity;
          if (bb.markedOffset >= 0) bb.markedOffset -= begin;
          this.copyTo(bb, 0, begin, end);
          return bb;
      };

      /**
       * Copies this ByteBuffer's contents to another ByteBuffer. Contents are the bytes between {@link ByteBuffer#offset} and
       *  {@link ByteBuffer#limit}.
       * @param {!ByteBuffer} target Target ByteBuffer
       * @param {number=} targetOffset Offset to copy to. Will use and increase the target's {@link ByteBuffer#offset}
       *  by the number of bytes copied if omitted.
       * @param {number=} sourceOffset Offset to start copying from. Will use and increase {@link ByteBuffer#offset} by the
       *  number of bytes copied if omitted.
       * @param {number=} sourceLimit Offset to end copying from, defaults to {@link ByteBuffer#limit}
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.copyTo = function(target, targetOffset, sourceOffset, sourceLimit) {
          var relative,
              targetRelative;
          if (!this.noAssert) {
              if (!ByteBuffer.isByteBuffer(target))
                  throw TypeError("Illegal target: Not a ByteBuffer");
          }
          targetOffset = (targetRelative = typeof targetOffset === 'undefined') ? target.offset : targetOffset | 0;
          sourceOffset = (relative = typeof sourceOffset === 'undefined') ? this.offset : sourceOffset | 0;
          sourceLimit = typeof sourceLimit === 'undefined' ? this.limit : sourceLimit | 0;

          if (targetOffset < 0 || targetOffset > target.buffer.byteLength)
              throw RangeError("Illegal target range: 0 <= "+targetOffset+" <= "+target.buffer.byteLength);
          if (sourceOffset < 0 || sourceLimit > this.buffer.byteLength)
              throw RangeError("Illegal source range: 0 <= "+sourceOffset+" <= "+this.buffer.byteLength);

          var len = sourceLimit - sourceOffset;
          if (len === 0)
              return target; // Nothing to copy

          target.ensureCapacity(targetOffset + len);

          target.view.set(this.view.subarray(sourceOffset, sourceLimit), targetOffset);

          if (relative) this.offset += len;
          if (targetRelative) target.offset += len;

          return this;
      };

      /**
       * Makes sure that this ByteBuffer is backed by a {@link ByteBuffer#buffer} of at least the specified capacity. If the
       *  current capacity is exceeded, it will be doubled. If double the current capacity is less than the required capacity,
       *  the required capacity will be used instead.
       * @param {number} capacity Required capacity
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.ensureCapacity = function(capacity) {
          var current = this.buffer.byteLength;
          if (current < capacity)
              return this.resize((current *= 2) > capacity ? current : capacity);
          return this;
      };

      /**
       * Overwrites this ByteBuffer's contents with the specified value. Contents are the bytes between
       *  {@link ByteBuffer#offset} and {@link ByteBuffer#limit}.
       * @param {number|string} value Byte value to fill with. If given as a string, the first character is used.
       * @param {number=} begin Begin offset. Will use and increase {@link ByteBuffer#offset} by the number of bytes
       *  written if omitted. defaults to {@link ByteBuffer#offset}.
       * @param {number=} end End offset, defaults to {@link ByteBuffer#limit}.
       * @returns {!ByteBuffer} this
       * @expose
       * @example `someByteBuffer.clear().fill(0)` fills the entire backing buffer with zeroes
       */
      ByteBufferPrototype.fill = function(value, begin, end) {
          var relative = typeof begin === 'undefined';
          if (relative) begin = this.offset;
          if (typeof value === 'string' && value.length > 0)
              value = value.charCodeAt(0);
          if (typeof begin === 'undefined') begin = this.offset;
          if (typeof end === 'undefined') end = this.limit;
          if (!this.noAssert) {
              if (typeof value !== 'number' || value % 1 !== 0)
                  throw TypeError("Illegal value: "+value+" (not an integer)");
              value |= 0;
              if (typeof begin !== 'number' || begin % 1 !== 0)
                  throw TypeError("Illegal begin: Not an integer");
              begin >>>= 0;
              if (typeof end !== 'number' || end % 1 !== 0)
                  throw TypeError("Illegal end: Not an integer");
              end >>>= 0;
              if (begin < 0 || begin > end || end > this.buffer.byteLength)
                  throw RangeError("Illegal range: 0 <= "+begin+" <= "+end+" <= "+this.buffer.byteLength);
          }
          if (begin >= end)
              return this; // Nothing to fill
          while (begin < end) this.view[begin++] = value;
          if (relative) this.offset = begin;
          return this;
      };

      /**
       * Makes this ByteBuffer ready for a new sequence of write or relative read operations. Sets `limit = offset` and
       *  `offset = 0`. Make sure always to flip a ByteBuffer when all relative read or write operations are complete.
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.flip = function() {
          this.limit = this.offset;
          this.offset = 0;
          return this;
      };
      /**
       * Marks an offset on this ByteBuffer to be used later.
       * @param {number=} offset Offset to mark. Defaults to {@link ByteBuffer#offset}.
       * @returns {!ByteBuffer} this
       * @throws {TypeError} If `offset` is not a valid number
       * @throws {RangeError} If `offset` is out of bounds
       * @see ByteBuffer#reset
       * @expose
       */
      ByteBufferPrototype.mark = function(offset) {
          offset = typeof offset === 'undefined' ? this.offset : offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          this.markedOffset = offset;
          return this;
      };
      /**
       * Sets the byte order.
       * @param {boolean} littleEndian `true` for little endian byte order, `false` for big endian
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.order = function(littleEndian) {
          if (!this.noAssert) {
              if (typeof littleEndian !== 'boolean')
                  throw TypeError("Illegal littleEndian: Not a boolean");
          }
          this.littleEndian = !!littleEndian;
          return this;
      };

      /**
       * Switches (to) little endian byte order.
       * @param {boolean=} littleEndian Defaults to `true`, otherwise uses big endian
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.LE = function(littleEndian) {
          this.littleEndian = typeof littleEndian !== 'undefined' ? !!littleEndian : true;
          return this;
      };

      /**
       * Switches (to) big endian byte order.
       * @param {boolean=} bigEndian Defaults to `true`, otherwise uses little endian
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.BE = function(bigEndian) {
          this.littleEndian = typeof bigEndian !== 'undefined' ? !bigEndian : false;
          return this;
      };
      /**
       * Prepends some data to this ByteBuffer. This will overwrite any contents before the specified offset up to the
       *  prepended data's length. If there is not enough space available before the specified `offset`, the backing buffer
       *  will be resized and its contents moved accordingly.
       * @param {!ByteBuffer|string|!ArrayBuffer} source Data to prepend. If `source` is a ByteBuffer, its offset will be
       *  modified according to the performed read operation.
       * @param {(string|number)=} encoding Encoding if `data` is a string ("base64", "hex", "binary", defaults to "utf8")
       * @param {number=} offset Offset to prepend at. Will use and decrease {@link ByteBuffer#offset} by the number of bytes
       *  prepended if omitted.
       * @returns {!ByteBuffer} this
       * @expose
       * @example A relative `00<01 02 03>.prepend(<04 05>)` results in `<04 05 01 02 03>, 04 05|`
       * @example An absolute `00<01 02 03>.prepend(<04 05>, 2)` results in `04<05 02 03>, 04 05|`
       */
      ByteBufferPrototype.prepend = function(source, encoding, offset) {
          if (typeof encoding === 'number' || typeof encoding !== 'string') {
              offset = encoding;
              encoding = undefined;
          }
          var relative = typeof offset === 'undefined';
          if (relative) offset = this.offset;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: "+offset+" (not an integer)");
              offset >>>= 0;
              if (offset < 0 || offset + 0 > this.buffer.byteLength)
                  throw RangeError("Illegal offset: 0 <= "+offset+" (+"+0+") <= "+this.buffer.byteLength);
          }
          if (!(source instanceof ByteBuffer))
              source = ByteBuffer.wrap(source, encoding);
          var len = source.limit - source.offset;
          if (len <= 0) return this; // Nothing to prepend
          var diff = len - offset;
          if (diff > 0) { // Not enough space before offset, so resize + move
              var buffer = new ArrayBuffer(this.buffer.byteLength + diff);
              var view = new Uint8Array(buffer);
              view.set(this.view.subarray(offset, this.buffer.byteLength), len);
              this.buffer = buffer;
              this.view = view;
              this.offset += diff;
              if (this.markedOffset >= 0) this.markedOffset += diff;
              this.limit += diff;
              offset += diff;
          } else {
              var arrayView = new Uint8Array(this.buffer);
          }
          this.view.set(source.view.subarray(source.offset, source.limit), offset - len);

          source.offset = source.limit;
          if (relative)
              this.offset -= len;
          return this;
      };

      /**
       * Prepends this ByteBuffer to another ByteBuffer. This will overwrite any contents before the specified offset up to the
       *  prepended data's length. If there is not enough space available before the specified `offset`, the backing buffer
       *  will be resized and its contents moved accordingly.
       * @param {!ByteBuffer} target Target ByteBuffer
       * @param {number=} offset Offset to prepend at. Will use and decrease {@link ByteBuffer#offset} by the number of bytes
       *  prepended if omitted.
       * @returns {!ByteBuffer} this
       * @expose
       * @see ByteBuffer#prepend
       */
      ByteBufferPrototype.prependTo = function(target, offset) {
          target.prepend(this, offset);
          return this;
      };
      /**
       * Prints debug information about this ByteBuffer's contents.
       * @param {function(string)=} out Output function to call, defaults to console.log
       * @expose
       */
      ByteBufferPrototype.printDebug = function(out) {
          if (typeof out !== 'function') out = console.log.bind(console);
          out(
              this.toString()+"\n"+
              "-------------------------------------------------------------------\n"+
              this.toDebug(/* columns */ true)
          );
      };

      /**
       * Gets the number of remaining readable bytes. Contents are the bytes between {@link ByteBuffer#offset} and
       *  {@link ByteBuffer#limit}, so this returns `limit - offset`.
       * @returns {number} Remaining readable bytes. May be negative if `offset > limit`.
       * @expose
       */
      ByteBufferPrototype.remaining = function() {
          return this.limit - this.offset;
      };
      /**
       * Resets this ByteBuffer's {@link ByteBuffer#offset}. If an offset has been marked through {@link ByteBuffer#mark}
       *  before, `offset` will be set to {@link ByteBuffer#markedOffset}, which will then be discarded. If no offset has been
       *  marked, sets `offset = 0`.
       * @returns {!ByteBuffer} this
       * @see ByteBuffer#mark
       * @expose
       */
      ByteBufferPrototype.reset = function() {
          if (this.markedOffset >= 0) {
              this.offset = this.markedOffset;
              this.markedOffset = -1;
          } else {
              this.offset = 0;
          }
          return this;
      };
      /**
       * Resizes this ByteBuffer to be backed by a buffer of at least the given capacity. Will do nothing if already that
       *  large or larger.
       * @param {number} capacity Capacity required
       * @returns {!ByteBuffer} this
       * @throws {TypeError} If `capacity` is not a number
       * @throws {RangeError} If `capacity < 0`
       * @expose
       */
      ByteBufferPrototype.resize = function(capacity) {
          if (!this.noAssert) {
              if (typeof capacity !== 'number' || capacity % 1 !== 0)
                  throw TypeError("Illegal capacity: "+capacity+" (not an integer)");
              capacity |= 0;
              if (capacity < 0)
                  throw RangeError("Illegal capacity: 0 <= "+capacity);
          }
          if (this.buffer.byteLength < capacity) {
              var buffer = new ArrayBuffer(capacity);
              var view = new Uint8Array(buffer);
              view.set(this.view);
              this.buffer = buffer;
              this.view = view;
          }
          return this;
      };
      /**
       * Reverses this ByteBuffer's contents.
       * @param {number=} begin Offset to start at, defaults to {@link ByteBuffer#offset}
       * @param {number=} end Offset to end at, defaults to {@link ByteBuffer#limit}
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.reverse = function(begin, end) {
          if (typeof begin === 'undefined') begin = this.offset;
          if (typeof end === 'undefined') end = this.limit;
          if (!this.noAssert) {
              if (typeof begin !== 'number' || begin % 1 !== 0)
                  throw TypeError("Illegal begin: Not an integer");
              begin >>>= 0;
              if (typeof end !== 'number' || end % 1 !== 0)
                  throw TypeError("Illegal end: Not an integer");
              end >>>= 0;
              if (begin < 0 || begin > end || end > this.buffer.byteLength)
                  throw RangeError("Illegal range: 0 <= "+begin+" <= "+end+" <= "+this.buffer.byteLength);
          }
          if (begin === end)
              return this; // Nothing to reverse
          Array.prototype.reverse.call(this.view.subarray(begin, end));
          return this;
      };
      /**
       * Skips the next `length` bytes. This will just advance
       * @param {number} length Number of bytes to skip. May also be negative to move the offset back.
       * @returns {!ByteBuffer} this
       * @expose
       */
      ByteBufferPrototype.skip = function(length) {
          if (!this.noAssert) {
              if (typeof length !== 'number' || length % 1 !== 0)
                  throw TypeError("Illegal length: "+length+" (not an integer)");
              length |= 0;
          }
          var offset = this.offset + length;
          if (!this.noAssert) {
              if (offset < 0 || offset > this.buffer.byteLength)
                  throw RangeError("Illegal length: 0 <= "+this.offset+" + "+length+" <= "+this.buffer.byteLength);
          }
          this.offset = offset;
          return this;
      };

      /**
       * Slices this ByteBuffer by creating a cloned instance with `offset = begin` and `limit = end`.
       * @param {number=} begin Begin offset, defaults to {@link ByteBuffer#offset}.
       * @param {number=} end End offset, defaults to {@link ByteBuffer#limit}.
       * @returns {!ByteBuffer} Clone of this ByteBuffer with slicing applied, backed by the same {@link ByteBuffer#buffer}
       * @expose
       */
      ByteBufferPrototype.slice = function(begin, end) {
          if (typeof begin === 'undefined') begin = this.offset;
          if (typeof end === 'undefined') end = this.limit;
          if (!this.noAssert) {
              if (typeof begin !== 'number' || begin % 1 !== 0)
                  throw TypeError("Illegal begin: Not an integer");
              begin >>>= 0;
              if (typeof end !== 'number' || end % 1 !== 0)
                  throw TypeError("Illegal end: Not an integer");
              end >>>= 0;
              if (begin < 0 || begin > end || end > this.buffer.byteLength)
                  throw RangeError("Illegal range: 0 <= "+begin+" <= "+end+" <= "+this.buffer.byteLength);
          }
          var bb = this.clone();
          bb.offset = begin;
          bb.limit = end;
          return bb;
      };
      /**
       * Returns a copy of the backing buffer that contains this ByteBuffer's contents. Contents are the bytes between
       *  {@link ByteBuffer#offset} and {@link ByteBuffer#limit}.
       * @param {boolean=} forceCopy If `true` returns a copy, otherwise returns a view referencing the same memory if
       *  possible. Defaults to `false`
       * @returns {!ArrayBuffer} Contents as an ArrayBuffer
       * @expose
       */
      ByteBufferPrototype.toBuffer = function(forceCopy) {
          var offset = this.offset,
              limit = this.limit;
          if (!this.noAssert) {
              if (typeof offset !== 'number' || offset % 1 !== 0)
                  throw TypeError("Illegal offset: Not an integer");
              offset >>>= 0;
              if (typeof limit !== 'number' || limit % 1 !== 0)
                  throw TypeError("Illegal limit: Not an integer");
              limit >>>= 0;
              if (offset < 0 || offset > limit || limit > this.buffer.byteLength)
                  throw RangeError("Illegal range: 0 <= "+offset+" <= "+limit+" <= "+this.buffer.byteLength);
          }
          // NOTE: It's not possible to have another ArrayBuffer reference the same memory as the backing buffer. This is
          // possible with Uint8Array#subarray only, but we have to return an ArrayBuffer by contract. So:
          if (!forceCopy && offset === 0 && limit === this.buffer.byteLength)
              return this.buffer;
          if (offset === limit)
              return EMPTY_BUFFER;
          var buffer = new ArrayBuffer(limit - offset);
          new Uint8Array(buffer).set(new Uint8Array(this.buffer).subarray(offset, limit), 0);
          return buffer;
      };

      /**
       * Returns a raw buffer compacted to contain this ByteBuffer's contents. Contents are the bytes between
       *  {@link ByteBuffer#offset} and {@link ByteBuffer#limit}. This is an alias of {@link ByteBuffer#toBuffer}.
       * @function
       * @param {boolean=} forceCopy If `true` returns a copy, otherwise returns a view referencing the same memory.
       *  Defaults to `false`
       * @returns {!ArrayBuffer} Contents as an ArrayBuffer
       * @expose
       */
      ByteBufferPrototype.toArrayBuffer = ByteBufferPrototype.toBuffer;

      /**
       * Converts the ByteBuffer's contents to a string.
       * @param {string=} encoding Output encoding. Returns an informative string representation if omitted but also allows
       *  direct conversion to "utf8", "hex", "base64" and "binary" encoding. "debug" returns a hex representation with
       *  highlighted offsets.
       * @param {number=} begin Offset to begin at, defaults to {@link ByteBuffer#offset}
       * @param {number=} end Offset to end at, defaults to {@link ByteBuffer#limit}
       * @returns {string} String representation
       * @throws {Error} If `encoding` is invalid
       * @expose
       */
      ByteBufferPrototype.toString = function(encoding, begin, end) {
          if (typeof encoding === 'undefined')
              return "ByteBufferAB(offset="+this.offset+",markedOffset="+this.markedOffset+",limit="+this.limit+",capacity="+this.capacity()+")";
          if (typeof encoding === 'number')
              encoding = "utf8",
              begin = encoding,
              end = begin;
          switch (encoding) {
              case "utf8":
                  return this.toUTF8(begin, end);
              case "base64":
                  return this.toBase64(begin, end);
              case "hex":
                  return this.toHex(begin, end);
              case "binary":
                  return this.toBinary(begin, end);
              case "debug":
                  return this.toDebug();
              case "columns":
                  return this.toColumns();
              default:
                  throw Error("Unsupported encoding: "+encoding);
          }
      };

      // lxiv-embeddable

      /**
       * lxiv-embeddable (c) 2014 Daniel Wirtz <dcode@dcode.io>
       * Released under the Apache License, Version 2.0
       * see: https://github.com/dcodeIO/lxiv for details
       */
      var lxiv = function() {

          /**
           * lxiv namespace.
           * @type {!Object.<string,*>}
           * @exports lxiv
           */
          var lxiv = {};

          /**
           * Character codes for output.
           * @type {!Array.<number>}
           * @inner
           */
          var aout = [
              65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80,
              81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 97, 98, 99, 100, 101, 102,
              103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118,
              119, 120, 121, 122, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 43, 47
          ];

          /**
           * Character codes for input.
           * @type {!Array.<number>}
           * @inner
           */
          var ain = [];
          for (var i=0, k=aout.length; i<k; ++i)
              ain[aout[i]] = i;

          /**
           * Encodes bytes to base64 char codes.
           * @param {!function():number|null} src Bytes source as a function returning the next byte respectively `null` if
           *  there are no more bytes left.
           * @param {!function(number)} dst Characters destination as a function successively called with each encoded char
           *  code.
           */
          lxiv.encode = function(src, dst) {
              var b, t;
              while ((b = src()) !== null) {
                  dst(aout[(b>>2)&0x3f]);
                  t = (b&0x3)<<4;
                  if ((b = src()) !== null) {
                      t |= (b>>4)&0xf;
                      dst(aout[(t|((b>>4)&0xf))&0x3f]);
                      t = (b&0xf)<<2;
                      if ((b = src()) !== null)
                          dst(aout[(t|((b>>6)&0x3))&0x3f]),
                          dst(aout[b&0x3f]);
                      else
                          dst(aout[t&0x3f]),
                          dst(61);
                  } else
                      dst(aout[t&0x3f]),
                      dst(61),
                      dst(61);
              }
          };

          /**
           * Decodes base64 char codes to bytes.
           * @param {!function():number|null} src Characters source as a function returning the next char code respectively
           *  `null` if there are no more characters left.
           * @param {!function(number)} dst Bytes destination as a function successively called with the next byte.
           * @throws {Error} If a character code is invalid
           */
          lxiv.decode = function(src, dst) {
              var c, t1, t2;
              function fail(c) {
                  throw Error("Illegal character code: "+c);
              }
              while ((c = src()) !== null) {
                  t1 = ain[c];
                  if (typeof t1 === 'undefined') fail(c);
                  if ((c = src()) !== null) {
                      t2 = ain[c];
                      if (typeof t2 === 'undefined') fail(c);
                      dst((t1<<2)>>>0|(t2&0x30)>>4);
                      if ((c = src()) !== null) {
                          t1 = ain[c];
                          if (typeof t1 === 'undefined')
                              if (c === 61) break; else fail(c);
                          dst(((t2&0xf)<<4)>>>0|(t1&0x3c)>>2);
                          if ((c = src()) !== null) {
                              t2 = ain[c];
                              if (typeof t2 === 'undefined')
                                  if (c === 61) break; else fail(c);
                              dst(((t1&0x3)<<6)>>>0|t2);
                          }
                      }
                  }
              }
          };

          /**
           * Tests if a string is valid base64.
           * @param {string} str String to test
           * @returns {boolean} `true` if valid, otherwise `false`
           */
          lxiv.test = function(str) {
              return /^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=)?$/.test(str);
          };

          return lxiv;
      }();

      // encodings/base64

      /**
       * Encodes this ByteBuffer's contents to a base64 encoded string.
       * @param {number=} begin Offset to begin at, defaults to {@link ByteBuffer#offset}.
       * @param {number=} end Offset to end at, defaults to {@link ByteBuffer#limit}.
       * @returns {string} Base64 encoded string
       * @throws {RangeError} If `begin` or `end` is out of bounds
       * @expose
       */
      ByteBufferPrototype.toBase64 = function(begin, end) {
          if (typeof begin === 'undefined')
              begin = this.offset;
          if (typeof end === 'undefined')
              end = this.limit;
          begin = begin | 0; end = end | 0;
          if (begin < 0 || end > this.capacity || begin > end)
              throw RangeError("begin, end");
          var sd; lxiv.encode(function() {
              return begin < end ? this.view[begin++] : null;
          }.bind(this), sd = stringDestination());
          return sd();
      };

      /**
       * Decodes a base64 encoded string to a ByteBuffer.
       * @param {string} str String to decode
       * @param {boolean=} littleEndian Whether to use little or big endian byte order. Defaults to
       *  {@link ByteBuffer.DEFAULT_ENDIAN}.
       * @returns {!ByteBuffer} ByteBuffer
       * @expose
       */
      ByteBuffer.fromBase64 = function(str, littleEndian) {
          if (typeof str !== 'string')
              throw TypeError("str");
          var bb = new ByteBuffer(str.length/4*3, littleEndian),
              i = 0;
          lxiv.decode(stringSource(str), function(b) {
              bb.view[i++] = b;
          });
          bb.limit = i;
          return bb;
      };

      /**
       * Encodes a binary string to base64 like `window.btoa` does.
       * @param {string} str Binary string
       * @returns {string} Base64 encoded string
       * @see https://developer.mozilla.org/en-US/docs/Web/API/Window.btoa
       * @expose
       */
      ByteBuffer.btoa = function(str) {
          return ByteBuffer.fromBinary(str).toBase64();
      };

      /**
       * Decodes a base64 encoded string to binary like `window.atob` does.
       * @param {string} b64 Base64 encoded string
       * @returns {string} Binary string
       * @see https://developer.mozilla.org/en-US/docs/Web/API/Window.atob
       * @expose
       */
      ByteBuffer.atob = function(b64) {
          return ByteBuffer.fromBase64(b64).toBinary();
      };

      // encodings/binary

      /**
       * Encodes this ByteBuffer to a binary encoded string, that is using only characters 0x00-0xFF as bytes.
       * @param {number=} begin Offset to begin at. Defaults to {@link ByteBuffer#offset}.
       * @param {number=} end Offset to end at. Defaults to {@link ByteBuffer#limit}.
       * @returns {string} Binary encoded string
       * @throws {RangeError} If `offset > limit`
       * @expose
       */
      ByteBufferPrototype.toBinary = function(begin, end) {
          if (typeof begin === 'undefined')
              begin = this.offset;
          if (typeof end === 'undefined')
              end = this.limit;
          begin |= 0; end |= 0;
          if (begin < 0 || end > this.capacity() || begin > end)
              throw RangeError("begin, end");
          if (begin === end)
              return "";
          var chars = [],
              parts = [];
          while (begin < end) {
              chars.push(this.view[begin++]);
              if (chars.length >= 1024)
                  parts.push(String.fromCharCode.apply(String, chars)),
                  chars = [];
          }
          return parts.join('') + String.fromCharCode.apply(String, chars);
      };

      /**
       * Decodes a binary encoded string, that is using only characters 0x00-0xFF as bytes, to a ByteBuffer.
       * @param {string} str String to decode
       * @param {boolean=} littleEndian Whether to use little or big endian byte order. Defaults to
       *  {@link ByteBuffer.DEFAULT_ENDIAN}.
       * @returns {!ByteBuffer} ByteBuffer
       * @expose
       */
      ByteBuffer.fromBinary = function(str, littleEndian) {
          if (typeof str !== 'string')
              throw TypeError("str");
          var i = 0,
              k = str.length,
              charCode,
              bb = new ByteBuffer(k, littleEndian);
          while (i<k) {
              charCode = str.charCodeAt(i);
              if (charCode > 0xff)
                  throw RangeError("illegal char code: "+charCode);
              bb.view[i++] = charCode;
          }
          bb.limit = k;
          return bb;
      };

      // encodings/debug

      /**
       * Encodes this ByteBuffer to a hex encoded string with marked offsets. Offset symbols are:
       * * `<` : offset,
       * * `'` : markedOffset,
       * * `>` : limit,
       * * `|` : offset and limit,
       * * `[` : offset and markedOffset,
       * * `]` : markedOffset and limit,
       * * `!` : offset, markedOffset and limit
       * @param {boolean=} columns If `true` returns two columns hex + ascii, defaults to `false`
       * @returns {string|!Array.<string>} Debug string or array of lines if `asArray = true`
       * @expose
       * @example `>00'01 02<03` contains four bytes with `limit=0, markedOffset=1, offset=3`
       * @example `00[01 02 03>` contains four bytes with `offset=markedOffset=1, limit=4`
       * @example `00|01 02 03` contains four bytes with `offset=limit=1, markedOffset=-1`
       * @example `|` contains zero bytes with `offset=limit=0, markedOffset=-1`
       */
      ByteBufferPrototype.toDebug = function(columns) {
          var i = -1,
              k = this.buffer.byteLength,
              b,
              hex = "",
              asc = "",
              out = "";
          while (i<k) {
              if (i !== -1) {
                  b = this.view[i];
                  if (b < 0x10) hex += "0"+b.toString(16).toUpperCase();
                  else hex += b.toString(16).toUpperCase();
                  if (columns)
                      asc += b > 32 && b < 127 ? String.fromCharCode(b) : '.';
              }
              ++i;
              if (columns) {
                  if (i > 0 && i % 16 === 0 && i !== k) {
                      while (hex.length < 3*16+3) hex += " ";
                      out += hex+asc+"\n";
                      hex = asc = "";
                  }
              }
              if (i === this.offset && i === this.limit)
                  hex += i === this.markedOffset ? "!" : "|";
              else if (i === this.offset)
                  hex += i === this.markedOffset ? "[" : "<";
              else if (i === this.limit)
                  hex += i === this.markedOffset ? "]" : ">";
              else
                  hex += i === this.markedOffset ? "'" : (columns || (i !== 0 && i !== k) ? " " : "");
          }
          if (columns && hex !== " ") {
              while (hex.length < 3*16+3)
                  hex += " ";
              out += hex + asc + "\n";
          }
          return columns ? out : hex;
      };

      /**
       * Decodes a hex encoded string with marked offsets to a ByteBuffer.
       * @param {string} str Debug string to decode (not be generated with `columns = true`)
       * @param {boolean=} littleEndian Whether to use little or big endian byte order. Defaults to
       *  {@link ByteBuffer.DEFAULT_ENDIAN}.
       * @param {boolean=} noAssert Whether to skip assertions of offsets and values. Defaults to
       *  {@link ByteBuffer.DEFAULT_NOASSERT}.
       * @returns {!ByteBuffer} ByteBuffer
       * @expose
       * @see ByteBuffer#toDebug
       */
      ByteBuffer.fromDebug = function(str, littleEndian, noAssert) {
          var k = str.length,
              bb = new ByteBuffer(((k+1)/3)|0, littleEndian, noAssert);
          var i = 0, j = 0, ch, b,
              rs = false, // Require symbol next
              ho = false, hm = false, hl = false, // Already has offset (ho), markedOffset (hm), limit (hl)?
              fail = false;
          while (i<k) {
              switch (ch = str.charAt(i++)) {
                  case '!':
                      if (!noAssert) {
                          if (ho || hm || hl) {
                              fail = true;
                              break;
                          }
                          ho = hm = hl = true;
                      }
                      bb.offset = bb.markedOffset = bb.limit = j;
                      rs = false;
                      break;
                  case '|':
                      if (!noAssert) {
                          if (ho || hl) {
                              fail = true;
                              break;
                          }
                          ho = hl = true;
                      }
                      bb.offset = bb.limit = j;
                      rs = false;
                      break;
                  case '[':
                      if (!noAssert) {
                          if (ho || hm) {
                              fail = true;
                              break;
                          }
                          ho = hm = true;
                      }
                      bb.offset = bb.markedOffset = j;
                      rs = false;
                      break;
                  case '<':
                      if (!noAssert) {
                          if (ho) {
                              fail = true;
                              break;
                          }
                          ho = true;
                      }
                      bb.offset = j;
                      rs = false;
                      break;
                  case ']':
                      if (!noAssert) {
                          if (hl || hm) {
                              fail = true;
                              break;
                          }
                          hl = hm = true;
                      }
                      bb.limit = bb.markedOffset = j;
                      rs = false;
                      break;
                  case '>':
                      if (!noAssert) {
                          if (hl) {
                              fail = true;
                              break;
                          }
                          hl = true;
                      }
                      bb.limit = j;
                      rs = false;
                      break;
                  case "'":
                      if (!noAssert) {
                          if (hm) {
                              fail = true;
                              break;
                          }
                          hm = true;
                      }
                      bb.markedOffset = j;
                      rs = false;
                      break;
                  case ' ':
                      rs = false;
                      break;
                  default:
                      if (!noAssert) {
                          if (rs) {
                              fail = true;
                              break;
                          }
                      }
                      b = parseInt(ch+str.charAt(i++), 16);
                      if (!noAssert) {
                          if (isNaN(b) || b < 0 || b > 255)
                              throw TypeError("Illegal str: Not a debug encoded string");
                      }
                      bb.view[j++] = b;
                      rs = true;
              }
              if (fail)
                  throw TypeError("Illegal str: Invalid symbol at "+i);
          }
          if (!noAssert) {
              if (!ho || !hl)
                  throw TypeError("Illegal str: Missing offset or limit");
              if (j<bb.buffer.byteLength)
                  throw TypeError("Illegal str: Not a debug encoded string (is it hex?) "+j+" < "+k);
          }
          return bb;
      };

      // encodings/hex

      /**
       * Encodes this ByteBuffer's contents to a hex encoded string.
       * @param {number=} begin Offset to begin at. Defaults to {@link ByteBuffer#offset}.
       * @param {number=} end Offset to end at. Defaults to {@link ByteBuffer#limit}.
       * @returns {string} Hex encoded string
       * @expose
       */
      ByteBufferPrototype.toHex = function(begin, end) {
          begin = typeof begin === 'undefined' ? this.offset : begin;
          end = typeof end === 'undefined' ? this.limit : end;
          if (!this.noAssert) {
              if (typeof begin !== 'number' || begin % 1 !== 0)
                  throw TypeError("Illegal begin: Not an integer");
              begin >>>= 0;
              if (typeof end !== 'number' || end % 1 !== 0)
                  throw TypeError("Illegal end: Not an integer");
              end >>>= 0;
              if (begin < 0 || begin > end || end > this.buffer.byteLength)
                  throw RangeError("Illegal range: 0 <= "+begin+" <= "+end+" <= "+this.buffer.byteLength);
          }
          var out = new Array(end - begin),
              b;
          while (begin < end) {
              b = this.view[begin++];
              if (b < 0x10)
                  out.push("0", b.toString(16));
              else out.push(b.toString(16));
          }
          return out.join('');
      };

      /**
       * Decodes a hex encoded string to a ByteBuffer.
       * @param {string} str String to decode
       * @param {boolean=} littleEndian Whether to use little or big endian byte order. Defaults to
       *  {@link ByteBuffer.DEFAULT_ENDIAN}.
       * @param {boolean=} noAssert Whether to skip assertions of offsets and values. Defaults to
       *  {@link ByteBuffer.DEFAULT_NOASSERT}.
       * @returns {!ByteBuffer} ByteBuffer
       * @expose
       */
      ByteBuffer.fromHex = function(str, littleEndian, noAssert) {
          if (!noAssert) {
              if (typeof str !== 'string')
                  throw TypeError("Illegal str: Not a string");
              if (str.length % 2 !== 0)
                  throw TypeError("Illegal str: Length not a multiple of 2");
          }
          var k = str.length,
              bb = new ByteBuffer((k / 2) | 0, littleEndian),
              b;
          for (var i=0, j=0; i<k; i+=2) {
              b = parseInt(str.substring(i, i+2), 16);
              if (!noAssert)
                  if (!isFinite(b) || b < 0 || b > 255)
                      throw TypeError("Illegal str: Contains non-hex characters");
              bb.view[j++] = b;
          }
          bb.limit = j;
          return bb;
      };

      // utfx-embeddable

      /**
       * utfx-embeddable (c) 2014 Daniel Wirtz <dcode@dcode.io>
       * Released under the Apache License, Version 2.0
       * see: https://github.com/dcodeIO/utfx for details
       */
      var utfx = function() {

          /**
           * utfx namespace.
           * @inner
           * @type {!Object.<string,*>}
           */
          var utfx = {};

          /**
           * Maximum valid code point.
           * @type {number}
           * @const
           */
          utfx.MAX_CODEPOINT = 0x10FFFF;

          /**
           * Encodes UTF8 code points to UTF8 bytes.
           * @param {(!function():number|null) | number} src Code points source, either as a function returning the next code point
           *  respectively `null` if there are no more code points left or a single numeric code point.
           * @param {!function(number)} dst Bytes destination as a function successively called with the next byte
           */
          utfx.encodeUTF8 = function(src, dst) {
              var cp = null;
              if (typeof src === 'number')
                  cp = src,
                  src = function() { return null; };
              while (cp !== null || (cp = src()) !== null) {
                  if (cp < 0x80)
                      dst(cp&0x7F);
                  else if (cp < 0x800)
                      dst(((cp>>6)&0x1F)|0xC0),
                      dst((cp&0x3F)|0x80);
                  else if (cp < 0x10000)
                      dst(((cp>>12)&0x0F)|0xE0),
                      dst(((cp>>6)&0x3F)|0x80),
                      dst((cp&0x3F)|0x80);
                  else
                      dst(((cp>>18)&0x07)|0xF0),
                      dst(((cp>>12)&0x3F)|0x80),
                      dst(((cp>>6)&0x3F)|0x80),
                      dst((cp&0x3F)|0x80);
                  cp = null;
              }
          };

          /**
           * Decodes UTF8 bytes to UTF8 code points.
           * @param {!function():number|null} src Bytes source as a function returning the next byte respectively `null` if there
           *  are no more bytes left.
           * @param {!function(number)} dst Code points destination as a function successively called with each decoded code point.
           * @throws {RangeError} If a starting byte is invalid in UTF8
           * @throws {Error} If the last sequence is truncated. Has an array property `bytes` holding the
           *  remaining bytes.
           */
          utfx.decodeUTF8 = function(src, dst) {
              var a, b, c, d, fail = function(b) {
                  b = b.slice(0, b.indexOf(null));
                  var err = Error(b.toString());
                  err.name = "TruncatedError";
                  err['bytes'] = b;
                  throw err;
              };
              while ((a = src()) !== null) {
                  if ((a&0x80) === 0)
                      dst(a);
                  else if ((a&0xE0) === 0xC0)
                      ((b = src()) === null) && fail([a, b]),
                      dst(((a&0x1F)<<6) | (b&0x3F));
                  else if ((a&0xF0) === 0xE0)
                      ((b=src()) === null || (c=src()) === null) && fail([a, b, c]),
                      dst(((a&0x0F)<<12) | ((b&0x3F)<<6) | (c&0x3F));
                  else if ((a&0xF8) === 0xF0)
                      ((b=src()) === null || (c=src()) === null || (d=src()) === null) && fail([a, b, c ,d]),
                      dst(((a&0x07)<<18) | ((b&0x3F)<<12) | ((c&0x3F)<<6) | (d&0x3F));
                  else throw RangeError("Illegal starting byte: "+a);
              }
          };

          /**
           * Converts UTF16 characters to UTF8 code points.
           * @param {!function():number|null} src Characters source as a function returning the next char code respectively
           *  `null` if there are no more characters left.
           * @param {!function(number)} dst Code points destination as a function successively called with each converted code
           *  point.
           */
          utfx.UTF16toUTF8 = function(src, dst) {
              var c1, c2 = null;
              while (true) {
                  if ((c1 = c2 !== null ? c2 : src()) === null)
                      break;
                  if (c1 >= 0xD800 && c1 <= 0xDFFF) {
                      if ((c2 = src()) !== null) {
                          if (c2 >= 0xDC00 && c2 <= 0xDFFF) {
                              dst((c1-0xD800)*0x400+c2-0xDC00+0x10000);
                              c2 = null; continue;
                          }
                      }
                  }
                  dst(c1);
              }
              if (c2 !== null) dst(c2);
          };

          /**
           * Converts UTF8 code points to UTF16 characters.
           * @param {(!function():number|null) | number} src Code points source, either as a function returning the next code point
           *  respectively `null` if there are no more code points left or a single numeric code point.
           * @param {!function(number)} dst Characters destination as a function successively called with each converted char code.
           * @throws {RangeError} If a code point is out of range
           */
          utfx.UTF8toUTF16 = function(src, dst) {
              var cp = null;
              if (typeof src === 'number')
                  cp = src, src = function() { return null; };
              while (cp !== null || (cp = src()) !== null) {
                  if (cp <= 0xFFFF)
                      dst(cp);
                  else
                      cp -= 0x10000,
                      dst((cp>>10)+0xD800),
                      dst((cp%0x400)+0xDC00);
                  cp = null;
              }
          };

          /**
           * Converts and encodes UTF16 characters to UTF8 bytes.
           * @param {!function():number|null} src Characters source as a function returning the next char code respectively `null`
           *  if there are no more characters left.
           * @param {!function(number)} dst Bytes destination as a function successively called with the next byte.
           */
          utfx.encodeUTF16toUTF8 = function(src, dst) {
              utfx.UTF16toUTF8(src, function(cp) {
                  utfx.encodeUTF8(cp, dst);
              });
          };

          /**
           * Decodes and converts UTF8 bytes to UTF16 characters.
           * @param {!function():number|null} src Bytes source as a function returning the next byte respectively `null` if there
           *  are no more bytes left.
           * @param {!function(number)} dst Characters destination as a function successively called with each converted char code.
           * @throws {RangeError} If a starting byte is invalid in UTF8
           * @throws {Error} If the last sequence is truncated. Has an array property `bytes` holding the remaining bytes.
           */
          utfx.decodeUTF8toUTF16 = function(src, dst) {
              utfx.decodeUTF8(src, function(cp) {
                  utfx.UTF8toUTF16(cp, dst);
              });
          };

          /**
           * Calculates the byte length of an UTF8 code point.
           * @param {number} cp UTF8 code point
           * @returns {number} Byte length
           */
          utfx.calculateCodePoint = function(cp) {
              return (cp < 0x80) ? 1 : (cp < 0x800) ? 2 : (cp < 0x10000) ? 3 : 4;
          };

          /**
           * Calculates the number of UTF8 bytes required to store UTF8 code points.
           * @param {(!function():number|null)} src Code points source as a function returning the next code point respectively
           *  `null` if there are no more code points left.
           * @returns {number} The number of UTF8 bytes required
           */
          utfx.calculateUTF8 = function(src) {
              var cp, l=0;
              while ((cp = src()) !== null)
                  l += (cp < 0x80) ? 1 : (cp < 0x800) ? 2 : (cp < 0x10000) ? 3 : 4;
              return l;
          };

          /**
           * Calculates the number of UTF8 code points respectively UTF8 bytes required to store UTF16 char codes.
           * @param {(!function():number|null)} src Characters source as a function returning the next char code respectively
           *  `null` if there are no more characters left.
           * @returns {!Array.<number>} The number of UTF8 code points at index 0 and the number of UTF8 bytes required at index 1.
           */
          utfx.calculateUTF16asUTF8 = function(src) {
              var n=0, l=0;
              utfx.UTF16toUTF8(src, function(cp) {
                  ++n; l += (cp < 0x80) ? 1 : (cp < 0x800) ? 2 : (cp < 0x10000) ? 3 : 4;
              });
              return [n,l];
          };

          return utfx;
      }();

      // encodings/utf8

      /**
       * Encodes this ByteBuffer's contents between {@link ByteBuffer#offset} and {@link ByteBuffer#limit} to an UTF8 encoded
       *  string.
       * @returns {string} Hex encoded string
       * @throws {RangeError} If `offset > limit`
       * @expose
       */
      ByteBufferPrototype.toUTF8 = function(begin, end) {
          if (typeof begin === 'undefined') begin = this.offset;
          if (typeof end === 'undefined') end = this.limit;
          if (!this.noAssert) {
              if (typeof begin !== 'number' || begin % 1 !== 0)
                  throw TypeError("Illegal begin: Not an integer");
              begin >>>= 0;
              if (typeof end !== 'number' || end % 1 !== 0)
                  throw TypeError("Illegal end: Not an integer");
              end >>>= 0;
              if (begin < 0 || begin > end || end > this.buffer.byteLength)
                  throw RangeError("Illegal range: 0 <= "+begin+" <= "+end+" <= "+this.buffer.byteLength);
          }
          var sd; try {
              utfx.decodeUTF8toUTF16(function() {
                  return begin < end ? this.view[begin++] : null;
              }.bind(this), sd = stringDestination());
          } catch (e) {
              if (begin !== end)
                  throw RangeError("Illegal range: Truncated data, "+begin+" != "+end);
          }
          return sd();
      };

      /**
       * Decodes an UTF8 encoded string to a ByteBuffer.
       * @param {string} str String to decode
       * @param {boolean=} littleEndian Whether to use little or big endian byte order. Defaults to
       *  {@link ByteBuffer.DEFAULT_ENDIAN}.
       * @param {boolean=} noAssert Whether to skip assertions of offsets and values. Defaults to
       *  {@link ByteBuffer.DEFAULT_NOASSERT}.
       * @returns {!ByteBuffer} ByteBuffer
       * @expose
       */
      ByteBuffer.fromUTF8 = function(str, littleEndian, noAssert) {
          if (!noAssert)
              if (typeof str !== 'string')
                  throw TypeError("Illegal str: Not a string");
          var bb = new ByteBuffer(utfx.calculateUTF16asUTF8(stringSource(str), true)[1], littleEndian, noAssert),
              i = 0;
          utfx.encodeUTF16toUTF8(stringSource(str), function(b) {
              bb.view[i++] = b;
          });
          bb.limit = i;
          return bb;
      };

      return ByteBuffer;
  });
  });

  var require$$2 = {};

  var protobufLight = createCommonjsModule(function (module) {
  /*
   Copyright 2013 Daniel Wirtz <dcode@dcode.io>

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
   */

  /**
   * @license protobuf.js (c) 2013 Daniel Wirtz <dcode@dcode.io>
   * Released under the Apache License, Version 2.0
   * see: https://github.com/dcodeIO/protobuf.js for details
   */
  (function(global, factory) {

      /* AMD */ if (typeof commonjsRequire === "function" && 'object' === "object" && module && module["exports"])
          module["exports"] = factory(bytebuffer, true);
      /* Global */ else
          (global["dcodeIO"] = global["dcodeIO"] || {})["ProtoBuf"] = factory(global["dcodeIO"]["ByteBuffer"]);

  })(commonjsGlobal, function(ByteBuffer, isCommonJS) {

      /**
       * The ProtoBuf namespace.
       * @exports ProtoBuf
       * @namespace
       * @expose
       */
      var ProtoBuf = {};

      /**
       * @type {!function(new: ByteBuffer, ...[*])}
       * @expose
       */
      ProtoBuf.ByteBuffer = ByteBuffer;

      /**
       * @type {?function(new: Long, ...[*])}
       * @expose
       */
      ProtoBuf.Long = ByteBuffer.Long || null;

      /**
       * ProtoBuf.js version.
       * @type {string}
       * @const
       * @expose
       */
      ProtoBuf.VERSION = "5.0.3";

      /**
       * Wire types.
       * @type {Object.<string,number>}
       * @const
       * @expose
       */
      ProtoBuf.WIRE_TYPES = {};

      /**
       * Varint wire type.
       * @type {number}
       * @expose
       */
      ProtoBuf.WIRE_TYPES.VARINT = 0;

      /**
       * Fixed 64 bits wire type.
       * @type {number}
       * @const
       * @expose
       */
      ProtoBuf.WIRE_TYPES.BITS64 = 1;

      /**
       * Length delimited wire type.
       * @type {number}
       * @const
       * @expose
       */
      ProtoBuf.WIRE_TYPES.LDELIM = 2;

      /**
       * Start group wire type.
       * @type {number}
       * @const
       * @expose
       */
      ProtoBuf.WIRE_TYPES.STARTGROUP = 3;

      /**
       * End group wire type.
       * @type {number}
       * @const
       * @expose
       */
      ProtoBuf.WIRE_TYPES.ENDGROUP = 4;

      /**
       * Fixed 32 bits wire type.
       * @type {number}
       * @const
       * @expose
       */
      ProtoBuf.WIRE_TYPES.BITS32 = 5;

      /**
       * Packable wire types.
       * @type {!Array.<number>}
       * @const
       * @expose
       */
      ProtoBuf.PACKABLE_WIRE_TYPES = [
          ProtoBuf.WIRE_TYPES.VARINT,
          ProtoBuf.WIRE_TYPES.BITS64,
          ProtoBuf.WIRE_TYPES.BITS32
      ];

      /**
       * Types.
       * @dict
       * @type {!Object.<string,{name: string, wireType: number, defaultValue: *}>}
       * @const
       * @expose
       */
      ProtoBuf.TYPES = {
          // According to the protobuf spec.
          "int32": {
              name: "int32",
              wireType: ProtoBuf.WIRE_TYPES.VARINT,
              defaultValue: 0
          },
          "uint32": {
              name: "uint32",
              wireType: ProtoBuf.WIRE_TYPES.VARINT,
              defaultValue: 0
          },
          "sint32": {
              name: "sint32",
              wireType: ProtoBuf.WIRE_TYPES.VARINT,
              defaultValue: 0
          },
          "int64": {
              name: "int64",
              wireType: ProtoBuf.WIRE_TYPES.VARINT,
              defaultValue: ProtoBuf.Long ? ProtoBuf.Long.ZERO : undefined
          },
          "uint64": {
              name: "uint64",
              wireType: ProtoBuf.WIRE_TYPES.VARINT,
              defaultValue: ProtoBuf.Long ? ProtoBuf.Long.UZERO : undefined
          },
          "sint64": {
              name: "sint64",
              wireType: ProtoBuf.WIRE_TYPES.VARINT,
              defaultValue: ProtoBuf.Long ? ProtoBuf.Long.ZERO : undefined
          },
          "bool": {
              name: "bool",
              wireType: ProtoBuf.WIRE_TYPES.VARINT,
              defaultValue: false
          },
          "double": {
              name: "double",
              wireType: ProtoBuf.WIRE_TYPES.BITS64,
              defaultValue: 0
          },
          "string": {
              name: "string",
              wireType: ProtoBuf.WIRE_TYPES.LDELIM,
              defaultValue: ""
          },
          "bytes": {
              name: "bytes",
              wireType: ProtoBuf.WIRE_TYPES.LDELIM,
              defaultValue: null // overridden in the code, must be a unique instance
          },
          "fixed32": {
              name: "fixed32",
              wireType: ProtoBuf.WIRE_TYPES.BITS32,
              defaultValue: 0
          },
          "sfixed32": {
              name: "sfixed32",
              wireType: ProtoBuf.WIRE_TYPES.BITS32,
              defaultValue: 0
          },
          "fixed64": {
              name: "fixed64",
              wireType: ProtoBuf.WIRE_TYPES.BITS64,
              defaultValue:  ProtoBuf.Long ? ProtoBuf.Long.UZERO : undefined
          },
          "sfixed64": {
              name: "sfixed64",
              wireType: ProtoBuf.WIRE_TYPES.BITS64,
              defaultValue: ProtoBuf.Long ? ProtoBuf.Long.ZERO : undefined
          },
          "float": {
              name: "float",
              wireType: ProtoBuf.WIRE_TYPES.BITS32,
              defaultValue: 0
          },
          "enum": {
              name: "enum",
              wireType: ProtoBuf.WIRE_TYPES.VARINT,
              defaultValue: 0
          },
          "message": {
              name: "message",
              wireType: ProtoBuf.WIRE_TYPES.LDELIM,
              defaultValue: null
          },
          "group": {
              name: "group",
              wireType: ProtoBuf.WIRE_TYPES.STARTGROUP,
              defaultValue: null
          }
      };

      /**
       * Valid map key types.
       * @type {!Array.<!Object.<string,{name: string, wireType: number, defaultValue: *}>>}
       * @const
       * @expose
       */
      ProtoBuf.MAP_KEY_TYPES = [
          ProtoBuf.TYPES["int32"],
          ProtoBuf.TYPES["sint32"],
          ProtoBuf.TYPES["sfixed32"],
          ProtoBuf.TYPES["uint32"],
          ProtoBuf.TYPES["fixed32"],
          ProtoBuf.TYPES["int64"],
          ProtoBuf.TYPES["sint64"],
          ProtoBuf.TYPES["sfixed64"],
          ProtoBuf.TYPES["uint64"],
          ProtoBuf.TYPES["fixed64"],
          ProtoBuf.TYPES["bool"],
          ProtoBuf.TYPES["string"],
          ProtoBuf.TYPES["bytes"]
      ];

      /**
       * Minimum field id.
       * @type {number}
       * @const
       * @expose
       */
      ProtoBuf.ID_MIN = 1;

      /**
       * Maximum field id.
       * @type {number}
       * @const
       * @expose
       */
      ProtoBuf.ID_MAX = 0x1FFFFFFF;

      /**
       * If set to `true`, field names will be converted from underscore notation to camel case. Defaults to `false`.
       *  Must be set prior to parsing.
       * @type {boolean}
       * @expose
       */
      ProtoBuf.convertFieldsToCamelCase = false;

      /**
       * By default, messages are populated with (setX, set_x) accessors for each field. This can be disabled by
       *  setting this to `false` prior to building messages.
       * @type {boolean}
       * @expose
       */
      ProtoBuf.populateAccessors = true;

      /**
       * By default, messages are populated with default values if a field is not present on the wire. To disable
       *  this behavior, set this setting to `false`.
       * @type {boolean}
       * @expose
       */
      ProtoBuf.populateDefaults = true;

      /**
       * @alias ProtoBuf.Util
       * @expose
       */
      ProtoBuf.Util = (function() {

          /**
           * ProtoBuf utilities.
           * @exports ProtoBuf.Util
           * @namespace
           */
          var Util = {};

          /**
           * Flag if running in node or not.
           * @type {boolean}
           * @const
           * @expose
           */
          Util.IS_NODE = !!(
              typeof process === 'object' && process+'' === '[object process]' && !process['browser']
          );

          /**
           * Constructs a XMLHttpRequest object.
           * @return {XMLHttpRequest}
           * @throws {Error} If XMLHttpRequest is not supported
           * @expose
           */
          Util.XHR = function() {
              // No dependencies please, ref: http://www.quirksmode.org/js/xmlhttp.html
              var XMLHttpFactories = [
                  function () {return new XMLHttpRequest()},
                  function () {return new ActiveXObject("Msxml2.XMLHTTP")},
                  function () {return new ActiveXObject("Msxml3.XMLHTTP")},
                  function () {return new ActiveXObject("Microsoft.XMLHTTP")}
              ];
              /** @type {?XMLHttpRequest} */
              var xhr = null;
              for (var i=0;i<XMLHttpFactories.length;i++) {
                  try { xhr = XMLHttpFactories[i](); }
                  catch (e) { continue; }
                  break;
              }
              if (!xhr)
                  throw Error("XMLHttpRequest is not supported");
              return xhr;
          };

          /**
           * Fetches a resource.
           * @param {string} path Resource path
           * @param {function(?string)=} callback Callback receiving the resource's contents. If omitted the resource will
           *   be fetched synchronously. If the request failed, contents will be null.
           * @return {?string|undefined} Resource contents if callback is omitted (null if the request failed), else undefined.
           * @expose
           */
          Util.fetch = function(path, callback) {
              if (callback && typeof callback != 'function')
                  callback = null;
              if (Util.IS_NODE) {
                  var fs = require$$2;
                  if (callback) {
                      fs.readFile(path, function(err, data) {
                          if (err)
                              callback(null);
                          else
                              callback(""+data);
                      });
                  } else
                      try {
                          return fs.readFileSync(path);
                      } catch (e) {
                          return null;
                      }
              } else {
                  var xhr = Util.XHR();
                  xhr.open('GET', path, callback ? true : false);
                  // xhr.setRequestHeader('User-Agent', 'XMLHTTP/1.0');
                  xhr.setRequestHeader('Accept', 'text/plain');
                  if (typeof xhr.overrideMimeType === 'function') xhr.overrideMimeType('text/plain');
                  if (callback) {
                      xhr.onreadystatechange = function() {
                          if (xhr.readyState != 4) return;
                          if (/* remote */ xhr.status == 200 || /* local */ (xhr.status == 0 && typeof xhr.responseText === 'string'))
                              callback(xhr.responseText);
                          else
                              callback(null);
                      };
                      if (xhr.readyState == 4)
                          return;
                      xhr.send(null);
                  } else {
                      xhr.send(null);
                      if (/* remote */ xhr.status == 200 || /* local */ (xhr.status == 0 && typeof xhr.responseText === 'string'))
                          return xhr.responseText;
                      return null;
                  }
              }
          };

          /**
           * Converts a string to camel case.
           * @param {string} str
           * @returns {string}
           * @expose
           */
          Util.toCamelCase = function(str) {
              return str.replace(/_([a-zA-Z])/g, function ($0, $1) {
                  return $1.toUpperCase();
              });
          };

          return Util;
      })();

      /**
       * Language expressions.
       * @type {!Object.<string,!RegExp>}
       * @expose
       */
      ProtoBuf.Lang = {

          // Characters always ending a statement
          DELIM: /[\s\{\}=;:\[\],'"\(\)<>]/g,

          // Field rules
          RULE: /^(?:required|optional|repeated|map)$/,

          // Field types
          TYPE: /^(?:double|float|int32|uint32|sint32|int64|uint64|sint64|fixed32|sfixed32|fixed64|sfixed64|bool|string|bytes)$/,

          // Names
          NAME: /^[a-zA-Z_][a-zA-Z_0-9]*$/,

          // Type definitions
          TYPEDEF: /^[a-zA-Z][a-zA-Z_0-9]*$/,

          // Type references
          TYPEREF: /^(?:\.?[a-zA-Z_][a-zA-Z_0-9]*)(?:\.[a-zA-Z_][a-zA-Z_0-9]*)*$/,

          // Fully qualified type references
          FQTYPEREF: /^(?:\.[a-zA-Z_][a-zA-Z_0-9]*)+$/,

          // All numbers
          NUMBER: /^-?(?:[1-9][0-9]*|0|0[xX][0-9a-fA-F]+|0[0-7]+|([0-9]*(\.[0-9]*)?([Ee][+-]?[0-9]+)?)|inf|nan)$/,

          // Decimal numbers
          NUMBER_DEC: /^(?:[1-9][0-9]*|0)$/,

          // Hexadecimal numbers
          NUMBER_HEX: /^0[xX][0-9a-fA-F]+$/,

          // Octal numbers
          NUMBER_OCT: /^0[0-7]+$/,

          // Floating point numbers
          NUMBER_FLT: /^([0-9]*(\.[0-9]*)?([Ee][+-]?[0-9]+)?|inf|nan)$/,

          // Booleans
          BOOL: /^(?:true|false)$/i,

          // Id numbers
          ID: /^(?:[1-9][0-9]*|0|0[xX][0-9a-fA-F]+|0[0-7]+)$/,

          // Negative id numbers (enum values)
          NEGID: /^\-?(?:[1-9][0-9]*|0|0[xX][0-9a-fA-F]+|0[0-7]+)$/,

          // Whitespaces
          WHITESPACE: /\s/,

          // All strings
          STRING: /(?:"([^"\\]*(?:\\.[^"\\]*)*)")|(?:'([^'\\]*(?:\\.[^'\\]*)*)')/g,

          // Double quoted strings
          STRING_DQ: /(?:"([^"\\]*(?:\\.[^"\\]*)*)")/g,

          // Single quoted strings
          STRING_SQ: /(?:'([^'\\]*(?:\\.[^'\\]*)*)')/g
      };


      /**
       * @alias ProtoBuf.Reflect
       * @expose
       */
      ProtoBuf.Reflect = (function(ProtoBuf) {

          /**
           * Reflection types.
           * @exports ProtoBuf.Reflect
           * @namespace
           */
          var Reflect = {};

          /**
           * Constructs a Reflect base class.
           * @exports ProtoBuf.Reflect.T
           * @constructor
           * @abstract
           * @param {!ProtoBuf.Builder} builder Builder reference
           * @param {?ProtoBuf.Reflect.T} parent Parent object
           * @param {string} name Object name
           */
          var T = function(builder, parent, name) {

              /**
               * Builder reference.
               * @type {!ProtoBuf.Builder}
               * @expose
               */
              this.builder = builder;

              /**
               * Parent object.
               * @type {?ProtoBuf.Reflect.T}
               * @expose
               */
              this.parent = parent;

              /**
               * Object name in namespace.
               * @type {string}
               * @expose
               */
              this.name = name;

              /**
               * Fully qualified class name
               * @type {string}
               * @expose
               */
              this.className;
          };

          /**
           * @alias ProtoBuf.Reflect.T.prototype
           * @inner
           */
          var TPrototype = T.prototype;

          /**
           * Returns the fully qualified name of this object.
           * @returns {string} Fully qualified name as of ".PATH.TO.THIS"
           * @expose
           */
          TPrototype.fqn = function() {
              var name = this.name,
                  ptr = this;
              do {
                  ptr = ptr.parent;
                  if (ptr == null)
                      break;
                  name = ptr.name+"."+name;
              } while (true);
              return name;
          };

          /**
           * Returns a string representation of this Reflect object (its fully qualified name).
           * @param {boolean=} includeClass Set to true to include the class name. Defaults to false.
           * @return String representation
           * @expose
           */
          TPrototype.toString = function(includeClass) {
              return (includeClass ? this.className + " " : "") + this.fqn();
          };

          /**
           * Builds this type.
           * @throws {Error} If this type cannot be built directly
           * @expose
           */
          TPrototype.build = function() {
              throw Error(this.toString(true)+" cannot be built directly");
          };

          /**
           * @alias ProtoBuf.Reflect.T
           * @expose
           */
          Reflect.T = T;

          /**
           * Constructs a new Namespace.
           * @exports ProtoBuf.Reflect.Namespace
           * @param {!ProtoBuf.Builder} builder Builder reference
           * @param {?ProtoBuf.Reflect.Namespace} parent Namespace parent
           * @param {string} name Namespace name
           * @param {Object.<string,*>=} options Namespace options
           * @param {string?} syntax The syntax level of this definition (e.g., proto3)
           * @constructor
           * @extends ProtoBuf.Reflect.T
           */
          var Namespace = function(builder, parent, name, options, syntax) {
              T.call(this, builder, parent, name);

              /**
               * @override
               */
              this.className = "Namespace";

              /**
               * Children inside the namespace.
               * @type {!Array.<ProtoBuf.Reflect.T>}
               */
              this.children = [];

              /**
               * Options.
               * @type {!Object.<string, *>}
               */
              this.options = options || {};

              /**
               * Syntax level (e.g., proto2 or proto3).
               * @type {!string}
               */
              this.syntax = syntax || "proto2";
          };

          /**
           * @alias ProtoBuf.Reflect.Namespace.prototype
           * @inner
           */
          var NamespacePrototype = Namespace.prototype = Object.create(T.prototype);

          /**
           * Returns an array of the namespace's children.
           * @param {ProtoBuf.Reflect.T=} type Filter type (returns instances of this type only). Defaults to null (all children).
           * @return {Array.<ProtoBuf.Reflect.T>}
           * @expose
           */
          NamespacePrototype.getChildren = function(type) {
              type = type || null;
              if (type == null)
                  return this.children.slice();
              var children = [];
              for (var i=0, k=this.children.length; i<k; ++i)
                  if (this.children[i] instanceof type)
                      children.push(this.children[i]);
              return children;
          };

          /**
           * Adds a child to the namespace.
           * @param {ProtoBuf.Reflect.T} child Child
           * @throws {Error} If the child cannot be added (duplicate)
           * @expose
           */
          NamespacePrototype.addChild = function(child) {
              var other;
              if (other = this.getChild(child.name)) {
                  // Try to revert camelcase transformation on collision
                  if (other instanceof Message.Field && other.name !== other.originalName && this.getChild(other.originalName) === null)
                      other.name = other.originalName; // Revert previous first (effectively keeps both originals)
                  else if (child instanceof Message.Field && child.name !== child.originalName && this.getChild(child.originalName) === null)
                      child.name = child.originalName;
                  else
                      throw Error("Duplicate name in namespace "+this.toString(true)+": "+child.name);
              }
              this.children.push(child);
          };

          /**
           * Gets a child by its name or id.
           * @param {string|number} nameOrId Child name or id
           * @return {?ProtoBuf.Reflect.T} The child or null if not found
           * @expose
           */
          NamespacePrototype.getChild = function(nameOrId) {
              var key = typeof nameOrId === 'number' ? 'id' : 'name';
              for (var i=0, k=this.children.length; i<k; ++i)
                  if (this.children[i][key] === nameOrId)
                      return this.children[i];
              return null;
          };

          /**
           * Resolves a reflect object inside of this namespace.
           * @param {string|!Array.<string>} qn Qualified name to resolve
           * @param {boolean=} excludeNonNamespace Excludes non-namespace types, defaults to `false`
           * @return {?ProtoBuf.Reflect.Namespace} The resolved type or null if not found
           * @expose
           */
          NamespacePrototype.resolve = function(qn, excludeNonNamespace) {
              var part = typeof qn === 'string' ? qn.split(".") : qn,
                  ptr = this,
                  i = 0;
              if (part[i] === "") { // Fully qualified name, e.g. ".My.Message'
                  while (ptr.parent !== null)
                      ptr = ptr.parent;
                  i++;
              }
              var child;
              do {
                  do {
                      if (!(ptr instanceof Reflect.Namespace)) {
                          ptr = null;
                          break;
                      }
                      child = ptr.getChild(part[i]);
                      if (!child || !(child instanceof Reflect.T) || (excludeNonNamespace && !(child instanceof Reflect.Namespace))) {
                          ptr = null;
                          break;
                      }
                      ptr = child; i++;
                  } while (i < part.length);
                  if (ptr != null)
                      break; // Found
                  // Else search the parent
                  if (this.parent !== null)
                      return this.parent.resolve(qn, excludeNonNamespace);
              } while (ptr != null);
              return ptr;
          };

          /**
           * Determines the shortest qualified name of the specified type, if any, relative to this namespace.
           * @param {!ProtoBuf.Reflect.T} t Reflection type
           * @returns {string} The shortest qualified name or, if there is none, the fqn
           * @expose
           */
          NamespacePrototype.qn = function(t) {
              var part = [], ptr = t;
              do {
                  part.unshift(ptr.name);
                  ptr = ptr.parent;
              } while (ptr !== null);
              for (var len=1; len <= part.length; len++) {
                  var qn = part.slice(part.length-len);
                  if (t === this.resolve(qn, t instanceof Reflect.Namespace))
                      return qn.join(".");
              }
              return t.fqn();
          };

          /**
           * Builds the namespace and returns the runtime counterpart.
           * @return {Object.<string,Function|Object>} Runtime namespace
           * @expose
           */
          NamespacePrototype.build = function() {
              /** @dict */
              var ns = {};
              var children = this.children;
              for (var i=0, k=children.length, child; i<k; ++i) {
                  child = children[i];
                  if (child instanceof Namespace)
                      ns[child.name] = child.build();
              }
              if (Object.defineProperty)
                  Object.defineProperty(ns, "$options", { "value": this.buildOpt() });
              return ns;
          };

          /**
           * Builds the namespace's '$options' property.
           * @return {Object.<string,*>}
           */
          NamespacePrototype.buildOpt = function() {
              var opt = {},
                  keys = Object.keys(this.options);
              for (var i=0, k=keys.length; i<k; ++i) {
                  var key = keys[i],
                      val = this.options[keys[i]];
                  // TODO: Options are not resolved, yet.
                  // if (val instanceof Namespace) {
                  //     opt[key] = val.build();
                  // } else {
                  opt[key] = val;
                  // }
              }
              return opt;
          };

          /**
           * Gets the value assigned to the option with the specified name.
           * @param {string=} name Returns the option value if specified, otherwise all options are returned.
           * @return {*|Object.<string,*>}null} Option value or NULL if there is no such option
           */
          NamespacePrototype.getOption = function(name) {
              if (typeof name === 'undefined')
                  return this.options;
              return typeof this.options[name] !== 'undefined' ? this.options[name] : null;
          };

          /**
           * @alias ProtoBuf.Reflect.Namespace
           * @expose
           */
          Reflect.Namespace = Namespace;

          /**
           * Constructs a new Element implementation that checks and converts values for a
           * particular field type, as appropriate.
           *
           * An Element represents a single value: either the value of a singular field,
           * or a value contained in one entry of a repeated field or map field. This
           * class does not implement these higher-level concepts; it only encapsulates
           * the low-level typechecking and conversion.
           *
           * @exports ProtoBuf.Reflect.Element
           * @param {{name: string, wireType: number}} type Resolved data type
           * @param {ProtoBuf.Reflect.T|null} resolvedType Resolved type, if relevant
           * (e.g. submessage field).
           * @param {boolean} isMapKey Is this element a Map key? The value will be
           * converted to string form if so.
           * @param {string} syntax Syntax level of defining message type, e.g.,
           * proto2 or proto3.
           * @param {string} name Name of the field containing this element (for error
           * messages)
           * @constructor
           */
          var Element = function(type, resolvedType, isMapKey, syntax, name) {

              /**
               * Element type, as a string (e.g., int32).
               * @type {{name: string, wireType: number}}
               */
              this.type = type;

              /**
               * Element type reference to submessage or enum definition, if needed.
               * @type {ProtoBuf.Reflect.T|null}
               */
              this.resolvedType = resolvedType;

              /**
               * Element is a map key.
               * @type {boolean}
               */
              this.isMapKey = isMapKey;

              /**
               * Syntax level of defining message type, e.g., proto2 or proto3.
               * @type {string}
               */
              this.syntax = syntax;

              /**
               * Name of the field containing this element (for error messages)
               * @type {string}
               */
              this.name = name;

              if (isMapKey && ProtoBuf.MAP_KEY_TYPES.indexOf(type) < 0)
                  throw Error("Invalid map key type: " + type.name);
          };

          var ElementPrototype = Element.prototype;

          /**
           * Obtains a (new) default value for the specified type.
           * @param type {string|{name: string, wireType: number}} Field type
           * @returns {*} Default value
           * @inner
           */
          function mkDefault(type) {
              if (typeof type === 'string')
                  type = ProtoBuf.TYPES[type];
              if (typeof type.defaultValue === 'undefined')
                  throw Error("default value for type "+type.name+" is not supported");
              if (type == ProtoBuf.TYPES["bytes"])
                  return new ByteBuffer(0);
              return type.defaultValue;
          }

          /**
           * Returns the default value for this field in proto3.
           * @function
           * @param type {string|{name: string, wireType: number}} the field type
           * @returns {*} Default value
           */
          Element.defaultFieldValue = mkDefault;

          /**
           * Makes a Long from a value.
           * @param {{low: number, high: number, unsigned: boolean}|string|number} value Value
           * @param {boolean=} unsigned Whether unsigned or not, defaults to reuse it from Long-like objects or to signed for
           *  strings and numbers
           * @returns {!Long}
           * @throws {Error} If the value cannot be converted to a Long
           * @inner
           */
          function mkLong(value, unsigned) {
              if (value && typeof value.low === 'number' && typeof value.high === 'number' && typeof value.unsigned === 'boolean'
                  && value.low === value.low && value.high === value.high)
                  return new ProtoBuf.Long(value.low, value.high, typeof unsigned === 'undefined' ? value.unsigned : unsigned);
              if (typeof value === 'string')
                  return ProtoBuf.Long.fromString(value, unsigned || false, 10);
              if (typeof value === 'number')
                  return ProtoBuf.Long.fromNumber(value, unsigned || false);
              throw Error("not convertible to Long");
          }

          ElementPrototype.toString = function() {
              return (this.name || '') + (this.isMapKey ? 'map' : 'value') + ' element';
          };

          /**
           * Checks if the given value can be set for an element of this type (singular
           * field or one element of a repeated field or map).
           * @param {*} value Value to check
           * @return {*} Verified, maybe adjusted, value
           * @throws {Error} If the value cannot be verified for this element slot
           * @expose
           */
          ElementPrototype.verifyValue = function(value) {
              var self = this;
              function fail(val, msg) {
                  throw Error("Illegal value for "+self.toString(true)+" of type "+self.type.name+": "+val+" ("+msg+")");
              }
              switch (this.type) {
                  // Signed 32bit
                  case ProtoBuf.TYPES["int32"]:
                  case ProtoBuf.TYPES["sint32"]:
                  case ProtoBuf.TYPES["sfixed32"]:
                      // Account for !NaN: value === value
                      if (typeof value !== 'number' || (value === value && value % 1 !== 0))
                          fail(typeof value, "not an integer");
                      return value > 4294967295 ? value | 0 : value;

                  // Unsigned 32bit
                  case ProtoBuf.TYPES["uint32"]:
                  case ProtoBuf.TYPES["fixed32"]:
                      if (typeof value !== 'number' || (value === value && value % 1 !== 0))
                          fail(typeof value, "not an integer");
                      return value < 0 ? value >>> 0 : value;

                  // Signed 64bit
                  case ProtoBuf.TYPES["int64"]:
                  case ProtoBuf.TYPES["sint64"]:
                  case ProtoBuf.TYPES["sfixed64"]: {
                      if (ProtoBuf.Long)
                          try {
                              return mkLong(value, false);
                          } catch (e) {
                              fail(typeof value, e.message);
                          }
                      else
                          fail(typeof value, "requires Long.js");
                  }

                  // Unsigned 64bit
                  case ProtoBuf.TYPES["uint64"]:
                  case ProtoBuf.TYPES["fixed64"]: {
                      if (ProtoBuf.Long)
                          try {
                              return mkLong(value, true);
                          } catch (e) {
                              fail(typeof value, e.message);
                          }
                      else
                          fail(typeof value, "requires Long.js");
                  }

                  // Bool
                  case ProtoBuf.TYPES["bool"]:
                      if (typeof value !== 'boolean')
                          fail(typeof value, "not a boolean");
                      return value;

                  // Float
                  case ProtoBuf.TYPES["float"]:
                  case ProtoBuf.TYPES["double"]:
                      if (typeof value !== 'number')
                          fail(typeof value, "not a number");
                      return value;

                  // Length-delimited string
                  case ProtoBuf.TYPES["string"]:
                      if (typeof value !== 'string' && !(value && value instanceof String))
                          fail(typeof value, "not a string");
                      return ""+value; // Convert String object to string

                  // Length-delimited bytes
                  case ProtoBuf.TYPES["bytes"]:
                      if (ByteBuffer.isByteBuffer(value))
                          return value;
                      return ByteBuffer.wrap(value, "base64");

                  // Constant enum value
                  case ProtoBuf.TYPES["enum"]: {
                      var values = this.resolvedType.getChildren(ProtoBuf.Reflect.Enum.Value);
                      for (i=0; i<values.length; i++)
                          if (values[i].name == value)
                              return values[i].id;
                          else if (values[i].id == value)
                              return values[i].id;

                      if (this.syntax === 'proto3') {
                          // proto3: just make sure it's an integer.
                          if (typeof value !== 'number' || (value === value && value % 1 !== 0))
                              fail(typeof value, "not an integer");
                          if (value > 4294967295 || value < 0)
                              fail(typeof value, "not in range for uint32");
                          return value;
                      } else {
                          // proto2 requires enum values to be valid.
                          fail(value, "not a valid enum value");
                      }
                  }
                  // Embedded message
                  case ProtoBuf.TYPES["group"]:
                  case ProtoBuf.TYPES["message"]: {
                      if (!value || typeof value !== 'object')
                          fail(typeof value, "object expected");
                      if (value instanceof this.resolvedType.clazz)
                          return value;
                      if (value instanceof ProtoBuf.Builder.Message) {
                          // Mismatched type: Convert to object (see: https://github.com/dcodeIO/ProtoBuf.js/issues/180)
                          var obj = {};
                          for (var i in value)
                              if (value.hasOwnProperty(i))
                                  obj[i] = value[i];
                          value = obj;
                      }
                      // Else let's try to construct one from a key-value object
                      return new (this.resolvedType.clazz)(value); // May throw for a hundred of reasons
                  }
              }

              // We should never end here
              throw Error("[INTERNAL] Illegal value for "+this.toString(true)+": "+value+" (undefined type "+this.type+")");
          };

          /**
           * Calculates the byte length of an element on the wire.
           * @param {number} id Field number
           * @param {*} value Field value
           * @returns {number} Byte length
           * @throws {Error} If the value cannot be calculated
           * @expose
           */
          ElementPrototype.calculateLength = function(id, value) {
              if (value === null) return 0; // Nothing to encode
              // Tag has already been written
              var n;
              switch (this.type) {
                  case ProtoBuf.TYPES["int32"]:
                      return value < 0 ? ByteBuffer.calculateVarint64(value) : ByteBuffer.calculateVarint32(value);
                  case ProtoBuf.TYPES["uint32"]:
                      return ByteBuffer.calculateVarint32(value);
                  case ProtoBuf.TYPES["sint32"]:
                      return ByteBuffer.calculateVarint32(ByteBuffer.zigZagEncode32(value));
                  case ProtoBuf.TYPES["fixed32"]:
                  case ProtoBuf.TYPES["sfixed32"]:
                  case ProtoBuf.TYPES["float"]:
                      return 4;
                  case ProtoBuf.TYPES["int64"]:
                  case ProtoBuf.TYPES["uint64"]:
                      return ByteBuffer.calculateVarint64(value);
                  case ProtoBuf.TYPES["sint64"]:
                      return ByteBuffer.calculateVarint64(ByteBuffer.zigZagEncode64(value));
                  case ProtoBuf.TYPES["fixed64"]:
                  case ProtoBuf.TYPES["sfixed64"]:
                      return 8;
                  case ProtoBuf.TYPES["bool"]:
                      return 1;
                  case ProtoBuf.TYPES["enum"]:
                      return ByteBuffer.calculateVarint32(value);
                  case ProtoBuf.TYPES["double"]:
                      return 8;
                  case ProtoBuf.TYPES["string"]:
                      n = ByteBuffer.calculateUTF8Bytes(value);
                      return ByteBuffer.calculateVarint32(n) + n;
                  case ProtoBuf.TYPES["bytes"]:
                      if (value.remaining() < 0)
                          throw Error("Illegal value for "+this.toString(true)+": "+value.remaining()+" bytes remaining");
                      return ByteBuffer.calculateVarint32(value.remaining()) + value.remaining();
                  case ProtoBuf.TYPES["message"]:
                      n = this.resolvedType.calculate(value);
                      return ByteBuffer.calculateVarint32(n) + n;
                  case ProtoBuf.TYPES["group"]:
                      n = this.resolvedType.calculate(value);
                      return n + ByteBuffer.calculateVarint32((id << 3) | ProtoBuf.WIRE_TYPES.ENDGROUP);
              }
              // We should never end here
              throw Error("[INTERNAL] Illegal value to encode in "+this.toString(true)+": "+value+" (unknown type)");
          };

          /**
           * Encodes a value to the specified buffer. Does not encode the key.
           * @param {number} id Field number
           * @param {*} value Field value
           * @param {ByteBuffer} buffer ByteBuffer to encode to
           * @return {ByteBuffer} The ByteBuffer for chaining
           * @throws {Error} If the value cannot be encoded
           * @expose
           */
          ElementPrototype.encodeValue = function(id, value, buffer) {
              if (value === null) return buffer; // Nothing to encode
              // Tag has already been written

              switch (this.type) {
                  // 32bit signed varint
                  case ProtoBuf.TYPES["int32"]:
                      // "If you use int32 or int64 as the type for a negative number, the resulting varint is always ten bytes
                      // long – it is, effectively, treated like a very large unsigned integer." (see #122)
                      if (value < 0)
                          buffer.writeVarint64(value);
                      else
                          buffer.writeVarint32(value);
                      break;

                  // 32bit unsigned varint
                  case ProtoBuf.TYPES["uint32"]:
                      buffer.writeVarint32(value);
                      break;

                  // 32bit varint zig-zag
                  case ProtoBuf.TYPES["sint32"]:
                      buffer.writeVarint32ZigZag(value);
                      break;

                  // Fixed unsigned 32bit
                  case ProtoBuf.TYPES["fixed32"]:
                      buffer.writeUint32(value);
                      break;

                  // Fixed signed 32bit
                  case ProtoBuf.TYPES["sfixed32"]:
                      buffer.writeInt32(value);
                      break;

                  // 64bit varint as-is
                  case ProtoBuf.TYPES["int64"]:
                  case ProtoBuf.TYPES["uint64"]:
                      buffer.writeVarint64(value); // throws
                      break;

                  // 64bit varint zig-zag
                  case ProtoBuf.TYPES["sint64"]:
                      buffer.writeVarint64ZigZag(value); // throws
                      break;

                  // Fixed unsigned 64bit
                  case ProtoBuf.TYPES["fixed64"]:
                      buffer.writeUint64(value); // throws
                      break;

                  // Fixed signed 64bit
                  case ProtoBuf.TYPES["sfixed64"]:
                      buffer.writeInt64(value); // throws
                      break;

                  // Bool
                  case ProtoBuf.TYPES["bool"]:
                      if (typeof value === 'string')
                          buffer.writeVarint32(value.toLowerCase() === 'false' ? 0 : !!value);
                      else
                          buffer.writeVarint32(value ? 1 : 0);
                      break;

                  // Constant enum value
                  case ProtoBuf.TYPES["enum"]:
                      buffer.writeVarint32(value);
                      break;

                  // 32bit float
                  case ProtoBuf.TYPES["float"]:
                      buffer.writeFloat32(value);
                      break;

                  // 64bit float
                  case ProtoBuf.TYPES["double"]:
                      buffer.writeFloat64(value);
                      break;

                  // Length-delimited string
                  case ProtoBuf.TYPES["string"]:
                      buffer.writeVString(value);
                      break;

                  // Length-delimited bytes
                  case ProtoBuf.TYPES["bytes"]:
                      if (value.remaining() < 0)
                          throw Error("Illegal value for "+this.toString(true)+": "+value.remaining()+" bytes remaining");
                      var prevOffset = value.offset;
                      buffer.writeVarint32(value.remaining());
                      buffer.append(value);
                      value.offset = prevOffset;
                      break;

                  // Embedded message
                  case ProtoBuf.TYPES["message"]:
                      var bb = new ByteBuffer().LE();
                      this.resolvedType.encode(value, bb);
                      buffer.writeVarint32(bb.offset);
                      buffer.append(bb.flip());
                      break;

                  // Legacy group
                  case ProtoBuf.TYPES["group"]:
                      this.resolvedType.encode(value, buffer);
                      buffer.writeVarint32((id << 3) | ProtoBuf.WIRE_TYPES.ENDGROUP);
                      break;

                  default:
                      // We should never end here
                      throw Error("[INTERNAL] Illegal value to encode in "+this.toString(true)+": "+value+" (unknown type)");
              }
              return buffer;
          };

          /**
           * Decode one element value from the specified buffer.
           * @param {ByteBuffer} buffer ByteBuffer to decode from
           * @param {number} wireType The field wire type
           * @param {number} id The field number
           * @return {*} Decoded value
           * @throws {Error} If the field cannot be decoded
           * @expose
           */
          ElementPrototype.decode = function(buffer, wireType, id) {
              if (wireType != this.type.wireType)
                  throw Error("Unexpected wire type for element");

              var value, nBytes;
              switch (this.type) {
                  // 32bit signed varint
                  case ProtoBuf.TYPES["int32"]:
                      return buffer.readVarint32() | 0;

                  // 32bit unsigned varint
                  case ProtoBuf.TYPES["uint32"]:
                      return buffer.readVarint32() >>> 0;

                  // 32bit signed varint zig-zag
                  case ProtoBuf.TYPES["sint32"]:
                      return buffer.readVarint32ZigZag() | 0;

                  // Fixed 32bit unsigned
                  case ProtoBuf.TYPES["fixed32"]:
                      return buffer.readUint32() >>> 0;

                  case ProtoBuf.TYPES["sfixed32"]:
                      return buffer.readInt32() | 0;

                  // 64bit signed varint
                  case ProtoBuf.TYPES["int64"]:
                      return buffer.readVarint64();

                  // 64bit unsigned varint
                  case ProtoBuf.TYPES["uint64"]:
                      return buffer.readVarint64().toUnsigned();

                  // 64bit signed varint zig-zag
                  case ProtoBuf.TYPES["sint64"]:
                      return buffer.readVarint64ZigZag();

                  // Fixed 64bit unsigned
                  case ProtoBuf.TYPES["fixed64"]:
                      return buffer.readUint64();

                  // Fixed 64bit signed
                  case ProtoBuf.TYPES["sfixed64"]:
                      return buffer.readInt64();

                  // Bool varint
                  case ProtoBuf.TYPES["bool"]:
                      return !!buffer.readVarint32();

                  // Constant enum value (varint)
                  case ProtoBuf.TYPES["enum"]:
                      // The following Builder.Message#set will already throw
                      return buffer.readVarint32();

                  // 32bit float
                  case ProtoBuf.TYPES["float"]:
                      return buffer.readFloat();

                  // 64bit float
                  case ProtoBuf.TYPES["double"]:
                      return buffer.readDouble();

                  // Length-delimited string
                  case ProtoBuf.TYPES["string"]:
                      return buffer.readVString();

                  // Length-delimited bytes
                  case ProtoBuf.TYPES["bytes"]: {
                      nBytes = buffer.readVarint32();
                      if (buffer.remaining() < nBytes)
                          throw Error("Illegal number of bytes for "+this.toString(true)+": "+nBytes+" required but got only "+buffer.remaining());
                      value = buffer.clone(); // Offset already set
                      value.limit = value.offset+nBytes;
                      buffer.offset += nBytes;
                      return value;
                  }

                  // Length-delimited embedded message
                  case ProtoBuf.TYPES["message"]: {
                      nBytes = buffer.readVarint32();
                      return this.resolvedType.decode(buffer, nBytes);
                  }

                  // Legacy group
                  case ProtoBuf.TYPES["group"]:
                      return this.resolvedType.decode(buffer, -1, id);
              }

              // We should never end here
              throw Error("[INTERNAL] Illegal decode type");
          };

          /**
           * Converts a value from a string to the canonical element type.
           *
           * Legal only when isMapKey is true.
           *
           * @param {string} str The string value
           * @returns {*} The value
           */
          ElementPrototype.valueFromString = function(str) {
              if (!this.isMapKey) {
                  throw Error("valueFromString() called on non-map-key element");
              }

              switch (this.type) {
                  case ProtoBuf.TYPES["int32"]:
                  case ProtoBuf.TYPES["sint32"]:
                  case ProtoBuf.TYPES["sfixed32"]:
                  case ProtoBuf.TYPES["uint32"]:
                  case ProtoBuf.TYPES["fixed32"]:
                      return this.verifyValue(parseInt(str));

                  case ProtoBuf.TYPES["int64"]:
                  case ProtoBuf.TYPES["sint64"]:
                  case ProtoBuf.TYPES["sfixed64"]:
                  case ProtoBuf.TYPES["uint64"]:
                  case ProtoBuf.TYPES["fixed64"]:
                        // Long-based fields support conversions from string already.
                        return this.verifyValue(str);

                  case ProtoBuf.TYPES["bool"]:
                        return str === "true";

                  case ProtoBuf.TYPES["string"]:
                        return this.verifyValue(str);

                  case ProtoBuf.TYPES["bytes"]:
                        return ByteBuffer.fromBinary(str);
              }
          };

          /**
           * Converts a value from the canonical element type to a string.
           *
           * It should be the case that `valueFromString(valueToString(val))` returns
           * a value equivalent to `verifyValue(val)` for every legal value of `val`
           * according to this element type.
           *
           * This may be used when the element must be stored or used as a string,
           * e.g., as a map key on an Object.
           *
           * Legal only when isMapKey is true.
           *
           * @param {*} val The value
           * @returns {string} The string form of the value.
           */
          ElementPrototype.valueToString = function(value) {
              if (!this.isMapKey) {
                  throw Error("valueToString() called on non-map-key element");
              }

              if (this.type === ProtoBuf.TYPES["bytes"]) {
                  return value.toString("binary");
              } else {
                  return value.toString();
              }
          };

          /**
           * @alias ProtoBuf.Reflect.Element
           * @expose
           */
          Reflect.Element = Element;

          /**
           * Constructs a new Message.
           * @exports ProtoBuf.Reflect.Message
           * @param {!ProtoBuf.Builder} builder Builder reference
           * @param {!ProtoBuf.Reflect.Namespace} parent Parent message or namespace
           * @param {string} name Message name
           * @param {Object.<string,*>=} options Message options
           * @param {boolean=} isGroup `true` if this is a legacy group
           * @param {string?} syntax The syntax level of this definition (e.g., proto3)
           * @constructor
           * @extends ProtoBuf.Reflect.Namespace
           */
          var Message = function(builder, parent, name, options, isGroup, syntax) {
              Namespace.call(this, builder, parent, name, options, syntax);

              /**
               * @override
               */
              this.className = "Message";

              /**
               * Extensions range.
               * @type {!Array.<number>|undefined}
               * @expose
               */
              this.extensions = undefined;

              /**
               * Runtime message class.
               * @type {?function(new:ProtoBuf.Builder.Message)}
               * @expose
               */
              this.clazz = null;

              /**
               * Whether this is a legacy group or not.
               * @type {boolean}
               * @expose
               */
              this.isGroup = !!isGroup;

              // The following cached collections are used to efficiently iterate over or look up fields when decoding.

              /**
               * Cached fields.
               * @type {?Array.<!ProtoBuf.Reflect.Message.Field>}
               * @private
               */
              this._fields = null;

              /**
               * Cached fields by id.
               * @type {?Object.<number,!ProtoBuf.Reflect.Message.Field>}
               * @private
               */
              this._fieldsById = null;

              /**
               * Cached fields by name.
               * @type {?Object.<string,!ProtoBuf.Reflect.Message.Field>}
               * @private
               */
              this._fieldsByName = null;
          };

          /**
           * @alias ProtoBuf.Reflect.Message.prototype
           * @inner
           */
          var MessagePrototype = Message.prototype = Object.create(Namespace.prototype);

          /**
           * Builds the message and returns the runtime counterpart, which is a fully functional class.
           * @see ProtoBuf.Builder.Message
           * @param {boolean=} rebuild Whether to rebuild or not, defaults to false
           * @return {ProtoBuf.Reflect.Message} Message class
           * @throws {Error} If the message cannot be built
           * @expose
           */
          MessagePrototype.build = function(rebuild) {
              if (this.clazz && !rebuild)
                  return this.clazz;

              // Create the runtime Message class in its own scope
              var clazz = (function(ProtoBuf, T) {

                  var fields = T.getChildren(ProtoBuf.Reflect.Message.Field),
                      oneofs = T.getChildren(ProtoBuf.Reflect.Message.OneOf);

                  /**
                   * Constructs a new runtime Message.
                   * @name ProtoBuf.Builder.Message
                   * @class Barebone of all runtime messages.
                   * @param {!Object.<string,*>|string} values Preset values
                   * @param {...string} var_args
                   * @constructor
                   * @throws {Error} If the message cannot be created
                   */
                  var Message = function(values, var_args) {
                      ProtoBuf.Builder.Message.call(this);

                      // Create virtual oneof properties
                      for (var i=0, k=oneofs.length; i<k; ++i)
                          this[oneofs[i].name] = null;
                      // Create fields and set default values
                      for (i=0, k=fields.length; i<k; ++i) {
                          var field = fields[i];
                          this[field.name] =
                              field.repeated ? [] :
                              (field.map ? new ProtoBuf.Map(field) : null);
                          if ((field.required || T.syntax === 'proto3') &&
                              field.defaultValue !== null)
                              this[field.name] = field.defaultValue;
                      }

                      if (arguments.length > 0) {
                          var value;
                          // Set field values from a values object
                          if (arguments.length === 1 && values !== null && typeof values === 'object' &&
                              /* not _another_ Message */ (typeof values.encode !== 'function' || values instanceof Message) &&
                              /* not a repeated field */ !Array.isArray(values) &&
                              /* not a Map */ !(values instanceof ProtoBuf.Map) &&
                              /* not a ByteBuffer */ !ByteBuffer.isByteBuffer(values) &&
                              /* not an ArrayBuffer */ !(values instanceof ArrayBuffer) &&
                              /* not a Long */ !(ProtoBuf.Long && values instanceof ProtoBuf.Long)) {
                              this.$set(values);
                          } else // Set field values from arguments, in declaration order
                              for (i=0, k=arguments.length; i<k; ++i)
                                  if (typeof (value = arguments[i]) !== 'undefined')
                                      this.$set(fields[i].name, value); // May throw
                      }
                  };

                  /**
                   * @alias ProtoBuf.Builder.Message.prototype
                   * @inner
                   */
                  var MessagePrototype = Message.prototype = Object.create(ProtoBuf.Builder.Message.prototype);

                  /**
                   * Adds a value to a repeated field.
                   * @name ProtoBuf.Builder.Message#add
                   * @function
                   * @param {string} key Field name
                   * @param {*} value Value to add
                   * @param {boolean=} noAssert Whether to assert the value or not (asserts by default)
                   * @returns {!ProtoBuf.Builder.Message} this
                   * @throws {Error} If the value cannot be added
                   * @expose
                   */
                  MessagePrototype.add = function(key, value, noAssert) {
                      var field = T._fieldsByName[key];
                      if (!noAssert) {
                          if (!field)
                              throw Error(this+"#"+key+" is undefined");
                          if (!(field instanceof ProtoBuf.Reflect.Message.Field))
                              throw Error(this+"#"+key+" is not a field: "+field.toString(true)); // May throw if it's an enum or embedded message
                          if (!field.repeated)
                              throw Error(this+"#"+key+" is not a repeated field");
                          value = field.verifyValue(value, true);
                      }
                      if (this[key] === null)
                          this[key] = [];
                      this[key].push(value);
                      return this;
                  };

                  /**
                   * Adds a value to a repeated field. This is an alias for {@link ProtoBuf.Builder.Message#add}.
                   * @name ProtoBuf.Builder.Message#$add
                   * @function
                   * @param {string} key Field name
                   * @param {*} value Value to add
                   * @param {boolean=} noAssert Whether to assert the value or not (asserts by default)
                   * @returns {!ProtoBuf.Builder.Message} this
                   * @throws {Error} If the value cannot be added
                   * @expose
                   */
                  MessagePrototype.$add = MessagePrototype.add;

                  /**
                   * Sets a field's value.
                   * @name ProtoBuf.Builder.Message#set
                   * @function
                   * @param {string|!Object.<string,*>} keyOrObj String key or plain object holding multiple values
                   * @param {(*|boolean)=} value Value to set if key is a string, otherwise omitted
                   * @param {boolean=} noAssert Whether to not assert for an actual field / proper value type, defaults to `false`
                   * @returns {!ProtoBuf.Builder.Message} this
                   * @throws {Error} If the value cannot be set
                   * @expose
                   */
                  MessagePrototype.set = function(keyOrObj, value, noAssert) {
                      if (keyOrObj && typeof keyOrObj === 'object') {
                          noAssert = value;
                          for (var ikey in keyOrObj) {
                              // Check if virtual oneof field - don't set these
                              if (keyOrObj.hasOwnProperty(ikey) && typeof (value = keyOrObj[ikey]) !== 'undefined' && T._oneofsByName[ikey] === undefined)
                                  this.$set(ikey, value, noAssert);
                          }
                          return this;
                      }
                      var field = T._fieldsByName[keyOrObj];
                      if (!noAssert) {
                          if (!field)
                              throw Error(this+"#"+keyOrObj+" is not a field: undefined");
                          if (!(field instanceof ProtoBuf.Reflect.Message.Field))
                              throw Error(this+"#"+keyOrObj+" is not a field: "+field.toString(true));
                          this[field.name] = (value = field.verifyValue(value)); // May throw
                      } else
                          this[keyOrObj] = value;
                      if (field && field.oneof) { // Field is part of an OneOf (not a virtual OneOf field)
                          var currentField = this[field.oneof.name]; // Virtual field references currently set field
                          if (value !== null) {
                              if (currentField !== null && currentField !== field.name)
                                  this[currentField] = null; // Clear currently set field
                              this[field.oneof.name] = field.name; // Point virtual field at this field
                          } else if (/* value === null && */currentField === keyOrObj)
                              this[field.oneof.name] = null; // Clear virtual field (current field explicitly cleared)
                      }
                      return this;
                  };

                  /**
                   * Sets a field's value. This is an alias for [@link ProtoBuf.Builder.Message#set}.
                   * @name ProtoBuf.Builder.Message#$set
                   * @function
                   * @param {string|!Object.<string,*>} keyOrObj String key or plain object holding multiple values
                   * @param {(*|boolean)=} value Value to set if key is a string, otherwise omitted
                   * @param {boolean=} noAssert Whether to not assert the value, defaults to `false`
                   * @throws {Error} If the value cannot be set
                   * @expose
                   */
                  MessagePrototype.$set = MessagePrototype.set;

                  /**
                   * Gets a field's value.
                   * @name ProtoBuf.Builder.Message#get
                   * @function
                   * @param {string} key Key
                   * @param {boolean=} noAssert Whether to not assert for an actual field, defaults to `false`
                   * @return {*} Value
                   * @throws {Error} If there is no such field
                   * @expose
                   */
                  MessagePrototype.get = function(key, noAssert) {
                      if (noAssert)
                          return this[key];
                      var field = T._fieldsByName[key];
                      if (!field || !(field instanceof ProtoBuf.Reflect.Message.Field))
                          throw Error(this+"#"+key+" is not a field: undefined");
                      if (!(field instanceof ProtoBuf.Reflect.Message.Field))
                          throw Error(this+"#"+key+" is not a field: "+field.toString(true));
                      return this[field.name];
                  };

                  /**
                   * Gets a field's value. This is an alias for {@link ProtoBuf.Builder.Message#$get}.
                   * @name ProtoBuf.Builder.Message#$get
                   * @function
                   * @param {string} key Key
                   * @return {*} Value
                   * @throws {Error} If there is no such field
                   * @expose
                   */
                  MessagePrototype.$get = MessagePrototype.get;

                  // Getters and setters

                  for (var i=0; i<fields.length; i++) {
                      var field = fields[i];
                      // no setters for extension fields as these are named by their fqn
                      if (field instanceof ProtoBuf.Reflect.Message.ExtensionField)
                          continue;

                      if (T.builder.options['populateAccessors'])
                          (function(field) {
                              // set/get[SomeValue]
                              var Name = field.originalName.replace(/(_[a-zA-Z])/g, function(match) {
                                  return match.toUpperCase().replace('_','');
                              });
                              Name = Name.substring(0,1).toUpperCase() + Name.substring(1);

                              // set/get_[some_value] FIXME: Do we really need these?
                              var name = field.originalName.replace(/([A-Z])/g, function(match) {
                                  return "_"+match;
                              });

                              /**
                               * The current field's unbound setter function.
                               * @function
                               * @param {*} value
                               * @param {boolean=} noAssert
                               * @returns {!ProtoBuf.Builder.Message}
                               * @inner
                               */
                              var setter = function(value, noAssert) {
                                  this[field.name] = noAssert ? value : field.verifyValue(value);
                                  return this;
                              };

                              /**
                               * The current field's unbound getter function.
                               * @function
                               * @returns {*}
                               * @inner
                               */
                              var getter = function() {
                                  return this[field.name];
                              };

                              if (T.getChild("set"+Name) === null)
                                  /**
                                   * Sets a value. This method is present for each field, but only if there is no name conflict with
                                   *  another field.
                                   * @name ProtoBuf.Builder.Message#set[SomeField]
                                   * @function
                                   * @param {*} value Value to set
                                   * @param {boolean=} noAssert Whether to not assert the value, defaults to `false`
                                   * @returns {!ProtoBuf.Builder.Message} this
                                   * @abstract
                                   * @throws {Error} If the value cannot be set
                                   */
                                  MessagePrototype["set"+Name] = setter;

                              if (T.getChild("set_"+name) === null)
                                  /**
                                   * Sets a value. This method is present for each field, but only if there is no name conflict with
                                   *  another field.
                                   * @name ProtoBuf.Builder.Message#set_[some_field]
                                   * @function
                                   * @param {*} value Value to set
                                   * @param {boolean=} noAssert Whether to not assert the value, defaults to `false`
                                   * @returns {!ProtoBuf.Builder.Message} this
                                   * @abstract
                                   * @throws {Error} If the value cannot be set
                                   */
                                  MessagePrototype["set_"+name] = setter;

                              if (T.getChild("get"+Name) === null)
                                  /**
                                   * Gets a value. This method is present for each field, but only if there is no name conflict with
                                   *  another field.
                                   * @name ProtoBuf.Builder.Message#get[SomeField]
                                   * @function
                                   * @abstract
                                   * @return {*} The value
                                   */
                                  MessagePrototype["get"+Name] = getter;

                              if (T.getChild("get_"+name) === null)
                                  /**
                                   * Gets a value. This method is present for each field, but only if there is no name conflict with
                                   *  another field.
                                   * @name ProtoBuf.Builder.Message#get_[some_field]
                                   * @function
                                   * @return {*} The value
                                   * @abstract
                                   */
                                  MessagePrototype["get_"+name] = getter;

                          })(field);
                  }

                  // En-/decoding

                  /**
                   * Encodes the message.
                   * @name ProtoBuf.Builder.Message#$encode
                   * @function
                   * @param {(!ByteBuffer|boolean)=} buffer ByteBuffer to encode to. Will create a new one and flip it if omitted.
                   * @param {boolean=} noVerify Whether to not verify field values, defaults to `false`
                   * @return {!ByteBuffer} Encoded message as a ByteBuffer
                   * @throws {Error} If the message cannot be encoded or if required fields are missing. The later still
                   *  returns the encoded ByteBuffer in the `encoded` property on the error.
                   * @expose
                   * @see ProtoBuf.Builder.Message#encode64
                   * @see ProtoBuf.Builder.Message#encodeHex
                   * @see ProtoBuf.Builder.Message#encodeAB
                   */
                  MessagePrototype.encode = function(buffer, noVerify) {
                      if (typeof buffer === 'boolean')
                          noVerify = buffer,
                          buffer = undefined;
                      var isNew = false;
                      if (!buffer)
                          buffer = new ByteBuffer(),
                          isNew = true;
                      var le = buffer.littleEndian;
                      try {
                          T.encode(this, buffer.LE(), noVerify);
                          return (isNew ? buffer.flip() : buffer).LE(le);
                      } catch (e) {
                          buffer.LE(le);
                          throw(e);
                      }
                  };

                  /**
                   * Encodes a message using the specified data payload.
                   * @param {!Object.<string,*>} data Data payload
                   * @param {(!ByteBuffer|boolean)=} buffer ByteBuffer to encode to. Will create a new one and flip it if omitted.
                   * @param {boolean=} noVerify Whether to not verify field values, defaults to `false`
                   * @return {!ByteBuffer} Encoded message as a ByteBuffer
                   * @expose
                   */
                  Message.encode = function(data, buffer, noVerify) {
                      return new Message(data).encode(buffer, noVerify);
                  };

                  /**
                   * Calculates the byte length of the message.
                   * @name ProtoBuf.Builder.Message#calculate
                   * @function
                   * @returns {number} Byte length
                   * @throws {Error} If the message cannot be calculated or if required fields are missing.
                   * @expose
                   */
                  MessagePrototype.calculate = function() {
                      return T.calculate(this);
                  };

                  /**
                   * Encodes the varint32 length-delimited message.
                   * @name ProtoBuf.Builder.Message#encodeDelimited
                   * @function
                   * @param {(!ByteBuffer|boolean)=} buffer ByteBuffer to encode to. Will create a new one and flip it if omitted.
                   * @param {boolean=} noVerify Whether to not verify field values, defaults to `false`
                   * @return {!ByteBuffer} Encoded message as a ByteBuffer
                   * @throws {Error} If the message cannot be encoded or if required fields are missing. The later still
                   *  returns the encoded ByteBuffer in the `encoded` property on the error.
                   * @expose
                   */
                  MessagePrototype.encodeDelimited = function(buffer, noVerify) {
                      var isNew = false;
                      if (!buffer)
                          buffer = new ByteBuffer(),
                          isNew = true;
                      var enc = new ByteBuffer().LE();
                      T.encode(this, enc, noVerify).flip();
                      buffer.writeVarint32(enc.remaining());
                      buffer.append(enc);
                      return isNew ? buffer.flip() : buffer;
                  };

                  /**
                   * Directly encodes the message to an ArrayBuffer.
                   * @name ProtoBuf.Builder.Message#encodeAB
                   * @function
                   * @return {ArrayBuffer} Encoded message as ArrayBuffer
                   * @throws {Error} If the message cannot be encoded or if required fields are missing. The later still
                   *  returns the encoded ArrayBuffer in the `encoded` property on the error.
                   * @expose
                   */
                  MessagePrototype.encodeAB = function() {
                      try {
                          return this.encode().toArrayBuffer();
                      } catch (e) {
                          if (e["encoded"]) e["encoded"] = e["encoded"].toArrayBuffer();
                          throw(e);
                      }
                  };

                  /**
                   * Returns the message as an ArrayBuffer. This is an alias for {@link ProtoBuf.Builder.Message#encodeAB}.
                   * @name ProtoBuf.Builder.Message#toArrayBuffer
                   * @function
                   * @return {ArrayBuffer} Encoded message as ArrayBuffer
                   * @throws {Error} If the message cannot be encoded or if required fields are missing. The later still
                   *  returns the encoded ArrayBuffer in the `encoded` property on the error.
                   * @expose
                   */
                  MessagePrototype.toArrayBuffer = MessagePrototype.encodeAB;

                  /**
                   * Directly encodes the message to a node Buffer.
                   * @name ProtoBuf.Builder.Message#encodeNB
                   * @function
                   * @return {!Buffer}
                   * @throws {Error} If the message cannot be encoded, not running under node.js or if required fields are
                   *  missing. The later still returns the encoded node Buffer in the `encoded` property on the error.
                   * @expose
                   */
                  MessagePrototype.encodeNB = function() {
                      try {
                          return this.encode().toBuffer();
                      } catch (e) {
                          if (e["encoded"]) e["encoded"] = e["encoded"].toBuffer();
                          throw(e);
                      }
                  };

                  /**
                   * Returns the message as a node Buffer. This is an alias for {@link ProtoBuf.Builder.Message#encodeNB}.
                   * @name ProtoBuf.Builder.Message#toBuffer
                   * @function
                   * @return {!Buffer}
                   * @throws {Error} If the message cannot be encoded or if required fields are missing. The later still
                   *  returns the encoded node Buffer in the `encoded` property on the error.
                   * @expose
                   */
                  MessagePrototype.toBuffer = MessagePrototype.encodeNB;

                  /**
                   * Directly encodes the message to a base64 encoded string.
                   * @name ProtoBuf.Builder.Message#encode64
                   * @function
                   * @return {string} Base64 encoded string
                   * @throws {Error} If the underlying buffer cannot be encoded or if required fields are missing. The later
                   *  still returns the encoded base64 string in the `encoded` property on the error.
                   * @expose
                   */
                  MessagePrototype.encode64 = function() {
                      try {
                          return this.encode().toBase64();
                      } catch (e) {
                          if (e["encoded"]) e["encoded"] = e["encoded"].toBase64();
                          throw(e);
                      }
                  };

                  /**
                   * Returns the message as a base64 encoded string. This is an alias for {@link ProtoBuf.Builder.Message#encode64}.
                   * @name ProtoBuf.Builder.Message#toBase64
                   * @function
                   * @return {string} Base64 encoded string
                   * @throws {Error} If the message cannot be encoded or if required fields are missing. The later still
                   *  returns the encoded base64 string in the `encoded` property on the error.
                   * @expose
                   */
                  MessagePrototype.toBase64 = MessagePrototype.encode64;

                  /**
                   * Directly encodes the message to a hex encoded string.
                   * @name ProtoBuf.Builder.Message#encodeHex
                   * @function
                   * @return {string} Hex encoded string
                   * @throws {Error} If the underlying buffer cannot be encoded or if required fields are missing. The later
                   *  still returns the encoded hex string in the `encoded` property on the error.
                   * @expose
                   */
                  MessagePrototype.encodeHex = function() {
                      try {
                          return this.encode().toHex();
                      } catch (e) {
                          if (e["encoded"]) e["encoded"] = e["encoded"].toHex();
                          throw(e);
                      }
                  };

                  /**
                   * Returns the message as a hex encoded string. This is an alias for {@link ProtoBuf.Builder.Message#encodeHex}.
                   * @name ProtoBuf.Builder.Message#toHex
                   * @function
                   * @return {string} Hex encoded string
                   * @throws {Error} If the message cannot be encoded or if required fields are missing. The later still
                   *  returns the encoded hex string in the `encoded` property on the error.
                   * @expose
                   */
                  MessagePrototype.toHex = MessagePrototype.encodeHex;

                  /**
                   * Clones a message object or field value to a raw object.
                   * @param {*} obj Object to clone
                   * @param {boolean} binaryAsBase64 Whether to include binary data as base64 strings or as a buffer otherwise
                   * @param {boolean} longsAsStrings Whether to encode longs as strings
                   * @param {!ProtoBuf.Reflect.T=} resolvedType The resolved field type if a field
                   * @returns {*} Cloned object
                   * @inner
                   */
                  function cloneRaw(obj, binaryAsBase64, longsAsStrings, resolvedType) {
                      if (obj === null || typeof obj !== 'object') {
                          // Convert enum values to their respective names
                          if (resolvedType && resolvedType instanceof ProtoBuf.Reflect.Enum) {
                              var name = ProtoBuf.Reflect.Enum.getName(resolvedType.object, obj);
                              if (name !== null)
                                  return name;
                          }
                          // Pass-through string, number, boolean, null...
                          return obj;
                      }
                      // Convert ByteBuffers to raw buffer or strings
                      if (ByteBuffer.isByteBuffer(obj))
                          return binaryAsBase64 ? obj.toBase64() : obj.toBuffer();
                      // Convert Longs to proper objects or strings
                      if (ProtoBuf.Long.isLong(obj))
                          return longsAsStrings ? obj.toString() : ProtoBuf.Long.fromValue(obj);
                      var clone;
                      // Clone arrays
                      if (Array.isArray(obj)) {
                          clone = [];
                          obj.forEach(function(v, k) {
                              clone[k] = cloneRaw(v, binaryAsBase64, longsAsStrings, resolvedType);
                          });
                          return clone;
                      }
                      clone = {};
                      // Convert maps to objects
                      if (obj instanceof ProtoBuf.Map) {
                          var it = obj.entries();
                          for (var e = it.next(); !e.done; e = it.next())
                              clone[obj.keyElem.valueToString(e.value[0])] = cloneRaw(e.value[1], binaryAsBase64, longsAsStrings, obj.valueElem.resolvedType);
                          return clone;
                      }
                      // Everything else is a non-null object
                      var type = obj.$type,
                          field = undefined;
                      for (var i in obj)
                          if (obj.hasOwnProperty(i)) {
                              if (type && (field = type.getChild(i)))
                                  clone[i] = cloneRaw(obj[i], binaryAsBase64, longsAsStrings, field.resolvedType);
                              else
                                  clone[i] = cloneRaw(obj[i], binaryAsBase64, longsAsStrings);
                          }
                      return clone;
                  }

                  /**
                   * Returns the message's raw payload.
                   * @param {boolean=} binaryAsBase64 Whether to include binary data as base64 strings instead of Buffers, defaults to `false`
                   * @param {boolean} longsAsStrings Whether to encode longs as strings
                   * @returns {Object.<string,*>} Raw payload
                   * @expose
                   */
                  MessagePrototype.toRaw = function(binaryAsBase64, longsAsStrings) {
                      return cloneRaw(this, !!binaryAsBase64, !!longsAsStrings, this.$type);
                  };

                  /**
                   * Encodes a message to JSON.
                   * @returns {string} JSON string
                   * @expose
                   */
                  MessagePrototype.encodeJSON = function() {
                      return JSON.stringify(
                          cloneRaw(this,
                               /* binary-as-base64 */ true,
                               /* longs-as-strings */ true,
                               this.$type
                          )
                      );
                  };

                  /**
                   * Decodes a message from the specified buffer or string.
                   * @name ProtoBuf.Builder.Message.decode
                   * @function
                   * @param {!ByteBuffer|!ArrayBuffer|!Buffer|string} buffer Buffer to decode from
                   * @param {(number|string)=} length Message length. Defaults to decode all the remainig data.
                   * @param {string=} enc Encoding if buffer is a string: hex, utf8 (not recommended), defaults to base64
                   * @return {!ProtoBuf.Builder.Message} Decoded message
                   * @throws {Error} If the message cannot be decoded or if required fields are missing. The later still
                   *  returns the decoded message with missing fields in the `decoded` property on the error.
                   * @expose
                   * @see ProtoBuf.Builder.Message.decode64
                   * @see ProtoBuf.Builder.Message.decodeHex
                   */
                  Message.decode = function(buffer, length, enc) {
                      if (typeof length === 'string')
                          enc = length,
                          length = -1;
                      if (typeof buffer === 'string')
                          buffer = ByteBuffer.wrap(buffer, enc ? enc : "base64");
                      else if (!ByteBuffer.isByteBuffer(buffer))
                          buffer = ByteBuffer.wrap(buffer); // May throw
                      var le = buffer.littleEndian;
                      try {
                          var msg = T.decode(buffer.LE(), length);
                          buffer.LE(le);
                          return msg;
                      } catch (e) {
                          buffer.LE(le);
                          throw(e);
                      }
                  };

                  /**
                   * Decodes a varint32 length-delimited message from the specified buffer or string.
                   * @name ProtoBuf.Builder.Message.decodeDelimited
                   * @function
                   * @param {!ByteBuffer|!ArrayBuffer|!Buffer|string} buffer Buffer to decode from
                   * @param {string=} enc Encoding if buffer is a string: hex, utf8 (not recommended), defaults to base64
                   * @return {ProtoBuf.Builder.Message} Decoded message or `null` if not enough bytes are available yet
                   * @throws {Error} If the message cannot be decoded or if required fields are missing. The later still
                   *  returns the decoded message with missing fields in the `decoded` property on the error.
                   * @expose
                   */
                  Message.decodeDelimited = function(buffer, enc) {
                      if (typeof buffer === 'string')
                          buffer = ByteBuffer.wrap(buffer, enc ? enc : "base64");
                      else if (!ByteBuffer.isByteBuffer(buffer))
                          buffer = ByteBuffer.wrap(buffer); // May throw
                      if (buffer.remaining() < 1)
                          return null;
                      var off = buffer.offset,
                          len = buffer.readVarint32();
                      if (buffer.remaining() < len) {
                          buffer.offset = off;
                          return null;
                      }
                      try {
                          var msg = T.decode(buffer.slice(buffer.offset, buffer.offset + len).LE());
                          buffer.offset += len;
                          return msg;
                      } catch (err) {
                          buffer.offset += len;
                          throw err;
                      }
                  };

                  /**
                   * Decodes the message from the specified base64 encoded string.
                   * @name ProtoBuf.Builder.Message.decode64
                   * @function
                   * @param {string} str String to decode from
                   * @return {!ProtoBuf.Builder.Message} Decoded message
                   * @throws {Error} If the message cannot be decoded or if required fields are missing. The later still
                   *  returns the decoded message with missing fields in the `decoded` property on the error.
                   * @expose
                   */
                  Message.decode64 = function(str) {
                      return Message.decode(str, "base64");
                  };

                  /**
                   * Decodes the message from the specified hex encoded string.
                   * @name ProtoBuf.Builder.Message.decodeHex
                   * @function
                   * @param {string} str String to decode from
                   * @return {!ProtoBuf.Builder.Message} Decoded message
                   * @throws {Error} If the message cannot be decoded or if required fields are missing. The later still
                   *  returns the decoded message with missing fields in the `decoded` property on the error.
                   * @expose
                   */
                  Message.decodeHex = function(str) {
                      return Message.decode(str, "hex");
                  };

                  /**
                   * Decodes the message from a JSON string.
                   * @name ProtoBuf.Builder.Message.decodeJSON
                   * @function
                   * @param {string} str String to decode from
                   * @return {!ProtoBuf.Builder.Message} Decoded message
                   * @throws {Error} If the message cannot be decoded or if required fields are
                   * missing.
                   * @expose
                   */
                  Message.decodeJSON = function(str) {
                      return new Message(JSON.parse(str));
                  };

                  // Utility

                  /**
                   * Returns a string representation of this Message.
                   * @name ProtoBuf.Builder.Message#toString
                   * @function
                   * @return {string} String representation as of ".Fully.Qualified.MessageName"
                   * @expose
                   */
                  MessagePrototype.toString = function() {
                      return T.toString();
                  };

                  if (Object.defineProperty)
                      Object.defineProperty(Message, '$options', { "value": T.buildOpt() }),
                      Object.defineProperty(MessagePrototype, "$options", { "value": Message["$options"] }),
                      Object.defineProperty(Message, "$type", { "value": T }),
                      Object.defineProperty(MessagePrototype, "$type", { "value": T });

                  return Message;

              })(ProtoBuf, this);

              // Static enums and prototyped sub-messages / cached collections
              this._fields = [];
              this._fieldsById = {};
              this._fieldsByName = {};
              this._oneofsByName = {};
              for (var i=0, k=this.children.length, child; i<k; i++) {
                  child = this.children[i];
                  if (child instanceof Enum || child instanceof Message || child instanceof Service) {
                      if (clazz.hasOwnProperty(child.name))
                          throw Error("Illegal reflect child of "+this.toString(true)+": "+child.toString(true)+" cannot override static property '"+child.name+"'");
                      clazz[child.name] = child.build();
                  } else if (child instanceof Message.Field)
                      child.build(),
                      this._fields.push(child),
                      this._fieldsById[child.id] = child,
                      this._fieldsByName[child.name] = child;
                  else if (child instanceof Message.OneOf) {
                      this._oneofsByName[child.name] = child;
                  }
                  else if (!(child instanceof Message.OneOf) && !(child instanceof Extension)) // Not built
                      throw Error("Illegal reflect child of "+this.toString(true)+": "+this.children[i].toString(true));
              }

              return this.clazz = clazz;
          };

          /**
           * Encodes a runtime message's contents to the specified buffer.
           * @param {!ProtoBuf.Builder.Message} message Runtime message to encode
           * @param {ByteBuffer} buffer ByteBuffer to write to
           * @param {boolean=} noVerify Whether to not verify field values, defaults to `false`
           * @return {ByteBuffer} The ByteBuffer for chaining
           * @throws {Error} If required fields are missing or the message cannot be encoded for another reason
           * @expose
           */
          MessagePrototype.encode = function(message, buffer, noVerify) {
              var fieldMissing = null,
                  field;
              for (var i=0, k=this._fields.length, val; i<k; ++i) {
                  field = this._fields[i];
                  val = message[field.name];
                  if (field.required && val === null) {
                      if (fieldMissing === null)
                          fieldMissing = field;
                  } else
                      field.encode(noVerify ? val : field.verifyValue(val), buffer, message);
              }
              if (fieldMissing !== null) {
                  var err = Error("Missing at least one required field for "+this.toString(true)+": "+fieldMissing);
                  err["encoded"] = buffer; // Still expose what we got
                  throw(err);
              }
              return buffer;
          };

          /**
           * Calculates a runtime message's byte length.
           * @param {!ProtoBuf.Builder.Message} message Runtime message to encode
           * @returns {number} Byte length
           * @throws {Error} If required fields are missing or the message cannot be calculated for another reason
           * @expose
           */
          MessagePrototype.calculate = function(message) {
              for (var n=0, i=0, k=this._fields.length, field, val; i<k; ++i) {
                  field = this._fields[i];
                  val = message[field.name];
                  if (field.required && val === null)
                     throw Error("Missing at least one required field for "+this.toString(true)+": "+field);
                  else
                      n += field.calculate(val, message);
              }
              return n;
          };

          /**
           * Skips all data until the end of the specified group has been reached.
           * @param {number} expectedId Expected GROUPEND id
           * @param {!ByteBuffer} buf ByteBuffer
           * @returns {boolean} `true` if a value as been skipped, `false` if the end has been reached
           * @throws {Error} If it wasn't possible to find the end of the group (buffer overrun or end tag mismatch)
           * @inner
           */
          function skipTillGroupEnd(expectedId, buf) {
              var tag = buf.readVarint32(), // Throws on OOB
                  wireType = tag & 0x07,
                  id = tag >>> 3;
              switch (wireType) {
                  case ProtoBuf.WIRE_TYPES.VARINT:
                      do tag = buf.readUint8();
                      while ((tag & 0x80) === 0x80);
                      break;
                  case ProtoBuf.WIRE_TYPES.BITS64:
                      buf.offset += 8;
                      break;
                  case ProtoBuf.WIRE_TYPES.LDELIM:
                      tag = buf.readVarint32(); // reads the varint
                      buf.offset += tag;        // skips n bytes
                      break;
                  case ProtoBuf.WIRE_TYPES.STARTGROUP:
                      skipTillGroupEnd(id, buf);
                      break;
                  case ProtoBuf.WIRE_TYPES.ENDGROUP:
                      if (id === expectedId)
                          return false;
                      else
                          throw Error("Illegal GROUPEND after unknown group: "+id+" ("+expectedId+" expected)");
                  case ProtoBuf.WIRE_TYPES.BITS32:
                      buf.offset += 4;
                      break;
                  default:
                      throw Error("Illegal wire type in unknown group "+expectedId+": "+wireType);
              }
              return true;
          }

          /**
           * Decodes an encoded message and returns the decoded message.
           * @param {ByteBuffer} buffer ByteBuffer to decode from
           * @param {number=} length Message length. Defaults to decode all remaining data.
           * @param {number=} expectedGroupEndId Expected GROUPEND id if this is a legacy group
           * @return {ProtoBuf.Builder.Message} Decoded message
           * @throws {Error} If the message cannot be decoded
           * @expose
           */
          MessagePrototype.decode = function(buffer, length, expectedGroupEndId) {
              if (typeof length !== 'number')
                  length = -1;
              var start = buffer.offset,
                  msg = new (this.clazz)(),
                  tag, wireType, id, field;
              while (buffer.offset < start+length || (length === -1 && buffer.remaining() > 0)) {
                  tag = buffer.readVarint32();
                  wireType = tag & 0x07;
                  id = tag >>> 3;
                  if (wireType === ProtoBuf.WIRE_TYPES.ENDGROUP) {
                      if (id !== expectedGroupEndId)
                          throw Error("Illegal group end indicator for "+this.toString(true)+": "+id+" ("+(expectedGroupEndId ? expectedGroupEndId+" expected" : "not a group")+")");
                      break;
                  }
                  if (!(field = this._fieldsById[id])) {
                      // "messages created by your new code can be parsed by your old code: old binaries simply ignore the new field when parsing."
                      switch (wireType) {
                          case ProtoBuf.WIRE_TYPES.VARINT:
                              buffer.readVarint32();
                              break;
                          case ProtoBuf.WIRE_TYPES.BITS32:
                              buffer.offset += 4;
                              break;
                          case ProtoBuf.WIRE_TYPES.BITS64:
                              buffer.offset += 8;
                              break;
                          case ProtoBuf.WIRE_TYPES.LDELIM:
                              var len = buffer.readVarint32();
                              buffer.offset += len;
                              break;
                          case ProtoBuf.WIRE_TYPES.STARTGROUP:
                              while (skipTillGroupEnd(id, buffer)) {}
                              break;
                          default:
                              throw Error("Illegal wire type for unknown field "+id+" in "+this.toString(true)+"#decode: "+wireType);
                      }
                      continue;
                  }
                  if (field.repeated && !field.options["packed"]) {
                      msg[field.name].push(field.decode(wireType, buffer));
                  } else if (field.map) {
                      var keyval = field.decode(wireType, buffer);
                      msg[field.name].set(keyval[0], keyval[1]);
                  } else {
                      msg[field.name] = field.decode(wireType, buffer);
                      if (field.oneof) { // Field is part of an OneOf (not a virtual OneOf field)
                          var currentField = msg[field.oneof.name]; // Virtual field references currently set field
                          if (currentField !== null && currentField !== field.name)
                              msg[currentField] = null; // Clear currently set field
                          msg[field.oneof.name] = field.name; // Point virtual field at this field
                      }
                  }
              }

              // Check if all required fields are present and set default values for optional fields that are not
              for (var i=0, k=this._fields.length; i<k; ++i) {
                  field = this._fields[i];
                  if (msg[field.name] === null) {
                      if (this.syntax === "proto3") { // Proto3 sets default values by specification
                          msg[field.name] = field.defaultValue;
                      } else if (field.required) {
                          var err = Error("Missing at least one required field for " + this.toString(true) + ": " + field.name);
                          err["decoded"] = msg; // Still expose what we got
                          throw(err);
                      } else if (ProtoBuf.populateDefaults && field.defaultValue !== null)
                          msg[field.name] = field.defaultValue;
                  }
              }
              return msg;
          };

          /**
           * @alias ProtoBuf.Reflect.Message
           * @expose
           */
          Reflect.Message = Message;

          /**
           * Constructs a new Message Field.
           * @exports ProtoBuf.Reflect.Message.Field
           * @param {!ProtoBuf.Builder} builder Builder reference
           * @param {!ProtoBuf.Reflect.Message} message Message reference
           * @param {string} rule Rule, one of requried, optional, repeated
           * @param {string?} keytype Key data type, if any.
           * @param {string} type Data type, e.g. int32
           * @param {string} name Field name
           * @param {number} id Unique field id
           * @param {Object.<string,*>=} options Options
           * @param {!ProtoBuf.Reflect.Message.OneOf=} oneof Enclosing OneOf
           * @param {string?} syntax The syntax level of this definition (e.g., proto3)
           * @constructor
           * @extends ProtoBuf.Reflect.T
           */
          var Field = function(builder, message, rule, keytype, type, name, id, options, oneof, syntax) {
              T.call(this, builder, message, name);

              /**
               * @override
               */
              this.className = "Message.Field";

              /**
               * Message field required flag.
               * @type {boolean}
               * @expose
               */
              this.required = rule === "required";

              /**
               * Message field repeated flag.
               * @type {boolean}
               * @expose
               */
              this.repeated = rule === "repeated";

              /**
               * Message field map flag.
               * @type {boolean}
               * @expose
               */
              this.map = rule === "map";

              /**
               * Message field key type. Type reference string if unresolved, protobuf
               * type if resolved. Valid only if this.map === true, null otherwise.
               * @type {string|{name: string, wireType: number}|null}
               * @expose
               */
              this.keyType = keytype || null;

              /**
               * Message field type. Type reference string if unresolved, protobuf type if
               * resolved. In a map field, this is the value type.
               * @type {string|{name: string, wireType: number}}
               * @expose
               */
              this.type = type;

              /**
               * Resolved type reference inside the global namespace.
               * @type {ProtoBuf.Reflect.T|null}
               * @expose
               */
              this.resolvedType = null;

              /**
               * Unique message field id.
               * @type {number}
               * @expose
               */
              this.id = id;

              /**
               * Message field options.
               * @type {!Object.<string,*>}
               * @dict
               * @expose
               */
              this.options = options || {};

              /**
               * Default value.
               * @type {*}
               * @expose
               */
              this.defaultValue = null;

              /**
               * Enclosing OneOf.
               * @type {?ProtoBuf.Reflect.Message.OneOf}
               * @expose
               */
              this.oneof = oneof || null;

              /**
               * Syntax level of this definition (e.g., proto3).
               * @type {string}
               * @expose
               */
              this.syntax = syntax || 'proto2';

              /**
               * Original field name.
               * @type {string}
               * @expose
               */
              this.originalName = this.name; // Used to revert camelcase transformation on naming collisions

              /**
               * Element implementation. Created in build() after types are resolved.
               * @type {ProtoBuf.Element}
               * @expose
               */
              this.element = null;

              /**
               * Key element implementation, for map fields. Created in build() after
               * types are resolved.
               * @type {ProtoBuf.Element}
               * @expose
               */
              this.keyElement = null;

              // Convert field names to camel case notation if the override is set
              if (this.builder.options['convertFieldsToCamelCase'] && !(this instanceof Message.ExtensionField))
                  this.name = ProtoBuf.Util.toCamelCase(this.name);
          };

          /**
           * @alias ProtoBuf.Reflect.Message.Field.prototype
           * @inner
           */
          var FieldPrototype = Field.prototype = Object.create(T.prototype);

          /**
           * Builds the field.
           * @override
           * @expose
           */
          FieldPrototype.build = function() {
              this.element = new Element(this.type, this.resolvedType, false, this.syntax, this.name);
              if (this.map)
                  this.keyElement = new Element(this.keyType, undefined, true, this.syntax, this.name);

              // In proto3, fields do not have field presence, and every field is set to
              // its type's default value ("", 0, 0.0, or false).
              if (this.syntax === 'proto3' && !this.repeated && !this.map)
                  this.defaultValue = Element.defaultFieldValue(this.type);

              // Otherwise, default values are present when explicitly specified
              else if (typeof this.options['default'] !== 'undefined')
                  this.defaultValue = this.verifyValue(this.options['default']);
          };

          /**
           * Checks if the given value can be set for this field.
           * @param {*} value Value to check
           * @param {boolean=} skipRepeated Whether to skip the repeated value check or not. Defaults to false.
           * @return {*} Verified, maybe adjusted, value
           * @throws {Error} If the value cannot be set for this field
           * @expose
           */
          FieldPrototype.verifyValue = function(value, skipRepeated) {
              skipRepeated = skipRepeated || false;
              var self = this;
              function fail(val, msg) {
                  throw Error("Illegal value for "+self.toString(true)+" of type "+self.type.name+": "+val+" ("+msg+")");
              }
              if (value === null) { // NULL values for optional fields
                  if (this.required)
                      fail(typeof value, "required");
                  if (this.syntax === 'proto3' && this.type !== ProtoBuf.TYPES["message"])
                      fail(typeof value, "proto3 field without field presence cannot be null");
                  return null;
              }
              var i;
              if (this.repeated && !skipRepeated) { // Repeated values as arrays
                  if (!Array.isArray(value))
                      value = [value];
                  var res = [];
                  for (i=0; i<value.length; i++)
                      res.push(this.element.verifyValue(value[i]));
                  return res;
              }
              if (this.map && !skipRepeated) { // Map values as objects
                  if (!(value instanceof ProtoBuf.Map)) {
                      // If not already a Map, attempt to convert.
                      if (!(value instanceof Object)) {
                          fail(typeof value,
                               "expected ProtoBuf.Map or raw object for map field");
                      }
                      return new ProtoBuf.Map(this, value);
                  } else {
                      return value;
                  }
              }
              // All non-repeated fields expect no array
              if (!this.repeated && Array.isArray(value))
                  fail(typeof value, "no array expected");

              return this.element.verifyValue(value);
          };

          /**
           * Determines whether the field will have a presence on the wire given its
           * value.
           * @param {*} value Verified field value
           * @param {!ProtoBuf.Builder.Message} message Runtime message
           * @return {boolean} Whether the field will be present on the wire
           */
          FieldPrototype.hasWirePresence = function(value, message) {
              if (this.syntax !== 'proto3')
                  return (value !== null);
              if (this.oneof && message[this.oneof.name] === this.name)
                  return true;
              switch (this.type) {
                  case ProtoBuf.TYPES["int32"]:
                  case ProtoBuf.TYPES["sint32"]:
                  case ProtoBuf.TYPES["sfixed32"]:
                  case ProtoBuf.TYPES["uint32"]:
                  case ProtoBuf.TYPES["fixed32"]:
                      return value !== 0;

                  case ProtoBuf.TYPES["int64"]:
                  case ProtoBuf.TYPES["sint64"]:
                  case ProtoBuf.TYPES["sfixed64"]:
                  case ProtoBuf.TYPES["uint64"]:
                  case ProtoBuf.TYPES["fixed64"]:
                      return value.low !== 0 || value.high !== 0;

                  case ProtoBuf.TYPES["bool"]:
                      return value;

                  case ProtoBuf.TYPES["float"]:
                  case ProtoBuf.TYPES["double"]:
                      return value !== 0.0;

                  case ProtoBuf.TYPES["string"]:
                      return value.length > 0;

                  case ProtoBuf.TYPES["bytes"]:
                      return value.remaining() > 0;

                  case ProtoBuf.TYPES["enum"]:
                      return value !== 0;

                  case ProtoBuf.TYPES["message"]:
                      return value !== null;
                  default:
                      return true;
              }
          };

          /**
           * Encodes the specified field value to the specified buffer.
           * @param {*} value Verified field value
           * @param {ByteBuffer} buffer ByteBuffer to encode to
           * @param {!ProtoBuf.Builder.Message} message Runtime message
           * @return {ByteBuffer} The ByteBuffer for chaining
           * @throws {Error} If the field cannot be encoded
           * @expose
           */
          FieldPrototype.encode = function(value, buffer, message) {
              if (this.type === null || typeof this.type !== 'object')
                  throw Error("[INTERNAL] Unresolved type in "+this.toString(true)+": "+this.type);
              if (value === null || (this.repeated && value.length == 0))
                  return buffer; // Optional omitted
              try {
                  if (this.repeated) {
                      var i;
                      // "Only repeated fields of primitive numeric types (types which use the varint, 32-bit, or 64-bit wire
                      // types) can be declared 'packed'."
                      if (this.options["packed"] && ProtoBuf.PACKABLE_WIRE_TYPES.indexOf(this.type.wireType) >= 0) {
                          // "All of the elements of the field are packed into a single key-value pair with wire type 2
                          // (length-delimited). Each element is encoded the same way it would be normally, except without a
                          // tag preceding it."
                          buffer.writeVarint32((this.id << 3) | ProtoBuf.WIRE_TYPES.LDELIM);
                          buffer.ensureCapacity(buffer.offset += 1); // We do not know the length yet, so let's assume a varint of length 1
                          var start = buffer.offset; // Remember where the contents begin
                          for (i=0; i<value.length; i++)
                              this.element.encodeValue(this.id, value[i], buffer);
                          var len = buffer.offset-start,
                              varintLen = ByteBuffer.calculateVarint32(len);
                          if (varintLen > 1) { // We need to move the contents
                              var contents = buffer.slice(start, buffer.offset);
                              start += varintLen-1;
                              buffer.offset = start;
                              buffer.append(contents);
                          }
                          buffer.writeVarint32(len, start-varintLen);
                      } else {
                          // "If your message definition has repeated elements (without the [packed=true] option), the encoded
                          // message has zero or more key-value pairs with the same tag number"
                          for (i=0; i<value.length; i++)
                              buffer.writeVarint32((this.id << 3) | this.type.wireType),
                              this.element.encodeValue(this.id, value[i], buffer);
                      }
                  } else if (this.map) {
                      // Write out each map entry as a submessage.
                      value.forEach(function(val, key, m) {
                          // Compute the length of the submessage (key, val) pair.
                          var length =
                              ByteBuffer.calculateVarint32((1 << 3) | this.keyType.wireType) +
                              this.keyElement.calculateLength(1, key) +
                              ByteBuffer.calculateVarint32((2 << 3) | this.type.wireType) +
                              this.element.calculateLength(2, val);

                          // Submessage with wire type of length-delimited.
                          buffer.writeVarint32((this.id << 3) | ProtoBuf.WIRE_TYPES.LDELIM);
                          buffer.writeVarint32(length);

                          // Write out the key and val.
                          buffer.writeVarint32((1 << 3) | this.keyType.wireType);
                          this.keyElement.encodeValue(1, key, buffer);
                          buffer.writeVarint32((2 << 3) | this.type.wireType);
                          this.element.encodeValue(2, val, buffer);
                      }, this);
                  } else {
                      if (this.hasWirePresence(value, message)) {
                          buffer.writeVarint32((this.id << 3) | this.type.wireType);
                          this.element.encodeValue(this.id, value, buffer);
                      }
                  }
              } catch (e) {
                  throw Error("Illegal value for "+this.toString(true)+": "+value+" ("+e+")");
              }
              return buffer;
          };

          /**
           * Calculates the length of this field's value on the network level.
           * @param {*} value Field value
           * @param {!ProtoBuf.Builder.Message} message Runtime message
           * @returns {number} Byte length
           * @expose
           */
          FieldPrototype.calculate = function(value, message) {
              value = this.verifyValue(value); // May throw
              if (this.type === null || typeof this.type !== 'object')
                  throw Error("[INTERNAL] Unresolved type in "+this.toString(true)+": "+this.type);
              if (value === null || (this.repeated && value.length == 0))
                  return 0; // Optional omitted
              var n = 0;
              try {
                  if (this.repeated) {
                      var i, ni;
                      if (this.options["packed"] && ProtoBuf.PACKABLE_WIRE_TYPES.indexOf(this.type.wireType) >= 0) {
                          n += ByteBuffer.calculateVarint32((this.id << 3) | ProtoBuf.WIRE_TYPES.LDELIM);
                          ni = 0;
                          for (i=0; i<value.length; i++)
                              ni += this.element.calculateLength(this.id, value[i]);
                          n += ByteBuffer.calculateVarint32(ni);
                          n += ni;
                      } else {
                          for (i=0; i<value.length; i++)
                              n += ByteBuffer.calculateVarint32((this.id << 3) | this.type.wireType),
                              n += this.element.calculateLength(this.id, value[i]);
                      }
                  } else if (this.map) {
                      // Each map entry becomes a submessage.
                      value.forEach(function(val, key, m) {
                          // Compute the length of the submessage (key, val) pair.
                          var length =
                              ByteBuffer.calculateVarint32((1 << 3) | this.keyType.wireType) +
                              this.keyElement.calculateLength(1, key) +
                              ByteBuffer.calculateVarint32((2 << 3) | this.type.wireType) +
                              this.element.calculateLength(2, val);

                          n += ByteBuffer.calculateVarint32((this.id << 3) | ProtoBuf.WIRE_TYPES.LDELIM);
                          n += ByteBuffer.calculateVarint32(length);
                          n += length;
                      }, this);
                  } else {
                      if (this.hasWirePresence(value, message)) {
                          n += ByteBuffer.calculateVarint32((this.id << 3) | this.type.wireType);
                          n += this.element.calculateLength(this.id, value);
                      }
                  }
              } catch (e) {
                  throw Error("Illegal value for "+this.toString(true)+": "+value+" ("+e+")");
              }
              return n;
          };

          /**
           * Decode the field value from the specified buffer.
           * @param {number} wireType Leading wire type
           * @param {ByteBuffer} buffer ByteBuffer to decode from
           * @param {boolean=} skipRepeated Whether to skip the repeated check or not. Defaults to false.
           * @return {*} Decoded value: array for packed repeated fields, [key, value] for
           *             map fields, or an individual value otherwise.
           * @throws {Error} If the field cannot be decoded
           * @expose
           */
          FieldPrototype.decode = function(wireType, buffer, skipRepeated) {
              var value, nBytes;

              // We expect wireType to match the underlying type's wireType unless we see
              // a packed repeated field, or unless this is a map field.
              var wireTypeOK =
                  (!this.map && wireType == this.type.wireType) ||
                  (!skipRepeated && this.repeated && this.options["packed"] &&
                   wireType == ProtoBuf.WIRE_TYPES.LDELIM) ||
                  (this.map && wireType == ProtoBuf.WIRE_TYPES.LDELIM);
              if (!wireTypeOK)
                  throw Error("Illegal wire type for field "+this.toString(true)+": "+wireType+" ("+this.type.wireType+" expected)");

              // Handle packed repeated fields.
              if (wireType == ProtoBuf.WIRE_TYPES.LDELIM && this.repeated && this.options["packed"] && ProtoBuf.PACKABLE_WIRE_TYPES.indexOf(this.type.wireType) >= 0) {
                  if (!skipRepeated) {
                      nBytes = buffer.readVarint32();
                      nBytes = buffer.offset + nBytes; // Limit
                      var values = [];
                      while (buffer.offset < nBytes)
                          values.push(this.decode(this.type.wireType, buffer, true));
                      return values;
                  }
                  // Read the next value otherwise...
              }

              // Handle maps.
              if (this.map) {
                  // Read one (key, value) submessage, and return [key, value]
                  var key = Element.defaultFieldValue(this.keyType);
                  value = Element.defaultFieldValue(this.type);

                  // Read the length
                  nBytes = buffer.readVarint32();
                  if (buffer.remaining() < nBytes)
                      throw Error("Illegal number of bytes for "+this.toString(true)+": "+nBytes+" required but got only "+buffer.remaining());

                  // Get a sub-buffer of this key/value submessage
                  var msgbuf = buffer.clone();
                  msgbuf.limit = msgbuf.offset + nBytes;
                  buffer.offset += nBytes;

                  while (msgbuf.remaining() > 0) {
                      var tag = msgbuf.readVarint32();
                      wireType = tag & 0x07;
                      var id = tag >>> 3;
                      if (id === 1) {
                          key = this.keyElement.decode(msgbuf, wireType, id);
                      } else if (id === 2) {
                          value = this.element.decode(msgbuf, wireType, id);
                      } else {
                          throw Error("Unexpected tag in map field key/value submessage");
                      }
                  }

                  return [key, value];
              }

              // Handle singular and non-packed repeated field values.
              return this.element.decode(buffer, wireType, this.id);
          };

          /**
           * @alias ProtoBuf.Reflect.Message.Field
           * @expose
           */
          Reflect.Message.Field = Field;

          /**
           * Constructs a new Message ExtensionField.
           * @exports ProtoBuf.Reflect.Message.ExtensionField
           * @param {!ProtoBuf.Builder} builder Builder reference
           * @param {!ProtoBuf.Reflect.Message} message Message reference
           * @param {string} rule Rule, one of requried, optional, repeated
           * @param {string} type Data type, e.g. int32
           * @param {string} name Field name
           * @param {number} id Unique field id
           * @param {!Object.<string,*>=} options Options
           * @constructor
           * @extends ProtoBuf.Reflect.Message.Field
           */
          var ExtensionField = function(builder, message, rule, type, name, id, options) {
              Field.call(this, builder, message, rule, /* keytype = */ null, type, name, id, options);

              /**
               * Extension reference.
               * @type {!ProtoBuf.Reflect.Extension}
               * @expose
               */
              this.extension;
          };

          // Extends Field
          ExtensionField.prototype = Object.create(Field.prototype);

          /**
           * @alias ProtoBuf.Reflect.Message.ExtensionField
           * @expose
           */
          Reflect.Message.ExtensionField = ExtensionField;

          /**
           * Constructs a new Message OneOf.
           * @exports ProtoBuf.Reflect.Message.OneOf
           * @param {!ProtoBuf.Builder} builder Builder reference
           * @param {!ProtoBuf.Reflect.Message} message Message reference
           * @param {string} name OneOf name
           * @constructor
           * @extends ProtoBuf.Reflect.T
           */
          var OneOf = function(builder, message, name) {
              T.call(this, builder, message, name);

              /**
               * Enclosed fields.
               * @type {!Array.<!ProtoBuf.Reflect.Message.Field>}
               * @expose
               */
              this.fields = [];
          };

          /**
           * @alias ProtoBuf.Reflect.Message.OneOf
           * @expose
           */
          Reflect.Message.OneOf = OneOf;

          /**
           * Constructs a new Enum.
           * @exports ProtoBuf.Reflect.Enum
           * @param {!ProtoBuf.Builder} builder Builder reference
           * @param {!ProtoBuf.Reflect.T} parent Parent Reflect object
           * @param {string} name Enum name
           * @param {Object.<string,*>=} options Enum options
           * @param {string?} syntax The syntax level (e.g., proto3)
           * @constructor
           * @extends ProtoBuf.Reflect.Namespace
           */
          var Enum = function(builder, parent, name, options, syntax) {
              Namespace.call(this, builder, parent, name, options, syntax);

              /**
               * @override
               */
              this.className = "Enum";

              /**
               * Runtime enum object.
               * @type {Object.<string,number>|null}
               * @expose
               */
              this.object = null;
          };

          /**
           * Gets the string name of an enum value.
           * @param {!ProtoBuf.Builder.Enum} enm Runtime enum
           * @param {number} value Enum value
           * @returns {?string} Name or `null` if not present
           * @expose
           */
          Enum.getName = function(enm, value) {
              var keys = Object.keys(enm);
              for (var i=0, key; i<keys.length; ++i)
                  if (enm[key = keys[i]] === value)
                      return key;
              return null;
          };

          /**
           * @alias ProtoBuf.Reflect.Enum.prototype
           * @inner
           */
          var EnumPrototype = Enum.prototype = Object.create(Namespace.prototype);

          /**
           * Builds this enum and returns the runtime counterpart.
           * @param {boolean} rebuild Whether to rebuild or not, defaults to false
           * @returns {!Object.<string,number>}
           * @expose
           */
          EnumPrototype.build = function(rebuild) {
              if (this.object && !rebuild)
                  return this.object;
              var enm = new ProtoBuf.Builder.Enum(),
                  values = this.getChildren(Enum.Value);
              for (var i=0, k=values.length; i<k; ++i)
                  enm[values[i]['name']] = values[i]['id'];
              if (Object.defineProperty)
                  Object.defineProperty(enm, '$options', {
                      "value": this.buildOpt(),
                      "enumerable": false
                  });
              return this.object = enm;
          };

          /**
           * @alias ProtoBuf.Reflect.Enum
           * @expose
           */
          Reflect.Enum = Enum;

          /**
           * Constructs a new Enum Value.
           * @exports ProtoBuf.Reflect.Enum.Value
           * @param {!ProtoBuf.Builder} builder Builder reference
           * @param {!ProtoBuf.Reflect.Enum} enm Enum reference
           * @param {string} name Field name
           * @param {number} id Unique field id
           * @constructor
           * @extends ProtoBuf.Reflect.T
           */
          var Value = function(builder, enm, name, id) {
              T.call(this, builder, enm, name);

              /**
               * @override
               */
              this.className = "Enum.Value";

              /**
               * Unique enum value id.
               * @type {number}
               * @expose
               */
              this.id = id;
          };

          // Extends T
          Value.prototype = Object.create(T.prototype);

          /**
           * @alias ProtoBuf.Reflect.Enum.Value
           * @expose
           */
          Reflect.Enum.Value = Value;

          /**
           * An extension (field).
           * @exports ProtoBuf.Reflect.Extension
           * @constructor
           * @param {!ProtoBuf.Builder} builder Builder reference
           * @param {!ProtoBuf.Reflect.T} parent Parent object
           * @param {string} name Object name
           * @param {!ProtoBuf.Reflect.Message.Field} field Extension field
           */
          var Extension = function(builder, parent, name, field) {
              T.call(this, builder, parent, name);

              /**
               * Extended message field.
               * @type {!ProtoBuf.Reflect.Message.Field}
               * @expose
               */
              this.field = field;
          };

          // Extends T
          Extension.prototype = Object.create(T.prototype);

          /**
           * @alias ProtoBuf.Reflect.Extension
           * @expose
           */
          Reflect.Extension = Extension;

          /**
           * Constructs a new Service.
           * @exports ProtoBuf.Reflect.Service
           * @param {!ProtoBuf.Builder} builder Builder reference
           * @param {!ProtoBuf.Reflect.Namespace} root Root
           * @param {string} name Service name
           * @param {Object.<string,*>=} options Options
           * @constructor
           * @extends ProtoBuf.Reflect.Namespace
           */
          var Service = function(builder, root, name, options) {
              Namespace.call(this, builder, root, name, options);

              /**
               * @override
               */
              this.className = "Service";

              /**
               * Built runtime service class.
               * @type {?function(new:ProtoBuf.Builder.Service)}
               */
              this.clazz = null;
          };

          /**
           * @alias ProtoBuf.Reflect.Service.prototype
           * @inner
           */
          var ServicePrototype = Service.prototype = Object.create(Namespace.prototype);

          /**
           * Builds the service and returns the runtime counterpart, which is a fully functional class.
           * @see ProtoBuf.Builder.Service
           * @param {boolean=} rebuild Whether to rebuild or not
           * @return {Function} Service class
           * @throws {Error} If the message cannot be built
           * @expose
           */
          ServicePrototype.build = function(rebuild) {
              if (this.clazz && !rebuild)
                  return this.clazz;

              // Create the runtime Service class in its own scope
              return this.clazz = (function(ProtoBuf, T) {

                  /**
                   * Constructs a new runtime Service.
                   * @name ProtoBuf.Builder.Service
                   * @param {function(string, ProtoBuf.Builder.Message, function(Error, ProtoBuf.Builder.Message=))=} rpcImpl RPC implementation receiving the method name and the message
                   * @class Barebone of all runtime services.
                   * @constructor
                   * @throws {Error} If the service cannot be created
                   */
                  var Service = function(rpcImpl) {
                      ProtoBuf.Builder.Service.call(this);

                      /**
                       * Service implementation.
                       * @name ProtoBuf.Builder.Service#rpcImpl
                       * @type {!function(string, ProtoBuf.Builder.Message, function(Error, ProtoBuf.Builder.Message=))}
                       * @expose
                       */
                      this.rpcImpl = rpcImpl || function(name, msg, callback) {
                          // This is what a user has to implement: A function receiving the method name, the actual message to
                          // send (type checked) and the callback that's either provided with the error as its first
                          // argument or null and the actual response message.
                          setTimeout(callback.bind(this, Error("Not implemented, see: https://github.com/dcodeIO/ProtoBuf.js/wiki/Services")), 0); // Must be async!
                      };
                  };

                  /**
                   * @alias ProtoBuf.Builder.Service.prototype
                   * @inner
                   */
                  var ServicePrototype = Service.prototype = Object.create(ProtoBuf.Builder.Service.prototype);

                  /**
                   * Asynchronously performs an RPC call using the given RPC implementation.
                   * @name ProtoBuf.Builder.Service.[Method]
                   * @function
                   * @param {!function(string, ProtoBuf.Builder.Message, function(Error, ProtoBuf.Builder.Message=))} rpcImpl RPC implementation
                   * @param {ProtoBuf.Builder.Message} req Request
                   * @param {function(Error, (ProtoBuf.Builder.Message|ByteBuffer|Buffer|string)=)} callback Callback receiving
                   *  the error if any and the response either as a pre-parsed message or as its raw bytes
                   * @abstract
                   */

                  /**
                   * Asynchronously performs an RPC call using the instance's RPC implementation.
                   * @name ProtoBuf.Builder.Service#[Method]
                   * @function
                   * @param {ProtoBuf.Builder.Message} req Request
                   * @param {function(Error, (ProtoBuf.Builder.Message|ByteBuffer|Buffer|string)=)} callback Callback receiving
                   *  the error if any and the response either as a pre-parsed message or as its raw bytes
                   * @abstract
                   */

                  var rpc = T.getChildren(ProtoBuf.Reflect.Service.RPCMethod);
                  for (var i=0; i<rpc.length; i++) {
                      (function(method) {

                          // service#Method(message, callback)
                          ServicePrototype[method.name] = function(req, callback) {
                              try {
                                  try {
                                      // If given as a buffer, decode the request. Will throw a TypeError if not a valid buffer.
                                      req = method.resolvedRequestType.clazz.decode(ByteBuffer.wrap(req));
                                  } catch (err) {
                                      if (!(err instanceof TypeError))
                                          throw err;
                                  }
                                  if (req === null || typeof req !== 'object')
                                      throw Error("Illegal arguments");
                                  if (!(req instanceof method.resolvedRequestType.clazz))
                                      req = new method.resolvedRequestType.clazz(req);
                                  this.rpcImpl(method.fqn(), req, function(err, res) { // Assumes that this is properly async
                                      if (err) {
                                          callback(err);
                                          return;
                                      }
                                      // Coalesce to empty string when service response has empty content
                                      if (res === null)
                                          res = '';
                                      try { res = method.resolvedResponseType.clazz.decode(res); } catch (notABuffer) {}
                                      if (!res || !(res instanceof method.resolvedResponseType.clazz)) {
                                          callback(Error("Illegal response type received in service method "+ T.name+"#"+method.name));
                                          return;
                                      }
                                      callback(null, res);
                                  });
                              } catch (err) {
                                  setTimeout(callback.bind(this, err), 0);
                              }
                          };

                          // Service.Method(rpcImpl, message, callback)
                          Service[method.name] = function(rpcImpl, req, callback) {
                              new Service(rpcImpl)[method.name](req, callback);
                          };

                          if (Object.defineProperty)
                              Object.defineProperty(Service[method.name], "$options", { "value": method.buildOpt() }),
                              Object.defineProperty(ServicePrototype[method.name], "$options", { "value": Service[method.name]["$options"] });
                      })(rpc[i]);
                  }

                  if (Object.defineProperty)
                      Object.defineProperty(Service, "$options", { "value": T.buildOpt() }),
                      Object.defineProperty(ServicePrototype, "$options", { "value": Service["$options"] }),
                      Object.defineProperty(Service, "$type", { "value": T }),
                      Object.defineProperty(ServicePrototype, "$type", { "value": T });

                  return Service;

              })(ProtoBuf, this);
          };

          /**
           * @alias ProtoBuf.Reflect.Service
           * @expose
           */
          Reflect.Service = Service;

          /**
           * Abstract service method.
           * @exports ProtoBuf.Reflect.Service.Method
           * @param {!ProtoBuf.Builder} builder Builder reference
           * @param {!ProtoBuf.Reflect.Service} svc Service
           * @param {string} name Method name
           * @param {Object.<string,*>=} options Options
           * @constructor
           * @extends ProtoBuf.Reflect.T
           */
          var Method = function(builder, svc, name, options) {
              T.call(this, builder, svc, name);

              /**
               * @override
               */
              this.className = "Service.Method";

              /**
               * Options.
               * @type {Object.<string, *>}
               * @expose
               */
              this.options = options || {};
          };

          /**
           * @alias ProtoBuf.Reflect.Service.Method.prototype
           * @inner
           */
          var MethodPrototype = Method.prototype = Object.create(T.prototype);

          /**
           * Builds the method's '$options' property.
           * @name ProtoBuf.Reflect.Service.Method#buildOpt
           * @function
           * @return {Object.<string,*>}
           */
          MethodPrototype.buildOpt = NamespacePrototype.buildOpt;

          /**
           * @alias ProtoBuf.Reflect.Service.Method
           * @expose
           */
          Reflect.Service.Method = Method;

          /**
           * RPC service method.
           * @exports ProtoBuf.Reflect.Service.RPCMethod
           * @param {!ProtoBuf.Builder} builder Builder reference
           * @param {!ProtoBuf.Reflect.Service} svc Service
           * @param {string} name Method name
           * @param {string} request Request message name
           * @param {string} response Response message name
           * @param {boolean} request_stream Whether requests are streamed
           * @param {boolean} response_stream Whether responses are streamed
           * @param {Object.<string,*>=} options Options
           * @constructor
           * @extends ProtoBuf.Reflect.Service.Method
           */
          var RPCMethod = function(builder, svc, name, request, response, request_stream, response_stream, options) {
              Method.call(this, builder, svc, name, options);

              /**
               * @override
               */
              this.className = "Service.RPCMethod";

              /**
               * Request message name.
               * @type {string}
               * @expose
               */
              this.requestName = request;

              /**
               * Response message name.
               * @type {string}
               * @expose
               */
              this.responseName = response;

              /**
               * Whether requests are streamed
               * @type {bool}
               * @expose
               */
              this.requestStream = request_stream;

              /**
               * Whether responses are streamed
               * @type {bool}
               * @expose
               */
              this.responseStream = response_stream;

              /**
               * Resolved request message type.
               * @type {ProtoBuf.Reflect.Message}
               * @expose
               */
              this.resolvedRequestType = null;

              /**
               * Resolved response message type.
               * @type {ProtoBuf.Reflect.Message}
               * @expose
               */
              this.resolvedResponseType = null;
          };

          // Extends Method
          RPCMethod.prototype = Object.create(Method.prototype);

          /**
           * @alias ProtoBuf.Reflect.Service.RPCMethod
           * @expose
           */
          Reflect.Service.RPCMethod = RPCMethod;

          return Reflect;

      })(ProtoBuf);

      /**
       * @alias ProtoBuf.Builder
       * @expose
       */
      ProtoBuf.Builder = (function(ProtoBuf, Lang, Reflect) {

          /**
           * Constructs a new Builder.
           * @exports ProtoBuf.Builder
           * @class Provides the functionality to build protocol messages.
           * @param {Object.<string,*>=} options Options
           * @constructor
           */
          var Builder = function(options) {

              /**
               * Namespace.
               * @type {ProtoBuf.Reflect.Namespace}
               * @expose
               */
              this.ns = new Reflect.Namespace(this, null, ""); // Global namespace

              /**
               * Namespace pointer.
               * @type {ProtoBuf.Reflect.T}
               * @expose
               */
              this.ptr = this.ns;

              /**
               * Resolved flag.
               * @type {boolean}
               * @expose
               */
              this.resolved = false;

              /**
               * The current building result.
               * @type {Object.<string,ProtoBuf.Builder.Message|Object>|null}
               * @expose
               */
              this.result = null;

              /**
               * Imported files.
               * @type {Array.<string>}
               * @expose
               */
              this.files = {};

              /**
               * Import root override.
               * @type {?string}
               * @expose
               */
              this.importRoot = null;

              /**
               * Options.
               * @type {!Object.<string, *>}
               * @expose
               */
              this.options = options || {};
          };

          /**
           * @alias ProtoBuf.Builder.prototype
           * @inner
           */
          var BuilderPrototype = Builder.prototype;

          // ----- Definition tests -----

          /**
           * Tests if a definition most likely describes a message.
           * @param {!Object} def
           * @returns {boolean}
           * @expose
           */
          Builder.isMessage = function(def) {
              // Messages require a string name
              if (typeof def["name"] !== 'string')
                  return false;
              // Messages do not contain values (enum) or rpc methods (service)
              if (typeof def["values"] !== 'undefined' || typeof def["rpc"] !== 'undefined')
                  return false;
              return true;
          };

          /**
           * Tests if a definition most likely describes a message field.
           * @param {!Object} def
           * @returns {boolean}
           * @expose
           */
          Builder.isMessageField = function(def) {
              // Message fields require a string rule, name and type and an id
              if (typeof def["rule"] !== 'string' || typeof def["name"] !== 'string' || typeof def["type"] !== 'string' || typeof def["id"] === 'undefined')
                  return false;
              return true;
          };

          /**
           * Tests if a definition most likely describes an enum.
           * @param {!Object} def
           * @returns {boolean}
           * @expose
           */
          Builder.isEnum = function(def) {
              // Enums require a string name
              if (typeof def["name"] !== 'string')
                  return false;
              // Enums require at least one value
              if (typeof def["values"] === 'undefined' || !Array.isArray(def["values"]) || def["values"].length === 0)
                  return false;
              return true;
          };

          /**
           * Tests if a definition most likely describes a service.
           * @param {!Object} def
           * @returns {boolean}
           * @expose
           */
          Builder.isService = function(def) {
              // Services require a string name and an rpc object
              if (typeof def["name"] !== 'string' || typeof def["rpc"] !== 'object' || !def["rpc"])
                  return false;
              return true;
          };

          /**
           * Tests if a definition most likely describes an extended message
           * @param {!Object} def
           * @returns {boolean}
           * @expose
           */
          Builder.isExtend = function(def) {
              // Extends rquire a string ref
              if (typeof def["ref"] !== 'string')
                  return false;
              return true;
          };

          // ----- Building -----

          /**
           * Resets the pointer to the root namespace.
           * @returns {!ProtoBuf.Builder} this
           * @expose
           */
          BuilderPrototype.reset = function() {
              this.ptr = this.ns;
              return this;
          };

          /**
           * Defines a namespace on top of the current pointer position and places the pointer on it.
           * @param {string} namespace
           * @return {!ProtoBuf.Builder} this
           * @expose
           */
          BuilderPrototype.define = function(namespace) {
              if (typeof namespace !== 'string' || !Lang.TYPEREF.test(namespace))
                  throw Error("illegal namespace: "+namespace);
              namespace.split(".").forEach(function(part) {
                  var ns = this.ptr.getChild(part);
                  if (ns === null) // Keep existing
                      this.ptr.addChild(ns = new Reflect.Namespace(this, this.ptr, part));
                  this.ptr = ns;
              }, this);
              return this;
          };

          /**
           * Creates the specified definitions at the current pointer position.
           * @param {!Array.<!Object>} defs Messages, enums or services to create
           * @returns {!ProtoBuf.Builder} this
           * @throws {Error} If a message definition is invalid
           * @expose
           */
          BuilderPrototype.create = function(defs) {
              if (!defs)
                  return this; // Nothing to create
              if (!Array.isArray(defs))
                  defs = [defs];
              else {
                  if (defs.length === 0)
                      return this;
                  defs = defs.slice();
              }

              // It's quite hard to keep track of scopes and memory here, so let's do this iteratively.
              var stack = [defs];
              while (stack.length > 0) {
                  defs = stack.pop();

                  if (!Array.isArray(defs)) // Stack always contains entire namespaces
                      throw Error("not a valid namespace: "+JSON.stringify(defs));

                  while (defs.length > 0) {
                      var def = defs.shift(); // Namespaces always contain an array of messages, enums and services

                      if (Builder.isMessage(def)) {
                          var obj = new Reflect.Message(this, this.ptr, def["name"], def["options"], def["isGroup"], def["syntax"]);

                          // Create OneOfs
                          var oneofs = {};
                          if (def["oneofs"])
                              Object.keys(def["oneofs"]).forEach(function(name) {
                                  obj.addChild(oneofs[name] = new Reflect.Message.OneOf(this, obj, name));
                              }, this);

                          // Create fields
                          if (def["fields"])
                              def["fields"].forEach(function(fld) {
                                  if (obj.getChild(fld["id"]|0) !== null)
                                      throw Error("duplicate or invalid field id in "+obj.name+": "+fld['id']);
                                  if (fld["options"] && typeof fld["options"] !== 'object')
                                      throw Error("illegal field options in "+obj.name+"#"+fld["name"]);
                                  var oneof = null;
                                  if (typeof fld["oneof"] === 'string' && !(oneof = oneofs[fld["oneof"]]))
                                      throw Error("illegal oneof in "+obj.name+"#"+fld["name"]+": "+fld["oneof"]);
                                  fld = new Reflect.Message.Field(this, obj, fld["rule"], fld["keytype"], fld["type"], fld["name"], fld["id"], fld["options"], oneof, def["syntax"]);
                                  if (oneof)
                                      oneof.fields.push(fld);
                                  obj.addChild(fld);
                              }, this);

                          // Push children to stack
                          var subObj = [];
                          if (def["enums"])
                              def["enums"].forEach(function(enm) {
                                  subObj.push(enm);
                              });
                          if (def["messages"])
                              def["messages"].forEach(function(msg) {
                                  subObj.push(msg);
                              });
                          if (def["services"])
                              def["services"].forEach(function(svc) {
                                  subObj.push(svc);
                              });

                          // Set extension ranges
                          if (def["extensions"]) {
                              if (typeof def["extensions"][0] === 'number') // pre 5.0.1
                                  obj.extensions = [ def["extensions"] ];
                              else
                                  obj.extensions = def["extensions"];
                          }

                          // Create on top of current namespace
                          this.ptr.addChild(obj);
                          if (subObj.length > 0) {
                              stack.push(defs); // Push the current level back
                              defs = subObj; // Continue processing sub level
                              subObj = null;
                              this.ptr = obj; // And move the pointer to this namespace
                              obj = null;
                              continue;
                          }
                          subObj = null;

                      } else if (Builder.isEnum(def)) {

                          obj = new Reflect.Enum(this, this.ptr, def["name"], def["options"], def["syntax"]);
                          def["values"].forEach(function(val) {
                              obj.addChild(new Reflect.Enum.Value(this, obj, val["name"], val["id"]));
                          }, this);
                          this.ptr.addChild(obj);

                      } else if (Builder.isService(def)) {

                          obj = new Reflect.Service(this, this.ptr, def["name"], def["options"]);
                          Object.keys(def["rpc"]).forEach(function(name) {
                              var mtd = def["rpc"][name];
                              obj.addChild(new Reflect.Service.RPCMethod(this, obj, name, mtd["request"], mtd["response"], !!mtd["request_stream"], !!mtd["response_stream"], mtd["options"]));
                          }, this);
                          this.ptr.addChild(obj);

                      } else if (Builder.isExtend(def)) {

                          obj = this.ptr.resolve(def["ref"], true);
                          if (obj) {
                              def["fields"].forEach(function(fld) {
                                  if (obj.getChild(fld['id']|0) !== null)
                                      throw Error("duplicate extended field id in "+obj.name+": "+fld['id']);
                                  // Check if field id is allowed to be extended
                                  if (obj.extensions) {
                                      var valid = false;
                                      obj.extensions.forEach(function(range) {
                                          if (fld["id"] >= range[0] && fld["id"] <= range[1])
                                              valid = true;
                                      });
                                      if (!valid)
                                          throw Error("illegal extended field id in "+obj.name+": "+fld['id']+" (not within valid ranges)");
                                  }
                                  // Convert extension field names to camel case notation if the override is set
                                  var name = fld["name"];
                                  if (this.options['convertFieldsToCamelCase'])
                                      name = ProtoBuf.Util.toCamelCase(name);
                                  // see #161: Extensions use their fully qualified name as their runtime key and...
                                  var field = new Reflect.Message.ExtensionField(this, obj, fld["rule"], fld["type"], this.ptr.fqn()+'.'+name, fld["id"], fld["options"]);
                                  // ...are added on top of the current namespace as an extension which is used for
                                  // resolving their type later on (the extension always keeps the original name to
                                  // prevent naming collisions)
                                  var ext = new Reflect.Extension(this, this.ptr, fld["name"], field);
                                  field.extension = ext;
                                  this.ptr.addChild(ext);
                                  obj.addChild(field);
                              }, this);

                          } else if (!/\.?google\.protobuf\./.test(def["ref"])) // Silently skip internal extensions
                              throw Error("extended message "+def["ref"]+" is not defined");

                      } else
                          throw Error("not a valid definition: "+JSON.stringify(def));

                      def = null;
                      obj = null;
                  }
                  // Break goes here
                  defs = null;
                  this.ptr = this.ptr.parent; // Namespace done, continue at parent
              }
              this.resolved = false; // Require re-resolve
              this.result = null; // Require re-build
              return this;
          };

          /**
           * Propagates syntax to all children.
           * @param {!Object} parent
           * @inner
           */
          function propagateSyntax(parent) {
              if (parent['messages']) {
                  parent['messages'].forEach(function(child) {
                      child["syntax"] = parent["syntax"];
                      propagateSyntax(child);
                  });
              }
              if (parent['enums']) {
                  parent['enums'].forEach(function(child) {
                      child["syntax"] = parent["syntax"];
                  });
              }
          }

          /**
           * Imports another definition into this builder.
           * @param {Object.<string,*>} json Parsed import
           * @param {(string|{root: string, file: string})=} filename Imported file name
           * @returns {!ProtoBuf.Builder} this
           * @throws {Error} If the definition or file cannot be imported
           * @expose
           */
          BuilderPrototype["import"] = function(json, filename) {
              var delim = '/';

              // Make sure to skip duplicate imports

              if (typeof filename === 'string') {

                  if (ProtoBuf.Util.IS_NODE)
                      filename = require$$2['resolve'](filename);
                  if (this.files[filename] === true)
                      return this.reset();
                  this.files[filename] = true;

              } else if (typeof filename === 'object') { // Object with root, file.

                  var root = filename.root;
                  if (ProtoBuf.Util.IS_NODE)
                      root = require$$2['resolve'](root);
                  if (root.indexOf("\\") >= 0 || filename.file.indexOf("\\") >= 0)
                      delim = '\\';
                  var fname;
                  if (ProtoBuf.Util.IS_NODE)
                      fname = require$$2['join'](root, filename.file);
                  else
                      fname = root + delim + filename.file;
                  if (this.files[fname] === true)
                      return this.reset();
                  this.files[fname] = true;
              }

              // Import imports

              if (json['imports'] && json['imports'].length > 0) {
                  var importRoot,
                      resetRoot = false;

                  if (typeof filename === 'object') { // If an import root is specified, override

                      this.importRoot = filename["root"]; resetRoot = true; // ... and reset afterwards
                      importRoot = this.importRoot;
                      filename = filename["file"];
                      if (importRoot.indexOf("\\") >= 0 || filename.indexOf("\\") >= 0)
                          delim = '\\';

                  } else if (typeof filename === 'string') {

                      if (this.importRoot) // If import root is overridden, use it
                          importRoot = this.importRoot;
                      else { // Otherwise compute from filename
                          if (filename.indexOf("/") >= 0) { // Unix
                              importRoot = filename.replace(/\/[^\/]*$/, "");
                              if (/* /file.proto */ importRoot === "")
                                  importRoot = "/";
                          } else if (filename.indexOf("\\") >= 0) { // Windows
                              importRoot = filename.replace(/\\[^\\]*$/, "");
                              delim = '\\';
                          } else
                              importRoot = ".";
                      }

                  } else
                      importRoot = null;

                  for (var i=0; i<json['imports'].length; i++) {
                      if (typeof json['imports'][i] === 'string') { // Import file
                          if (!importRoot)
                              throw Error("cannot determine import root");
                          var importFilename = json['imports'][i];
                          if (importFilename === "google/protobuf/descriptor.proto")
                              continue; // Not needed and therefore not used
                          if (ProtoBuf.Util.IS_NODE)
                              importFilename = require$$2['join'](importRoot, importFilename);
                          else
                              importFilename = importRoot + delim + importFilename;
                          if (this.files[importFilename] === true)
                              continue; // Already imported
                          if (/\.proto$/i.test(importFilename) && !ProtoBuf.DotProto)       // If this is a light build
                              importFilename = importFilename.replace(/\.proto$/, ".json"); // always load the JSON file
                          var contents = ProtoBuf.Util.fetch(importFilename);
                          if (contents === null)
                              throw Error("failed to import '"+importFilename+"' in '"+filename+"': file not found");
                          if (/\.json$/i.test(importFilename)) // Always possible
                              this["import"](JSON.parse(contents+""), importFilename); // May throw
                          else
                              this["import"](ProtoBuf.DotProto.Parser.parse(contents), importFilename); // May throw
                      } else // Import structure
                          if (!filename)
                              this["import"](json['imports'][i]);
                          else if (/\.(\w+)$/.test(filename)) // With extension: Append _importN to the name portion to make it unique
                              this["import"](json['imports'][i], filename.replace(/^(.+)\.(\w+)$/, function($0, $1, $2) { return $1+"_import"+i+"."+$2; }));
                          else // Without extension: Append _importN to make it unique
                              this["import"](json['imports'][i], filename+"_import"+i);
                  }
                  if (resetRoot) // Reset import root override when all imports are done
                      this.importRoot = null;
              }

              // Import structures

              if (json['package'])
                  this.define(json['package']);
              if (json['syntax'])
                  propagateSyntax(json);
              var base = this.ptr;
              if (json['options'])
                  Object.keys(json['options']).forEach(function(key) {
                      base.options[key] = json['options'][key];
                  });
              if (json['messages'])
                  this.create(json['messages']),
                  this.ptr = base;
              if (json['enums'])
                  this.create(json['enums']),
                  this.ptr = base;
              if (json['services'])
                  this.create(json['services']),
                  this.ptr = base;
              if (json['extends'])
                  this.create(json['extends']);

              return this.reset();
          };

          /**
           * Resolves all namespace objects.
           * @throws {Error} If a type cannot be resolved
           * @returns {!ProtoBuf.Builder} this
           * @expose
           */
          BuilderPrototype.resolveAll = function() {
              // Resolve all reflected objects
              var res;
              if (this.ptr == null || typeof this.ptr.type === 'object')
                  return this; // Done (already resolved)

              if (this.ptr instanceof Reflect.Namespace) { // Resolve children

                  this.ptr.children.forEach(function(child) {
                      this.ptr = child;
                      this.resolveAll();
                  }, this);

              } else if (this.ptr instanceof Reflect.Message.Field) { // Resolve type

                  if (!Lang.TYPE.test(this.ptr.type)) {
                      if (!Lang.TYPEREF.test(this.ptr.type))
                          throw Error("illegal type reference in "+this.ptr.toString(true)+": "+this.ptr.type);
                      res = (this.ptr instanceof Reflect.Message.ExtensionField ? this.ptr.extension.parent : this.ptr.parent).resolve(this.ptr.type, true);
                      if (!res)
                          throw Error("unresolvable type reference in "+this.ptr.toString(true)+": "+this.ptr.type);
                      this.ptr.resolvedType = res;
                      if (res instanceof Reflect.Enum) {
                          this.ptr.type = ProtoBuf.TYPES["enum"];
                          if (this.ptr.syntax === 'proto3' && res.syntax !== 'proto3')
                              throw Error("proto3 message cannot reference proto2 enum");
                      }
                      else if (res instanceof Reflect.Message)
                          this.ptr.type = res.isGroup ? ProtoBuf.TYPES["group"] : ProtoBuf.TYPES["message"];
                      else
                          throw Error("illegal type reference in "+this.ptr.toString(true)+": "+this.ptr.type);
                  } else
                      this.ptr.type = ProtoBuf.TYPES[this.ptr.type];

                  // If it's a map field, also resolve the key type. The key type can be only a numeric, string, or bool type
                  // (i.e., no enums or messages), so we don't need to resolve against the current namespace.
                  if (this.ptr.map) {
                      if (!Lang.TYPE.test(this.ptr.keyType))
                          throw Error("illegal key type for map field in "+this.ptr.toString(true)+": "+this.ptr.keyType);
                      this.ptr.keyType = ProtoBuf.TYPES[this.ptr.keyType];
                  }

                  // If it's a repeated and packable field then proto3 mandates it should be packed by
                  // default
                  if (
                    this.ptr.syntax === 'proto3' &&
                    this.ptr.repeated && this.ptr.options.packed === undefined &&
                    ProtoBuf.PACKABLE_WIRE_TYPES.indexOf(this.ptr.type.wireType) !== -1
                  ) {
                    this.ptr.options.packed = true;
                  }

              } else if (this.ptr instanceof ProtoBuf.Reflect.Service.Method) {

                  if (this.ptr instanceof ProtoBuf.Reflect.Service.RPCMethod) {
                      res = this.ptr.parent.resolve(this.ptr.requestName, true);
                      if (!res || !(res instanceof ProtoBuf.Reflect.Message))
                          throw Error("Illegal type reference in "+this.ptr.toString(true)+": "+this.ptr.requestName);
                      this.ptr.resolvedRequestType = res;
                      res = this.ptr.parent.resolve(this.ptr.responseName, true);
                      if (!res || !(res instanceof ProtoBuf.Reflect.Message))
                          throw Error("Illegal type reference in "+this.ptr.toString(true)+": "+this.ptr.responseName);
                      this.ptr.resolvedResponseType = res;
                  } else // Should not happen as nothing else is implemented
                      throw Error("illegal service type in "+this.ptr.toString(true));

              } else if (
                  !(this.ptr instanceof ProtoBuf.Reflect.Message.OneOf) && // Not built
                  !(this.ptr instanceof ProtoBuf.Reflect.Extension) && // Not built
                  !(this.ptr instanceof ProtoBuf.Reflect.Enum.Value) // Built in enum
              )
                  throw Error("illegal object in namespace: "+typeof(this.ptr)+": "+this.ptr);

              return this.reset();
          };

          /**
           * Builds the protocol. This will first try to resolve all definitions and, if this has been successful,
           * return the built package.
           * @param {(string|Array.<string>)=} path Specifies what to return. If omitted, the entire namespace will be returned.
           * @returns {!ProtoBuf.Builder.Message|!Object.<string,*>}
           * @throws {Error} If a type could not be resolved
           * @expose
           */
          BuilderPrototype.build = function(path) {
              this.reset();
              if (!this.resolved)
                  this.resolveAll(),
                  this.resolved = true,
                  this.result = null; // Require re-build
              if (this.result === null) // (Re-)Build
                  this.result = this.ns.build();
              if (!path)
                  return this.result;
              var part = typeof path === 'string' ? path.split(".") : path,
                  ptr = this.result; // Build namespace pointer (no hasChild etc.)
              for (var i=0; i<part.length; i++)
                  if (ptr[part[i]])
                      ptr = ptr[part[i]];
                  else {
                      ptr = null;
                      break;
                  }
              return ptr;
          };

          /**
           * Similar to {@link ProtoBuf.Builder#build}, but looks up the internal reflection descriptor.
           * @param {string=} path Specifies what to return. If omitted, the entire namespace wiil be returned.
           * @param {boolean=} excludeNonNamespace Excludes non-namespace types like fields, defaults to `false`
           * @returns {?ProtoBuf.Reflect.T} Reflection descriptor or `null` if not found
           */
          BuilderPrototype.lookup = function(path, excludeNonNamespace) {
              return path ? this.ns.resolve(path, excludeNonNamespace) : this.ns;
          };

          /**
           * Returns a string representation of this object.
           * @return {string} String representation as of "Builder"
           * @expose
           */
          BuilderPrototype.toString = function() {
              return "Builder";
          };

          // ----- Base classes -----
          // Exist for the sole purpose of being able to "... instanceof ProtoBuf.Builder.Message" etc.

          /**
           * @alias ProtoBuf.Builder.Message
           */
          Builder.Message = function() {};

          /**
           * @alias ProtoBuf.Builder.Enum
           */
          Builder.Enum = function() {};

          /**
           * @alias ProtoBuf.Builder.Message
           */
          Builder.Service = function() {};

          return Builder;

      })(ProtoBuf, ProtoBuf.Lang, ProtoBuf.Reflect);

      /**
       * @alias ProtoBuf.Map
       * @expose
       */
      ProtoBuf.Map = (function(ProtoBuf, Reflect) {

          /**
           * Constructs a new Map. A Map is a container that is used to implement map
           * fields on message objects. It closely follows the ES6 Map API; however,
           * it is distinct because we do not want to depend on external polyfills or
           * on ES6 itself.
           *
           * @exports ProtoBuf.Map
           * @param {!ProtoBuf.Reflect.Field} field Map field
           * @param {Object.<string,*>=} contents Initial contents
           * @constructor
           */
          var Map = function(field, contents) {
              if (!field.map)
                  throw Error("field is not a map");

              /**
               * The field corresponding to this map.
               * @type {!ProtoBuf.Reflect.Field}
               */
              this.field = field;

              /**
               * Element instance corresponding to key type.
               * @type {!ProtoBuf.Reflect.Element}
               */
              this.keyElem = new Reflect.Element(field.keyType, null, true, field.syntax);

              /**
               * Element instance corresponding to value type.
               * @type {!ProtoBuf.Reflect.Element}
               */
              this.valueElem = new Reflect.Element(field.type, field.resolvedType, false, field.syntax);

              /**
               * Internal map: stores mapping of (string form of key) -> (key, value)
               * pair.
               *
               * We provide map semantics for arbitrary key types, but we build on top
               * of an Object, which has only string keys. In order to avoid the need
               * to convert a string key back to its native type in many situations,
               * we store the native key value alongside the value. Thus, we only need
               * a one-way mapping from a key type to its string form that guarantees
               * uniqueness and equality (i.e., str(K1) === str(K2) if and only if K1
               * === K2).
               *
               * @type {!Object<string, {key: *, value: *}>}
               */
              this.map = {};

              /**
               * Returns the number of elements in the map.
               */
              Object.defineProperty(this, "size", {
                  get: function() { return Object.keys(this.map).length; }
              });

              // Fill initial contents from a raw object.
              if (contents) {
                  var keys = Object.keys(contents);
                  for (var i = 0; i < keys.length; i++) {
                      var key = this.keyElem.valueFromString(keys[i]);
                      var val = this.valueElem.verifyValue(contents[keys[i]]);
                      this.map[this.keyElem.valueToString(key)] =
                          { key: key, value: val };
                  }
              }
          };

          var MapPrototype = Map.prototype;

          /**
           * Helper: return an iterator over an array.
           * @param {!Array<*>} arr the array
           * @returns {!Object} an iterator
           * @inner
           */
          function arrayIterator(arr) {
              var idx = 0;
              return {
                  next: function() {
                      if (idx < arr.length)
                          return { done: false, value: arr[idx++] };
                      return { done: true };
                  }
              }
          }

          /**
           * Clears the map.
           */
          MapPrototype.clear = function() {
              this.map = {};
          };

          /**
           * Deletes a particular key from the map.
           * @returns {boolean} Whether any entry with this key was deleted.
           */
          MapPrototype["delete"] = function(key) {
              var keyValue = this.keyElem.valueToString(this.keyElem.verifyValue(key));
              var hadKey = keyValue in this.map;
              delete this.map[keyValue];
              return hadKey;
          };

          /**
           * Returns an iterator over [key, value] pairs in the map.
           * @returns {Object} The iterator
           */
          MapPrototype.entries = function() {
              var entries = [];
              var strKeys = Object.keys(this.map);
              for (var i = 0, entry; i < strKeys.length; i++)
                  entries.push([(entry=this.map[strKeys[i]]).key, entry.value]);
              return arrayIterator(entries);
          };

          /**
           * Returns an iterator over keys in the map.
           * @returns {Object} The iterator
           */
          MapPrototype.keys = function() {
              var keys = [];
              var strKeys = Object.keys(this.map);
              for (var i = 0; i < strKeys.length; i++)
                  keys.push(this.map[strKeys[i]].key);
              return arrayIterator(keys);
          };

          /**
           * Returns an iterator over values in the map.
           * @returns {!Object} The iterator
           */
          MapPrototype.values = function() {
              var values = [];
              var strKeys = Object.keys(this.map);
              for (var i = 0; i < strKeys.length; i++)
                  values.push(this.map[strKeys[i]].value);
              return arrayIterator(values);
          };

          /**
           * Iterates over entries in the map, calling a function on each.
           * @param {function(this:*, *, *, *)} cb The callback to invoke with value, key, and map arguments.
           * @param {Object=} thisArg The `this` value for the callback
           */
          MapPrototype.forEach = function(cb, thisArg) {
              var strKeys = Object.keys(this.map);
              for (var i = 0, entry; i < strKeys.length; i++)
                  cb.call(thisArg, (entry=this.map[strKeys[i]]).value, entry.key, this);
          };

          /**
           * Sets a key in the map to the given value.
           * @param {*} key The key
           * @param {*} value The value
           * @returns {!ProtoBuf.Map} The map instance
           */
          MapPrototype.set = function(key, value) {
              var keyValue = this.keyElem.verifyValue(key);
              var valValue = this.valueElem.verifyValue(value);
              this.map[this.keyElem.valueToString(keyValue)] =
                  { key: keyValue, value: valValue };
              return this;
          };

          /**
           * Gets the value corresponding to a key in the map.
           * @param {*} key The key
           * @returns {*|undefined} The value, or `undefined` if key not present
           */
          MapPrototype.get = function(key) {
              var keyValue = this.keyElem.valueToString(this.keyElem.verifyValue(key));
              if (!(keyValue in this.map))
                  return undefined;
              return this.map[keyValue].value;
          };

          /**
           * Determines whether the given key is present in the map.
           * @param {*} key The key
           * @returns {boolean} `true` if the key is present
           */
          MapPrototype.has = function(key) {
              var keyValue = this.keyElem.valueToString(this.keyElem.verifyValue(key));
              return (keyValue in this.map);
          };

          return Map;
      })(ProtoBuf, ProtoBuf.Reflect);


      /**
       * Constructs a new empty Builder.
       * @param {Object.<string,*>=} options Builder options, defaults to global options set on ProtoBuf
       * @return {!ProtoBuf.Builder} Builder
       * @expose
       */
      ProtoBuf.newBuilder = function(options) {
          options = options || {};
          if (typeof options['convertFieldsToCamelCase'] === 'undefined')
              options['convertFieldsToCamelCase'] = ProtoBuf.convertFieldsToCamelCase;
          if (typeof options['populateAccessors'] === 'undefined')
              options['populateAccessors'] = ProtoBuf.populateAccessors;
          return new ProtoBuf.Builder(options);
      };

      /**
       * Loads a .json definition and returns the Builder.
       * @param {!*|string} json JSON definition
       * @param {(ProtoBuf.Builder|string|{root: string, file: string})=} builder Builder to append to. Will create a new one if omitted.
       * @param {(string|{root: string, file: string})=} filename The corresponding file name if known. Must be specified for imports.
       * @return {ProtoBuf.Builder} Builder to create new messages
       * @throws {Error} If the definition cannot be parsed or built
       * @expose
       */
      ProtoBuf.loadJson = function(json, builder, filename) {
          if (typeof builder === 'string' || (builder && typeof builder["file"] === 'string' && typeof builder["root"] === 'string'))
              filename = builder,
              builder = null;
          if (!builder || typeof builder !== 'object')
              builder = ProtoBuf.newBuilder();
          if (typeof json === 'string')
              json = JSON.parse(json);
          builder["import"](json, filename);
          builder.resolveAll();
          return builder;
      };

      /**
       * Loads a .json file and returns the Builder.
       * @param {string|!{root: string, file: string}} filename Path to json file or an object specifying 'file' with
       *  an overridden 'root' path for all imported files.
       * @param {function(?Error, !ProtoBuf.Builder=)=} callback Callback that will receive `null` as the first and
       *  the Builder as its second argument on success, otherwise the error as its first argument. If omitted, the
       *  file will be read synchronously and this function will return the Builder.
       * @param {ProtoBuf.Builder=} builder Builder to append to. Will create a new one if omitted.
       * @return {?ProtoBuf.Builder|undefined} The Builder if synchronous (no callback specified, will be NULL if the
       *   request has failed), else undefined
       * @expose
       */
      ProtoBuf.loadJsonFile = function(filename, callback, builder) {
          if (callback && typeof callback === 'object')
              builder = callback,
              callback = null;
          else if (!callback || typeof callback !== 'function')
              callback = null;
          if (callback)
              return ProtoBuf.Util.fetch(typeof filename === 'string' ? filename : filename["root"]+"/"+filename["file"], function(contents) {
                  if (contents === null) {
                      callback(Error("Failed to fetch file"));
                      return;
                  }
                  try {
                      callback(null, ProtoBuf.loadJson(JSON.parse(contents), builder, filename));
                  } catch (e) {
                      callback(e);
                  }
              });
          var contents = ProtoBuf.Util.fetch(typeof filename === 'object' ? filename["root"]+"/"+filename["file"] : filename);
          return contents === null ? null : ProtoBuf.loadJson(JSON.parse(contents), builder, filename);
      };

      return ProtoBuf;
  });
  });

  var messageCompiled = protobufLight.newBuilder({})['import']({
    "package": 'push_server.messages2',
    syntax: 'proto2',
    options: {
      objc_class_prefix: 'AVIM'
    },
    messages: [{
      name: 'JsonObjectMessage',
      syntax: 'proto2',
      fields: [{
        rule: 'required',
        type: 'string',
        name: 'data',
        id: 1
      }]
    }, {
      name: 'UnreadTuple',
      syntax: 'proto2',
      fields: [{
        rule: 'required',
        type: 'string',
        name: 'cid',
        id: 1
      }, {
        rule: 'required',
        type: 'int32',
        name: 'unread',
        id: 2
      }, {
        rule: 'optional',
        type: 'string',
        name: 'mid',
        id: 3
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'timestamp',
        id: 4
      }, {
        rule: 'optional',
        type: 'string',
        name: 'from',
        id: 5
      }, {
        rule: 'optional',
        type: 'string',
        name: 'data',
        id: 6
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'patchTimestamp',
        id: 7
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'mentioned',
        id: 8
      }, {
        rule: 'optional',
        type: 'bytes',
        name: 'binaryMsg',
        id: 9
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'convType',
        id: 10
      }]
    }, {
      name: 'LogItem',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'string',
        name: 'from',
        id: 1
      }, {
        rule: 'optional',
        type: 'string',
        name: 'data',
        id: 2
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'timestamp',
        id: 3
      }, {
        rule: 'optional',
        type: 'string',
        name: 'msgId',
        id: 4
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'ackAt',
        id: 5
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'readAt',
        id: 6
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'patchTimestamp',
        id: 7
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'mentionAll',
        id: 8
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'mentionPids',
        id: 9
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'bin',
        id: 10
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'convType',
        id: 11
      }]
    }, {
      name: 'ConvMemberInfo',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'string',
        name: 'pid',
        id: 1
      }, {
        rule: 'optional',
        type: 'string',
        name: 'role',
        id: 2
      }, {
        rule: 'optional',
        type: 'string',
        name: 'infoId',
        id: 3
      }]
    }, {
      name: 'DataCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'repeated',
        type: 'string',
        name: 'ids',
        id: 1
      }, {
        rule: 'repeated',
        type: 'JsonObjectMessage',
        name: 'msg',
        id: 2
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'offline',
        id: 3
      }]
    }, {
      name: 'SessionCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'int64',
        name: 't',
        id: 1
      }, {
        rule: 'optional',
        type: 'string',
        name: 'n',
        id: 2
      }, {
        rule: 'optional',
        type: 'string',
        name: 's',
        id: 3
      }, {
        rule: 'optional',
        type: 'string',
        name: 'ua',
        id: 4
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'r',
        id: 5
      }, {
        rule: 'optional',
        type: 'string',
        name: 'tag',
        id: 6
      }, {
        rule: 'optional',
        type: 'string',
        name: 'deviceId',
        id: 7
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'sessionPeerIds',
        id: 8
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'onlineSessionPeerIds',
        id: 9
      }, {
        rule: 'optional',
        type: 'string',
        name: 'st',
        id: 10
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'stTtl',
        id: 11
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'code',
        id: 12
      }, {
        rule: 'optional',
        type: 'string',
        name: 'reason',
        id: 13
      }, {
        rule: 'optional',
        type: 'string',
        name: 'deviceToken',
        id: 14
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'sp',
        id: 15
      }, {
        rule: 'optional',
        type: 'string',
        name: 'detail',
        id: 16
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'lastUnreadNotifTime',
        id: 17
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'lastPatchTime',
        id: 18
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'configBitmap',
        id: 19
      }]
    }, {
      name: 'ErrorCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'required',
        type: 'int32',
        name: 'code',
        id: 1
      }, {
        rule: 'required',
        type: 'string',
        name: 'reason',
        id: 2
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'appCode',
        id: 3
      }, {
        rule: 'optional',
        type: 'string',
        name: 'detail',
        id: 4
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'pids',
        id: 5
      }, {
        rule: 'optional',
        type: 'string',
        name: 'appMsg',
        id: 6
      }]
    }, {
      name: 'DirectCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'string',
        name: 'msg',
        id: 1
      }, {
        rule: 'optional',
        type: 'string',
        name: 'uid',
        id: 2
      }, {
        rule: 'optional',
        type: 'string',
        name: 'fromPeerId',
        id: 3
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'timestamp',
        id: 4
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'offline',
        id: 5
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'hasMore',
        id: 6
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'toPeerIds',
        id: 7
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'r',
        id: 10
      }, {
        rule: 'optional',
        type: 'string',
        name: 'cid',
        id: 11
      }, {
        rule: 'optional',
        type: 'string',
        name: 'id',
        id: 12
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'transient',
        id: 13
      }, {
        rule: 'optional',
        type: 'string',
        name: 'dt',
        id: 14
      }, {
        rule: 'optional',
        type: 'string',
        name: 'roomId',
        id: 15
      }, {
        rule: 'optional',
        type: 'string',
        name: 'pushData',
        id: 16
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'will',
        id: 17
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'patchTimestamp',
        id: 18
      }, {
        rule: 'optional',
        type: 'bytes',
        name: 'binaryMsg',
        id: 19
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'mentionPids',
        id: 20
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'mentionAll',
        id: 21
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'convType',
        id: 22
      }]
    }, {
      name: 'AckCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'int32',
        name: 'code',
        id: 1
      }, {
        rule: 'optional',
        type: 'string',
        name: 'reason',
        id: 2
      }, {
        rule: 'optional',
        type: 'string',
        name: 'mid',
        id: 3
      }, {
        rule: 'optional',
        type: 'string',
        name: 'cid',
        id: 4
      }, {
        rule: 'optional',
        type: 'int64',
        name: 't',
        id: 5
      }, {
        rule: 'optional',
        type: 'string',
        name: 'uid',
        id: 6
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'fromts',
        id: 7
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'tots',
        id: 8
      }, {
        rule: 'optional',
        type: 'string',
        name: 'type',
        id: 9
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'ids',
        id: 10
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'appCode',
        id: 11
      }, {
        rule: 'optional',
        type: 'string',
        name: 'appMsg',
        id: 12
      }]
    }, {
      name: 'UnreadCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'repeated',
        type: 'UnreadTuple',
        name: 'convs',
        id: 1
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'notifTime',
        id: 2
      }]
    }, {
      name: 'ConvCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'repeated',
        type: 'string',
        name: 'm',
        id: 1
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'transient',
        id: 2
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'unique',
        id: 3
      }, {
        rule: 'optional',
        type: 'string',
        name: 'cid',
        id: 4
      }, {
        rule: 'optional',
        type: 'string',
        name: 'cdate',
        id: 5
      }, {
        rule: 'optional',
        type: 'string',
        name: 'initBy',
        id: 6
      }, {
        rule: 'optional',
        type: 'string',
        name: 'sort',
        id: 7
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'limit',
        id: 8
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'skip',
        id: 9
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'flag',
        id: 10
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'count',
        id: 11
      }, {
        rule: 'optional',
        type: 'string',
        name: 'udate',
        id: 12
      }, {
        rule: 'optional',
        type: 'int64',
        name: 't',
        id: 13
      }, {
        rule: 'optional',
        type: 'string',
        name: 'n',
        id: 14
      }, {
        rule: 'optional',
        type: 'string',
        name: 's',
        id: 15
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'statusSub',
        id: 16
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'statusPub',
        id: 17
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'statusTTL',
        id: 18
      }, {
        rule: 'optional',
        type: 'string',
        name: 'uniqueId',
        id: 19
      }, {
        rule: 'optional',
        type: 'string',
        name: 'targetClientId',
        id: 20
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'maxReadTimestamp',
        id: 21
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'maxAckTimestamp',
        id: 22
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'queryAllMembers',
        id: 23
      }, {
        rule: 'repeated',
        type: 'MaxReadTuple',
        name: 'maxReadTuples',
        id: 24
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'cids',
        id: 25
      }, {
        rule: 'optional',
        type: 'ConvMemberInfo',
        name: 'info',
        id: 26
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'tempConv',
        id: 27
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'tempConvTTL',
        id: 28
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'tempConvIds',
        id: 29
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'allowedPids',
        id: 30
      }, {
        rule: 'repeated',
        type: 'ErrorCommand',
        name: 'failedPids',
        id: 31
      }, {
        rule: 'optional',
        type: 'string',
        name: 'next',
        id: 40
      }, {
        rule: 'optional',
        type: 'JsonObjectMessage',
        name: 'results',
        id: 100
      }, {
        rule: 'optional',
        type: 'JsonObjectMessage',
        name: 'where',
        id: 101
      }, {
        rule: 'optional',
        type: 'JsonObjectMessage',
        name: 'attr',
        id: 103
      }, {
        rule: 'optional',
        type: 'JsonObjectMessage',
        name: 'attrModified',
        id: 104
      }]
    }, {
      name: 'RoomCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'string',
        name: 'roomId',
        id: 1
      }, {
        rule: 'optional',
        type: 'string',
        name: 's',
        id: 2
      }, {
        rule: 'optional',
        type: 'int64',
        name: 't',
        id: 3
      }, {
        rule: 'optional',
        type: 'string',
        name: 'n',
        id: 4
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'transient',
        id: 5
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'roomPeerIds',
        id: 6
      }, {
        rule: 'optional',
        type: 'string',
        name: 'byPeerId',
        id: 7
      }]
    }, {
      name: 'LogsCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'string',
        name: 'cid',
        id: 1
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'l',
        id: 2
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'limit',
        id: 3
      }, {
        rule: 'optional',
        type: 'int64',
        name: 't',
        id: 4
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'tt',
        id: 5
      }, {
        rule: 'optional',
        type: 'string',
        name: 'tmid',
        id: 6
      }, {
        rule: 'optional',
        type: 'string',
        name: 'mid',
        id: 7
      }, {
        rule: 'optional',
        type: 'string',
        name: 'checksum',
        id: 8
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'stored',
        id: 9
      }, {
        rule: 'optional',
        type: 'QueryDirection',
        name: 'direction',
        id: 10,
        options: {
          "default": 'OLD'
        }
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'tIncluded',
        id: 11
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'ttIncluded',
        id: 12
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'lctype',
        id: 13
      }, {
        rule: 'repeated',
        type: 'LogItem',
        name: 'logs',
        id: 105
      }],
      enums: [{
        name: 'QueryDirection',
        syntax: 'proto2',
        values: [{
          name: 'OLD',
          id: 1
        }, {
          name: 'NEW',
          id: 2
        }]
      }]
    }, {
      name: 'RcpCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'string',
        name: 'id',
        id: 1
      }, {
        rule: 'optional',
        type: 'string',
        name: 'cid',
        id: 2
      }, {
        rule: 'optional',
        type: 'int64',
        name: 't',
        id: 3
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'read',
        id: 4
      }, {
        rule: 'optional',
        type: 'string',
        name: 'from',
        id: 5
      }]
    }, {
      name: 'ReadTuple',
      syntax: 'proto2',
      fields: [{
        rule: 'required',
        type: 'string',
        name: 'cid',
        id: 1
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'timestamp',
        id: 2
      }, {
        rule: 'optional',
        type: 'string',
        name: 'mid',
        id: 3
      }]
    }, {
      name: 'MaxReadTuple',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'string',
        name: 'pid',
        id: 1
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'maxAckTimestamp',
        id: 2
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'maxReadTimestamp',
        id: 3
      }]
    }, {
      name: 'ReadCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'string',
        name: 'cid',
        id: 1
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'cids',
        id: 2
      }, {
        rule: 'repeated',
        type: 'ReadTuple',
        name: 'convs',
        id: 3
      }]
    }, {
      name: 'PresenceCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'StatusType',
        name: 'status',
        id: 1
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'sessionPeerIds',
        id: 2
      }, {
        rule: 'optional',
        type: 'string',
        name: 'cid',
        id: 3
      }]
    }, {
      name: 'ReportCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'bool',
        name: 'initiative',
        id: 1
      }, {
        rule: 'optional',
        type: 'string',
        name: 'type',
        id: 2
      }, {
        rule: 'optional',
        type: 'string',
        name: 'data',
        id: 3
      }]
    }, {
      name: 'PatchItem',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'string',
        name: 'cid',
        id: 1
      }, {
        rule: 'optional',
        type: 'string',
        name: 'mid',
        id: 2
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'timestamp',
        id: 3
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'recall',
        id: 4
      }, {
        rule: 'optional',
        type: 'string',
        name: 'data',
        id: 5
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'patchTimestamp',
        id: 6
      }, {
        rule: 'optional',
        type: 'string',
        name: 'from',
        id: 7
      }, {
        rule: 'optional',
        type: 'bytes',
        name: 'binaryMsg',
        id: 8
      }, {
        rule: 'optional',
        type: 'bool',
        name: 'mentionAll',
        id: 9
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'mentionPids',
        id: 10
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'patchCode',
        id: 11
      }, {
        rule: 'optional',
        type: 'string',
        name: 'patchReason',
        id: 12
      }]
    }, {
      name: 'PatchCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'repeated',
        type: 'PatchItem',
        name: 'patches',
        id: 1
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'lastPatchTime',
        id: 2
      }]
    }, {
      name: 'PubsubCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'string',
        name: 'cid',
        id: 1
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'cids',
        id: 2
      }, {
        rule: 'optional',
        type: 'string',
        name: 'topic',
        id: 3
      }, {
        rule: 'optional',
        type: 'string',
        name: 'subtopic',
        id: 4
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'topics',
        id: 5
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'subtopics',
        id: 6
      }, {
        rule: 'optional',
        type: 'JsonObjectMessage',
        name: 'results',
        id: 7
      }]
    }, {
      name: 'BlacklistCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'string',
        name: 'srcCid',
        id: 1
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'toPids',
        id: 2
      }, {
        rule: 'optional',
        type: 'string',
        name: 'srcPid',
        id: 3
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'toCids',
        id: 4
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'limit',
        id: 5
      }, {
        rule: 'optional',
        type: 'string',
        name: 'next',
        id: 6
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'blockedPids',
        id: 8
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'blockedCids',
        id: 9
      }, {
        rule: 'repeated',
        type: 'string',
        name: 'allowedPids',
        id: 10
      }, {
        rule: 'repeated',
        type: 'ErrorCommand',
        name: 'failedPids',
        id: 11
      }, {
        rule: 'optional',
        type: 'int64',
        name: 't',
        id: 12
      }, {
        rule: 'optional',
        type: 'string',
        name: 'n',
        id: 13
      }, {
        rule: 'optional',
        type: 'string',
        name: 's',
        id: 14
      }]
    }, {
      name: 'GenericCommand',
      syntax: 'proto2',
      fields: [{
        rule: 'optional',
        type: 'CommandType',
        name: 'cmd',
        id: 1
      }, {
        rule: 'optional',
        type: 'OpType',
        name: 'op',
        id: 2
      }, {
        rule: 'optional',
        type: 'string',
        name: 'appId',
        id: 3
      }, {
        rule: 'optional',
        type: 'string',
        name: 'peerId',
        id: 4
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'i',
        id: 5
      }, {
        rule: 'optional',
        type: 'string',
        name: 'installationId',
        id: 6
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'priority',
        id: 7
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'service',
        id: 8
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'serverTs',
        id: 9
      }, {
        rule: 'optional',
        type: 'int64',
        name: 'clientTs',
        id: 10
      }, {
        rule: 'optional',
        type: 'int32',
        name: 'notificationType',
        id: 11
      }, {
        rule: 'optional',
        type: 'DataCommand',
        name: 'dataMessage',
        id: 101
      }, {
        rule: 'optional',
        type: 'SessionCommand',
        name: 'sessionMessage',
        id: 102
      }, {
        rule: 'optional',
        type: 'ErrorCommand',
        name: 'errorMessage',
        id: 103
      }, {
        rule: 'optional',
        type: 'DirectCommand',
        name: 'directMessage',
        id: 104
      }, {
        rule: 'optional',
        type: 'AckCommand',
        name: 'ackMessage',
        id: 105
      }, {
        rule: 'optional',
        type: 'UnreadCommand',
        name: 'unreadMessage',
        id: 106
      }, {
        rule: 'optional',
        type: 'ReadCommand',
        name: 'readMessage',
        id: 107
      }, {
        rule: 'optional',
        type: 'RcpCommand',
        name: 'rcpMessage',
        id: 108
      }, {
        rule: 'optional',
        type: 'LogsCommand',
        name: 'logsMessage',
        id: 109
      }, {
        rule: 'optional',
        type: 'ConvCommand',
        name: 'convMessage',
        id: 110
      }, {
        rule: 'optional',
        type: 'RoomCommand',
        name: 'roomMessage',
        id: 111
      }, {
        rule: 'optional',
        type: 'PresenceCommand',
        name: 'presenceMessage',
        id: 112
      }, {
        rule: 'optional',
        type: 'ReportCommand',
        name: 'reportMessage',
        id: 113
      }, {
        rule: 'optional',
        type: 'PatchCommand',
        name: 'patchMessage',
        id: 114
      }, {
        rule: 'optional',
        type: 'PubsubCommand',
        name: 'pubsubMessage',
        id: 115
      }, {
        rule: 'optional',
        type: 'BlacklistCommand',
        name: 'blacklistMessage',
        id: 116
      }]
    }],
    enums: [{
      name: 'CommandType',
      syntax: 'proto2',
      values: [{
        name: 'session',
        id: 0
      }, {
        name: 'conv',
        id: 1
      }, {
        name: 'direct',
        id: 2
      }, {
        name: 'ack',
        id: 3
      }, {
        name: 'rcp',
        id: 4
      }, {
        name: 'unread',
        id: 5
      }, {
        name: 'logs',
        id: 6
      }, {
        name: 'error',
        id: 7
      }, {
        name: 'login',
        id: 8
      }, {
        name: 'data',
        id: 9
      }, {
        name: 'room',
        id: 10
      }, {
        name: 'read',
        id: 11
      }, {
        name: 'presence',
        id: 12
      }, {
        name: 'report',
        id: 13
      }, {
        name: 'echo',
        id: 14
      }, {
        name: 'loggedin',
        id: 15
      }, {
        name: 'logout',
        id: 16
      }, {
        name: 'loggedout',
        id: 17
      }, {
        name: 'patch',
        id: 18
      }, {
        name: 'pubsub',
        id: 19
      }, {
        name: 'blacklist',
        id: 20
      }, {
        name: 'goaway',
        id: 21
      }]
    }, {
      name: 'OpType',
      syntax: 'proto2',
      values: [{
        name: 'open',
        id: 1
      }, {
        name: 'add',
        id: 2
      }, {
        name: 'remove',
        id: 3
      }, {
        name: 'close',
        id: 4
      }, {
        name: 'opened',
        id: 5
      }, {
        name: 'closed',
        id: 6
      }, {
        name: 'query',
        id: 7
      }, {
        name: 'query_result',
        id: 8
      }, {
        name: 'conflict',
        id: 9
      }, {
        name: 'added',
        id: 10
      }, {
        name: 'removed',
        id: 11
      }, {
        name: 'refresh',
        id: 12
      }, {
        name: 'refreshed',
        id: 13
      }, {
        name: 'start',
        id: 30
      }, {
        name: 'started',
        id: 31
      }, {
        name: 'joined',
        id: 32
      }, {
        name: 'members_joined',
        id: 33
      }, {
        name: 'left',
        id: 39
      }, {
        name: 'members_left',
        id: 40
      }, {
        name: 'results',
        id: 42
      }, {
        name: 'count',
        id: 43
      }, {
        name: 'result',
        id: 44
      }, {
        name: 'update',
        id: 45
      }, {
        name: 'updated',
        id: 46
      }, {
        name: 'mute',
        id: 47
      }, {
        name: 'unmute',
        id: 48
      }, {
        name: 'status',
        id: 49
      }, {
        name: 'members',
        id: 50
      }, {
        name: 'max_read',
        id: 51
      }, {
        name: 'is_member',
        id: 52
      }, {
        name: 'member_info_update',
        id: 53
      }, {
        name: 'member_info_updated',
        id: 54
      }, {
        name: 'member_info_changed',
        id: 55
      }, {
        name: 'join',
        id: 80
      }, {
        name: 'invite',
        id: 81
      }, {
        name: 'leave',
        id: 82
      }, {
        name: 'kick',
        id: 83
      }, {
        name: 'reject',
        id: 84
      }, {
        name: 'invited',
        id: 85
      }, {
        name: 'kicked',
        id: 86
      }, {
        name: 'upload',
        id: 100
      }, {
        name: 'uploaded',
        id: 101
      }, {
        name: 'subscribe',
        id: 120
      }, {
        name: 'subscribed',
        id: 121
      }, {
        name: 'unsubscribe',
        id: 122
      }, {
        name: 'unsubscribed',
        id: 123
      }, {
        name: 'is_subscribed',
        id: 124
      }, {
        name: 'modify',
        id: 150
      }, {
        name: 'modified',
        id: 151
      }, {
        name: 'block',
        id: 170
      }, {
        name: 'unblock',
        id: 171
      }, {
        name: 'blocked',
        id: 172
      }, {
        name: 'unblocked',
        id: 173
      }, {
        name: 'members_blocked',
        id: 174
      }, {
        name: 'members_unblocked',
        id: 175
      }, {
        name: 'check_block',
        id: 176
      }, {
        name: 'check_result',
        id: 177
      }, {
        name: 'add_shutup',
        id: 180
      }, {
        name: 'remove_shutup',
        id: 181
      }, {
        name: 'query_shutup',
        id: 182
      }, {
        name: 'shutup_added',
        id: 183
      }, {
        name: 'shutup_removed',
        id: 184
      }, {
        name: 'shutup_result',
        id: 185
      }, {
        name: 'shutuped',
        id: 186
      }, {
        name: 'unshutuped',
        id: 187
      }, {
        name: 'members_shutuped',
        id: 188
      }, {
        name: 'members_unshutuped',
        id: 189
      }, {
        name: 'check_shutup',
        id: 190
      }]
    }, {
      name: 'StatusType',
      syntax: 'proto2',
      values: [{
        name: 'on',
        id: 1
      }, {
        name: 'off',
        id: 2
      }]
    }],
    isNamespace: true
  }).build();

  var _messages$push_server = messageCompiled.push_server.messages2,
      JsonObjectMessage = _messages$push_server.JsonObjectMessage,
      UnreadTuple = _messages$push_server.UnreadTuple,
      LogItem = _messages$push_server.LogItem,
      DataCommand = _messages$push_server.DataCommand,
      SessionCommand = _messages$push_server.SessionCommand,
      ErrorCommand = _messages$push_server.ErrorCommand,
      DirectCommand = _messages$push_server.DirectCommand,
      AckCommand = _messages$push_server.AckCommand,
      UnreadCommand = _messages$push_server.UnreadCommand,
      ConvCommand = _messages$push_server.ConvCommand,
      RoomCommand = _messages$push_server.RoomCommand,
      LogsCommand = _messages$push_server.LogsCommand,
      RcpCommand = _messages$push_server.RcpCommand,
      ReadTuple = _messages$push_server.ReadTuple,
      MaxReadTuple = _messages$push_server.MaxReadTuple,
      ReadCommand = _messages$push_server.ReadCommand,
      PresenceCommand = _messages$push_server.PresenceCommand,
      ReportCommand = _messages$push_server.ReportCommand,
      GenericCommand = _messages$push_server.GenericCommand,
      BlacklistCommand = _messages$push_server.BlacklistCommand,
      PatchCommand = _messages$push_server.PatchCommand,
      PatchItem = _messages$push_server.PatchItem,
      ConvMemberInfo = _messages$push_server.ConvMemberInfo,
      CommandType = _messages$push_server.CommandType,
      OpType = _messages$push_server.OpType,
      StatusType = _messages$push_server.StatusType;

  var message = /*#__PURE__*/Object.freeze({
    __proto__: null,
    JsonObjectMessage: JsonObjectMessage,
    UnreadTuple: UnreadTuple,
    LogItem: LogItem,
    DataCommand: DataCommand,
    SessionCommand: SessionCommand,
    ErrorCommand: ErrorCommand,
    DirectCommand: DirectCommand,
    AckCommand: AckCommand,
    UnreadCommand: UnreadCommand,
    ConvCommand: ConvCommand,
    RoomCommand: RoomCommand,
    LogsCommand: LogsCommand,
    RcpCommand: RcpCommand,
    ReadTuple: ReadTuple,
    MaxReadTuple: MaxReadTuple,
    ReadCommand: ReadCommand,
    PresenceCommand: PresenceCommand,
    ReportCommand: ReportCommand,
    GenericCommand: GenericCommand,
    BlacklistCommand: BlacklistCommand,
    PatchCommand: PatchCommand,
    PatchItem: PatchItem,
    ConvMemberInfo: ConvMemberInfo,
    CommandType: CommandType,
    OpType: OpType,
    StatusType: StatusType
  });

  var eventemitter3 = createCommonjsModule(function (module) {

  var has = Object.prototype.hasOwnProperty
    , prefix = '~';

  /**
   * Constructor to create a storage for our `EE` objects.
   * An `Events` instance is a plain object whose properties are event names.
   *
   * @constructor
   * @private
   */
  function Events() {}

  //
  // We try to not inherit from `Object.prototype`. In some engines creating an
  // instance in this way is faster than calling `Object.create(null)` directly.
  // If `Object.create(null)` is not supported we prefix the event names with a
  // character to make sure that the built-in object properties are not
  // overridden or used as an attack vector.
  //
  if (Object.create) {
    Events.prototype = Object.create(null);

    //
    // This hack is needed because the `__proto__` property is still inherited in
    // some old browsers like Android 4, iPhone 5.1, Opera 11 and Safari 5.
    //
    if (!new Events().__proto__) prefix = false;
  }

  /**
   * Representation of a single event listener.
   *
   * @param {Function} fn The listener function.
   * @param {*} context The context to invoke the listener with.
   * @param {Boolean} [once=false] Specify if the listener is a one-time listener.
   * @constructor
   * @private
   */
  function EE(fn, context, once) {
    this.fn = fn;
    this.context = context;
    this.once = once || false;
  }

  /**
   * Add a listener for a given event.
   *
   * @param {EventEmitter} emitter Reference to the `EventEmitter` instance.
   * @param {(String|Symbol)} event The event name.
   * @param {Function} fn The listener function.
   * @param {*} context The context to invoke the listener with.
   * @param {Boolean} once Specify if the listener is a one-time listener.
   * @returns {EventEmitter}
   * @private
   */
  function addListener(emitter, event, fn, context, once) {
    if (typeof fn !== 'function') {
      throw new TypeError('The listener must be a function');
    }

    var listener = new EE(fn, context || emitter, once)
      , evt = prefix ? prefix + event : event;

    if (!emitter._events[evt]) emitter._events[evt] = listener, emitter._eventsCount++;
    else if (!emitter._events[evt].fn) emitter._events[evt].push(listener);
    else emitter._events[evt] = [emitter._events[evt], listener];

    return emitter;
  }

  /**
   * Clear event by name.
   *
   * @param {EventEmitter} emitter Reference to the `EventEmitter` instance.
   * @param {(String|Symbol)} evt The Event name.
   * @private
   */
  function clearEvent(emitter, evt) {
    if (--emitter._eventsCount === 0) emitter._events = new Events();
    else delete emitter._events[evt];
  }

  /**
   * Minimal `EventEmitter` interface that is molded against the Node.js
   * `EventEmitter` interface.
   *
   * @constructor
   * @public
   */
  function EventEmitter() {
    this._events = new Events();
    this._eventsCount = 0;
  }

  /**
   * Return an array listing the events for which the emitter has registered
   * listeners.
   *
   * @returns {Array}
   * @public
   */
  EventEmitter.prototype.eventNames = function eventNames() {
    var names = []
      , events
      , name;

    if (this._eventsCount === 0) return names;

    for (name in (events = this._events)) {
      if (has.call(events, name)) names.push(prefix ? name.slice(1) : name);
    }

    if (Object.getOwnPropertySymbols) {
      return names.concat(Object.getOwnPropertySymbols(events));
    }

    return names;
  };

  /**
   * Return the listeners registered for a given event.
   *
   * @param {(String|Symbol)} event The event name.
   * @returns {Array} The registered listeners.
   * @public
   */
  EventEmitter.prototype.listeners = function listeners(event) {
    var evt = prefix ? prefix + event : event
      , handlers = this._events[evt];

    if (!handlers) return [];
    if (handlers.fn) return [handlers.fn];

    for (var i = 0, l = handlers.length, ee = new Array(l); i < l; i++) {
      ee[i] = handlers[i].fn;
    }

    return ee;
  };

  /**
   * Return the number of listeners listening to a given event.
   *
   * @param {(String|Symbol)} event The event name.
   * @returns {Number} The number of listeners.
   * @public
   */
  EventEmitter.prototype.listenerCount = function listenerCount(event) {
    var evt = prefix ? prefix + event : event
      , listeners = this._events[evt];

    if (!listeners) return 0;
    if (listeners.fn) return 1;
    return listeners.length;
  };

  /**
   * Calls each of the listeners registered for a given event.
   *
   * @param {(String|Symbol)} event The event name.
   * @returns {Boolean} `true` if the event had listeners, else `false`.
   * @public
   */
  EventEmitter.prototype.emit = function emit(event, a1, a2, a3, a4, a5) {
    var evt = prefix ? prefix + event : event;

    if (!this._events[evt]) return false;

    var listeners = this._events[evt]
      , len = arguments.length
      , args
      , i;

    if (listeners.fn) {
      if (listeners.once) this.removeListener(event, listeners.fn, undefined, true);

      switch (len) {
        case 1: return listeners.fn.call(listeners.context), true;
        case 2: return listeners.fn.call(listeners.context, a1), true;
        case 3: return listeners.fn.call(listeners.context, a1, a2), true;
        case 4: return listeners.fn.call(listeners.context, a1, a2, a3), true;
        case 5: return listeners.fn.call(listeners.context, a1, a2, a3, a4), true;
        case 6: return listeners.fn.call(listeners.context, a1, a2, a3, a4, a5), true;
      }

      for (i = 1, args = new Array(len -1); i < len; i++) {
        args[i - 1] = arguments[i];
      }

      listeners.fn.apply(listeners.context, args);
    } else {
      var length = listeners.length
        , j;

      for (i = 0; i < length; i++) {
        if (listeners[i].once) this.removeListener(event, listeners[i].fn, undefined, true);

        switch (len) {
          case 1: listeners[i].fn.call(listeners[i].context); break;
          case 2: listeners[i].fn.call(listeners[i].context, a1); break;
          case 3: listeners[i].fn.call(listeners[i].context, a1, a2); break;
          case 4: listeners[i].fn.call(listeners[i].context, a1, a2, a3); break;
          default:
            if (!args) for (j = 1, args = new Array(len -1); j < len; j++) {
              args[j - 1] = arguments[j];
            }

            listeners[i].fn.apply(listeners[i].context, args);
        }
      }
    }

    return true;
  };

  /**
   * Add a listener for a given event.
   *
   * @param {(String|Symbol)} event The event name.
   * @param {Function} fn The listener function.
   * @param {*} [context=this] The context to invoke the listener with.
   * @returns {EventEmitter} `this`.
   * @public
   */
  EventEmitter.prototype.on = function on(event, fn, context) {
    return addListener(this, event, fn, context, false);
  };

  /**
   * Add a one-time listener for a given event.
   *
   * @param {(String|Symbol)} event The event name.
   * @param {Function} fn The listener function.
   * @param {*} [context=this] The context to invoke the listener with.
   * @returns {EventEmitter} `this`.
   * @public
   */
  EventEmitter.prototype.once = function once(event, fn, context) {
    return addListener(this, event, fn, context, true);
  };

  /**
   * Remove the listeners of a given event.
   *
   * @param {(String|Symbol)} event The event name.
   * @param {Function} fn Only remove the listeners that match this function.
   * @param {*} context Only remove the listeners that have this context.
   * @param {Boolean} once Only remove one-time listeners.
   * @returns {EventEmitter} `this`.
   * @public
   */
  EventEmitter.prototype.removeListener = function removeListener(event, fn, context, once) {
    var evt = prefix ? prefix + event : event;

    if (!this._events[evt]) return this;
    if (!fn) {
      clearEvent(this, evt);
      return this;
    }

    var listeners = this._events[evt];

    if (listeners.fn) {
      if (
        listeners.fn === fn &&
        (!once || listeners.once) &&
        (!context || listeners.context === context)
      ) {
        clearEvent(this, evt);
      }
    } else {
      for (var i = 0, events = [], length = listeners.length; i < length; i++) {
        if (
          listeners[i].fn !== fn ||
          (once && !listeners[i].once) ||
          (context && listeners[i].context !== context)
        ) {
          events.push(listeners[i]);
        }
      }

      //
      // Reset the array, or remove it completely if we have no more listeners.
      //
      if (events.length) this._events[evt] = events.length === 1 ? events[0] : events;
      else clearEvent(this, evt);
    }

    return this;
  };

  /**
   * Remove all listeners, or those of the specified event.
   *
   * @param {(String|Symbol)} [event] The event name.
   * @returns {EventEmitter} `this`.
   * @public
   */
  EventEmitter.prototype.removeAllListeners = function removeAllListeners(event) {
    var evt;

    if (event) {
      evt = prefix ? prefix + event : event;
      if (this._events[evt]) clearEvent(this, evt);
    } else {
      this._events = new Events();
      this._eventsCount = 0;
    }

    return this;
  };

  //
  // Alias methods names because people roll like that.
  //
  EventEmitter.prototype.off = EventEmitter.prototype.removeListener;
  EventEmitter.prototype.addListener = EventEmitter.prototype.on;

  //
  // Expose the prefix.
  //
  EventEmitter.prefixed = prefix;

  //
  // Allow `EventEmitter` to be imported as module namespace.
  //
  EventEmitter.EventEmitter = EventEmitter;

  //
  // Expose the module.
  //
  {
    module.exports = EventEmitter;
  }
  });

  var runtime_1 = createCommonjsModule(function (module) {
  /**
   * Copyright (c) 2014-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  var runtime = (function (exports) {

    var Op = Object.prototype;
    var hasOwn = Op.hasOwnProperty;
    var undefined$1; // More compressible than void 0.
    var $Symbol = typeof Symbol === "function" ? Symbol : {};
    var iteratorSymbol = $Symbol.iterator || "@@iterator";
    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

    function wrap(innerFn, outerFn, self, tryLocsList) {
      // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
      var generator = Object.create(protoGenerator.prototype);
      var context = new Context(tryLocsList || []);

      // The ._invoke method unifies the implementations of the .next,
      // .throw, and .return methods.
      generator._invoke = makeInvokeMethod(innerFn, self, context);

      return generator;
    }
    exports.wrap = wrap;

    // Try/catch helper to minimize deoptimizations. Returns a completion
    // record like context.tryEntries[i].completion. This interface could
    // have been (and was previously) designed to take a closure to be
    // invoked without arguments, but in all the cases we care about we
    // already have an existing method we want to call, so there's no need
    // to create a new function object. We can even get away with assuming
    // the method takes exactly one argument, since that happens to be true
    // in every case, so we don't have to touch the arguments object. The
    // only additional allocation required is the completion record, which
    // has a stable shape and so hopefully should be cheap to allocate.
    function tryCatch(fn, obj, arg) {
      try {
        return { type: "normal", arg: fn.call(obj, arg) };
      } catch (err) {
        return { type: "throw", arg: err };
      }
    }

    var GenStateSuspendedStart = "suspendedStart";
    var GenStateSuspendedYield = "suspendedYield";
    var GenStateExecuting = "executing";
    var GenStateCompleted = "completed";

    // Returning this object from the innerFn has the same effect as
    // breaking out of the dispatch switch statement.
    var ContinueSentinel = {};

    // Dummy constructor functions that we use as the .constructor and
    // .constructor.prototype properties for functions that return Generator
    // objects. For full spec compliance, you may wish to configure your
    // minifier not to mangle the names of these two functions.
    function Generator() {}
    function GeneratorFunction() {}
    function GeneratorFunctionPrototype() {}

    // This is a polyfill for %IteratorPrototype% for environments that
    // don't natively support it.
    var IteratorPrototype = {};
    IteratorPrototype[iteratorSymbol] = function () {
      return this;
    };

    var getProto = Object.getPrototypeOf;
    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    if (NativeIteratorPrototype &&
        NativeIteratorPrototype !== Op &&
        hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
      // This environment has a native %IteratorPrototype%; use it instead
      // of the polyfill.
      IteratorPrototype = NativeIteratorPrototype;
    }

    var Gp = GeneratorFunctionPrototype.prototype =
      Generator.prototype = Object.create(IteratorPrototype);
    GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
    GeneratorFunctionPrototype.constructor = GeneratorFunction;
    GeneratorFunctionPrototype[toStringTagSymbol] =
      GeneratorFunction.displayName = "GeneratorFunction";

    // Helper for defining the .next, .throw, and .return methods of the
    // Iterator interface in terms of a single ._invoke method.
    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function(method) {
        prototype[method] = function(arg) {
          return this._invoke(method, arg);
        };
      });
    }

    exports.isGeneratorFunction = function(genFun) {
      var ctor = typeof genFun === "function" && genFun.constructor;
      return ctor
        ? ctor === GeneratorFunction ||
          // For the native GeneratorFunction constructor, the best we can
          // do is to check its .name property.
          (ctor.displayName || ctor.name) === "GeneratorFunction"
        : false;
    };

    exports.mark = function(genFun) {
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
      } else {
        genFun.__proto__ = GeneratorFunctionPrototype;
        if (!(toStringTagSymbol in genFun)) {
          genFun[toStringTagSymbol] = "GeneratorFunction";
        }
      }
      genFun.prototype = Object.create(Gp);
      return genFun;
    };

    // Within the body of any async function, `await x` is transformed to
    // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
    // `hasOwn.call(value, "__await")` to determine if the yielded value is
    // meant to be awaited.
    exports.awrap = function(arg) {
      return { __await: arg };
    };

    function AsyncIterator(generator) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);
        if (record.type === "throw") {
          reject(record.arg);
        } else {
          var result = record.arg;
          var value = result.value;
          if (value &&
              typeof value === "object" &&
              hasOwn.call(value, "__await")) {
            return Promise.resolve(value.__await).then(function(value) {
              invoke("next", value, resolve, reject);
            }, function(err) {
              invoke("throw", err, resolve, reject);
            });
          }

          return Promise.resolve(value).then(function(unwrapped) {
            // When a yielded Promise is resolved, its final value becomes
            // the .value of the Promise<{value,done}> result for the
            // current iteration.
            result.value = unwrapped;
            resolve(result);
          }, function(error) {
            // If a rejected Promise was yielded, throw the rejection back
            // into the async generator function so it can be handled there.
            return invoke("throw", error, resolve, reject);
          });
        }
      }

      var previousPromise;

      function enqueue(method, arg) {
        function callInvokeWithMethodAndArg() {
          return new Promise(function(resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise =
          // If enqueue has been called before, then we want to wait until
          // all previous Promises have been resolved before calling invoke,
          // so that results are always delivered in the correct order. If
          // enqueue has not been called before, then it is important to
          // call invoke immediately, without waiting on a callback to fire,
          // so that the async generator function has the opportunity to do
          // any necessary setup in a predictable way. This predictability
          // is why the Promise constructor synchronously invokes its
          // executor callback, and why async functions synchronously
          // execute code before the first await. Since we implement simple
          // async functions in terms of async generators, it is especially
          // important to get this right, even though it requires care.
          previousPromise ? previousPromise.then(
            callInvokeWithMethodAndArg,
            // Avoid propagating failures to Promises returned by later
            // invocations of the iterator.
            callInvokeWithMethodAndArg
          ) : callInvokeWithMethodAndArg();
      }

      // Define the unified helper method that is used to implement .next,
      // .throw, and .return (see defineIteratorMethods).
      this._invoke = enqueue;
    }

    defineIteratorMethods(AsyncIterator.prototype);
    AsyncIterator.prototype[asyncIteratorSymbol] = function () {
      return this;
    };
    exports.AsyncIterator = AsyncIterator;

    // Note that simple async functions are implemented on top of
    // AsyncIterator objects; they just return a Promise for the value of
    // the final result produced by the iterator.
    exports.async = function(innerFn, outerFn, self, tryLocsList) {
      var iter = new AsyncIterator(
        wrap(innerFn, outerFn, self, tryLocsList)
      );

      return exports.isGeneratorFunction(outerFn)
        ? iter // If outerFn is a generator, return the full iterator.
        : iter.next().then(function(result) {
            return result.done ? result.value : iter.next();
          });
    };

    function makeInvokeMethod(innerFn, self, context) {
      var state = GenStateSuspendedStart;

      return function invoke(method, arg) {
        if (state === GenStateExecuting) {
          throw new Error("Generator is already running");
        }

        if (state === GenStateCompleted) {
          if (method === "throw") {
            throw arg;
          }

          // Be forgiving, per 25.3.3.3.3 of the spec:
          // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
          return doneResult();
        }

        context.method = method;
        context.arg = arg;

        while (true) {
          var delegate = context.delegate;
          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);
            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if (context.method === "next") {
            // Setting context._sent for legacy support of Babel's
            // function.sent implementation.
            context.sent = context._sent = context.arg;

          } else if (context.method === "throw") {
            if (state === GenStateSuspendedStart) {
              state = GenStateCompleted;
              throw context.arg;
            }

            context.dispatchException(context.arg);

          } else if (context.method === "return") {
            context.abrupt("return", context.arg);
          }

          state = GenStateExecuting;

          var record = tryCatch(innerFn, self, context);
          if (record.type === "normal") {
            // If an exception is thrown from innerFn, we leave state ===
            // GenStateExecuting and loop back for another invocation.
            state = context.done
              ? GenStateCompleted
              : GenStateSuspendedYield;

            if (record.arg === ContinueSentinel) {
              continue;
            }

            return {
              value: record.arg,
              done: context.done
            };

          } else if (record.type === "throw") {
            state = GenStateCompleted;
            // Dispatch the exception by looping back around to the
            // context.dispatchException(context.arg) call above.
            context.method = "throw";
            context.arg = record.arg;
          }
        }
      };
    }

    // Call delegate.iterator[context.method](context.arg) and handle the
    // result, either by returning a { value, done } result from the
    // delegate iterator, or by modifying context.method and context.arg,
    // setting context.delegate to null, and returning the ContinueSentinel.
    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];
      if (method === undefined$1) {
        // A .throw or .return when the delegate iterator has no .throw
        // method always terminates the yield* loop.
        context.delegate = null;

        if (context.method === "throw") {
          // Note: ["return"] must be used for ES3 parsing compatibility.
          if (delegate.iterator["return"]) {
            // If the delegate iterator has a return method, give it a
            // chance to clean up.
            context.method = "return";
            context.arg = undefined$1;
            maybeInvokeDelegate(delegate, context);

            if (context.method === "throw") {
              // If maybeInvokeDelegate(context) changed context.method from
              // "return" to "throw", let that override the TypeError below.
              return ContinueSentinel;
            }
          }

          context.method = "throw";
          context.arg = new TypeError(
            "The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);

      if (record.type === "throw") {
        context.method = "throw";
        context.arg = record.arg;
        context.delegate = null;
        return ContinueSentinel;
      }

      var info = record.arg;

      if (! info) {
        context.method = "throw";
        context.arg = new TypeError("iterator result is not an object");
        context.delegate = null;
        return ContinueSentinel;
      }

      if (info.done) {
        // Assign the result of the finished delegate to the temporary
        // variable specified by delegate.resultName (see delegateYield).
        context[delegate.resultName] = info.value;

        // Resume execution at the desired location (see delegateYield).
        context.next = delegate.nextLoc;

        // If context.method was "throw" but the delegate handled the
        // exception, let the outer generator proceed normally. If
        // context.method was "next", forget context.arg since it has been
        // "consumed" by the delegate iterator. If context.method was
        // "return", allow the original .return call to continue in the
        // outer generator.
        if (context.method !== "return") {
          context.method = "next";
          context.arg = undefined$1;
        }

      } else {
        // Re-yield the result returned by the delegate method.
        return info;
      }

      // The delegate iterator is finished, so forget it and continue with
      // the outer generator.
      context.delegate = null;
      return ContinueSentinel;
    }

    // Define Generator.prototype.{next,throw,return} in terms of the
    // unified ._invoke helper method.
    defineIteratorMethods(Gp);

    Gp[toStringTagSymbol] = "Generator";

    // A Generator should always return itself as the iterator object when the
    // @@iterator function is called on it. Some browsers' implementations of the
    // iterator prototype chain incorrectly implement this, causing the Generator
    // object to not be returned from this call. This ensures that doesn't happen.
    // See https://github.com/facebook/regenerator/issues/274 for more details.
    Gp[iteratorSymbol] = function() {
      return this;
    };

    Gp.toString = function() {
      return "[object Generator]";
    };

    function pushTryEntry(locs) {
      var entry = { tryLoc: locs[0] };

      if (1 in locs) {
        entry.catchLoc = locs[1];
      }

      if (2 in locs) {
        entry.finallyLoc = locs[2];
        entry.afterLoc = locs[3];
      }

      this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal";
      delete record.arg;
      entry.completion = record;
    }

    function Context(tryLocsList) {
      // The root entry object (effectively a try statement without a catch
      // or a finally block) gives us a place to store values thrown from
      // locations where there is no enclosing try statement.
      this.tryEntries = [{ tryLoc: "root" }];
      tryLocsList.forEach(pushTryEntry, this);
      this.reset(true);
    }

    exports.keys = function(object) {
      var keys = [];
      for (var key in object) {
        keys.push(key);
      }
      keys.reverse();

      // Rather than returning an object with a next method, we keep
      // things simple and return the next function itself.
      return function next() {
        while (keys.length) {
          var key = keys.pop();
          if (key in object) {
            next.value = key;
            next.done = false;
            return next;
          }
        }

        // To avoid creating an additional object, we just hang the .value
        // and .done properties off the next function object itself. This
        // also ensures that the minifier will not anonymize the function.
        next.done = true;
        return next;
      };
    };

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) {
          return iteratorMethod.call(iterable);
        }

        if (typeof iterable.next === "function") {
          return iterable;
        }

        if (!isNaN(iterable.length)) {
          var i = -1, next = function next() {
            while (++i < iterable.length) {
              if (hasOwn.call(iterable, i)) {
                next.value = iterable[i];
                next.done = false;
                return next;
              }
            }

            next.value = undefined$1;
            next.done = true;

            return next;
          };

          return next.next = next;
        }
      }

      // Return an iterator with no values.
      return { next: doneResult };
    }
    exports.values = values;

    function doneResult() {
      return { value: undefined$1, done: true };
    }

    Context.prototype = {
      constructor: Context,

      reset: function(skipTempReset) {
        this.prev = 0;
        this.next = 0;
        // Resetting context._sent for legacy support of Babel's
        // function.sent implementation.
        this.sent = this._sent = undefined$1;
        this.done = false;
        this.delegate = null;

        this.method = "next";
        this.arg = undefined$1;

        this.tryEntries.forEach(resetTryEntry);

        if (!skipTempReset) {
          for (var name in this) {
            // Not sure about the optimal order of these conditions:
            if (name.charAt(0) === "t" &&
                hasOwn.call(this, name) &&
                !isNaN(+name.slice(1))) {
              this[name] = undefined$1;
            }
          }
        }
      },

      stop: function() {
        this.done = true;

        var rootEntry = this.tryEntries[0];
        var rootRecord = rootEntry.completion;
        if (rootRecord.type === "throw") {
          throw rootRecord.arg;
        }

        return this.rval;
      },

      dispatchException: function(exception) {
        if (this.done) {
          throw exception;
        }

        var context = this;
        function handle(loc, caught) {
          record.type = "throw";
          record.arg = exception;
          context.next = loc;

          if (caught) {
            // If the dispatched exception was caught by a catch block,
            // then let that catch block handle the exception normally.
            context.method = "next";
            context.arg = undefined$1;
          }

          return !! caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          var record = entry.completion;

          if (entry.tryLoc === "root") {
            // Exception thrown outside of any try block that could handle
            // it, so set the completion value of the entire function to
            // throw the exception.
            return handle("end");
          }

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc");
            var hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              } else if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }

            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              }

            } else if (hasFinally) {
              if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }

            } else {
              throw new Error("try statement without catch or finally");
            }
          }
        }
      },

      abrupt: function(type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc <= this.prev &&
              hasOwn.call(entry, "finallyLoc") &&
              this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        if (finallyEntry &&
            (type === "break" ||
             type === "continue") &&
            finallyEntry.tryLoc <= arg &&
            arg <= finallyEntry.finallyLoc) {
          // Ignore the finally entry if control is not jumping to a
          // location outside the try/catch block.
          finallyEntry = null;
        }

        var record = finallyEntry ? finallyEntry.completion : {};
        record.type = type;
        record.arg = arg;

        if (finallyEntry) {
          this.method = "next";
          this.next = finallyEntry.finallyLoc;
          return ContinueSentinel;
        }

        return this.complete(record);
      },

      complete: function(record, afterLoc) {
        if (record.type === "throw") {
          throw record.arg;
        }

        if (record.type === "break" ||
            record.type === "continue") {
          this.next = record.arg;
        } else if (record.type === "return") {
          this.rval = this.arg = record.arg;
          this.method = "return";
          this.next = "end";
        } else if (record.type === "normal" && afterLoc) {
          this.next = afterLoc;
        }

        return ContinueSentinel;
      },

      finish: function(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) {
            this.complete(entry.completion, entry.afterLoc);
            resetTryEntry(entry);
            return ContinueSentinel;
          }
        }
      },

      "catch": function(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;
            if (record.type === "throw") {
              var thrown = record.arg;
              resetTryEntry(entry);
            }
            return thrown;
          }
        }

        // The context.catch method must only be called with a location
        // argument that corresponds to a known catch block.
        throw new Error("illegal catch attempt");
      },

      delegateYield: function(iterable, resultName, nextLoc) {
        this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        };

        if (this.method === "next") {
          // Deliberately forget the last sent value so that we don't
          // accidentally pass it on to the delegate.
          this.arg = undefined$1;
        }

        return ContinueSentinel;
      }
    };

    // Regardless of whether this script is executing as a CommonJS module
    // or not, return the runtime object so that we can declare the variable
    // regeneratorRuntime in the outer scope, which allows this module to be
    // injected easily by `bin/regenerator --include-runtime script.js`.
    return exports;

  }(
    // If this script is executing as a CommonJS module, use module.exports
    // as the regeneratorRuntime namespace. Otherwise create a new empty
    // object. Either way, the resulting object will be used to initialize
    // the regeneratorRuntime variable at the top of this file.
     module.exports 
  ));

  try {
    regeneratorRuntime = runtime;
  } catch (accidentalStrictMode) {
    // This module should not be running in strict mode, so the above
    // assignment should always work unless something is misconfigured. Just
    // in case runtime.js accidentally runs in strict mode, we can escape
    // strict mode using a global Function call. This could conceivably fail
    // if a Content Security Policy forbids using Function, but in that case
    // the proper solution is to fix the accidental strict mode problem. If
    // you've misconfigured your bundler to force strict mode and applied a
    // CSP to forbid Function, and you're not willing to fix either of those
    // problems, please detail your unique predicament in a GitHub issue.
    Function("r", "regeneratorRuntime = r")(runtime);
  }
  });

  var regenerator = runtime_1;

  /**
   * Helpers.
   */

  var s = 1000;
  var m = s * 60;
  var h = m * 60;
  var d = h * 24;
  var w = d * 7;
  var y = d * 365.25;

  /**
   * Parse or format the given `val`.
   *
   * Options:
   *
   *  - `long` verbose formatting [false]
   *
   * @param {String|Number} val
   * @param {Object} [options]
   * @throws {Error} throw an error if val is not a non-empty string or a number
   * @return {String|Number}
   * @api public
   */

  var ms = function(val, options) {
    options = options || {};
    var type = typeof val;
    if (type === 'string' && val.length > 0) {
      return parse(val);
    } else if (type === 'number' && isNaN(val) === false) {
      return options.long ? fmtLong(val) : fmtShort(val);
    }
    throw new Error(
      'val is not a non-empty string or a valid number. val=' +
        JSON.stringify(val)
    );
  };

  /**
   * Parse the given `str` and return milliseconds.
   *
   * @param {String} str
   * @return {Number}
   * @api private
   */

  function parse(str) {
    str = String(str);
    if (str.length > 100) {
      return;
    }
    var match = /^((?:\d+)?\-?\d?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(
      str
    );
    if (!match) {
      return;
    }
    var n = parseFloat(match[1]);
    var type = (match[2] || 'ms').toLowerCase();
    switch (type) {
      case 'years':
      case 'year':
      case 'yrs':
      case 'yr':
      case 'y':
        return n * y;
      case 'weeks':
      case 'week':
      case 'w':
        return n * w;
      case 'days':
      case 'day':
      case 'd':
        return n * d;
      case 'hours':
      case 'hour':
      case 'hrs':
      case 'hr':
      case 'h':
        return n * h;
      case 'minutes':
      case 'minute':
      case 'mins':
      case 'min':
      case 'm':
        return n * m;
      case 'seconds':
      case 'second':
      case 'secs':
      case 'sec':
      case 's':
        return n * s;
      case 'milliseconds':
      case 'millisecond':
      case 'msecs':
      case 'msec':
      case 'ms':
        return n;
      default:
        return undefined;
    }
  }

  /**
   * Short format for `ms`.
   *
   * @param {Number} ms
   * @return {String}
   * @api private
   */

  function fmtShort(ms) {
    var msAbs = Math.abs(ms);
    if (msAbs >= d) {
      return Math.round(ms / d) + 'd';
    }
    if (msAbs >= h) {
      return Math.round(ms / h) + 'h';
    }
    if (msAbs >= m) {
      return Math.round(ms / m) + 'm';
    }
    if (msAbs >= s) {
      return Math.round(ms / s) + 's';
    }
    return ms + 'ms';
  }

  /**
   * Long format for `ms`.
   *
   * @param {Number} ms
   * @return {String}
   * @api private
   */

  function fmtLong(ms) {
    var msAbs = Math.abs(ms);
    if (msAbs >= d) {
      return plural(ms, msAbs, d, 'day');
    }
    if (msAbs >= h) {
      return plural(ms, msAbs, h, 'hour');
    }
    if (msAbs >= m) {
      return plural(ms, msAbs, m, 'minute');
    }
    if (msAbs >= s) {
      return plural(ms, msAbs, s, 'second');
    }
    return ms + ' ms';
  }

  /**
   * Pluralization helper.
   */

  function plural(ms, msAbs, n, name) {
    var isPlural = msAbs >= n * 1.5;
    return Math.round(ms / n) + ' ' + name + (isPlural ? 's' : '');
  }

  /**
   * This is the common logic for both the Node.js and web browser
   * implementations of `debug()`.
   */
  function setup(env) {
    createDebug.debug = createDebug;
    createDebug.default = createDebug;
    createDebug.coerce = coerce;
    createDebug.disable = disable;
    createDebug.enable = enable;
    createDebug.enabled = enabled;
    createDebug.humanize = ms;
    Object.keys(env).forEach(function (key) {
      createDebug[key] = env[key];
    });
    /**
    * Active `debug` instances.
    */

    createDebug.instances = [];
    /**
    * The currently active debug mode names, and names to skip.
    */

    createDebug.names = [];
    createDebug.skips = [];
    /**
    * Map of special "%n" handling functions, for the debug "format" argument.
    *
    * Valid key names are a single, lower or upper-case letter, i.e. "n" and "N".
    */

    createDebug.formatters = {};
    /**
    * Selects a color for a debug namespace
    * @param {String} namespace The namespace string for the for the debug instance to be colored
    * @return {Number|String} An ANSI color code for the given namespace
    * @api private
    */

    function selectColor(namespace) {
      var hash = 0;

      for (var i = 0; i < namespace.length; i++) {
        hash = (hash << 5) - hash + namespace.charCodeAt(i);
        hash |= 0; // Convert to 32bit integer
      }

      return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
    }

    createDebug.selectColor = selectColor;
    /**
    * Create a debugger with the given `namespace`.
    *
    * @param {String} namespace
    * @return {Function}
    * @api public
    */

    function createDebug(namespace) {
      var prevTime;

      function debug() {
        // Disabled?
        if (!debug.enabled) {
          return;
        }

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        var self = debug; // Set `diff` timestamp

        var curr = Number(new Date());
        var ms = curr - (prevTime || curr);
        self.diff = ms;
        self.prev = prevTime;
        self.curr = curr;
        prevTime = curr;
        args[0] = createDebug.coerce(args[0]);

        if (typeof args[0] !== 'string') {
          // Anything else let's inspect with %O
          args.unshift('%O');
        } // Apply any `formatters` transformations


        var index = 0;
        args[0] = args[0].replace(/%([a-zA-Z%])/g, function (match, format) {
          // If we encounter an escaped % then don't increase the array index
          if (match === '%%') {
            return match;
          }

          index++;
          var formatter = createDebug.formatters[format];

          if (typeof formatter === 'function') {
            var val = args[index];
            match = formatter.call(self, val); // Now we need to remove `args[index]` since it's inlined in the `format`

            args.splice(index, 1);
            index--;
          }

          return match;
        }); // Apply env-specific formatting (colors, etc.)

        createDebug.formatArgs.call(self, args);
        var logFn = self.log || createDebug.log;
        logFn.apply(self, args);
      }

      debug.namespace = namespace;
      debug.enabled = createDebug.enabled(namespace);
      debug.useColors = createDebug.useColors();
      debug.color = selectColor(namespace);
      debug.destroy = destroy;
      debug.extend = extend; // Debug.formatArgs = formatArgs;
      // debug.rawLog = rawLog;
      // env-specific initialization logic for debug instances

      if (typeof createDebug.init === 'function') {
        createDebug.init(debug);
      }

      createDebug.instances.push(debug);
      return debug;
    }

    function destroy() {
      var index = createDebug.instances.indexOf(this);

      if (index !== -1) {
        createDebug.instances.splice(index, 1);
        return true;
      }

      return false;
    }

    function extend(namespace, delimiter) {
      return createDebug(this.namespace + (typeof delimiter === 'undefined' ? ':' : delimiter) + namespace);
    }
    /**
    * Enables a debug mode by namespaces. This can include modes
    * separated by a colon and wildcards.
    *
    * @param {String} namespaces
    * @api public
    */


    function enable(namespaces) {
      createDebug.save(namespaces);
      createDebug.names = [];
      createDebug.skips = [];
      var i;
      var split = (typeof namespaces === 'string' ? namespaces : '').split(/[\s,]+/);
      var len = split.length;

      for (i = 0; i < len; i++) {
        if (!split[i]) {
          // ignore empty strings
          continue;
        }

        namespaces = split[i].replace(/\*/g, '.*?');

        if (namespaces[0] === '-') {
          createDebug.skips.push(new RegExp('^' + namespaces.substr(1) + '$'));
        } else {
          createDebug.names.push(new RegExp('^' + namespaces + '$'));
        }
      }

      for (i = 0; i < createDebug.instances.length; i++) {
        var instance = createDebug.instances[i];
        instance.enabled = createDebug.enabled(instance.namespace);
      }
    }
    /**
    * Disable debug output.
    *
    * @api public
    */


    function disable() {
      createDebug.enable('');
    }
    /**
    * Returns true if the given mode name is enabled, false otherwise.
    *
    * @param {String} name
    * @return {Boolean}
    * @api public
    */


    function enabled(name) {
      if (name[name.length - 1] === '*') {
        return true;
      }

      var i;
      var len;

      for (i = 0, len = createDebug.skips.length; i < len; i++) {
        if (createDebug.skips[i].test(name)) {
          return false;
        }
      }

      for (i = 0, len = createDebug.names.length; i < len; i++) {
        if (createDebug.names[i].test(name)) {
          return true;
        }
      }

      return false;
    }
    /**
    * Coerce `val`.
    *
    * @param {Mixed} val
    * @return {Mixed}
    * @api private
    */


    function coerce(val) {
      if (val instanceof Error) {
        return val.stack || val.message;
      }

      return val;
    }

    createDebug.enable(createDebug.load());
    return createDebug;
  }

  var common = setup;

  var browser = createCommonjsModule(function (module, exports) {

  function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

  /* eslint-env browser */

  /**
   * This is the web browser implementation of `debug()`.
   */
  exports.log = log;
  exports.formatArgs = formatArgs;
  exports.save = save;
  exports.load = load;
  exports.useColors = useColors;
  exports.storage = localstorage();
  /**
   * Colors.
   */

  exports.colors = ['#0000CC', '#0000FF', '#0033CC', '#0033FF', '#0066CC', '#0066FF', '#0099CC', '#0099FF', '#00CC00', '#00CC33', '#00CC66', '#00CC99', '#00CCCC', '#00CCFF', '#3300CC', '#3300FF', '#3333CC', '#3333FF', '#3366CC', '#3366FF', '#3399CC', '#3399FF', '#33CC00', '#33CC33', '#33CC66', '#33CC99', '#33CCCC', '#33CCFF', '#6600CC', '#6600FF', '#6633CC', '#6633FF', '#66CC00', '#66CC33', '#9900CC', '#9900FF', '#9933CC', '#9933FF', '#99CC00', '#99CC33', '#CC0000', '#CC0033', '#CC0066', '#CC0099', '#CC00CC', '#CC00FF', '#CC3300', '#CC3333', '#CC3366', '#CC3399', '#CC33CC', '#CC33FF', '#CC6600', '#CC6633', '#CC9900', '#CC9933', '#CCCC00', '#CCCC33', '#FF0000', '#FF0033', '#FF0066', '#FF0099', '#FF00CC', '#FF00FF', '#FF3300', '#FF3333', '#FF3366', '#FF3399', '#FF33CC', '#FF33FF', '#FF6600', '#FF6633', '#FF9900', '#FF9933', '#FFCC00', '#FFCC33'];
  /**
   * Currently only WebKit-based Web Inspectors, Firefox >= v31,
   * and the Firebug extension (any Firefox version) are known
   * to support "%c" CSS customizations.
   *
   * TODO: add a `localStorage` variable to explicitly enable/disable colors
   */
  // eslint-disable-next-line complexity

  function useColors() {
    // NB: In an Electron preload script, document will be defined but not fully
    // initialized. Since we know we're in Chrome, we'll just detect this case
    // explicitly
    if (typeof window !== 'undefined' && window.process && (window.process.type === 'renderer' || window.process.__nwjs)) {
      return true;
    } // Internet Explorer and Edge do not support colors.


    if (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
      return false;
    } // Is webkit? http://stackoverflow.com/a/16459606/376773
    // document is undefined in react-native: https://github.com/facebook/react-native/pull/1632


    return typeof document !== 'undefined' && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || // Is firebug? http://stackoverflow.com/a/398120/376773
    typeof window !== 'undefined' && window.console && (window.console.firebug || window.console.exception && window.console.table) || // Is firefox >= v31?
    // https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
    typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || // Double check webkit in userAgent just in case we are in a worker
    typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
  }
  /**
   * Colorize log arguments if enabled.
   *
   * @api public
   */


  function formatArgs(args) {
    args[0] = (this.useColors ? '%c' : '') + this.namespace + (this.useColors ? ' %c' : ' ') + args[0] + (this.useColors ? '%c ' : ' ') + '+' + module.exports.humanize(this.diff);

    if (!this.useColors) {
      return;
    }

    var c = 'color: ' + this.color;
    args.splice(1, 0, c, 'color: inherit'); // The final "%c" is somewhat tricky, because there could be other
    // arguments passed either before or after the %c, so we need to
    // figure out the correct index to insert the CSS into

    var index = 0;
    var lastC = 0;
    args[0].replace(/%[a-zA-Z%]/g, function (match) {
      if (match === '%%') {
        return;
      }

      index++;

      if (match === '%c') {
        // We only are interested in the *last* %c
        // (the user may have provided their own)
        lastC = index;
      }
    });
    args.splice(lastC, 0, c);
  }
  /**
   * Invokes `console.log()` when available.
   * No-op when `console.log` is not a "function".
   *
   * @api public
   */


  function log() {
    var _console;

    // This hackery is required for IE8/9, where
    // the `console.log` function doesn't have 'apply'
    return (typeof console === "undefined" ? "undefined" : _typeof(console)) === 'object' && console.log && (_console = console).log.apply(_console, arguments);
  }
  /**
   * Save `namespaces`.
   *
   * @param {String} namespaces
   * @api private
   */


  function save(namespaces) {
    try {
      if (namespaces) {
        exports.storage.setItem('debug', namespaces);
      } else {
        exports.storage.removeItem('debug');
      }
    } catch (error) {// Swallow
      // XXX (@Qix-) should we be logging these?
    }
  }
  /**
   * Load `namespaces`.
   *
   * @return {String} returns the previously persisted debug modes
   * @api private
   */


  function load() {
    var r;

    try {
      r = exports.storage.getItem('debug');
    } catch (error) {} // Swallow
    // XXX (@Qix-) should we be logging these?
    // If debug isn't set in LS, and we're in Electron, try to load $DEBUG


    if (!r && typeof process !== 'undefined' && 'env' in process) {
      r = process.env.DEBUG;
    }

    return r;
  }
  /**
   * Localstorage attempts to return the localstorage.
   *
   * This is necessary because safari throws
   * when a user disables cookies/localstorage
   * and you attempt to access it.
   *
   * @return {LocalStorage}
   * @api private
   */


  function localstorage() {
    try {
      // TVMLKit (Apple TV JS Runtime) does not have a window object, just localStorage in the global context
      // The Browser also has localStorage in the global context.
      return localStorage;
    } catch (error) {// Swallow
      // XXX (@Qix-) should we be logging these?
    }
  }

  module.exports = common(exports);
  var formatters = module.exports.formatters;
  /**
   * Map %j to `JSON.stringify()`, since no Web Inspectors do that by default.
   */

  formatters.j = function (v) {
    try {
      return JSON.stringify(v);
    } catch (error) {
      return '[UnexpectedJSONParseError]: ' + error.message;
    }
  };
  });
  var browser_1 = browser.log;
  var browser_2 = browser.formatArgs;
  var browser_3 = browser.save;
  var browser_4 = browser.load;
  var browser_5 = browser.useColors;
  var browser_6 = browser.storage;
  var browser_7 = browser.colors;

  var componentEmitter = createCommonjsModule(function (module) {
    /**
     * Expose `Emitter`.
     */
    {
      module.exports = Emitter;
    }
    /**
     * Initialize a new `Emitter`.
     *
     * @api public
     */


    function Emitter(obj) {
      if (obj) return mixin(obj);
    }
    /**
     * Mixin the emitter properties.
     *
     * @param {Object} obj
     * @return {Object}
     * @api private
     */

    function mixin(obj) {
      for (var key in Emitter.prototype) {
        obj[key] = Emitter.prototype[key];
      }

      return obj;
    }
    /**
     * Listen on the given `event` with `fn`.
     *
     * @param {String} event
     * @param {Function} fn
     * @return {Emitter}
     * @api public
     */


    Emitter.prototype.on = Emitter.prototype.addEventListener = function (event, fn) {
      this._callbacks = this._callbacks || {};
      (this._callbacks['$' + event] = this._callbacks['$' + event] || []).push(fn);
      return this;
    };
    /**
     * Adds an `event` listener that will be invoked a single
     * time then automatically removed.
     *
     * @param {String} event
     * @param {Function} fn
     * @return {Emitter}
     * @api public
     */


    Emitter.prototype.once = function (event, fn) {
      function on() {
        this.off(event, on);
        fn.apply(this, arguments);
      }

      on.fn = fn;
      this.on(event, on);
      return this;
    };
    /**
     * Remove the given callback for `event` or all
     * registered callbacks.
     *
     * @param {String} event
     * @param {Function} fn
     * @return {Emitter}
     * @api public
     */


    Emitter.prototype.off = Emitter.prototype.removeListener = Emitter.prototype.removeAllListeners = Emitter.prototype.removeEventListener = function (event, fn) {
      this._callbacks = this._callbacks || {}; // all

      if (0 == arguments.length) {
        this._callbacks = {};
        return this;
      } // specific event


      var callbacks = this._callbacks['$' + event];
      if (!callbacks) return this; // remove all handlers

      if (1 == arguments.length) {
        delete this._callbacks['$' + event];
        return this;
      } // remove specific handler


      var cb;

      for (var i = 0; i < callbacks.length; i++) {
        cb = callbacks[i];

        if (cb === fn || cb.fn === fn) {
          callbacks.splice(i, 1);
          break;
        }
      } // Remove event specific arrays for event types that no
      // one is subscribed for to avoid memory leak.


      if (callbacks.length === 0) {
        delete this._callbacks['$' + event];
      }

      return this;
    };
    /**
     * Emit `event` with the given args.
     *
     * @param {String} event
     * @param {Mixed} ...
     * @return {Emitter}
     */


    Emitter.prototype.emit = function (event) {
      this._callbacks = this._callbacks || {};
      var args = new Array(arguments.length - 1),
          callbacks = this._callbacks['$' + event];

      for (var i = 1; i < arguments.length; i++) {
        args[i - 1] = arguments[i];
      }

      if (callbacks) {
        callbacks = callbacks.slice(0);

        for (var i = 0, len = callbacks.length; i < len; ++i) {
          callbacks[i].apply(this, args);
        }
      }

      return this;
    };
    /**
     * Return array of callbacks for `event`.
     *
     * @param {String} event
     * @return {Array}
     * @api public
     */


    Emitter.prototype.listeners = function (event) {
      this._callbacks = this._callbacks || {};
      return this._callbacks['$' + event] || [];
    };
    /**
     * Check if this emitter has `event` handlers.
     *
     * @param {String} event
     * @return {Boolean}
     * @api public
     */


    Emitter.prototype.hasListeners = function (event) {
      return !!this.listeners(event).length;
    };
  });

  var fastSafeStringify = stringify;
  stringify.default = stringify;
  stringify.stable = deterministicStringify;
  stringify.stableStringify = deterministicStringify;

  var arr = [];
  var replacerStack = [];

  // Regular stringify
  function stringify (obj, replacer, spacer) {
    decirc(obj, '', [], undefined);
    var res;
    if (replacerStack.length === 0) {
      res = JSON.stringify(obj, replacer, spacer);
    } else {
      res = JSON.stringify(obj, replaceGetterValues(replacer), spacer);
    }
    while (arr.length !== 0) {
      var part = arr.pop();
      if (part.length === 4) {
        Object.defineProperty(part[0], part[1], part[3]);
      } else {
        part[0][part[1]] = part[2];
      }
    }
    return res
  }
  function decirc (val, k, stack, parent) {
    var i;
    if (typeof val === 'object' && val !== null) {
      for (i = 0; i < stack.length; i++) {
        if (stack[i] === val) {
          var propertyDescriptor = Object.getOwnPropertyDescriptor(parent, k);
          if (propertyDescriptor.get !== undefined) {
            if (propertyDescriptor.configurable) {
              Object.defineProperty(parent, k, { value: '[Circular]' });
              arr.push([parent, k, val, propertyDescriptor]);
            } else {
              replacerStack.push([val, k]);
            }
          } else {
            parent[k] = '[Circular]';
            arr.push([parent, k, val]);
          }
          return
        }
      }
      stack.push(val);
      // Optimize for Arrays. Big arrays could kill the performance otherwise!
      if (Array.isArray(val)) {
        for (i = 0; i < val.length; i++) {
          decirc(val[i], i, stack, val);
        }
      } else {
        var keys = Object.keys(val);
        for (i = 0; i < keys.length; i++) {
          var key = keys[i];
          decirc(val[key], key, stack, val);
        }
      }
      stack.pop();
    }
  }

  // Stable-stringify
  function compareFunction (a, b) {
    if (a < b) {
      return -1
    }
    if (a > b) {
      return 1
    }
    return 0
  }

  function deterministicStringify (obj, replacer, spacer) {
    var tmp = deterministicDecirc(obj, '', [], undefined) || obj;
    var res;
    if (replacerStack.length === 0) {
      res = JSON.stringify(tmp, replacer, spacer);
    } else {
      res = JSON.stringify(tmp, replaceGetterValues(replacer), spacer);
    }
    while (arr.length !== 0) {
      var part = arr.pop();
      if (part.length === 4) {
        Object.defineProperty(part[0], part[1], part[3]);
      } else {
        part[0][part[1]] = part[2];
      }
    }
    return res
  }

  function deterministicDecirc (val, k, stack, parent) {
    var i;
    if (typeof val === 'object' && val !== null) {
      for (i = 0; i < stack.length; i++) {
        if (stack[i] === val) {
          var propertyDescriptor = Object.getOwnPropertyDescriptor(parent, k);
          if (propertyDescriptor.get !== undefined) {
            if (propertyDescriptor.configurable) {
              Object.defineProperty(parent, k, { value: '[Circular]' });
              arr.push([parent, k, val, propertyDescriptor]);
            } else {
              replacerStack.push([val, k]);
            }
          } else {
            parent[k] = '[Circular]';
            arr.push([parent, k, val]);
          }
          return
        }
      }
      if (typeof val.toJSON === 'function') {
        return
      }
      stack.push(val);
      // Optimize for Arrays. Big arrays could kill the performance otherwise!
      if (Array.isArray(val)) {
        for (i = 0; i < val.length; i++) {
          deterministicDecirc(val[i], i, stack, val);
        }
      } else {
        // Create a temporary object in the required way
        var tmp = {};
        var keys = Object.keys(val).sort(compareFunction);
        for (i = 0; i < keys.length; i++) {
          var key = keys[i];
          deterministicDecirc(val[key], key, stack, val);
          tmp[key] = val[key];
        }
        if (parent !== undefined) {
          arr.push([parent, k, val]);
          parent[k] = tmp;
        } else {
          return tmp
        }
      }
      stack.pop();
    }
  }

  // wraps replacer function to handle values we couldn't replace
  // and mark them as [Circular]
  function replaceGetterValues (replacer) {
    replacer = replacer !== undefined ? replacer : function (k, v) { return v };
    return function (key, val) {
      if (replacerStack.length > 0) {
        for (var i = 0; i < replacerStack.length; i++) {
          var part = replacerStack[i];
          if (part[1] === key && part[0] === val) {
            val = '[Circular]';
            replacerStack.splice(i, 1);
            break
          }
        }
      }
      return replacer.call(this, key, val)
    }
  }

  function _typeof$1(obj) {
    if (typeof Symbol === "function" && _typeof(Symbol.iterator) === "symbol") {
      _typeof$1 = function _typeof$1(obj) {
        return _typeof(obj);
      };
    } else {
      _typeof$1 = function _typeof$1(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof(obj);
      };
    }

    return _typeof$1(obj);
  }
  /**
   * Check if `obj` is an object.
   *
   * @param {Object} obj
   * @return {Boolean}
   * @api private
   */


  function isObject(obj) {
    return obj !== null && _typeof$1(obj) === 'object';
  }

  var isObject_1 = isObject;

  function _typeof$2(obj) {
    if (typeof Symbol === "function" && _typeof(Symbol.iterator) === "symbol") {
      _typeof$2 = function _typeof$1(obj) {
        return _typeof(obj);
      };
    } else {
      _typeof$2 = function _typeof$1(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof(obj);
      };
    }

    return _typeof$2(obj);
  }
  /**
   * Module of mixed-in functions shared between node and client code
   */

  /**
   * Expose `RequestBase`.
   */


  var requestBase = RequestBase;
  /**
   * Initialize a new `RequestBase`.
   *
   * @api public
   */

  function RequestBase(obj) {
    if (obj) return mixin(obj);
  }
  /**
   * Mixin the prototype properties.
   *
   * @param {Object} obj
   * @return {Object}
   * @api private
   */


  function mixin(obj) {
    for (var key in RequestBase.prototype) {
      if (Object.prototype.hasOwnProperty.call(RequestBase.prototype, key)) obj[key] = RequestBase.prototype[key];
    }

    return obj;
  }
  /**
   * Clear previous timeout.
   *
   * @return {Request} for chaining
   * @api public
   */


  RequestBase.prototype.clearTimeout = function () {
    clearTimeout(this._timer);
    clearTimeout(this._responseTimeoutTimer);
    clearTimeout(this._uploadTimeoutTimer);
    delete this._timer;
    delete this._responseTimeoutTimer;
    delete this._uploadTimeoutTimer;
    return this;
  };
  /**
   * Override default response body parser
   *
   * This function will be called to convert incoming data into request.body
   *
   * @param {Function}
   * @api public
   */


  RequestBase.prototype.parse = function (fn) {
    this._parser = fn;
    return this;
  };
  /**
   * Set format of binary response body.
   * In browser valid formats are 'blob' and 'arraybuffer',
   * which return Blob and ArrayBuffer, respectively.
   *
   * In Node all values result in Buffer.
   *
   * Examples:
   *
   *      req.get('/')
   *        .responseType('blob')
   *        .end(callback);
   *
   * @param {String} val
   * @return {Request} for chaining
   * @api public
   */


  RequestBase.prototype.responseType = function (val) {
    this._responseType = val;
    return this;
  };
  /**
   * Override default request body serializer
   *
   * This function will be called to convert data set via .send or .attach into payload to send
   *
   * @param {Function}
   * @api public
   */


  RequestBase.prototype.serialize = function (fn) {
    this._serializer = fn;
    return this;
  };
  /**
   * Set timeouts.
   *
   * - response timeout is time between sending request and receiving the first byte of the response. Includes DNS and connection time.
   * - deadline is the time from start of the request to receiving response body in full. If the deadline is too short large files may not load at all on slow connections.
   * - upload is the time  since last bit of data was sent or received. This timeout works only if deadline timeout is off
   *
   * Value of 0 or false means no timeout.
   *
   * @param {Number|Object} ms or {response, deadline}
   * @return {Request} for chaining
   * @api public
   */


  RequestBase.prototype.timeout = function (options) {
    if (!options || _typeof$2(options) !== 'object') {
      this._timeout = options;
      this._responseTimeout = 0;
      this._uploadTimeout = 0;
      return this;
    }

    for (var option in options) {
      if (Object.prototype.hasOwnProperty.call(options, option)) {
        switch (option) {
          case 'deadline':
            this._timeout = options.deadline;
            break;

          case 'response':
            this._responseTimeout = options.response;
            break;

          case 'upload':
            this._uploadTimeout = options.upload;
            break;

          default:
            console.warn('Unknown timeout option', option);
        }
      }
    }

    return this;
  };
  /**
   * Set number of retry attempts on error.
   *
   * Failed requests will be retried 'count' times if timeout or err.code >= 500.
   *
   * @param {Number} count
   * @param {Function} [fn]
   * @return {Request} for chaining
   * @api public
   */


  RequestBase.prototype.retry = function (count, fn) {
    // Default to 1 if no count passed or true
    if (arguments.length === 0 || count === true) count = 1;
    if (count <= 0) count = 0;
    this._maxRetries = count;
    this._retries = 0;
    this._retryCallback = fn;
    return this;
  };

  var ERROR_CODES = ['ECONNRESET', 'ETIMEDOUT', 'EADDRINFO', 'ESOCKETTIMEDOUT'];
  /**
   * Determine if a request should be retried.
   * (Borrowed from segmentio/superagent-retry)
   *
   * @param {Error} err an error
   * @param {Response} [res] response
   * @returns {Boolean} if segment should be retried
   */

  RequestBase.prototype._shouldRetry = function (err, res) {
    if (!this._maxRetries || this._retries++ >= this._maxRetries) {
      return false;
    }

    if (this._retryCallback) {
      try {
        var override = this._retryCallback(err, res);

        if (override === true) return true;
        if (override === false) return false; // undefined falls back to defaults
      } catch (err2) {
        console.error(err2);
      }
    }

    if (res && res.status && res.status >= 500 && res.status !== 501) return true;

    if (err) {
      if (err.code && ERROR_CODES.indexOf(err.code) !== -1) return true; // Superagent timeout

      if (err.timeout && err.code === 'ECONNABORTED') return true;
      if (err.crossDomain) return true;
    }

    return false;
  };
  /**
   * Retry request
   *
   * @return {Request} for chaining
   * @api private
   */


  RequestBase.prototype._retry = function () {
    this.clearTimeout(); // node

    if (this.req) {
      this.req = null;
      this.req = this.request();
    }

    this._aborted = false;
    this.timedout = false;
    return this._end();
  };
  /**
   * Promise support
   *
   * @param {Function} resolve
   * @param {Function} [reject]
   * @return {Request}
   */


  RequestBase.prototype.then = function (resolve, reject) {
    var _this = this;

    if (!this._fullfilledPromise) {
      var self = this;

      if (this._endCalled) {
        console.warn('Warning: superagent request was sent twice, because both .end() and .then() were called. Never call .end() if you use promises');
      }

      this._fullfilledPromise = new Promise(function (resolve, reject) {
        self.on('abort', function () {
          var err = new Error('Aborted');
          err.code = 'ABORTED';
          err.status = _this.status;
          err.method = _this.method;
          err.url = _this.url;
          reject(err);
        });
        self.end(function (err, res) {
          if (err) reject(err);else resolve(res);
        });
      });
    }

    return this._fullfilledPromise.then(resolve, reject);
  };

  RequestBase.prototype["catch"] = function (cb) {
    return this.then(undefined, cb);
  };
  /**
   * Allow for extension
   */


  RequestBase.prototype.use = function (fn) {
    fn(this);
    return this;
  };

  RequestBase.prototype.ok = function (cb) {
    if (typeof cb !== 'function') throw new Error('Callback required');
    this._okCallback = cb;
    return this;
  };

  RequestBase.prototype._isResponseOK = function (res) {
    if (!res) {
      return false;
    }

    if (this._okCallback) {
      return this._okCallback(res);
    }

    return res.status >= 200 && res.status < 300;
  };
  /**
   * Get request header `field`.
   * Case-insensitive.
   *
   * @param {String} field
   * @return {String}
   * @api public
   */


  RequestBase.prototype.get = function (field) {
    return this._header[field.toLowerCase()];
  };
  /**
   * Get case-insensitive header `field` value.
   * This is a deprecated internal API. Use `.get(field)` instead.
   *
   * (getHeader is no longer used internally by the superagent code base)
   *
   * @param {String} field
   * @return {String}
   * @api private
   * @deprecated
   */


  RequestBase.prototype.getHeader = RequestBase.prototype.get;
  /**
   * Set header `field` to `val`, or multiple fields with one object.
   * Case-insensitive.
   *
   * Examples:
   *
   *      req.get('/')
   *        .set('Accept', 'application/json')
   *        .set('X-API-Key', 'foobar')
   *        .end(callback);
   *
   *      req.get('/')
   *        .set({ Accept: 'application/json', 'X-API-Key': 'foobar' })
   *        .end(callback);
   *
   * @param {String|Object} field
   * @param {String} val
   * @return {Request} for chaining
   * @api public
   */

  RequestBase.prototype.set = function (field, val) {
    if (isObject_1(field)) {
      for (var key in field) {
        if (Object.prototype.hasOwnProperty.call(field, key)) this.set(key, field[key]);
      }

      return this;
    }

    this._header[field.toLowerCase()] = val;
    this.header[field] = val;
    return this;
  }; // eslint-disable-next-line valid-jsdoc

  /**
   * Remove header `field`.
   * Case-insensitive.
   *
   * Example:
   *
   *      req.get('/')
   *        .unset('User-Agent')
   *        .end(callback);
   *
   * @param {String} field field name
   */


  RequestBase.prototype.unset = function (field) {
    delete this._header[field.toLowerCase()];
    delete this.header[field];
    return this;
  };
  /**
   * Write the field `name` and `val`, or multiple fields with one object
   * for "multipart/form-data" request bodies.
   *
   * ``` js
   * request.post('/upload')
   *   .field('foo', 'bar')
   *   .end(callback);
   *
   * request.post('/upload')
   *   .field({ foo: 'bar', baz: 'qux' })
   *   .end(callback);
   * ```
   *
   * @param {String|Object} name name of field
   * @param {String|Blob|File|Buffer|fs.ReadStream} val value of field
   * @return {Request} for chaining
   * @api public
   */


  RequestBase.prototype.field = function (name, val) {
    // name should be either a string or an object.
    if (name === null || undefined === name) {
      throw new Error('.field(name, val) name can not be empty');
    }

    if (this._data) {
      throw new Error(".field() can't be used if .send() is used. Please use only .send() or only .field() & .attach()");
    }

    if (isObject_1(name)) {
      for (var key in name) {
        if (Object.prototype.hasOwnProperty.call(name, key)) this.field(key, name[key]);
      }

      return this;
    }

    if (Array.isArray(val)) {
      for (var i in val) {
        if (Object.prototype.hasOwnProperty.call(val, i)) this.field(name, val[i]);
      }

      return this;
    } // val should be defined now


    if (val === null || undefined === val) {
      throw new Error('.field(name, val) val can not be empty');
    }

    if (typeof val === 'boolean') {
      val = String(val);
    }

    this._getFormData().append(name, val);

    return this;
  };
  /**
   * Abort the request, and clear potential timeout.
   *
   * @return {Request} request
   * @api public
   */


  RequestBase.prototype.abort = function () {
    if (this._aborted) {
      return this;
    }

    this._aborted = true;
    if (this.xhr) this.xhr.abort(); // browser

    if (this.req) this.req.abort(); // node

    this.clearTimeout();
    this.emit('abort');
    return this;
  };

  RequestBase.prototype._auth = function (user, pass, options, base64Encoder) {
    switch (options.type) {
      case 'basic':
        this.set('Authorization', "Basic ".concat(base64Encoder("".concat(user, ":").concat(pass))));
        break;

      case 'auto':
        this.username = user;
        this.password = pass;
        break;

      case 'bearer':
        // usage would be .auth(accessToken, { type: 'bearer' })
        this.set('Authorization', "Bearer ".concat(user));
        break;
    }

    return this;
  };
  /**
   * Enable transmission of cookies with x-domain requests.
   *
   * Note that for this to work the origin must not be
   * using "Access-Control-Allow-Origin" with a wildcard,
   * and also must set "Access-Control-Allow-Credentials"
   * to "true".
   *
   * @api public
   */


  RequestBase.prototype.withCredentials = function (on) {
    // This is browser-only functionality. Node side is no-op.
    if (on === undefined) on = true;
    this._withCredentials = on;
    return this;
  };
  /**
   * Set the max redirects to `n`. Does nothing in browser XHR implementation.
   *
   * @param {Number} n
   * @return {Request} for chaining
   * @api public
   */


  RequestBase.prototype.redirects = function (n) {
    this._maxRedirects = n;
    return this;
  };
  /**
   * Maximum size of buffered response body, in bytes. Counts uncompressed size.
   * Default 200MB.
   *
   * @param {Number} n number of bytes
   * @return {Request} for chaining
   */


  RequestBase.prototype.maxResponseSize = function (n) {
    if (typeof n !== 'number') {
      throw new TypeError('Invalid argument');
    }

    this._maxResponseSize = n;
    return this;
  };
  /**
   * Convert to a plain javascript object (not JSON string) of scalar properties.
   * Note as this method is designed to return a useful non-this value,
   * it cannot be chained.
   *
   * @return {Object} describing method, url, and data of this request
   * @api public
   */


  RequestBase.prototype.toJSON = function () {
    return {
      method: this.method,
      url: this.url,
      data: this._data,
      headers: this._header
    };
  };
  /**
   * Send `data` as the request body, defaulting the `.type()` to "json" when
   * an object is given.
   *
   * Examples:
   *
   *       // manual json
   *       request.post('/user')
   *         .type('json')
   *         .send('{"name":"tj"}')
   *         .end(callback)
   *
   *       // auto json
   *       request.post('/user')
   *         .send({ name: 'tj' })
   *         .end(callback)
   *
   *       // manual x-www-form-urlencoded
   *       request.post('/user')
   *         .type('form')
   *         .send('name=tj')
   *         .end(callback)
   *
   *       // auto x-www-form-urlencoded
   *       request.post('/user')
   *         .type('form')
   *         .send({ name: 'tj' })
   *         .end(callback)
   *
   *       // defaults to x-www-form-urlencoded
   *      request.post('/user')
   *        .send('name=tobi')
   *        .send('species=ferret')
   *        .end(callback)
   *
   * @param {String|Object} data
   * @return {Request} for chaining
   * @api public
   */
  // eslint-disable-next-line complexity


  RequestBase.prototype.send = function (data) {
    var isObj = isObject_1(data);
    var type = this._header['content-type'];

    if (this._formData) {
      throw new Error(".send() can't be used if .attach() or .field() is used. Please use only .send() or only .field() & .attach()");
    }

    if (isObj && !this._data) {
      if (Array.isArray(data)) {
        this._data = [];
      } else if (!this._isHost(data)) {
        this._data = {};
      }
    } else if (data && this._data && this._isHost(this._data)) {
      throw new Error("Can't merge these send calls");
    } // merge


    if (isObj && isObject_1(this._data)) {
      for (var key in data) {
        if (Object.prototype.hasOwnProperty.call(data, key)) this._data[key] = data[key];
      }
    } else if (typeof data === 'string') {
      // default to x-www-form-urlencoded
      if (!type) this.type('form');
      type = this._header['content-type'];

      if (type === 'application/x-www-form-urlencoded') {
        this._data = this._data ? "".concat(this._data, "&").concat(data) : data;
      } else {
        this._data = (this._data || '') + data;
      }
    } else {
      this._data = data;
    }

    if (!isObj || this._isHost(data)) {
      return this;
    } // default to json


    if (!type) this.type('json');
    return this;
  };
  /**
   * Sort `querystring` by the sort function
   *
   *
   * Examples:
   *
   *       // default order
   *       request.get('/user')
   *         .query('name=Nick')
   *         .query('search=Manny')
   *         .sortQuery()
   *         .end(callback)
   *
   *       // customized sort function
   *       request.get('/user')
   *         .query('name=Nick')
   *         .query('search=Manny')
   *         .sortQuery(function(a, b){
   *           return a.length - b.length;
   *         })
   *         .end(callback)
   *
   *
   * @param {Function} sort
   * @return {Request} for chaining
   * @api public
   */


  RequestBase.prototype.sortQuery = function (sort) {
    // _sort default to true but otherwise can be a function or boolean
    this._sort = typeof sort === 'undefined' ? true : sort;
    return this;
  };
  /**
   * Compose querystring to append to req.url
   *
   * @api private
   */


  RequestBase.prototype._finalizeQueryString = function () {
    var query = this._query.join('&');

    if (query) {
      this.url += (this.url.indexOf('?') >= 0 ? '&' : '?') + query;
    }

    this._query.length = 0; // Makes the call idempotent

    if (this._sort) {
      var index = this.url.indexOf('?');

      if (index >= 0) {
        var queryArr = this.url.substring(index + 1).split('&');

        if (typeof this._sort === 'function') {
          queryArr.sort(this._sort);
        } else {
          queryArr.sort();
        }

        this.url = this.url.substring(0, index) + '?' + queryArr.join('&');
      }
    }
  }; // For backwards compat only


  RequestBase.prototype._appendQueryString = function () {
    console.warn('Unsupported');
  };
  /**
   * Invoke callback with timeout error.
   *
   * @api private
   */


  RequestBase.prototype._timeoutError = function (reason, timeout, errno) {
    if (this._aborted) {
      return;
    }

    var err = new Error("".concat(reason + timeout, "ms exceeded"));
    err.timeout = timeout;
    err.code = 'ECONNABORTED';
    err.errno = errno;
    this.timedout = true;
    this.abort();
    this.callback(err);
  };

  RequestBase.prototype._setTimeouts = function () {
    var self = this; // deadline

    if (this._timeout && !this._timer) {
      this._timer = setTimeout(function () {
        self._timeoutError('Timeout of ', self._timeout, 'ETIME');
      }, this._timeout);
    } // response timeout


    if (this._responseTimeout && !this._responseTimeoutTimer) {
      this._responseTimeoutTimer = setTimeout(function () {
        self._timeoutError('Response timeout of ', self._responseTimeout, 'ETIMEDOUT');
      }, this._responseTimeout);
    }
  };

  /**
   * Return the mime type for the given `str`.
   *
   * @param {String} str
   * @return {String}
   * @api private
   */

  var type = function type(str) {
    return str.split(/ *; */).shift();
  };
  /**
   * Return header field parameters.
   *
   * @param {String} str
   * @return {Object}
   * @api private
   */


  var params = function params(str) {
    return str.split(/ *; */).reduce(function (obj, str) {
      var parts = str.split(/ *= */);
      var key = parts.shift();
      var val = parts.shift();
      if (key && val) obj[key] = val;
      return obj;
    }, {});
  };
  /**
   * Parse Link header fields.
   *
   * @param {String} str
   * @return {Object}
   * @api private
   */


  var parseLinks = function parseLinks(str) {
    return str.split(/ *, */).reduce(function (obj, str) {
      var parts = str.split(/ *; */);
      var url = parts[0].slice(1, -1);
      var rel = parts[1].split(/ *= */)[1].slice(1, -1);
      obj[rel] = url;
      return obj;
    }, {});
  };
  /**
   * Strip content related fields from `header`.
   *
   * @param {Object} header
   * @return {Object} header
   * @api private
   */


  var cleanHeader = function cleanHeader(header, changesOrigin) {
    delete header['content-type'];
    delete header['content-length'];
    delete header['transfer-encoding'];
    delete header.host; // secuirty

    if (changesOrigin) {
      delete header.authorization;
      delete header.cookie;
    }

    return header;
  };

  var utils = {
    type: type,
    params: params,
    parseLinks: parseLinks,
    cleanHeader: cleanHeader
  };

  /**
   * Module dependencies.
   */

  /**
   * Expose `ResponseBase`.
   */


  var responseBase = ResponseBase;
  /**
   * Initialize a new `ResponseBase`.
   *
   * @api public
   */

  function ResponseBase(obj) {
    if (obj) return mixin$1(obj);
  }
  /**
   * Mixin the prototype properties.
   *
   * @param {Object} obj
   * @return {Object}
   * @api private
   */


  function mixin$1(obj) {
    for (var key in ResponseBase.prototype) {
      if (Object.prototype.hasOwnProperty.call(ResponseBase.prototype, key)) obj[key] = ResponseBase.prototype[key];
    }

    return obj;
  }
  /**
   * Get case-insensitive `field` value.
   *
   * @param {String} field
   * @return {String}
   * @api public
   */


  ResponseBase.prototype.get = function (field) {
    return this.header[field.toLowerCase()];
  };
  /**
   * Set header related properties:
   *
   *   - `.type` the content type without params
   *
   * A response of "Content-Type: text/plain; charset=utf-8"
   * will provide you with a `.type` of "text/plain".
   *
   * @param {Object} header
   * @api private
   */


  ResponseBase.prototype._setHeaderProperties = function (header) {
    // TODO: moar!
    // TODO: make this a util
    // content-type
    var ct = header['content-type'] || '';
    this.type = utils.type(ct); // params

    var params = utils.params(ct);

    for (var key in params) {
      if (Object.prototype.hasOwnProperty.call(params, key)) this[key] = params[key];
    }

    this.links = {}; // links

    try {
      if (header.link) {
        this.links = utils.parseLinks(header.link);
      }
    } catch (err) {// ignore
    }
  };
  /**
   * Set flags such as `.ok` based on `status`.
   *
   * For example a 2xx response will give you a `.ok` of __true__
   * whereas 5xx will be __false__ and `.error` will be __true__. The
   * `.clientError` and `.serverError` are also available to be more
   * specific, and `.statusType` is the class of error ranging from 1..5
   * sometimes useful for mapping respond colors etc.
   *
   * "sugar" properties are also defined for common cases. Currently providing:
   *
   *   - .noContent
   *   - .badRequest
   *   - .unauthorized
   *   - .notAcceptable
   *   - .notFound
   *
   * @param {Number} status
   * @api private
   */


  ResponseBase.prototype._setStatusProperties = function (status) {
    var type = status / 100 | 0; // status / class

    this.statusCode = status;
    this.status = this.statusCode;
    this.statusType = type; // basics

    this.info = type === 1;
    this.ok = type === 2;
    this.redirect = type === 3;
    this.clientError = type === 4;
    this.serverError = type === 5;
    this.error = type === 4 || type === 5 ? this.toError() : false; // sugar

    this.created = status === 201;
    this.accepted = status === 202;
    this.noContent = status === 204;
    this.badRequest = status === 400;
    this.unauthorized = status === 401;
    this.notAcceptable = status === 406;
    this.forbidden = status === 403;
    this.notFound = status === 404;
    this.unprocessableEntity = status === 422;
  };

  function _toConsumableArray$1(arr) {
    return _arrayWithoutHoles$1(arr) || _iterableToArray$1(arr) || _nonIterableSpread$1();
  }

  function _nonIterableSpread$1() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
  }

  function _iterableToArray$1(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
  }

  function _arrayWithoutHoles$1(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
        arr2[i] = arr[i];
      }

      return arr2;
    }
  }

  function Agent() {
    this._defaults = [];
  }

  ['use', 'on', 'once', 'set', 'query', 'type', 'accept', 'auth', 'withCredentials', 'sortQuery', 'retry', 'ok', 'redirects', 'timeout', 'buffer', 'serialize', 'parse', 'ca', 'key', 'pfx', 'cert'].forEach(function (fn) {
    // Default setting for all requests from this agent
    Agent.prototype[fn] = function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      this._defaults.push({
        fn: fn,
        args: args
      });

      return this;
    };
  });

  Agent.prototype._setDefaults = function (req) {
    this._defaults.forEach(function (def) {
      req[def.fn].apply(req, _toConsumableArray$1(def.args));
    });
  };

  var agentBase = Agent;

  var client = createCommonjsModule(function (module, exports) {

    function _typeof$1(obj) {
      if (typeof Symbol === "function" && _typeof(Symbol.iterator) === "symbol") {
        _typeof$1 = function _typeof$1(obj) {
          return _typeof(obj);
        };
      } else {
        _typeof$1 = function _typeof$1(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof(obj);
        };
      }

      return _typeof$1(obj);
    }
    /**
     * Root reference for iframes.
     */


    var root;

    if (typeof window !== 'undefined') {
      // Browser window
      root = window;
    } else if (typeof self === 'undefined') {
      // Other environments
      console.warn('Using browser-only version of superagent in non-browser environment');
      root = void 0;
    } else {
      // Web Worker
      root = self;
    }
    /**
     * Noop.
     */


    function noop() {}
    /**
     * Expose `request`.
     */


    module.exports = function (method, url) {
      // callback
      if (typeof url === 'function') {
        return new exports.Request('GET', method).end(url);
      } // url first


      if (arguments.length === 1) {
        return new exports.Request('GET', method);
      }

      return new exports.Request(method, url);
    };

    exports = module.exports;
    var request = exports;
    exports.Request = Request;
    /**
     * Determine XHR.
     */

    request.getXHR = function () {
      if (root.XMLHttpRequest && (!root.location || root.location.protocol !== 'file:' || !root.ActiveXObject)) {
        return new XMLHttpRequest();
      }

      try {
        return new ActiveXObject('Microsoft.XMLHTTP');
      } catch (err) {}

      try {
        return new ActiveXObject('Msxml2.XMLHTTP.6.0');
      } catch (err) {}

      try {
        return new ActiveXObject('Msxml2.XMLHTTP.3.0');
      } catch (err) {}

      try {
        return new ActiveXObject('Msxml2.XMLHTTP');
      } catch (err) {}

      throw new Error('Browser-only version of superagent could not find XHR');
    };
    /**
     * Removes leading and trailing whitespace, added to support IE.
     *
     * @param {String} s
     * @return {String}
     * @api private
     */


    var trim = ''.trim ? function (s) {
      return s.trim();
    } : function (s) {
      return s.replace(/(^\s*|\s*$)/g, '');
    };
    /**
     * Serialize the given `obj`.
     *
     * @param {Object} obj
     * @return {String}
     * @api private
     */

    function serialize(obj) {
      if (!isObject_1(obj)) return obj;
      var pairs = [];

      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) pushEncodedKeyValuePair(pairs, key, obj[key]);
      }

      return pairs.join('&');
    }
    /**
     * Helps 'serialize' with serializing arrays.
     * Mutates the pairs array.
     *
     * @param {Array} pairs
     * @param {String} key
     * @param {Mixed} val
     */


    function pushEncodedKeyValuePair(pairs, key, val) {
      if (val === undefined) return;

      if (val === null) {
        pairs.push(encodeURIComponent(key));
        return;
      }

      if (Array.isArray(val)) {
        val.forEach(function (v) {
          pushEncodedKeyValuePair(pairs, key, v);
        });
      } else if (isObject_1(val)) {
        for (var subkey in val) {
          if (Object.prototype.hasOwnProperty.call(val, subkey)) pushEncodedKeyValuePair(pairs, "".concat(key, "[").concat(subkey, "]"), val[subkey]);
        }
      } else {
        pairs.push(encodeURIComponent(key) + '=' + encodeURIComponent(val));
      }
    }
    /**
     * Expose serialization method.
     */


    request.serializeObject = serialize;
    /**
     * Parse the given x-www-form-urlencoded `str`.
     *
     * @param {String} str
     * @return {Object}
     * @api private
     */

    function parseString(str) {
      var obj = {};
      var pairs = str.split('&');
      var pair;
      var pos;

      for (var i = 0, len = pairs.length; i < len; ++i) {
        pair = pairs[i];
        pos = pair.indexOf('=');

        if (pos === -1) {
          obj[decodeURIComponent(pair)] = '';
        } else {
          obj[decodeURIComponent(pair.slice(0, pos))] = decodeURIComponent(pair.slice(pos + 1));
        }
      }

      return obj;
    }
    /**
     * Expose parser.
     */


    request.parseString = parseString;
    /**
     * Default MIME type map.
     *
     *     superagent.types.xml = 'application/xml';
     *
     */

    request.types = {
      html: 'text/html',
      json: 'application/json',
      xml: 'text/xml',
      urlencoded: 'application/x-www-form-urlencoded',
      form: 'application/x-www-form-urlencoded',
      'form-data': 'application/x-www-form-urlencoded'
    };
    /**
     * Default serialization map.
     *
     *     superagent.serialize['application/xml'] = function(obj){
     *       return 'generated xml here';
     *     };
     *
     */

    request.serialize = {
      'application/x-www-form-urlencoded': serialize,
      'application/json': fastSafeStringify
    };
    /**
     * Default parsers.
     *
     *     superagent.parse['application/xml'] = function(str){
     *       return { object parsed from str };
     *     };
     *
     */

    request.parse = {
      'application/x-www-form-urlencoded': parseString,
      'application/json': JSON.parse
    };
    /**
     * Parse the given header `str` into
     * an object containing the mapped fields.
     *
     * @param {String} str
     * @return {Object}
     * @api private
     */

    function parseHeader(str) {
      var lines = str.split(/\r?\n/);
      var fields = {};
      var index;
      var line;
      var field;
      var val;

      for (var i = 0, len = lines.length; i < len; ++i) {
        line = lines[i];
        index = line.indexOf(':');

        if (index === -1) {
          // could be empty line, just skip it
          continue;
        }

        field = line.slice(0, index).toLowerCase();
        val = trim(line.slice(index + 1));
        fields[field] = val;
      }

      return fields;
    }
    /**
     * Check if `mime` is json or has +json structured syntax suffix.
     *
     * @param {String} mime
     * @return {Boolean}
     * @api private
     */


    function isJSON(mime) {
      // should match /json or +json
      // but not /json-seq
      return /[/+]json($|[^-\w])/.test(mime);
    }
    /**
     * Initialize a new `Response` with the given `xhr`.
     *
     *  - set flags (.ok, .error, etc)
     *  - parse header
     *
     * Examples:
     *
     *  Aliasing `superagent` as `request` is nice:
     *
     *      request = superagent;
     *
     *  We can use the promise-like API, or pass callbacks:
     *
     *      request.get('/').end(function(res){});
     *      request.get('/', function(res){});
     *
     *  Sending data can be chained:
     *
     *      request
     *        .post('/user')
     *        .send({ name: 'tj' })
     *        .end(function(res){});
     *
     *  Or passed to `.send()`:
     *
     *      request
     *        .post('/user')
     *        .send({ name: 'tj' }, function(res){});
     *
     *  Or passed to `.post()`:
     *
     *      request
     *        .post('/user', { name: 'tj' })
     *        .end(function(res){});
     *
     * Or further reduced to a single call for simple cases:
     *
     *      request
     *        .post('/user', { name: 'tj' }, function(res){});
     *
     * @param {XMLHTTPRequest} xhr
     * @param {Object} options
     * @api private
     */


    function Response(req) {
      this.req = req;
      this.xhr = this.req.xhr; // responseText is accessible only if responseType is '' or 'text' and on older browsers

      this.text = this.req.method !== 'HEAD' && (this.xhr.responseType === '' || this.xhr.responseType === 'text') || typeof this.xhr.responseType === 'undefined' ? this.xhr.responseText : null;
      this.statusText = this.req.xhr.statusText;
      var status = this.xhr.status; // handle IE9 bug: http://stackoverflow.com/questions/10046972/msie-returns-status-code-of-1223-for-ajax-request

      if (status === 1223) {
        status = 204;
      }

      this._setStatusProperties(status);

      this.headers = parseHeader(this.xhr.getAllResponseHeaders());
      this.header = this.headers; // getAllResponseHeaders sometimes falsely returns "" for CORS requests, but
      // getResponseHeader still works. so we get content-type even if getting
      // other headers fails.

      this.header['content-type'] = this.xhr.getResponseHeader('content-type');

      this._setHeaderProperties(this.header);

      if (this.text === null && req._responseType) {
        this.body = this.xhr.response;
      } else {
        this.body = this.req.method === 'HEAD' ? null : this._parseBody(this.text ? this.text : this.xhr.response);
      }
    } // eslint-disable-next-line new-cap


    responseBase(Response.prototype);
    /**
     * Parse the given body `str`.
     *
     * Used for auto-parsing of bodies. Parsers
     * are defined on the `superagent.parse` object.
     *
     * @param {String} str
     * @return {Mixed}
     * @api private
     */

    Response.prototype._parseBody = function (str) {
      var parse = request.parse[this.type];

      if (this.req._parser) {
        return this.req._parser(this, str);
      }

      if (!parse && isJSON(this.type)) {
        parse = request.parse['application/json'];
      }

      return parse && str && (str.length > 0 || str instanceof Object) ? parse(str) : null;
    };
    /**
     * Return an `Error` representative of this response.
     *
     * @return {Error}
     * @api public
     */


    Response.prototype.toError = function () {
      var req = this.req;
      var method = req.method;
      var url = req.url;
      var msg = "cannot ".concat(method, " ").concat(url, " (").concat(this.status, ")");
      var err = new Error(msg);
      err.status = this.status;
      err.method = method;
      err.url = url;
      return err;
    };
    /**
     * Expose `Response`.
     */


    request.Response = Response;
    /**
     * Initialize a new `Request` with the given `method` and `url`.
     *
     * @param {String} method
     * @param {String} url
     * @api public
     */

    function Request(method, url) {
      var self = this;
      this._query = this._query || [];
      this.method = method;
      this.url = url;
      this.header = {}; // preserves header name case

      this._header = {}; // coerces header names to lowercase

      this.on('end', function () {
        var err = null;
        var res = null;

        try {
          res = new Response(self);
        } catch (err2) {
          err = new Error('Parser is unable to parse the response');
          err.parse = true;
          err.original = err2; // issue #675: return the raw response if the response parsing fails

          if (self.xhr) {
            // ie9 doesn't have 'response' property
            err.rawResponse = typeof self.xhr.responseType === 'undefined' ? self.xhr.responseText : self.xhr.response; // issue #876: return the http status code if the response parsing fails

            err.status = self.xhr.status ? self.xhr.status : null;
            err.statusCode = err.status; // backwards-compat only
          } else {
            err.rawResponse = null;
            err.status = null;
          }

          return self.callback(err);
        }

        self.emit('response', res);
        var new_err;

        try {
          if (!self._isResponseOK(res)) {
            new_err = new Error(res.statusText || 'Unsuccessful HTTP response');
          }
        } catch (err2) {
          new_err = err2; // ok() callback can throw
        } // #1000 don't catch errors from the callback to avoid double calling it


        if (new_err) {
          new_err.original = err;
          new_err.response = res;
          new_err.status = res.status;
          self.callback(new_err, res);
        } else {
          self.callback(null, res);
        }
      });
    }
    /**
     * Mixin `Emitter` and `RequestBase`.
     */
    // eslint-disable-next-line new-cap


    componentEmitter(Request.prototype); // eslint-disable-next-line new-cap

    requestBase(Request.prototype);
    /**
     * Set Content-Type to `type`, mapping values from `request.types`.
     *
     * Examples:
     *
     *      superagent.types.xml = 'application/xml';
     *
     *      request.post('/')
     *        .type('xml')
     *        .send(xmlstring)
     *        .end(callback);
     *
     *      request.post('/')
     *        .type('application/xml')
     *        .send(xmlstring)
     *        .end(callback);
     *
     * @param {String} type
     * @return {Request} for chaining
     * @api public
     */

    Request.prototype.type = function (type) {
      this.set('Content-Type', request.types[type] || type);
      return this;
    };
    /**
     * Set Accept to `type`, mapping values from `request.types`.
     *
     * Examples:
     *
     *      superagent.types.json = 'application/json';
     *
     *      request.get('/agent')
     *        .accept('json')
     *        .end(callback);
     *
     *      request.get('/agent')
     *        .accept('application/json')
     *        .end(callback);
     *
     * @param {String} accept
     * @return {Request} for chaining
     * @api public
     */


    Request.prototype.accept = function (type) {
      this.set('Accept', request.types[type] || type);
      return this;
    };
    /**
     * Set Authorization field value with `user` and `pass`.
     *
     * @param {String} user
     * @param {String} [pass] optional in case of using 'bearer' as type
     * @param {Object} options with 'type' property 'auto', 'basic' or 'bearer' (default 'basic')
     * @return {Request} for chaining
     * @api public
     */


    Request.prototype.auth = function (user, pass, options) {
      if (arguments.length === 1) pass = '';

      if (_typeof$1(pass) === 'object' && pass !== null) {
        // pass is optional and can be replaced with options
        options = pass;
        pass = '';
      }

      if (!options) {
        options = {
          type: typeof btoa === 'function' ? 'basic' : 'auto'
        };
      }

      var encoder = function encoder(string) {
        if (typeof btoa === 'function') {
          return btoa(string);
        }

        throw new Error('Cannot use basic auth, btoa is not a function');
      };

      return this._auth(user, pass, options, encoder);
    };
    /**
     * Add query-string `val`.
     *
     * Examples:
     *
     *   request.get('/shoes')
     *     .query('size=10')
     *     .query({ color: 'blue' })
     *
     * @param {Object|String} val
     * @return {Request} for chaining
     * @api public
     */


    Request.prototype.query = function (val) {
      if (typeof val !== 'string') val = serialize(val);
      if (val) this._query.push(val);
      return this;
    };
    /**
     * Queue the given `file` as an attachment to the specified `field`,
     * with optional `options` (or filename).
     *
     * ``` js
     * request.post('/upload')
     *   .attach('content', new Blob(['<a id="a"><b id="b">hey!</b></a>'], { type: "text/html"}))
     *   .end(callback);
     * ```
     *
     * @param {String} field
     * @param {Blob|File} file
     * @param {String|Object} options
     * @return {Request} for chaining
     * @api public
     */


    Request.prototype.attach = function (field, file, options) {
      if (file) {
        if (this._data) {
          throw new Error("superagent can't mix .send() and .attach()");
        }

        this._getFormData().append(field, file, options || file.name);
      }

      return this;
    };

    Request.prototype._getFormData = function () {
      if (!this._formData) {
        this._formData = new root.FormData();
      }

      return this._formData;
    };
    /**
     * Invoke the callback with `err` and `res`
     * and handle arity check.
     *
     * @param {Error} err
     * @param {Response} res
     * @api private
     */


    Request.prototype.callback = function (err, res) {
      if (this._shouldRetry(err, res)) {
        return this._retry();
      }

      var fn = this._callback;
      this.clearTimeout();

      if (err) {
        if (this._maxRetries) err.retries = this._retries - 1;
        this.emit('error', err);
      }

      fn(err, res);
    };
    /**
     * Invoke callback with x-domain error.
     *
     * @api private
     */


    Request.prototype.crossDomainError = function () {
      var err = new Error('Request has been terminated\nPossible causes: the network is offline, Origin is not allowed by Access-Control-Allow-Origin, the page is being unloaded, etc.');
      err.crossDomain = true;
      err.status = this.status;
      err.method = this.method;
      err.url = this.url;
      this.callback(err);
    }; // This only warns, because the request is still likely to work


    Request.prototype.agent = function () {
      console.warn('This is not supported in browser version of superagent');
      return this;
    };

    Request.prototype.buffer = Request.prototype.ca;
    Request.prototype.ca = Request.prototype.agent; // This throws, because it can't send/receive data as expected

    Request.prototype.write = function () {
      throw new Error('Streaming is not supported in browser version of superagent');
    };

    Request.prototype.pipe = Request.prototype.write;
    /**
     * Check if `obj` is a host object,
     * we don't want to serialize these :)
     *
     * @param {Object} obj host object
     * @return {Boolean} is a host object
     * @api private
     */

    Request.prototype._isHost = function (obj) {
      // Native objects stringify to [object File], [object Blob], [object FormData], etc.
      return obj && _typeof$1(obj) === 'object' && !Array.isArray(obj) && Object.prototype.toString.call(obj) !== '[object Object]';
    };
    /**
     * Initiate request, invoking callback `fn(res)`
     * with an instanceof `Response`.
     *
     * @param {Function} fn
     * @return {Request} for chaining
     * @api public
     */


    Request.prototype.end = function (fn) {
      if (this._endCalled) {
        console.warn('Warning: .end() was called twice. This is not supported in superagent');
      }

      this._endCalled = true; // store callback

      this._callback = fn || noop; // querystring

      this._finalizeQueryString();

      this._end();
    };

    Request.prototype._setUploadTimeout = function () {
      var self = this; // upload timeout it's wokrs only if deadline timeout is off

      if (this._uploadTimeout && !this._uploadTimeoutTimer) {
        this._uploadTimeoutTimer = setTimeout(function () {
          self._timeoutError('Upload timeout of ', self._uploadTimeout, 'ETIMEDOUT');
        }, this._uploadTimeout);
      }
    }; // eslint-disable-next-line complexity


    Request.prototype._end = function () {
      if (this._aborted) return this.callback(new Error('The request has been aborted even before .end() was called'));
      var self = this;
      this.xhr = request.getXHR();
      var xhr = this.xhr;
      var data = this._formData || this._data;

      this._setTimeouts(); // state change


      xhr.onreadystatechange = function () {
        var readyState = xhr.readyState;

        if (readyState >= 2 && self._responseTimeoutTimer) {
          clearTimeout(self._responseTimeoutTimer);
        }

        if (readyState !== 4) {
          return;
        } // In IE9, reads to any property (e.g. status) off of an aborted XHR will
        // result in the error "Could not complete the operation due to error c00c023f"


        var status;

        try {
          status = xhr.status;
        } catch (err) {
          status = 0;
        }

        if (!status) {
          if (self.timedout || self._aborted) return;
          return self.crossDomainError();
        }

        self.emit('end');
      }; // progress


      var handleProgress = function handleProgress(direction, e) {
        if (e.total > 0) {
          e.percent = e.loaded / e.total * 100;

          if (e.percent === 100) {
            clearTimeout(self._uploadTimeoutTimer);
          }
        }

        e.direction = direction;
        self.emit('progress', e);
      };

      if (this.hasListeners('progress')) {
        try {
          xhr.addEventListener('progress', handleProgress.bind(null, 'download'));

          if (xhr.upload) {
            xhr.upload.addEventListener('progress', handleProgress.bind(null, 'upload'));
          }
        } catch (err) {// Accessing xhr.upload fails in IE from a web worker, so just pretend it doesn't exist.
          // Reported here:
          // https://connect.microsoft.com/IE/feedback/details/837245/xmlhttprequest-upload-throws-invalid-argument-when-used-from-web-worker-context
        }
      }

      if (xhr.upload) {
        this._setUploadTimeout();
      } // initiate request


      try {
        if (this.username && this.password) {
          xhr.open(this.method, this.url, true, this.username, this.password);
        } else {
          xhr.open(this.method, this.url, true);
        }
      } catch (err) {
        // see #1149
        return this.callback(err);
      } // CORS


      if (this._withCredentials) xhr.withCredentials = true; // body

      if (!this._formData && this.method !== 'GET' && this.method !== 'HEAD' && typeof data !== 'string' && !this._isHost(data)) {
        // serialize stuff
        var contentType = this._header['content-type'];

        var _serialize = this._serializer || request.serialize[contentType ? contentType.split(';')[0] : ''];

        if (!_serialize && isJSON(contentType)) {
          _serialize = request.serialize['application/json'];
        }

        if (_serialize) data = _serialize(data);
      } // set header fields


      for (var field in this.header) {
        if (this.header[field] === null) continue;
        if (Object.prototype.hasOwnProperty.call(this.header, field)) xhr.setRequestHeader(field, this.header[field]);
      }

      if (this._responseType) {
        xhr.responseType = this._responseType;
      } // send stuff


      this.emit('request', this); // IE11 xhr.send(undefined) sends 'undefined' string as POST payload (instead of nothing)
      // We need null here if data is undefined

      xhr.send(typeof data === 'undefined' ? null : data);
    };

    request.agent = function () {
      return new agentBase();
    };

    ['GET', 'POST', 'OPTIONS', 'PATCH', 'PUT', 'DELETE'].forEach(function (method) {
      agentBase.prototype[method.toLowerCase()] = function (url, fn) {
        var req = new request.Request(method, url);

        this._setDefaults(req);

        if (fn) {
          req.end(fn);
        }

        return req;
      };
    });
    agentBase.prototype.del = agentBase.prototype["delete"];
    /**
     * GET `url` with optional callback `fn(res)`.
     *
     * @param {String} url
     * @param {Mixed|Function} [data] or fn
     * @param {Function} [fn]
     * @return {Request}
     * @api public
     */

    request.get = function (url, data, fn) {
      var req = request('GET', url);

      if (typeof data === 'function') {
        fn = data;
        data = null;
      }

      if (data) req.query(data);
      if (fn) req.end(fn);
      return req;
    };
    /**
     * HEAD `url` with optional callback `fn(res)`.
     *
     * @param {String} url
     * @param {Mixed|Function} [data] or fn
     * @param {Function} [fn]
     * @return {Request}
     * @api public
     */


    request.head = function (url, data, fn) {
      var req = request('HEAD', url);

      if (typeof data === 'function') {
        fn = data;
        data = null;
      }

      if (data) req.query(data);
      if (fn) req.end(fn);
      return req;
    };
    /**
     * OPTIONS query to `url` with optional callback `fn(res)`.
     *
     * @param {String} url
     * @param {Mixed|Function} [data] or fn
     * @param {Function} [fn]
     * @return {Request}
     * @api public
     */


    request.options = function (url, data, fn) {
      var req = request('OPTIONS', url);

      if (typeof data === 'function') {
        fn = data;
        data = null;
      }

      if (data) req.send(data);
      if (fn) req.end(fn);
      return req;
    };
    /**
     * DELETE `url` with optional `data` and callback `fn(res)`.
     *
     * @param {String} url
     * @param {Mixed} [data]
     * @param {Function} [fn]
     * @return {Request}
     * @api public
     */


    function del(url, data, fn) {
      var req = request('DELETE', url);

      if (typeof data === 'function') {
        fn = data;
        data = null;
      }

      if (data) req.send(data);
      if (fn) req.end(fn);
      return req;
    }

    request.del = del;
    request["delete"] = del;
    /**
     * PATCH `url` with optional `data` and callback `fn(res)`.
     *
     * @param {String} url
     * @param {Mixed} [data]
     * @param {Function} [fn]
     * @return {Request}
     * @api public
     */

    request.patch = function (url, data, fn) {
      var req = request('PATCH', url);

      if (typeof data === 'function') {
        fn = data;
        data = null;
      }

      if (data) req.send(data);
      if (fn) req.end(fn);
      return req;
    };
    /**
     * POST `url` with optional `data` and callback `fn(res)`.
     *
     * @param {String} url
     * @param {Mixed} [data]
     * @param {Function} [fn]
     * @return {Request}
     * @api public
     */


    request.post = function (url, data, fn) {
      var req = request('POST', url);

      if (typeof data === 'function') {
        fn = data;
        data = null;
      }

      if (data) req.send(data);
      if (fn) req.end(fn);
      return req;
    };
    /**
     * PUT `url` with optional `data` and callback `fn(res)`.
     *
     * @param {String} url
     * @param {Mixed|Function} [data] or fn
     * @param {Function} [fn]
     * @return {Request}
     * @api public
     */


    request.put = function (url, data, fn) {
      var req = request('PUT', url);

      if (typeof data === 'function') {
        fn = data;
        data = null;
      }

      if (data) req.send(data);
      if (fn) req.end(fn);
      return req;
    };
  });
  var client_1 = client.Request;

  /**
   * Copies the values of `source` to `array`.
   *
   * @private
   * @param {Array} source The array to copy values from.
   * @param {Array} [array=[]] The array to copy values to.
   * @returns {Array} Returns `array`.
   */
  function copyArray(source, array) {
    var index = -1,
        length = source.length;

    array || (array = Array(length));
    while (++index < length) {
      array[index] = source[index];
    }
    return array;
  }

  var _copyArray = copyArray;

  /* Built-in method references for those with the same name as other `lodash` methods. */
  var nativeFloor = Math.floor,
      nativeRandom = Math.random;

  /**
   * The base implementation of `_.random` without support for returning
   * floating-point numbers.
   *
   * @private
   * @param {number} lower The lower bound.
   * @param {number} upper The upper bound.
   * @returns {number} Returns the random number.
   */
  function baseRandom(lower, upper) {
    return lower + nativeFloor(nativeRandom() * (upper - lower + 1));
  }

  var _baseRandom = baseRandom;

  /**
   * A specialized version of `_.shuffle` which mutates and sets the size of `array`.
   *
   * @private
   * @param {Array} array The array to shuffle.
   * @param {number} [size=array.length] The size of `array`.
   * @returns {Array} Returns `array`.
   */
  function shuffleSelf(array, size) {
    var index = -1,
        length = array.length,
        lastIndex = length - 1;

    size = size === undefined ? length : size;
    while (++index < size) {
      var rand = _baseRandom(index, lastIndex),
          value = array[rand];

      array[rand] = array[index];
      array[index] = value;
    }
    array.length = size;
    return array;
  }

  var _shuffleSelf = shuffleSelf;

  /**
   * A specialized version of `_.shuffle` for arrays.
   *
   * @private
   * @param {Array} array The array to shuffle.
   * @returns {Array} Returns the new shuffled array.
   */
  function arrayShuffle(array) {
    return _shuffleSelf(_copyArray(array));
  }

  var _arrayShuffle = arrayShuffle;

  /**
   * A specialized version of `_.map` for arrays without support for iteratee
   * shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the new mapped array.
   */
  function arrayMap(array, iteratee) {
    var index = -1,
        length = array == null ? 0 : array.length,
        result = Array(length);

    while (++index < length) {
      result[index] = iteratee(array[index], index, array);
    }
    return result;
  }

  var _arrayMap = arrayMap;

  /**
   * The base implementation of `_.values` and `_.valuesIn` which creates an
   * array of `object` property values corresponding to the property names
   * of `props`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {Array} props The property names to get values for.
   * @returns {Object} Returns the array of property values.
   */
  function baseValues(object, props) {
    return _arrayMap(props, function(key) {
      return object[key];
    });
  }

  var _baseValues = baseValues;

  /**
   * The base implementation of `_.times` without support for iteratee shorthands
   * or max array length checks.
   *
   * @private
   * @param {number} n The number of times to invoke `iteratee`.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the array of results.
   */
  function baseTimes(n, iteratee) {
    var index = -1,
        result = Array(n);

    while (++index < n) {
      result[index] = iteratee(index);
    }
    return result;
  }

  var _baseTimes = baseTimes;

  /** Detect free variable `global` from Node.js. */
  var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

  var _freeGlobal = freeGlobal;

  /** Detect free variable `self`. */
  var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

  /** Used as a reference to the global object. */
  var root = _freeGlobal || freeSelf || Function('return this')();

  var _root = root;

  /** Built-in value references. */
  var Symbol$1 = _root.Symbol;

  var _Symbol = Symbol$1;

  /** Used for built-in method references. */
  var objectProto = Object.prototype;

  /** Used to check objects for own properties. */
  var hasOwnProperty$1 = objectProto.hasOwnProperty;

  /**
   * Used to resolve the
   * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
   * of values.
   */
  var nativeObjectToString = objectProto.toString;

  /** Built-in value references. */
  var symToStringTag = _Symbol ? _Symbol.toStringTag : undefined;

  /**
   * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
   *
   * @private
   * @param {*} value The value to query.
   * @returns {string} Returns the raw `toStringTag`.
   */
  function getRawTag(value) {
    var isOwn = hasOwnProperty$1.call(value, symToStringTag),
        tag = value[symToStringTag];

    try {
      value[symToStringTag] = undefined;
      var unmasked = true;
    } catch (e) {}

    var result = nativeObjectToString.call(value);
    if (unmasked) {
      if (isOwn) {
        value[symToStringTag] = tag;
      } else {
        delete value[symToStringTag];
      }
    }
    return result;
  }

  var _getRawTag = getRawTag;

  /** Used for built-in method references. */
  var objectProto$1 = Object.prototype;

  /**
   * Used to resolve the
   * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
   * of values.
   */
  var nativeObjectToString$1 = objectProto$1.toString;

  /**
   * Converts `value` to a string using `Object.prototype.toString`.
   *
   * @private
   * @param {*} value The value to convert.
   * @returns {string} Returns the converted string.
   */
  function objectToString(value) {
    return nativeObjectToString$1.call(value);
  }

  var _objectToString = objectToString;

  /** `Object#toString` result references. */
  var nullTag = '[object Null]',
      undefinedTag = '[object Undefined]';

  /** Built-in value references. */
  var symToStringTag$1 = _Symbol ? _Symbol.toStringTag : undefined;

  /**
   * The base implementation of `getTag` without fallbacks for buggy environments.
   *
   * @private
   * @param {*} value The value to query.
   * @returns {string} Returns the `toStringTag`.
   */
  function baseGetTag(value) {
    if (value == null) {
      return value === undefined ? undefinedTag : nullTag;
    }
    return (symToStringTag$1 && symToStringTag$1 in Object(value))
      ? _getRawTag(value)
      : _objectToString(value);
  }

  var _baseGetTag = baseGetTag;

  /**
   * Checks if `value` is object-like. A value is object-like if it's not `null`
   * and has a `typeof` result of "object".
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
   * @example
   *
   * _.isObjectLike({});
   * // => true
   *
   * _.isObjectLike([1, 2, 3]);
   * // => true
   *
   * _.isObjectLike(_.noop);
   * // => false
   *
   * _.isObjectLike(null);
   * // => false
   */
  function isObjectLike(value) {
    return value != null && typeof value == 'object';
  }

  var isObjectLike_1 = isObjectLike;

  /** `Object#toString` result references. */
  var argsTag = '[object Arguments]';

  /**
   * The base implementation of `_.isArguments`.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an `arguments` object,
   */
  function baseIsArguments(value) {
    return isObjectLike_1(value) && _baseGetTag(value) == argsTag;
  }

  var _baseIsArguments = baseIsArguments;

  /** Used for built-in method references. */
  var objectProto$2 = Object.prototype;

  /** Used to check objects for own properties. */
  var hasOwnProperty$2 = objectProto$2.hasOwnProperty;

  /** Built-in value references. */
  var propertyIsEnumerable = objectProto$2.propertyIsEnumerable;

  /**
   * Checks if `value` is likely an `arguments` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an `arguments` object,
   *  else `false`.
   * @example
   *
   * _.isArguments(function() { return arguments; }());
   * // => true
   *
   * _.isArguments([1, 2, 3]);
   * // => false
   */
  var isArguments = _baseIsArguments(function() { return arguments; }()) ? _baseIsArguments : function(value) {
    return isObjectLike_1(value) && hasOwnProperty$2.call(value, 'callee') &&
      !propertyIsEnumerable.call(value, 'callee');
  };

  var isArguments_1 = isArguments;

  /**
   * Checks if `value` is classified as an `Array` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an array, else `false`.
   * @example
   *
   * _.isArray([1, 2, 3]);
   * // => true
   *
   * _.isArray(document.body.children);
   * // => false
   *
   * _.isArray('abc');
   * // => false
   *
   * _.isArray(_.noop);
   * // => false
   */
  var isArray = Array.isArray;

  var isArray_1 = isArray;

  /**
   * This method returns `false`.
   *
   * @static
   * @memberOf _
   * @since 4.13.0
   * @category Util
   * @returns {boolean} Returns `false`.
   * @example
   *
   * _.times(2, _.stubFalse);
   * // => [false, false]
   */
  function stubFalse() {
    return false;
  }

  var stubFalse_1 = stubFalse;

  var isBuffer_1 = createCommonjsModule(function (module, exports) {
  /** Detect free variable `exports`. */
  var freeExports =  exports && !exports.nodeType && exports;

  /** Detect free variable `module`. */
  var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

  /** Detect the popular CommonJS extension `module.exports`. */
  var moduleExports = freeModule && freeModule.exports === freeExports;

  /** Built-in value references. */
  var Buffer = moduleExports ? _root.Buffer : undefined;

  /* Built-in method references for those with the same name as other `lodash` methods. */
  var nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined;

  /**
   * Checks if `value` is a buffer.
   *
   * @static
   * @memberOf _
   * @since 4.3.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
   * @example
   *
   * _.isBuffer(new Buffer(2));
   * // => true
   *
   * _.isBuffer(new Uint8Array(2));
   * // => false
   */
  var isBuffer = nativeIsBuffer || stubFalse_1;

  module.exports = isBuffer;
  });

  /** Used as references for various `Number` constants. */
  var MAX_SAFE_INTEGER = 9007199254740991;

  /** Used to detect unsigned integer values. */
  var reIsUint = /^(?:0|[1-9]\d*)$/;

  /**
   * Checks if `value` is a valid array-like index.
   *
   * @private
   * @param {*} value The value to check.
   * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
   * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
   */
  function isIndex(value, length) {
    var type = typeof value;
    length = length == null ? MAX_SAFE_INTEGER : length;

    return !!length &&
      (type == 'number' ||
        (type != 'symbol' && reIsUint.test(value))) &&
          (value > -1 && value % 1 == 0 && value < length);
  }

  var _isIndex = isIndex;

  /** Used as references for various `Number` constants. */
  var MAX_SAFE_INTEGER$1 = 9007199254740991;

  /**
   * Checks if `value` is a valid array-like length.
   *
   * **Note:** This method is loosely based on
   * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
   * @example
   *
   * _.isLength(3);
   * // => true
   *
   * _.isLength(Number.MIN_VALUE);
   * // => false
   *
   * _.isLength(Infinity);
   * // => false
   *
   * _.isLength('3');
   * // => false
   */
  function isLength(value) {
    return typeof value == 'number' &&
      value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER$1;
  }

  var isLength_1 = isLength;

  /** `Object#toString` result references. */
  var argsTag$1 = '[object Arguments]',
      arrayTag = '[object Array]',
      boolTag = '[object Boolean]',
      dateTag = '[object Date]',
      errorTag = '[object Error]',
      funcTag = '[object Function]',
      mapTag = '[object Map]',
      numberTag = '[object Number]',
      objectTag = '[object Object]',
      regexpTag = '[object RegExp]',
      setTag = '[object Set]',
      stringTag = '[object String]',
      weakMapTag = '[object WeakMap]';

  var arrayBufferTag = '[object ArrayBuffer]',
      dataViewTag = '[object DataView]',
      float32Tag = '[object Float32Array]',
      float64Tag = '[object Float64Array]',
      int8Tag = '[object Int8Array]',
      int16Tag = '[object Int16Array]',
      int32Tag = '[object Int32Array]',
      uint8Tag = '[object Uint8Array]',
      uint8ClampedTag = '[object Uint8ClampedArray]',
      uint16Tag = '[object Uint16Array]',
      uint32Tag = '[object Uint32Array]';

  /** Used to identify `toStringTag` values of typed arrays. */
  var typedArrayTags = {};
  typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
  typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
  typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
  typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
  typedArrayTags[uint32Tag] = true;
  typedArrayTags[argsTag$1] = typedArrayTags[arrayTag] =
  typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
  typedArrayTags[dataViewTag] = typedArrayTags[dateTag] =
  typedArrayTags[errorTag] = typedArrayTags[funcTag] =
  typedArrayTags[mapTag] = typedArrayTags[numberTag] =
  typedArrayTags[objectTag] = typedArrayTags[regexpTag] =
  typedArrayTags[setTag] = typedArrayTags[stringTag] =
  typedArrayTags[weakMapTag] = false;

  /**
   * The base implementation of `_.isTypedArray` without Node.js optimizations.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
   */
  function baseIsTypedArray(value) {
    return isObjectLike_1(value) &&
      isLength_1(value.length) && !!typedArrayTags[_baseGetTag(value)];
  }

  var _baseIsTypedArray = baseIsTypedArray;

  /**
   * The base implementation of `_.unary` without support for storing metadata.
   *
   * @private
   * @param {Function} func The function to cap arguments for.
   * @returns {Function} Returns the new capped function.
   */
  function baseUnary(func) {
    return function(value) {
      return func(value);
    };
  }

  var _baseUnary = baseUnary;

  var _nodeUtil = createCommonjsModule(function (module, exports) {
  /** Detect free variable `exports`. */
  var freeExports =  exports && !exports.nodeType && exports;

  /** Detect free variable `module`. */
  var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

  /** Detect the popular CommonJS extension `module.exports`. */
  var moduleExports = freeModule && freeModule.exports === freeExports;

  /** Detect free variable `process` from Node.js. */
  var freeProcess = moduleExports && _freeGlobal.process;

  /** Used to access faster Node.js helpers. */
  var nodeUtil = (function() {
    try {
      // Use `util.types` for Node.js 10+.
      var types = freeModule && freeModule.require && freeModule.require('util').types;

      if (types) {
        return types;
      }

      // Legacy `process.binding('util')` for Node.js < 10.
      return freeProcess && freeProcess.binding && freeProcess.binding('util');
    } catch (e) {}
  }());

  module.exports = nodeUtil;
  });

  /* Node.js helper references. */
  var nodeIsTypedArray = _nodeUtil && _nodeUtil.isTypedArray;

  /**
   * Checks if `value` is classified as a typed array.
   *
   * @static
   * @memberOf _
   * @since 3.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
   * @example
   *
   * _.isTypedArray(new Uint8Array);
   * // => true
   *
   * _.isTypedArray([]);
   * // => false
   */
  var isTypedArray = nodeIsTypedArray ? _baseUnary(nodeIsTypedArray) : _baseIsTypedArray;

  var isTypedArray_1 = isTypedArray;

  /** Used for built-in method references. */
  var objectProto$3 = Object.prototype;

  /** Used to check objects for own properties. */
  var hasOwnProperty$3 = objectProto$3.hasOwnProperty;

  /**
   * Creates an array of the enumerable property names of the array-like `value`.
   *
   * @private
   * @param {*} value The value to query.
   * @param {boolean} inherited Specify returning inherited property names.
   * @returns {Array} Returns the array of property names.
   */
  function arrayLikeKeys(value, inherited) {
    var isArr = isArray_1(value),
        isArg = !isArr && isArguments_1(value),
        isBuff = !isArr && !isArg && isBuffer_1(value),
        isType = !isArr && !isArg && !isBuff && isTypedArray_1(value),
        skipIndexes = isArr || isArg || isBuff || isType,
        result = skipIndexes ? _baseTimes(value.length, String) : [],
        length = result.length;

    for (var key in value) {
      if ((inherited || hasOwnProperty$3.call(value, key)) &&
          !(skipIndexes && (
             // Safari 9 has enumerable `arguments.length` in strict mode.
             key == 'length' ||
             // Node.js 0.10 has enumerable non-index properties on buffers.
             (isBuff && (key == 'offset' || key == 'parent')) ||
             // PhantomJS 2 has enumerable non-index properties on typed arrays.
             (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
             // Skip index properties.
             _isIndex(key, length)
          ))) {
        result.push(key);
      }
    }
    return result;
  }

  var _arrayLikeKeys = arrayLikeKeys;

  /** Used for built-in method references. */
  var objectProto$4 = Object.prototype;

  /**
   * Checks if `value` is likely a prototype object.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
   */
  function isPrototype(value) {
    var Ctor = value && value.constructor,
        proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto$4;

    return value === proto;
  }

  var _isPrototype = isPrototype;

  /**
   * Creates a unary function that invokes `func` with its argument transformed.
   *
   * @private
   * @param {Function} func The function to wrap.
   * @param {Function} transform The argument transform.
   * @returns {Function} Returns the new function.
   */
  function overArg(func, transform) {
    return function(arg) {
      return func(transform(arg));
    };
  }

  var _overArg = overArg;

  /* Built-in method references for those with the same name as other `lodash` methods. */
  var nativeKeys = _overArg(Object.keys, Object);

  var _nativeKeys = nativeKeys;

  /** Used for built-in method references. */
  var objectProto$5 = Object.prototype;

  /** Used to check objects for own properties. */
  var hasOwnProperty$4 = objectProto$5.hasOwnProperty;

  /**
   * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   */
  function baseKeys(object) {
    if (!_isPrototype(object)) {
      return _nativeKeys(object);
    }
    var result = [];
    for (var key in Object(object)) {
      if (hasOwnProperty$4.call(object, key) && key != 'constructor') {
        result.push(key);
      }
    }
    return result;
  }

  var _baseKeys = baseKeys;

  /**
   * Checks if `value` is the
   * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
   * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an object, else `false`.
   * @example
   *
   * _.isObject({});
   * // => true
   *
   * _.isObject([1, 2, 3]);
   * // => true
   *
   * _.isObject(_.noop);
   * // => true
   *
   * _.isObject(null);
   * // => false
   */
  function isObject$1(value) {
    var type = typeof value;
    return value != null && (type == 'object' || type == 'function');
  }

  var isObject_1$1 = isObject$1;

  /** `Object#toString` result references. */
  var asyncTag = '[object AsyncFunction]',
      funcTag$1 = '[object Function]',
      genTag = '[object GeneratorFunction]',
      proxyTag = '[object Proxy]';

  /**
   * Checks if `value` is classified as a `Function` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a function, else `false`.
   * @example
   *
   * _.isFunction(_);
   * // => true
   *
   * _.isFunction(/abc/);
   * // => false
   */
  function isFunction(value) {
    if (!isObject_1$1(value)) {
      return false;
    }
    // The use of `Object#toString` avoids issues with the `typeof` operator
    // in Safari 9 which returns 'object' for typed arrays and other constructors.
    var tag = _baseGetTag(value);
    return tag == funcTag$1 || tag == genTag || tag == asyncTag || tag == proxyTag;
  }

  var isFunction_1 = isFunction;

  /**
   * Checks if `value` is array-like. A value is considered array-like if it's
   * not a function and has a `value.length` that's an integer greater than or
   * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
   * @example
   *
   * _.isArrayLike([1, 2, 3]);
   * // => true
   *
   * _.isArrayLike(document.body.children);
   * // => true
   *
   * _.isArrayLike('abc');
   * // => true
   *
   * _.isArrayLike(_.noop);
   * // => false
   */
  function isArrayLike(value) {
    return value != null && isLength_1(value.length) && !isFunction_1(value);
  }

  var isArrayLike_1 = isArrayLike;

  /**
   * Creates an array of the own enumerable property names of `object`.
   *
   * **Note:** Non-object values are coerced to objects. See the
   * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
   * for more details.
   *
   * @static
   * @since 0.1.0
   * @memberOf _
   * @category Object
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   * @example
   *
   * function Foo() {
   *   this.a = 1;
   *   this.b = 2;
   * }
   *
   * Foo.prototype.c = 3;
   *
   * _.keys(new Foo);
   * // => ['a', 'b'] (iteration order is not guaranteed)
   *
   * _.keys('hi');
   * // => ['0', '1']
   */
  function keys(object) {
    return isArrayLike_1(object) ? _arrayLikeKeys(object) : _baseKeys(object);
  }

  var keys_1 = keys;

  /**
   * Creates an array of the own enumerable string keyed property values of `object`.
   *
   * **Note:** Non-object values are coerced to objects.
   *
   * @static
   * @since 0.1.0
   * @memberOf _
   * @category Object
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property values.
   * @example
   *
   * function Foo() {
   *   this.a = 1;
   *   this.b = 2;
   * }
   *
   * Foo.prototype.c = 3;
   *
   * _.values(new Foo);
   * // => [1, 2] (iteration order is not guaranteed)
   *
   * _.values('hi');
   * // => ['h', 'i']
   */
  function values(object) {
    return object == null ? [] : _baseValues(object, keys_1(object));
  }

  var values_1 = values;

  /**
   * The base implementation of `_.shuffle`.
   *
   * @private
   * @param {Array|Object} collection The collection to shuffle.
   * @returns {Array} Returns the new shuffled array.
   */
  function baseShuffle(collection) {
    return _shuffleSelf(values_1(collection));
  }

  var _baseShuffle = baseShuffle;

  /**
   * Creates an array of shuffled values, using a version of the
   * [Fisher-Yates shuffle](https://en.wikipedia.org/wiki/Fisher-Yates_shuffle).
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Collection
   * @param {Array|Object} collection The collection to shuffle.
   * @returns {Array} Returns the new shuffled array.
   * @example
   *
   * _.shuffle([1, 2, 3, 4]);
   * // => [4, 1, 3, 2]
   */
  function shuffle(collection) {
    var func = isArray_1(collection) ? _arrayShuffle : _baseShuffle;
    return func(collection);
  }

  var shuffle_1 = shuffle;

  var stateMachine = createCommonjsModule(function (module, exports) {
  /*

    Javascript State Machine Library - https://github.com/jakesgordon/javascript-state-machine

    Copyright (c) 2012, 2013, 2014, 2015, Jake Gordon and contributors
    Released under the MIT license - https://github.com/jakesgordon/javascript-state-machine/blob/master/LICENSE

  */

  (function () {

    var StateMachine = {

      //---------------------------------------------------------------------------

      VERSION: "2.4.0",

      //---------------------------------------------------------------------------

      Result: {
        SUCCEEDED:    1, // the event transitioned successfully from one state to another
        NOTRANSITION: 2, // the event was successfull but no state transition was necessary
        CANCELLED:    3, // the event was cancelled by the caller in a beforeEvent callback
        PENDING:      4  // the event is asynchronous and the caller is in control of when the transition occurs
      },

      Error: {
        INVALID_TRANSITION: 100, // caller tried to fire an event that was innapropriate in the current state
        PENDING_TRANSITION: 200, // caller tried to fire an event while an async transition was still pending
        INVALID_CALLBACK:   300 // caller provided callback function threw an exception
      },

      WILDCARD: '*',
      ASYNC: 'async',

      //---------------------------------------------------------------------------

      create: function(cfg, target) {

        var initial      = (typeof cfg.initial == 'string') ? { state: cfg.initial } : cfg.initial; // allow for a simple string, or an object with { state: 'foo', event: 'setup', defer: true|false }
        var terminal     = cfg.terminal || cfg['final'];
        var fsm          = target || cfg.target  || {};
        var events       = cfg.events || [];
        var callbacks    = cfg.callbacks || {};
        var map          = {}; // track state transitions allowed for an event { event: { from: [ to ] } }
        var transitions  = {}; // track events allowed from a state            { state: [ event ] }

        var add = function(e) {
          var from = Array.isArray(e.from) ? e.from : (e.from ? [e.from] : [StateMachine.WILDCARD]); // allow 'wildcard' transition if 'from' is not specified
          map[e.name] = map[e.name] || {};
          for (var n = 0 ; n < from.length ; n++) {
            transitions[from[n]] = transitions[from[n]] || [];
            transitions[from[n]].push(e.name);

            map[e.name][from[n]] = e.to || from[n]; // allow no-op transition if 'to' is not specified
          }
          if (e.to)
            transitions[e.to] = transitions[e.to] || [];
        };

        if (initial) {
          initial.event = initial.event || 'startup';
          add({ name: initial.event, from: 'none', to: initial.state });
        }

        for(var n = 0 ; n < events.length ; n++)
          add(events[n]);

        for(var name in map) {
          if (map.hasOwnProperty(name))
            fsm[name] = StateMachine.buildEvent(name, map[name]);
        }

        for(var name in callbacks) {
          if (callbacks.hasOwnProperty(name))
            fsm[name] = callbacks[name];
        }

        fsm.current     = 'none';
        fsm.is          = function(state) { return Array.isArray(state) ? (state.indexOf(this.current) >= 0) : (this.current === state); };
        fsm.can         = function(event) { return !this.transition && (map[event] !== undefined) && (map[event].hasOwnProperty(this.current) || map[event].hasOwnProperty(StateMachine.WILDCARD)); };
        fsm.cannot      = function(event) { return !this.can(event); };
        fsm.transitions = function()      { return (transitions[this.current] || []).concat(transitions[StateMachine.WILDCARD] || []); };
        fsm.isFinished  = function()      { return this.is(terminal); };
        fsm.error       = cfg.error || function(name, from, to, args, error, msg, e) { throw e || msg; }; // default behavior when something unexpected happens is to throw an exception, but caller can override this behavior if desired (see github issue #3 and #17)
        fsm.states      = function() { return Object.keys(transitions).sort() };

        if (initial && !initial.defer)
          fsm[initial.event]();

        return fsm;

      },

      //===========================================================================

      doCallback: function(fsm, func, name, from, to, args) {
        if (func) {
          try {
            return func.apply(fsm, [name, from, to].concat(args));
          }
          catch(e) {
            return fsm.error(name, from, to, args, StateMachine.Error.INVALID_CALLBACK, "an exception occurred in a caller-provided callback function", e);
          }
        }
      },

      beforeAnyEvent:  function(fsm, name, from, to, args) { return StateMachine.doCallback(fsm, fsm['onbeforeevent'],                       name, from, to, args); },
      afterAnyEvent:   function(fsm, name, from, to, args) { return StateMachine.doCallback(fsm, fsm['onafterevent'] || fsm['onevent'],      name, from, to, args); },
      leaveAnyState:   function(fsm, name, from, to, args) { return StateMachine.doCallback(fsm, fsm['onleavestate'],                        name, from, to, args); },
      enterAnyState:   function(fsm, name, from, to, args) { return StateMachine.doCallback(fsm, fsm['onenterstate'] || fsm['onstate'],      name, from, to, args); },
      changeState:     function(fsm, name, from, to, args) { return StateMachine.doCallback(fsm, fsm['onchangestate'],                       name, from, to, args); },

      beforeThisEvent: function(fsm, name, from, to, args) { return StateMachine.doCallback(fsm, fsm['onbefore' + name],                     name, from, to, args); },
      afterThisEvent:  function(fsm, name, from, to, args) { return StateMachine.doCallback(fsm, fsm['onafter'  + name] || fsm['on' + name], name, from, to, args); },
      leaveThisState:  function(fsm, name, from, to, args) { return StateMachine.doCallback(fsm, fsm['onleave'  + from],                     name, from, to, args); },
      enterThisState:  function(fsm, name, from, to, args) { return StateMachine.doCallback(fsm, fsm['onenter'  + to]   || fsm['on' + to],   name, from, to, args); },

      beforeEvent: function(fsm, name, from, to, args) {
        if ((false === StateMachine.beforeThisEvent(fsm, name, from, to, args)) ||
            (false === StateMachine.beforeAnyEvent( fsm, name, from, to, args)))
          return false;
      },

      afterEvent: function(fsm, name, from, to, args) {
        StateMachine.afterThisEvent(fsm, name, from, to, args);
        StateMachine.afterAnyEvent( fsm, name, from, to, args);
      },

      leaveState: function(fsm, name, from, to, args) {
        var specific = StateMachine.leaveThisState(fsm, name, from, to, args),
            general  = StateMachine.leaveAnyState( fsm, name, from, to, args);
        if ((false === specific) || (false === general))
          return false;
        else if ((StateMachine.ASYNC === specific) || (StateMachine.ASYNC === general))
          return StateMachine.ASYNC;
      },

      enterState: function(fsm, name, from, to, args) {
        StateMachine.enterThisState(fsm, name, from, to, args);
        StateMachine.enterAnyState( fsm, name, from, to, args);
      },

      //===========================================================================

      buildEvent: function(name, map) {
        return function() {

          var from  = this.current;
          var to    = map[from] || (map[StateMachine.WILDCARD] != StateMachine.WILDCARD ? map[StateMachine.WILDCARD] : from) || from;
          var args  = Array.prototype.slice.call(arguments); // turn arguments into pure array

          if (this.transition)
            return this.error(name, from, to, args, StateMachine.Error.PENDING_TRANSITION, "event " + name + " inappropriate because previous transition did not complete");

          if (this.cannot(name))
            return this.error(name, from, to, args, StateMachine.Error.INVALID_TRANSITION, "event " + name + " inappropriate in current state " + this.current);

          if (false === StateMachine.beforeEvent(this, name, from, to, args))
            return StateMachine.Result.CANCELLED;

          if (from === to) {
            StateMachine.afterEvent(this, name, from, to, args);
            return StateMachine.Result.NOTRANSITION;
          }

          // prepare a transition method for use EITHER lower down, or by caller if they want an async transition (indicated by an ASYNC return value from leaveState)
          var fsm = this;
          this.transition = function() {
            fsm.transition = null; // this method should only ever be called once
            fsm.current = to;
            StateMachine.enterState( fsm, name, from, to, args);
            StateMachine.changeState(fsm, name, from, to, args);
            StateMachine.afterEvent( fsm, name, from, to, args);
            return StateMachine.Result.SUCCEEDED;
          };
          this.transition.cancel = function() { // provide a way for caller to cancel async transition if desired (issue #22)
            fsm.transition = null;
            StateMachine.afterEvent(fsm, name, from, to, args);
          };

          var leave = StateMachine.leaveState(this, name, from, to, args);
          if (false === leave) {
            this.transition = null;
            return StateMachine.Result.CANCELLED;
          }
          else if (StateMachine.ASYNC === leave) {
            return StateMachine.Result.PENDING;
          }
          else {
            if (this.transition) // need to check in case user manually called transition() but forgot to return StateMachine.ASYNC
              return this.transition();
          }

        };
      }

    }; // StateMachine

    //===========================================================================

    //======
    // NODE
    //======
    {
      if ( module.exports) {
        exports = module.exports = StateMachine;
      }
      exports.StateMachine = StateMachine;
    }

  }());
  });
  var stateMachine_1 = stateMachine.StateMachine;

  /** Built-in value references. */
  var getPrototype = _overArg(Object.getPrototypeOf, Object);

  var _getPrototype = getPrototype;

  /** `Object#toString` result references. */
  var objectTag$1 = '[object Object]';

  /** Used for built-in method references. */
  var funcProto = Function.prototype,
      objectProto$6 = Object.prototype;

  /** Used to resolve the decompiled source of functions. */
  var funcToString = funcProto.toString;

  /** Used to check objects for own properties. */
  var hasOwnProperty$5 = objectProto$6.hasOwnProperty;

  /** Used to infer the `Object` constructor. */
  var objectCtorString = funcToString.call(Object);

  /**
   * Checks if `value` is a plain object, that is, an object created by the
   * `Object` constructor or one with a `[[Prototype]]` of `null`.
   *
   * @static
   * @memberOf _
   * @since 0.8.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a plain object, else `false`.
   * @example
   *
   * function Foo() {
   *   this.a = 1;
   * }
   *
   * _.isPlainObject(new Foo);
   * // => false
   *
   * _.isPlainObject([1, 2, 3]);
   * // => false
   *
   * _.isPlainObject({ 'x': 0, 'y': 0 });
   * // => true
   *
   * _.isPlainObject(Object.create(null));
   * // => true
   */
  function isPlainObject(value) {
    if (!isObjectLike_1(value) || _baseGetTag(value) != objectTag$1) {
      return false;
    }
    var proto = _getPrototype(value);
    if (proto === null) {
      return true;
    }
    var Ctor = hasOwnProperty$5.call(proto, 'constructor') && proto.constructor;
    return typeof Ctor == 'function' && Ctor instanceof Ctor &&
      funcToString.call(Ctor) == objectCtorString;
  }

  var isPlainObject_1 = isPlainObject;

  /* eslint-disable */
  var global$1 = typeof global !== 'undefined' ? global : typeof window !== 'undefined' ? window : {};

  var EXPIRED = Symbol('expired');
  var debug = browser('LC:Expirable');

  var Expirable =
  /*#__PURE__*/
  function () {
    function Expirable(value, ttl) {
      this.originalValue = value;

      if (typeof ttl === 'number') {
        this.expiredAt = Date.now() + ttl;
      }
    }

    _createClass(Expirable, [{
      key: "value",
      get: function get() {
        var expired = this.expiredAt && this.expiredAt <= Date.now();
        if (expired) debug("expired: ".concat(this.originalValue));
        return expired ? EXPIRED : this.originalValue;
      }
    }]);

    return Expirable;
  }();
  Expirable.EXPIRED = EXPIRED;

  var debug$1 = browser('LC:Cache');

  var Cache =
  /*#__PURE__*/
  function () {
    function Cache() {
      var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'anonymous';
      this.name = name;
      this._map = {};
    }

    var _proto = Cache.prototype;

    _proto.get = function get(key) {
      var cache = this._map[key];

      if (cache) {
        var value = cache.value;

        if (value !== Expirable.EXPIRED) {
          debug$1('[%s] hit: %s', this.name, key);
          return value;
        }

        delete this._map[key];
      }

      debug$1("[".concat(this.name, "] missed: ").concat(key));
      return null;
    };

    _proto.set = function set(key, value, ttl) {
      debug$1('[%s] set: %s %d', this.name, key, ttl);
      this._map[key] = new Expirable(value, ttl);
    };

    return Cache;
  }();

  var debug$2 = {
    enable: function enable() {
      var namespaces = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'LC*';
      return browser.enable(namespaces);
    },
    disable: browser.disable
  };
  var tryAll = function tryAll(promiseConstructors) {
    var promise = new Promise(promiseConstructors[0]);

    if (promiseConstructors.length === 1) {
      return promise;
    }

    return promise["catch"](function () {
      return tryAll(promiseConstructors.slice(1));
    });
  }; // eslint-disable-next-line no-sequences

  var tap = function tap(interceptor) {
    return function (value) {
      return interceptor(value), value;
    };
  };
  var isIE10 = global$1.navigator && global$1.navigator.userAgent && global$1.navigator.userAgent.indexOf('MSIE 10.') !== -1;
  var map = new WeakMap(); // protected property helper

  var internal = function internal(object) {
    if (!map.has(object)) {
      map.set(object, {});
    }

    return map.get(object);
  };
  var compact = function compact(obj, filter) {
    if (!isPlainObject_1(obj)) return obj;

    var object = _objectSpread2({}, obj);

    Object.keys(object).forEach(function (prop) {
      var value = object[prop];

      if (value === filter) {
        delete object[prop];
      } else {
        object[prop] = compact(value, filter);
      }
    });
    return object;
  }; // debug utility

  var removeNull = function removeNull(obj) {
    return compact(obj, null);
  };

  var trim = function trim(message) {
    return removeNull(JSON.parse(JSON.stringify(message)));
  };
  var ensureArray = function ensureArray(target) {
    if (Array.isArray(target)) {
      return target;
    }

    if (target === undefined || target === null) {
      return [];
    }

    return [target];
  };
  var isWeapp = // eslint-disable-next-line no-undef
  (typeof wx === "undefined" ? "undefined" : _typeof(wx)) === 'object' && typeof wx.connectSocket === 'function'; // throttle decorator
  var isCNApp = function isCNApp(appId) {
    return appId.slice(-9) !== '-MdYXbMMI';
  };

  var _class;
  var debug$3 = browser('LC:WebSocketPlus');
  var OPEN$1 = 'open';
  var DISCONNECT = 'disconnect';
  var RECONNECT = 'reconnect';
  var RETRY = 'retry';
  var SCHEDULE = 'schedule';
  var OFFLINE = 'offline';
  var ONLINE = 'online';
  var ERROR = 'error';
  var MESSAGE = 'message';
  var HEARTBEAT_TIME = 180000;
  var TIMEOUT_TIME = 380000;

  var DEFAULT_RETRY_STRATEGY = function DEFAULT_RETRY_STRATEGY(attempt) {
    return Math.min(1000 * Math.pow(2, attempt), 300000);
  };

  var requireConnected = function requireConnected(target, name, descriptor) {
    return _objectSpread2({}, descriptor, {
      value: function requireConnectedWrapper() {
        var _descriptor$value;

        this.checkConnectionAvailability(name);

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return (_descriptor$value = descriptor.value).call.apply(_descriptor$value, [this].concat(args));
      }
    });
  };

  var WebSocketPlus = (_class =
  /*#__PURE__*/
  function (_EventEmitter) {
    _inheritsLoose(WebSocketPlus, _EventEmitter);

    _createClass(WebSocketPlus, [{
      key: "urls",
      get: function get() {
        return this._urls;
      },
      set: function set(urls) {
        this._urls = ensureArray(urls);
      }
    }]);

    function WebSocketPlus(getUrls, protocol) {
      var _this;

      if (typeof websocket === 'undefined') {
        throw new Error('WebSocket is undefined. Polyfill is required in this runtime.');
      }

      _this = _EventEmitter.call(this) || this;

      _this.init();

      _this._protocol = protocol;
      Promise.resolve(typeof getUrls === 'function' ? getUrls() : getUrls).then(ensureArray).then(function (urls) {
        _this._urls = urls;
        return _this._open();
      }).then(function () {
        _this.__postponeTimeoutTimer = _this._postponeTimeoutTimer.bind(_assertThisInitialized(_this));

        if (global$1.addEventListener) {
          _this.__pause = function () {
            if (_this.can('pause')) _this.pause();
          };

          _this.__resume = function () {
            if (_this.can('resume')) _this.resume();
          };

          global$1.addEventListener('offline', _this.__pause);
          global$1.addEventListener('online', _this.__resume);
        }

        _this.open();
      })["catch"](_this["throw"].bind(_assertThisInitialized(_this)));
      return _this;
    }

    var _proto = WebSocketPlus.prototype;

    _proto._open = function _open() {
      var _this2 = this;

      return this._createWs(this._urls, this._protocol).then(function (ws) {
        var _this2$_urls = _toArray(_this2._urls),
            first = _this2$_urls[0],
            reset = _this2$_urls.slice(1);

        _this2._urls = [].concat(_toConsumableArray(reset), [first]);
        return ws;
      });
    };

    _proto._createWs = function _createWs(urls, protocol) {
      var _this3 = this;

      return tryAll(urls.map(function (url) {
        return function (resolve, reject) {
          debug$3("connect [".concat(url, "] ").concat(protocol));
          var ws = protocol ? new websocket(url, protocol) : new websocket(url);
          ws.binaryType = _this3.binaryType || 'arraybuffer';

          ws.onopen = function () {
            return resolve(ws);
          };

          ws.onclose = function (error) {
            if (error instanceof Error) {
              return reject(error);
            } // in browser, error event is useless


            return reject(new Error("Failed to connect [".concat(url, "]")));
          };

          ws.onerror = ws.onclose;
        };
      })).then(function (ws) {
        _this3._ws = ws;
        _this3._ws.onclose = _this3._handleClose.bind(_this3);
        _this3._ws.onmessage = _this3._handleMessage.bind(_this3);
        return ws;
      });
    };

    _proto._destroyWs = function _destroyWs() {
      var ws = this._ws;
      if (!ws) return;
      ws.onopen = null;
      ws.onclose = null;
      ws.onerror = null;
      ws.onmessage = null;
      this._ws = null;
      ws.close();
    } // eslint-disable-next-line class-methods-use-this
    ;

    _proto.onbeforeevent = function onbeforeevent(event, from, to) {
      for (var _len2 = arguments.length, payload = new Array(_len2 > 3 ? _len2 - 3 : 0), _key2 = 3; _key2 < _len2; _key2++) {
        payload[_key2 - 3] = arguments[_key2];
      }

      debug$3("".concat(event, ": ").concat(from, " -> ").concat(to, " %o"), payload);
    };

    _proto.onopen = function onopen() {
      this.emit(OPEN$1);
    };

    _proto.onconnected = function onconnected() {
      this._startConnectionKeeper();
    };

    _proto.onleaveconnected = function onleaveconnected(event, from, to) {
      this._stopConnectionKeeper();

      this._destroyWs();

      if (to === 'offline' || to === 'disconnected') {
        this.emit(DISCONNECT);
      }
    };

    _proto.onpause = function onpause() {
      this.emit(OFFLINE);
    };

    _proto.onbeforeresume = function onbeforeresume() {
      this.emit(ONLINE);
    };

    _proto.onreconnect = function onreconnect() {
      this.emit(RECONNECT);
    };

    _proto.ondisconnected = function ondisconnected(event, from, to) {
      var _this4 = this;

      var attempt = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
      var delay = from === OFFLINE ? 0 : DEFAULT_RETRY_STRATEGY.call(null, attempt);
      debug$3("schedule attempt=".concat(attempt, " delay=").concat(delay));
      this.emit(SCHEDULE, attempt, delay);

      if (this.__scheduledRetry) {
        clearTimeout(this.__scheduledRetry);
      }

      this.__scheduledRetry = setTimeout(function () {
        if (_this4.is('disconnected')) {
          _this4.retry(attempt);
        }
      }, delay);
    };

    _proto.onretry = function onretry(event, from, to) {
      var _this5 = this;

      var attempt = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
      this.emit(RETRY, attempt);

      this._open().then(function () {
        return _this5.can('reconnect') ? _this5.reconnect() : _this5._destroyWs();
      }, function () {
        return _this5.can('fail') && _this5.fail(attempt + 1);
      });
    };

    _proto.onerror = function onerror(event, from, to, error) {
      this.emit(ERROR, error);
    };

    _proto.onclose = function onclose() {
      if (global$1.removeEventListener) {
        if (this.__pause) global$1.removeEventListener('offline', this.__pause);
        if (this.__resume) global$1.removeEventListener('online', this.__resume);
      }
    };

    _proto.checkConnectionAvailability = function checkConnectionAvailability() {
      var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'API';

      if (!this.is('connected')) {
        var currentState = this.current;
        console.warn("".concat(name, " should not be called when the connection is ").concat(currentState));

        if (this.is('disconnected') || this.is('reconnecting')) {
          console.warn('disconnect and reconnect event should be handled to avoid such calls.');
        }

        throw new Error('Connection unavailable');
      }
    } // jsdoc-ignore-start
    ;

    _proto. // jsdoc-ignore-end
    _ping = function _ping() {
      debug$3('ping');

      try {
        this.ping();
      } catch (error) {
        console.warn("websocket ping error: ".concat(error.message));
      }
    };

    _proto.ping = function ping() {
      if (this._ws.ping) {
        this._ws.ping();
      } else {
        console.warn("The WebSocket implement does not support sending ping frame.\n        Override ping method to use application defined ping/pong mechanism.");
      }
    };

    _proto._postponeTimeoutTimer = function _postponeTimeoutTimer() {
      var _this6 = this;

      debug$3('_postponeTimeoutTimer');

      this._clearTimeoutTimers();

      this._timeoutTimer = setTimeout(function () {
        debug$3('timeout');

        _this6.disconnect();
      }, TIMEOUT_TIME);
    };

    _proto._clearTimeoutTimers = function _clearTimeoutTimers() {
      if (this._timeoutTimer) {
        clearTimeout(this._timeoutTimer);
      }
    };

    _proto._startConnectionKeeper = function _startConnectionKeeper() {
      debug$3('start connection keeper');
      this._heartbeatTimer = setInterval(this._ping.bind(this), HEARTBEAT_TIME);
      var addListener = this._ws.addListener || this._ws.addEventListener;

      if (!addListener) {
        debug$3('connection keeper disabled due to the lack of #addEventListener.');
        return;
      }

      addListener.call(this._ws, 'message', this.__postponeTimeoutTimer);
      addListener.call(this._ws, 'pong', this.__postponeTimeoutTimer);

      this._postponeTimeoutTimer();
    };

    _proto._stopConnectionKeeper = function _stopConnectionKeeper() {
      debug$3('stop connection keeper'); // websockets/ws#489

      var removeListener = this._ws.removeListener || this._ws.removeEventListener;

      if (removeListener) {
        removeListener.call(this._ws, 'message', this.__postponeTimeoutTimer);
        removeListener.call(this._ws, 'pong', this.__postponeTimeoutTimer);

        this._clearTimeoutTimers();
      }

      if (this._heartbeatTimer) {
        clearInterval(this._heartbeatTimer);
      }
    };

    _proto._handleClose = function _handleClose(event) {
      debug$3("ws closed [".concat(event.code, "] ").concat(event.reason)); // socket closed manually, ignore close event.

      if (this.isFinished()) return;
      this.handleClose(event);
    };

    _proto.handleClose = function handleClose() {
      // reconnect
      this.disconnect();
    } // jsdoc-ignore-start
    ;

    _proto. // jsdoc-ignore-end
    send = function send(data) {
      debug$3('send', data);

      this._ws.send(data);
    };

    _proto._handleMessage = function _handleMessage(event) {
      debug$3('message', event.data);
      this.handleMessage(event.data);
    };

    _proto.handleMessage = function handleMessage(message) {
      this.emit(MESSAGE, message);
    };

    return WebSocketPlus;
  }(eventemitter3), (_applyDecoratedDescriptor(_class.prototype, "_ping", [requireConnected], Object.getOwnPropertyDescriptor(_class.prototype, "_ping"), _class.prototype), _applyDecoratedDescriptor(_class.prototype, "send", [requireConnected], Object.getOwnPropertyDescriptor(_class.prototype, "send"), _class.prototype)), _class);
  stateMachine.create({
    target: WebSocketPlus.prototype,
    initial: {
      state: 'initialized',
      event: 'init',
      defer: true
    },
    terminal: 'closed',
    events: [{
      name: 'open',
      from: 'initialized',
      to: 'connected'
    }, {
      name: 'disconnect',
      from: 'connected',
      to: 'disconnected'
    }, {
      name: 'retry',
      from: 'disconnected',
      to: 'reconnecting'
    }, {
      name: 'fail',
      from: 'reconnecting',
      to: 'disconnected'
    }, {
      name: 'reconnect',
      from: 'reconnecting',
      to: 'connected'
    }, {
      name: 'pause',
      from: ['connected', 'disconnected', 'reconnecting'],
      to: 'offline'
    }, {}, {
      name: 'resume',
      from: 'offline',
      to: 'disconnected'
    }, {
      name: 'close',
      from: ['connected', 'disconnected', 'reconnecting', 'offline'],
      to: 'closed'
    }, {
      name: 'throw',
      from: '*',
      to: 'error'
    }]
  });

  var error = Object.freeze({
    1000: {
      name: 'CLOSE_NORMAL'
    },
    1006: {
      name: 'CLOSE_ABNORMAL'
    },
    4100: {
      name: 'APP_NOT_AVAILABLE',
      message: 'App not exists or realtime message service is disabled.'
    },
    4102: {
      name: 'SIGNATURE_FAILED',
      message: 'Login signature mismatch.'
    },
    4103: {
      name: 'INVALID_LOGIN',
      message: 'Malformed clientId.'
    },
    4105: {
      name: 'SESSION_REQUIRED',
      message: 'Message sent before session opened.'
    },
    4107: {
      name: 'READ_TIMEOUT'
    },
    4108: {
      name: 'LOGIN_TIMEOUT'
    },
    4109: {
      name: 'FRAME_TOO_LONG'
    },
    4110: {
      name: 'INVALID_ORIGIN',
      message: 'Access denied by domain whitelist.'
    },
    4111: {
      name: 'SESSION_CONFLICT'
    },
    4112: {
      name: 'SESSION_TOKEN_EXPIRED'
    },
    4113: {
      name: 'APP_QUOTA_EXCEEDED',
      message: 'The daily active users limit exceeded.'
    },
    4116: {
      name: 'MESSAGE_SENT_QUOTA_EXCEEDED',
      message: 'Command sent too fast.'
    },
    4200: {
      name: 'INTERNAL_ERROR',
      message: 'Internal error, please contact LeanCloud for support.'
    },
    4301: {
      name: 'CONVERSATION_API_FAILED',
      message: 'Upstream Conversatoin API failed, see error.detail for details.'
    },
    4302: {
      name: 'CONVERSATION_SIGNATURE_FAILED',
      message: 'Conversation action signature mismatch.'
    },
    4303: {
      name: 'CONVERSATION_NOT_FOUND'
    },
    4304: {
      name: 'CONVERSATION_FULL'
    },
    4305: {
      name: 'CONVERSATION_REJECTED_BY_APP',
      message: 'Conversation action rejected by hook.'
    },
    4306: {
      name: 'CONVERSATION_UPDATE_FAILED'
    },
    4307: {
      name: 'CONVERSATION_READ_ONLY'
    },
    4308: {
      name: 'CONVERSATION_NOT_ALLOWED'
    },
    4309: {
      name: 'CONVERSATION_UPDATE_REJECTED',
      message: 'Conversation update rejected because the client is not a member.'
    },
    4310: {
      name: 'CONVERSATION_QUERY_FAILED',
      message: 'Conversation query failed because it is too expansive.'
    },
    4311: {
      name: 'CONVERSATION_LOG_FAILED'
    },
    4312: {
      name: 'CONVERSATION_LOG_REJECTED',
      message: 'Message query rejected because the client is not a member of the conversation.'
    },
    4313: {
      name: 'SYSTEM_CONVERSATION_REQUIRED'
    },
    4314: {
      name: 'NORMAL_CONVERSATION_REQUIRED'
    },
    4315: {
      name: 'CONVERSATION_BLACKLISTED',
      message: 'Blacklisted in the conversation.'
    },
    4316: {
      name: 'TRANSIENT_CONVERSATION_REQUIRED'
    },
    4317: {
      name: 'CONVERSATION_MEMBERSHIP_REQUIRED'
    },
    4318: {
      name: 'CONVERSATION_API_QUOTA_EXCEEDED',
      message: 'LeanCloud API quota exceeded. You may upgrade your plan.'
    },
    4323: {
      name: 'TEMPORARY_CONVERSATION_EXPIRED',
      message: 'Temporary conversation expired or does not exist.'
    },
    4401: {
      name: 'INVALID_MESSAGING_TARGET',
      message: 'Conversation does not exist or client is not a member.'
    },
    4402: {
      name: 'MESSAGE_REJECTED_BY_APP',
      message: 'Message rejected by hook.'
    },
    4403: {
      name: 'MESSAGE_OWNERSHIP_REQUIRED'
    },
    4404: {
      name: 'MESSAGE_NOT_FOUND'
    },
    4405: {
      name: 'MESSAGE_UPDATE_REJECTED_BY_APP',
      message: 'Message update rejected by hook.'
    },
    4406: {
      name: 'MESSAGE_EDIT_DISABLED'
    },
    4407: {
      name: 'MESSAGE_RECALL_DISABLED'
    },
    5130: {
      name: 'OWNER_PROMOTION_NOT_ALLOWED',
      message: "Updating a member's role to owner is not allowed."
    }
  });
  var ErrorCode = Object.freeze(Object.keys(error).reduce(function (result, code) {
    return Object.assign(result, _defineProperty({}, error[code].name, Number(code)));
  }, {}));
  var createError = function createError(_ref) {
    var code = _ref.code,
        reason = _ref.reason,
        appCode = _ref.appCode,
        detail = _ref.detail,
        errorMessage = _ref.error;
    var message = reason || detail || errorMessage;
    var name = reason;

    if (!message && error[code]) {
      name = error[code].name;
      message = error[code].message || name;
    }

    if (!message) {
      message = "Unknow Error: ".concat(code);
    }

    var err = new Error(message);
    return Object.assign(err, {
      code: code,
      appCode: appCode,
      detail: detail,
      name: name
    });
  };

  var debug$4 = browser('LC:Connection');
  var COMMAND_TIMEOUT = 20000;
  var EXPIRE = Symbol('expire');

  var Connection =
  /*#__PURE__*/
  function (_WebSocketPlus) {
    _inheritsLoose(Connection, _WebSocketPlus);

    function Connection(getUrl, _ref) {
      var _this;

      var format = _ref.format,
          version = _ref.version;
      debug$4('initializing Connection');
      var protocolString = "lc.".concat(format, ".").concat(version);

      if (!isWeapp) {
        _this = _WebSocketPlus.call(this, getUrl, protocolString) || this;
      } else {
        _this = _WebSocketPlus.call(this, getUrl().then(function (urls) {
          return urls.map(function (url) {
            return "".concat(url).concat(url.indexOf('?') === -1 ? '?' : '&', "subprotocol=").concat(encodeURIComponent(protocolString));
          });
        })) || this;
      }

      _this._protocalFormat = format;
      _this._commands = {};
      _this._serialId = 0;
      return _assertThisInitialized(_this);
    }

    var _proto = Connection.prototype;

    _proto.send = function send(command) {
      var _this2 = this;

      var waitingForRespond,
          serialId,
          message,
          _args = arguments;
      return regenerator.async(function send$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              waitingForRespond = _args.length > 1 && _args[1] !== undefined ? _args[1] : true;

              if (waitingForRespond) {
                this._serialId += 1;
                serialId = this._serialId;
                command.i = serialId; // eslint-disable-line no-param-reassign
              }

              if (debug$4.enabled) debug$4('↑ %O sent', trim(command));

              if (this._protocalFormat === 'proto2base64') {
                message = command.toBase64();
              } else if (command.toArrayBuffer) {
                message = command.toArrayBuffer();
              }

              if (message) {
                _context.next = 6;
                break;
              }

              throw new TypeError("".concat(command, " is not a GenericCommand"));

            case 6:
              _WebSocketPlus.prototype.send.call(this, message);

              if (waitingForRespond) {
                _context.next = 9;
                break;
              }

              return _context.abrupt("return", undefined);

            case 9:
              return _context.abrupt("return", new Promise(function (resolve, reject) {
                _this2._commands[serialId] = {
                  resolve: resolve,
                  reject: reject,
                  timeout: setTimeout(function () {
                    if (_this2._commands[serialId]) {
                      if (debug$4.enabled) debug$4('✗ %O timeout', trim(command));
                      reject(createError({
                        error: "Command Timeout [cmd:".concat(command.cmd, " op:").concat(command.op, "]"),
                        name: 'COMMAND_TIMEOUT'
                      }));
                      delete _this2._commands[serialId];
                    }
                  }, COMMAND_TIMEOUT)
                };
              }));

            case 10:
            case "end":
              return _context.stop();
          }
        }
      }, null, this);
    };

    _proto.handleMessage = function handleMessage(msg) {
      var message;

      try {
        message = GenericCommand.decode(msg);
        if (debug$4.enabled) debug$4('↓ %O received', trim(message));
      } catch (e) {
        console.warn('Decode message failed:', e.message, msg);
        return;
      }

      var serialId = message.i;

      if (serialId) {
        if (this._commands[serialId]) {
          clearTimeout(this._commands[serialId].timeout);

          if (message.cmd === CommandType.error) {
            this._commands[serialId].reject(createError(message.errorMessage));
          } else {
            this._commands[serialId].resolve(message);
          }

          delete this._commands[serialId];
        } else {
          console.warn("Unexpected command received with serialId [".concat(serialId, "],\n         which have timed out or never been requested."));
        }
      } else {
        switch (message.cmd) {
          case CommandType.error:
            {
              this.emit(ERROR, createError(message.errorMessage));
              return;
            }

          case CommandType.goaway:
            {
              this.emit(EXPIRE);
              return;
            }

          default:
            {
              this.emit(MESSAGE, message);
            }
        }
      }
    };

    _proto.ping = function ping() {
      return this.send(new GenericCommand({
        cmd: CommandType.echo
      }))["catch"](function (error) {
        return debug$4('ping failed:', error);
      });
    };

    return Connection;
  }(WebSocketPlus);

  var applyDecorators = function applyDecorators(decorators, target) {
    if (decorators) {
      decorators.forEach(function (decorator) {
        try {
          decorator(target);
        } catch (error) {
          if (decorator._pluginName) {
            error.message += "[".concat(decorator._pluginName, "]");
          }

          throw error;
        }
      });
    }
  };
  var applyDispatcher = function applyDispatcher(dispatchers, payload) {
    return ensureArray(dispatchers).reduce(function (resultPromise, dispatcher) {
      return resultPromise.then(function (shouldDispatch) {
        return shouldDispatch === false ? false : dispatcher.apply(void 0, _toConsumableArray(payload));
      })["catch"](function (error) {
        if (dispatcher._pluginName) {
          // eslint-disable-next-line no-param-reassign
          error.message += "[".concat(dispatcher._pluginName, "]");
        }

        throw error;
      });
    }, Promise.resolve(true));
  };

  var version = "5.0.0-beta.2";

  var debug$5 = browser('LC:Realtime');
  var debugRequest = browser('LC:request');
  var routerCache = new Cache('push-router');

  var Realtime =
  /*#__PURE__*/
  function (_EventEmitter) {
    _inheritsLoose(Realtime, _EventEmitter);

    /**
     * @extends EventEmitter
     * @param  {Object} options
     * @param  {String} options.appId
     * @param  {String} options.appKey （since 4.0.0）
     * @param  {String|Object} [options.server] 指定服务器域名，中国节点应用此参数必填（since 4.0.0）
     * @param  {Boolean} [options.pushOfflineMessages=false] 启用推送离线消息模式（默认为发送未读消息通知模式）
     * @param  {Boolean} [options.noBinary=false] 设置 WebSocket 使用字符串格式收发消息（默认为二进制格式）。
     *                                            适用于 WebSocket 实现不支持二进制数据格式的情况
     * @param  {Boolean} [options.ssl=true] 使用 wss 进行连接
     * @param  {String|String[]} [options.RTMServers] 指定私有部署的 RTM 服务器地址（since 4.0.0）
     * @param  {Plugin[]} [options.plugins] 加载插件（since 3.1.0）
     */
    function Realtime(_ref) {
      var _this2;

      var plugins = _ref.plugins,
          options = _objectWithoutProperties(_ref, ["plugins"]);

      debug$5('initializing Realtime %s %O', version, options);
      _this2 = _EventEmitter.call(this) || this;

      if (typeof options.appId !== 'string') {
        throw new TypeError("appId [".concat(options.appId, "] is not a string"));
      }

      if (typeof options.appKey !== 'string') {
        throw new TypeError("appKey [".concat(options.appKey, "] is not a string"));
      }

      if (isCNApp(options.appId)) {
        if (!options.server) {
          throw new TypeError("server option is required for apps from CN region");
        }
      }

      _this2._options = _objectSpread2({
        appId: undefined,
        appKey: undefined,
        pushOfflineMessages: false,
        noBinary: false,
        ssl: true,
        RTMServerName: process.env.RTM_SERVER_NAME
      }, options);
      _this2._cache = new Cache('endpoints');

      var _this = internal(_assertThisInitialized(_this2));

      _this.clients = new Set();
      _this.pendingClients = new Set();
      var mergedPlugins = [].concat(_toConsumableArray(ensureArray(Realtime.__preRegisteredPlugins)), _toConsumableArray(ensureArray(plugins)));
      debug$5('Using plugins %o', mergedPlugins.map(function (plugin) {
        return plugin.name;
      }));
      _this2._plugins = mergedPlugins.reduce(function (result, plugin) {
        Object.keys(plugin).forEach(function (hook) {
          if ({}.hasOwnProperty.call(plugin, hook) && hook !== 'name') {
            if (plugin.name) {
              ensureArray(plugin[hook]).forEach(function (value) {
                // eslint-disable-next-line no-param-reassign
                value._pluginName = plugin.name;
              });
            } // eslint-disable-next-line no-param-reassign


            result[hook] = ensureArray(result[hook]).concat(plugin[hook]);
          }
        });
        return result;
      }, {}); // onRealtimeCreate hook

      applyDecorators(_this2._plugins.onRealtimeCreate, _assertThisInitialized(_this2));
      return _this2;
    }

    var _proto = Realtime.prototype;

    _proto._request = function _request(_ref2) {
      var method, _ref2$version, version, path, query, headers, _ref2$data, data, _this$_options, appId, server, _ref3, api, url;

      return regenerator.async(function _request$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              method = _ref2.method, _ref2$version = _ref2.version, version = _ref2$version === void 0 ? '1.1' : _ref2$version, path = _ref2.path, query = _ref2.query, headers = _ref2.headers, _ref2$data = _ref2.data, data = _ref2$data === void 0 ? {} : _ref2$data;
              _this$_options = this._options, appId = _this$_options.appId, server = _this$_options.server;
              _context.next = 4;
              return regenerator.awrap(this.constructor._getServerUrls({
                appId: appId,
                server: server
              }));

            case 4:
              _ref3 = _context.sent;
              api = _ref3.api;
              url = "".concat(api, "/").concat(version).concat(path);
              debugRequest('Req: %O %O %O', method, url, {
                query: query,
                headers: headers,
                data: data
              });
              return _context.abrupt("return", client(method, url).set(_objectSpread2({
                'X-LC-Id': this._options.appId,
                'X-LC-Key': this._options.appKey
              }, headers)).query(query).send(data).then(function (response) {
                debugRequest('Res: %O %O %O', url, response.status, response.body);
                return response.body;
              }, function (error) {
                debugRequest('Error: %O %O %O', url, error.response.status, error.response.body);

                if (error.response && error.response.body && error.response.body.code) {
                  throw createError(error.response.body);
                }

                throw error;
              }));

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, null, this);
    };

    _proto._open = function _open() {
      var _this3 = this;

      if (this._openPromise) return this._openPromise;
      var format = 'protobuf2';

      if (this._options.noBinary) {
        // 不发送 binary data，fallback to base64 string
        format = 'proto2base64';
      }

      var version = 3;

      if (this._options.pushOfflineMessages) {
        // 不推送离线消息，而是发送对话的未读通知
        version = 1;
      }

      var protocol = {
        format: format,
        version: version
      };
      this._openPromise = new Promise(function (resolve, reject) {
        debug$5('No connection established, create a new one.');
        var connection = new Connection(function () {
          return _this3._getRTMServers(_this3._options);
        }, protocol);
        connection.on(OPEN$1, function () {
          return resolve(connection);
        }).on(ERROR, reject).on(EXPIRE, function _callee() {
          return regenerator.async(function _callee$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  debug$5('Connection expired. Refresh endpoints.');

                  _this3._cache.set('endpoints', null, 0);

                  _context2.next = 4;
                  return regenerator.awrap(_this3._getRTMServers(_this3._options));

                case 4:
                  connection.urls = _context2.sent;
                  connection.disconnect();

                case 6:
                case "end":
                  return _context2.stop();
              }
            }
          });
        }).on(MESSAGE, _this3._dispatchCommand.bind(_this3));
        /**
         * 连接断开。
         * 连接断开可能是因为 SDK 进入了离线状态（see {@link Realtime#event:OFFLINE}），或长时间没有收到服务器心跳。
         * 连接断开后所有的网络操作都会失败，请在连接断开后禁用相关的 UI 元素。
         * @event Realtime#DISCONNECT
         */

        /**
         * 计划在一段时间后尝试重新连接
         * @event Realtime#SCHEDULE
         * @param {Number} attempt 尝试重连的次数
         * @param {Number} delay 延迟的毫秒数
         */

        /**
         * 正在尝试重新连接
         * @event Realtime#RETRY
         * @param {Number} attempt 尝试重连的次数
         */

        /**
         * 连接恢复正常。
         * 请重新启用在 {@link Realtime#event:DISCONNECT} 事件中禁用的相关 UI 元素
         * @event Realtime#RECONNECT
         */

        /**
         * 客户端连接断开
         * @event IMClient#DISCONNECT
         * @see Realtime#event:DISCONNECT
         * @since 3.2.0
         */

        /**
         * 计划在一段时间后尝试重新连接
         * @event IMClient#SCHEDULE
         * @param {Number} attempt 尝试重连的次数
         * @param {Number} delay 延迟的毫秒数
         * @since 3.2.0
         */

        /**
         * 正在尝试重新连接
         * @event IMClient#RETRY
         * @param {Number} attempt 尝试重连的次数
         * @since 3.2.0
         */

        /**
         * 客户端进入离线状态。
         * 这通常意味着网络已断开，或者 {@link Realtime#pause} 被调用
         * @event Realtime#OFFLINE
         * @since 3.4.0
         */

        /**
         * 客户端恢复在线状态
         * 这通常意味着网络已恢复，或者 {@link Realtime#resume} 被调用
         * @event Realtime#ONLINE
         * @since 3.4.0
         */

        /**
         * 进入离线状态。
         * 这通常意味着网络已断开，或者 {@link Realtime#pause} 被调用
         * @event IMClient#OFFLINE
         * @since 3.4.0
         */

        /**
         * 恢复在线状态
         * 这通常意味着网络已恢复，或者 {@link Realtime#resume} 被调用
         * @event IMClient#ONLINE
         * @since 3.4.0
         */
        // event proxy

        [DISCONNECT, RECONNECT, RETRY, SCHEDULE, OFFLINE, ONLINE].forEach(function (event) {
          return connection.on(event, function () {
            for (var _len = arguments.length, payload = new Array(_len), _key = 0; _key < _len; _key++) {
              payload[_key] = arguments[_key];
            }

            debug$5("".concat(event, " event emitted. %o"), payload);

            _this3.emit.apply(_this3, [event].concat(payload));

            if (event !== RECONNECT) {
              internal(_this3).clients.forEach(function (client) {
                client.emit.apply(client, [event].concat(payload));
              });
            }
          });
        }); // override handleClose

        connection.handleClose = function handleClose(event) {
          var isFatal = [ErrorCode.APP_NOT_AVAILABLE, ErrorCode.INVALID_LOGIN, ErrorCode.INVALID_ORIGIN].some(function (errorCode) {
            return errorCode === event.code;
          });

          if (isFatal) {
            // in these cases, SDK should throw.
            this["throw"](createError(event));
          } else {
            // reconnect
            this.disconnect();
          }
        };

        internal(_this3).connection = connection;
      });
      return this._openPromise;
    };

    _proto._getRTMServers = function _getRTMServers(options) {
      var info, cachedEndPoints;
      return regenerator.async(function _getRTMServers$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (!options.RTMServers) {
                _context3.next = 2;
                break;
              }

              return _context3.abrupt("return", shuffle_1(ensureArray(options.RTMServers)));

            case 2:
              cachedEndPoints = this._cache.get('endpoints');

              if (!cachedEndPoints) {
                _context3.next = 9;
                break;
              }

              _context3.next = 6;
              return regenerator.awrap(cachedEndPoints);

            case 6:
              info = _context3.sent;
              _context3.next = 13;
              break;

            case 9:
              _context3.next = 11;
              return regenerator.awrap(this.constructor._fetchRTMServers(options));

            case 11:
              info = _context3.sent;

              this._cache.set('endpoints', info, info.ttl * 1000);

            case 13:
              debug$5('endpoint info: %O', info);
              return _context3.abrupt("return", [info.server, info.secondary]);

            case 15:
            case "end":
              return _context3.stop();
          }
        }
      }, null, this);
    };

    Realtime._getServerUrls = function _getServerUrls(_ref4) {
      var appId, server, cachedRouter, defaultProtocol;
      return regenerator.async(function _getServerUrls$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              appId = _ref4.appId, server = _ref4.server;
              debug$5('fetch server urls');

              if (!server) {
                _context4.next = 6;
                break;
              }

              if (!(typeof server !== 'string')) {
                _context4.next = 5;
                break;
              }

              return _context4.abrupt("return", server);

            case 5:
              return _context4.abrupt("return", {
                RTMRouter: server,
                api: server
              });

            case 6:
              cachedRouter = routerCache.get(appId);

              if (!cachedRouter) {
                _context4.next = 9;
                break;
              }

              return _context4.abrupt("return", cachedRouter);

            case 9:
              defaultProtocol = 'https://';
              return _context4.abrupt("return", client.get('https://app-router.com/2/route').query({
                appId: appId
              }).timeout(20000).then(function (res) {
                return res.body;
              }).then(tap(debug$5)).then(function (_ref5) {
                var RTMRouterServer = _ref5.rtm_router_server,
                    APIServer = _ref5.api_server,
                    _ref5$ttl = _ref5.ttl,
                    ttl = _ref5$ttl === void 0 ? 3600 : _ref5$ttl;

                if (!RTMRouterServer) {
                  throw new Error('rtm router not exists');
                }

                var serverUrls = {
                  RTMRouter: "".concat(defaultProtocol).concat(RTMRouterServer),
                  api: "".concat(defaultProtocol).concat(APIServer)
                };
                routerCache.set(appId, serverUrls, ttl * 1000);
                return serverUrls;
              })["catch"](function () {
                var id = appId.slice(0, 8).toLowerCase();
                var domain = 'lncldglobal.com';
                return {
                  RTMRouter: "".concat(defaultProtocol).concat(id, ".rtm.").concat(domain),
                  api: "".concat(defaultProtocol).concat(id, ".api.").concat(domain)
                };
              }));

            case 11:
            case "end":
              return _context4.stop();
          }
        }
      });
    };

    Realtime._fetchRTMServers = function _fetchRTMServers(_ref6) {
      var appId = _ref6.appId,
          ssl = _ref6.ssl,
          server = _ref6.server,
          RTMServerName = _ref6.RTMServerName;
      debug$5('fetch endpoint info');
      return this._getServerUrls({
        appId: appId,
        server: server
      }).then(tap(debug$5)).then(function (_ref7) {
        var RTMRouter = _ref7.RTMRouter;
        return client.get("".concat(RTMRouter, "/v1/route")).query({
          appId: appId,
          secure: ssl,
          features: isWeapp ? 'wechat' : undefined,
          server: RTMServerName,
          _t: Date.now()
        }).timeout(20000).then(function (res) {
          return res.body;
        }).then(tap(debug$5));
      });
    };

    _proto._close = function _close() {
      if (this._openPromise) {
        this._openPromise.then(function (connection) {
          return connection.close();
        });
      }

      delete this._openPromise;
    }
    /**
     * 手动进行重连。
     * SDK 在网络出现异常时会自动按照一定的时间间隔尝试重连，调用该方法会立即尝试重连并重置重连尝试计数器。
     * 只能在 `SCHEDULE` 事件之后，`RETRY` 事件之前调用，如果当前网络正常或者正在进行重连，调用该方法会抛异常。
     */
    ;

    _proto.retry = function retry() {
      var _internal = internal(this),
          connection = _internal.connection;

      if (!connection) {
        throw new Error('no connection established');
      }

      if (connection.cannot('retry')) {
        throw new Error("retrying not allowed when not disconnected. the connection is now ".concat(connection.current));
      }

      return connection.retry();
    }
    /**
     * 暂停，使 SDK 进入离线状态。
     * 你可以在网络断开、应用进入后台等时刻调用该方法让 SDK 进入离线状态，离线状态下不会尝试重连。
     * 在浏览器中 SDK 会自动监听网络变化，因此无需手动调用该方法。
     *
     * @since 3.4.0
     * @see Realtime#event:OFFLINE
     */
    ;

    _proto.pause = function pause() {
      // 这个方法常常在网络断开、进入后台时被调用，此时 connection 可能没有建立或者已经 close。
      // 因此不像 retry，这个方法应该尽可能 loose
      var _internal2 = internal(this),
          connection = _internal2.connection;

      if (!connection) return;
      if (connection.can('pause')) connection.pause();
    }
    /**
     * 恢复在线状态。
     * 你可以在网络恢复、应用回到前台等时刻调用该方法让 SDK 恢复在线状态，恢复在线状态后 SDK 会开始尝试重连。
     *
     * @since 3.4.0
     * @see Realtime#event:ONLINE
     */
    ;

    _proto.resume = function resume() {
      // 与 pause 一样，这个方法应该尽可能 loose
      var _internal3 = internal(this),
          connection = _internal3.connection;

      if (!connection) return;
      if (connection.can('resume')) connection.resume();
    };

    _proto._registerPending = function _registerPending(value) {
      internal(this).pendingClients.add(value);
    };

    _proto._deregisterPending = function _deregisterPending(client) {
      internal(this).pendingClients["delete"](client);
    };

    _proto._register = function _register(client) {
      internal(this).clients.add(client);
    };

    _proto._deregister = function _deregister(client) {
      var _this = internal(this);

      _this.clients["delete"](client);

      if (_this.clients.size + _this.pendingClients.size === 0) {
        this._close();
      }
    };

    _proto._dispatchCommand = function _dispatchCommand(command) {
      return applyDispatcher(this._plugins.beforeCommandDispatch, [command, this]).then(function (shouldDispatch) {
        // no plugin handled this command
        if (shouldDispatch) return debug$5('[WARN] Unexpected message received: %O', trim(command));
        return false;
      });
    };

    return Realtime;
  }(eventemitter3);

  var polyfilledPromise = Promise;

  exports.EventEmitter = eventemitter3;
  exports.Promise = polyfilledPromise;
  exports.Protocals = message;
  exports.Realtime = Realtime;
  exports.debug = debug$2;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=realtime-core-weapp.js.map
